/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.common.accessory.api.model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.ArrayList;
import java.util.List;

/**
 * @Author wupeng
 * @Description 出库单
 * @Date 18:48 2023/7/31
 * @Param
 * @return
 **/
@Data
@ApiModel(value = "出库申请对象模型")
public class WarehouseOutputBillBo {

    @ApiModelProperty(value = "出库单号")
    private String billNo;

    @ApiModelProperty(value = "出库类型")
    private String type;

    @ApiModelProperty(value = "备注")
    private String remark;

    @ApiModelProperty(value = "去向")
    private String destination;

    @ApiModelProperty(value = "是否自动审核出库")
    private Boolean autoAudit = false;

    @ApiModelProperty(value = "扫描的物料号/唯一码/批次号")
    private String scanCode;

    @ApiModelProperty(value = "出库明细")
    private List<WarehouseOutputBillDetailBo> outputBillDetails = new ArrayList<>();

}
