package com.sw.common.accessory.server.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@ApiModel(value = "辅材信息详情")
public class AccessoryDetails {

    private Long id;
    @ApiModelProperty(value = "设备辅材id", required = true)
    Long equipmentAccessoryId;
    @ApiModelProperty(value = "物料id", required = true)
    Long materialId;
    @ApiModelProperty(value = "物料状态", required = true)
    int accessoryStatus;
    @ApiModelProperty(value = "物料类型", required = true)
    String materialType;
    @ApiModelProperty(value = "物料名称", required = true)
    String materialName;
    @ApiModelProperty(value = "物料料号", required = true)
    String materialCode;
    @ApiModelProperty(value = "批次号")
    String batchCode;
    @ApiModelProperty(value = "唯一码")
    String uniqueCode;
    @ApiModelProperty(value = "数量")
    Integer number;
    @ApiModelProperty(value = "物料状态（0：待上机，1：上机中，2：退库中，3：已退库，4：待出库）", required = true)
    Integer status;
    @ApiModelProperty(value = "预警状态（0：未预警，1：已预警）", required = true)
    Integer warnStatus;
    @ApiModelProperty(value = "额定寿命", required = true)
    Integer ratedLife;
    @ApiModelProperty(value = "已使用寿命", required = true)
    Integer usefulLife;
    @ApiModelProperty(value = "剩余寿命", required = true)
    Integer remainingLife;
    @ApiModelProperty(value = "预警寿命")
    Integer warnLife;
    @ApiModelProperty(value = "上机时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date upperTime;
    @ApiModelProperty(value = "下机时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date downTime;
    @ApiModelProperty(value = "预警时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date warnTime;
    @ApiModelProperty(value = "创建/修改人", required = true)
    String userCreate;
    @ApiModelProperty(value = "创建/修改时间", required = true)
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date gmtCreate;

    /**
     * 辅料模型属性
     */
    @ApiModelProperty(value = "规格")
    String specification;
    @ApiModelProperty(value = "物料型号")
    String xh;
    @ApiModelProperty(value = "物料图号")
    String th;
    @ApiModelProperty(value = "物料单位")
    String unit;
    @ApiModelProperty(value = "物料供应商")
    String supplier;
    @ApiModelProperty(value = "部位编码")
    String partCode;
    @ApiModelProperty(value = "部位名称")
    String partName;
}