package com.sw.common.accessory.server.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotNull;
import java.util.Date;

/**
 * @author lf
 * @description 石墨件工时上报dto
 * @date 2024/3/9 19:44
 */
@Data
@ApiModel(value = "石墨件工时上报dto")
public class AccessoryProductionOrderDto {
    private Long id;
    /**
     * 单晶生产工单id
     */
    @ApiModelProperty("单晶生产工单id")
    @NotNull(message = "单晶生产工单id不能为空")
    private Long orderNoId;
    /**
     * 辅料详情id
     */
    @ApiModelProperty("辅料详情id")
    private Long accessoryId;
    /**
     * 排程工单号
     */
    @ApiModelProperty("排程工单号")
    private String productionNo;
    /**
     * 设备号
     */
    @ApiModelProperty("设备号")
    @NotNull(message = "设备号不能为空")
    private String deviceCode;
    /**
     * 物料号
     */
    @ApiModelProperty("物料号")
    @NotNull(message = "物料号不能为空")
    private String materialCode;
    /**
     * 开始时间
     */
    @ApiModelProperty("开始时间")
    private Date startTime;
    /**
     * 上次结束时间
     */
    @ApiModelProperty("上次结束时间")
    private Date lastEndTime;
    /**
     * 结束时间
     */
    @ApiModelProperty("结束时间")
    private Date endTime;
    /**
     * 上报时间
     */
    @ApiModelProperty("上报时间")
    private Date reportTime;
    /**
     * 创建人
     */
    @ApiModelProperty("创建人")
    private String createUser;
    /**
     * 创建时间
     */
    @ApiModelProperty("创建时间")
    private Date createTime;
    /**
     * 逻辑删除，true：删除，false：未删除
     */
    @ApiModelProperty("逻辑删除")
    private boolean del;
    /**
     * 物料维度软删，true：删除，false：未删除
     */
    @ApiModelProperty("物料维度软删")
    private boolean materialDel;
    /**
     * 工单维度软删，true：删除，false：未删除
     */
    @ApiModelProperty("工单维度软删")
    private boolean productionDel;
}
