package com.sw.common.accessory.server.dto;

import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import java.util.List;

/**
 * @author zhaowenjie
 * <p>
 * 批量对调数据
 */
@Getter
@Setter
public class BatchSwitch {
    /**
     * 设备号
     */
    @NotBlank(message = "设备号不能为空")
    private String equipmentNo;
    /**
     * 目标设备号
     */
    @NotBlank(message = "目标设备号不能为空")
    private String targetEquipmentNo;
    /**
     * 对调辅料数据列表
     */
    @Size(min = 1, max = 100, message = "对调辅料数据列表不能为空，且不能超过100个")
    private List<SwitchData> switchDatas;

    /**
     * 对调辅料数据
     */
    @Getter
    @Setter
    public static class SwitchData {
        /**
         * 对调辅料id
         */
        @NotBlank(message = "对调辅料id不能为空")
        private Long accessory;
        /**
         * 目标辅料id
         */
        @NotBlank(message = "目标辅料id不能为空")
        private Long targetAccessory;
    }
}