package com.sw.common.accessory.server.dto;

import com.sw.common.mybatisplus.base.BaseDto;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.models.auth.In;
import lombok.Data;

import java.util.Date;

/**
 * 热场部位维护表
 */
@Data
@ApiModel(value = "热场部位Dto")
public class PartDto{

    private Long id;
    /**
     * 设备id
     */
    private Integer deviceModelId;
    /**
     * 设备编码
     */
    private String deviceModelCode;
    /**
     * 设备名称
     */
    private String deviceModelName;
    /**
     * 部位编码
     */
    @ApiModelProperty(value = "部位编码", required = true)
    private String partCode;
    /**
     * 部位名称
     */
    @ApiModelProperty(value = "部位名称")
    private String partName;
    /**
     * 物料id
     */
    @ApiModelProperty(value = "物料id")
    private Integer materialId;
    /**
     * 物料编码
     */
    @ApiModelProperty(value = "物料编码")
    private String materialCode;
    /**
     * 物料名称
     */
    @ApiModelProperty(value = "物料名称")
    private String materialName;
    /**
     * 数量
     */
    @ApiModelProperty(value = "数量")
    private Integer count;
    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private String createBy;
    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 修改人
     */
    @ApiModelProperty(value = "修改人")
    private String updateBy;
    /**
     * 修改时间
     */
    @ApiModelProperty(value = "修改时间")
    private Date updateTime;
}
