package com.sw.common.accessory.server.dto;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;


/**
 * MES报工SAP工时接口对象 report_sap_workinghours
 * 
 * @author liru
 * @date 2024-01-07
 */
@Data
@ApiModel(value = "MES报工SAP工时接口Dto")
public class ReportSapWorkinghoursDto
{
    /** ID */
    @ApiModelProperty(value = "ID" )
    @JSONField(serialize = false)
    private Long id;

    /** Recode Id */
    @ApiModelProperty(value = "Recode Id" )
    @JSONField(name = "RECORD_ID")
    private String recordId;

    /** 生产订单号码 */
    @ApiModelProperty(value = "生产订单号码" )
    @JSONField(name = "PRODUCTION_ORDER_ID")
    private String productionOrderId;

    /** 工厂 */
    @ApiModelProperty(value = "工厂" )
    @JSONField(name = "PLANT")
    private String plant;

    /** 生产订单类型 */
    @ApiModelProperty(value = "生产订单类型" )
    @JSONField(name = "ORDER_TYPE")
    private String orderType;

    /** 生产订单工序号  */
    @ApiModelProperty(value = "生产订单工序号 " )
    @JSONField(name = "OPERATION_ID")
    private String operationId;

    /** 生产订单工作中心 */
    @ApiModelProperty(value = "生产订单工作中心" )
    @JSONField(name = "WORKCENTER_ID")
    private String workcenterId;

    /** 合格数量 */
    @ApiModelProperty(value = "合格数量" )
    @JSONField(name = "CNF_QTY1")
    private String cnfQty1;

    /** 报废数量 */
    @ApiModelProperty(value = "报废数量" )
    @JSONField(name = "CNF_QTY2")
    private String cnfQty2;

    /** 返工数量 */
    @ApiModelProperty(value = "返工数量" )
    @JSONField(name = "CNF_QTY3")
    private String cnfQty3;

    /** 单位 */
    @ApiModelProperty(value = "单位" )
    @JSONField(name = "CNF_UOM")
    private String cnfUom;

    /** 实际加工时间 */
    @ApiModelProperty(value = "实际加工时间" )
    @JSONField(name = "CNF_TIME")
    private String cnfTime;

    /** 实际加工时间单位 */
    @ApiModelProperty(value = "实际加工时间单位" )
    @JSONField(name = "CNF_TIME_UOM")
    private String cnfTimeUom;

    /** 确认日期 */
    @ApiModelProperty(value = "确认日期" )
    @JsonFormat(pattern = "yyyyMMdd")
    @JSONField(name = "CNF_DATE",format = "yyyyMMdd")
    private Date cnfDate;

    /** 报工状态(0:未报工,1:已报工) */
    @ApiModelProperty(value = "报工状态(0:未报工,1:已报工)" )
    @JSONField(serialize = false)
    private Boolean status;
    /**工序名称**/
    @ExcelProperty(value = "工序", index = 15)
    @JSONField(serialize = false)
    private String procName;

    @ExcelProperty(value = "备注", index = 16)
    @JSONField(serialize = false)
    private String remark;

    @ExcelProperty(value = "晶编", index = 17)
    @JSONField(serialize = false)
    private String crystalNo;

}
