package com.sw.common.accessory.server.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.util.Date;

/**
 * 辅料排程工单关系表
 * @author lf
 * @description
 * @date 2024/3/9 20:01
 */
@Data
@TableName(value = "accessory_production_order")
public class AccessoryProductionOrder {
    @TableId(type = IdType.AUTO)
    private Long id;
    /**
     * 辅料详情id
     */
    private Long accessoryId;
    /**
     * 物料号
     */
    private String materialCode;
    /**
     * 排程工单号
     */
    private String productionNo;
    /**
     * 单晶生产工单id
     */
    private Long orderNoId;
    /**
     * 设备号
     */
    private String deviceCode;
    /**
     * 开始时间
     */
    private Date startTime;
    /**
     * 上次结束时间
     */
    private Date lastEndTime;
    /**
     * 结束时间
     */
    private Date endTime;
    /**
     * 上报时间
     */
    private Date reportTime;
    /**
     * 创建人
     */
    private String createUser;
    /**
     * 创建时间
     */
    private Date createTime;
    /**
     * 逻辑删除，true：删除，false：未删除
     */
    private boolean del;
    /**
     * 物料逻辑删除，true：删除，false：未删除
     */
    private boolean materialDel;
    /**
     * 工单逻辑删除，true：删除，false：未删除
     */
    private boolean productionDel;

    public void setDel(boolean materialDel,boolean productionDel){
        if(materialDel == true && productionDel == true){
            this.del = true;
        }else {
            this.del = false;
        }
    }
}
