/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.common.accessory.server.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@TableName(value="accy_apply_record")
public class ApplyRecord  implements Serializable{
    @TableId(type = IdType.AUTO)
    private Long id;
    
	/**
	 * 申请单号
	 */
    private String code;
    
	/**
	 * 设备号
	 */
    private String equipmentCode;
	/**
	 * 设备类型id
	 */
	private Integer deviceTypeId;
	/**
	 * 设备类型编码
	 */
	private String deviceTypeCode;
	/**
	 * 设备类型名称
	 */
	private String deviceTypeName;
	/**
	 * 物料id
	 */
	private Long materialId;
    
	/**
	 * 物料类型
	 */
    private String materialType;
    
	/**
	 * 物料名称
	 */
    private String materialName;
	/**
	 * 部位id
	 */
	private Long partId;

	/**
	 * 部位编码
	 */
	private String partCode;

	/**
	 * 部位名称
	 */
	private String partName;
	/**
	 * 物料料号
	 */
    private String materialCode;
    
	/**
	 * 数量
	 */
    private Integer number;
    
	/**
	 * 单位
	 */
    private String unit;
    
	/**
	 * 原因
	 */
    private String reason;
    
	/**
	 * 状态（0:待出库，1:已出库，2：已取消，3:已拒绝）
	 */
    private Integer status;
    
	/**
	 * 申请人
	 */
    private String userCreate;
    
	/**
	 * 申请时间
	 */
    private Date gmtCreate;
    
	/**
	 * 确认人
	 */
    private String userConfirm;
    
	/**
	 * 确认时间
	 */
    private Date gmtConfirm;

	/**
	 * 物料状态（0:正常,1:返修,2:报废,3:煅烧可用,）
	 */
	private Integer accessoryStatus;
    

	public ApplyRecord() {
	}

	public ApplyRecord(Long id) {
		this.id = id;
	}
}
