/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.common.accessory.server.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@TableName(value = "accy_equipment_accessory")
public class EquipmentAccessory implements Serializable {
    @TableId(type = IdType.AUTO)
    private Long id;

    /**
     * 模块
     */
    private String area;

    /**
     * 系列
     */
    private String series;

    /**
     * 设备号
     */
    private String equipmentCode;

    /**
     * 预警数量
     */
    private Integer earlyWarningCount;

    /**
     * 待上机数量
     */
    private Integer waitingBoardingCount;

    /**
     * 上机中数量
     */
    private Integer boardingCount;

    /**
     * 退库中数量
     */
    private Integer stockReturnCount;

    /**
     * 待出库数量
     */
    private Integer waitingOutboundCount;

    /**
     * 创建/修改人
     */
    private String userCreate;

    /**
     * 创建/修改时间
     */
    private Date gmtCreate;


    public EquipmentAccessory() {
    }

    public EquipmentAccessory(Long id) {
        this.id = id;
    }
}
