/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.common.accessory.server.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@TableName(value="accy_replacement_record")
public class ReplacementRecord  implements Serializable{
    @TableId(type = IdType.AUTO)
    private Long id;
    
	/**
	 * 设备号
	 */
    private String equipmentCode;
    
	/**
	 * 物料类型
	 */
    private String materialType;
    
	/**
	 * 物料名称
	 */
    private String materialName;
    
	/**
	 * 物料料号
	 */
    private String materialCode;
    
	/**
	 * 批次号
	 */
    private String batchCode;
    
	/**
	 * 唯一码
	 */
    private String uniqueCode;
    
	/**
	 * 数量
	 */
    private Integer number;


	/**
	 * 规格
	 */
	private String specification;
    
	/**
	 * 供应商
	 */
    private String supplier;
    
	/**
	 * 额定寿命
	 */
    private Integer ratedLife;
    
	/**
	 * 已使用寿命
	 */
    private Integer usefulLife;
    
	/**
	 * 剩余寿命
	 */
    private Integer remainingLife;
    
	/**
	 * 预警寿命
	 */
    private Integer warnLife;
    
	/**
	 * 物料类型（前）
	 */
    private String materialTypeOld;
    
	/**
	 * 物料名称（前）
	 */
    private String materialNameOld;
    
	/**
	 * 物料料号（前）
	 */
    private String materialCodeOld;
    
	/**
	 * 批次号（前）
	 */
    private String batchCodeOld;
    
	/**
	 * 唯一码（前）
	 */
    private String uniqueCodeOld;
    
	/**
	 * 数量（前）
	 */
    private Integer numberOld;

	/**
	 * 规格（前）
	 */
	private String specificationOld;
    
	/**
	 * 供应商（前）
	 */
    private String supplierOld;
    
	/**
	 * 额定寿命（前）
	 */
    private Integer ratedLifeOld;
    
	/**
	 * 已使用寿命（前）
	 */
    private Integer usefulLifeOld;
    
	/**
	 * 剩余寿命（前）
	 */
    private Integer remainingLifeOld;
    
	/**
	 * 预警寿命（前）
	 */
    private Integer warnLifeOld;
    
	/**
	 * 换下时间
	 */
    private Date replaceTime;
    
	/**
	 * 换下人
	 */
    private String replaceUser;
    
	/**
	 * 换上时间
	 */
    private Date changeTime;
    
	/**
	 * 换上人
	 */
    private String changeUser;
    
	/**
	 * 备注
	 */
    private String remark;

	/**
	 * 原因
	 */
	private String reason;
    

	public ReplacementRecord() {
	}

	public ReplacementRecord(Long id) {
		this.id = id;
	}
}
