package com.sw.common.accessory.server.mapper;

import com.sw.common.accessory.server.entity.DeterminationQuality;
import com.sw.common.mybatisplus.base.BaseDao;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

@Mapper
public interface DeterminationQualityMapper extends BaseDao<DeterminationQuality> {
    @Select("select * from accy_anomaly_determination_quality  where unique_code = #{uniqueCode}")
    DeterminationQuality findQualityByUniqueCode(String uniqueCode);
    @Select("select * from accy_anomaly_determination_quality  where accessory_id = #{accessoryId} order by id desc limit 1")
    DeterminationQuality findQualityByAccessoryId(Long accessoryId);
    @Select("select * from accy_anomaly_determination_quality where id = #{id} and del = 0")
    DeterminationQuality getDeterminationQualityById(Long id);

    @Select("select * from accy_anomaly_determination_quality  where input_bill_no = #{billNo}")
    DeterminationQuality findByInputBillNo(String billNo);
}
