package com.sw.mes.auth.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import lombok.Data;

/**
 * 【系统域—系统管理】菜单配置
 * @TableName auth_permission
 */
@TableName(value ="auth_permission")
@Data
public class AuthPermission implements Serializable {
    /**
     *
     */
    @TableId(type = IdType.AUTO)
    private Integer id;

    /**
     * 权限编码(如menu:view)
     */
    private String code;

    /**
     * 权限类型(button、uri等)
     */
    private String type;

    /**
     * 权限名称(如编辑用户)
     */
    private String name;

    /**
     * 权限链接(当资源类型为url时需要填写)
     */
    private String url;

    /**
     * 所属的菜单ID
     */
    private Integer parentId;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}
