package com.sw.mes.auth.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;

import java.io.Serializable;
import java.util.Date;

import com.sw.mes.core.annotation.Jinko;
import lombok.Data;

/**
 * 【系统域—系统管理】用户表
 *
 * @TableName auth_user
 */
@Jinko(value = "用户表新增字段", author = "liangfeng")
@TableName(value = "auth_user")
@Data
public class AuthUser implements Serializable {
    /**
     *
     */
    @TableId(type = IdType.AUTO)
    private Integer id;

    /**
     * 登录名
     */
    private String loginName;

    /**
     * 真实姓名
     */
    private String realName;

    /**
     * 密码
     */
    private String password;

    /**
     * 电话号码
     */
    private String phoneNo;

    /**
     * 工号
     */
    private String workNo;

    /**
     * 电子邮件地址
     */
    private String email;

    /**
     * 加密的盐
     */
    private String salt;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 用户状态
     */
    private String status;

    /**
     * 卡号
     */
    private String cardNumber;

    /**
     * 班次
     */
    private String className;

    /**
     * 班组
     */
    private String classTeam;
    /**
     * 岗位
     */
    private String post;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}
