package com.sw.mes.auth.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.sw.mes.auth.domain.AuthRoleFactory;
import com.sw.mes.auth.mapper.AuthRoleFactoryMapper;
import com.sw.mes.auth.service.AuthRoleFactoryService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author lf
 * @date 2023/12/28 9:12
 */
@Service
public class AuthRoleFactoryServiceImpl extends ServiceImpl<AuthRoleFactoryMapper, AuthRoleFactory>
        implements AuthRoleFactoryService {

    @Override
    public List<AuthRoleFactory> findAuthRoleFactoryByRoleId(Integer roleId) {
        LambdaQueryWrapper<AuthRoleFactory> qw = new LambdaQueryWrapper<>();
        qw.eq(AuthRoleFactory::getRoleId, roleId);
        return super.list(qw);
    }
}
