/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.itemclean.clean.domain;

import java.io.Serializable;
import java.util.Date;
import java.math.BigDecimal;

import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@TableName("cleaning_process_flow")
@ApiModel(value = "CleaningProcessFlow对象", description = "料理-工艺路线")
public class CleaningProcessFlow implements Serializable {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 站点名称
	 */
    @Column(length=100)
    private String siteName;
    
	/**
	 * 工单
	 */
    @Column(length=100)
    private String workOrder;
    
	/**
	 * 母工单
	 */
    @Column(length=100)
    private String masterWorkOrder;

	/**
	 * 设备号
	 */
	@Column(length=100)
	private String deviceNo;

	/**
	 * 载具号
	 */
	@Column(length=100)
	private String boxNo;

	/**
	 * 上一站点
	 */
	@Column(length=100)
	private String lastSite;

	/**
	 * 重量
	 */
    @Column(length=19)
    private BigDecimal weight;
    
	/**
	 * 余料重量
	 */
    @Column(length=19)
    private BigDecimal unusedWeight;

	/**
	 * 使用重量
	 */
    @Column(length=19)
    private BigDecimal usedWeight;

	/**
	 * 创建者
	 */
    @Column(length=32)
    private String createUser;
    
	/**
	 * 创建时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createTime;

	/**
	 * 站点名称
	 */
	@Column(length=100)
	private String currentSiteName;
	/**
	 * 进出站状态
	 * 0 待进站
	 * 1 进站
	 * 2 出站
	 */
	private Integer status;

	public CleaningProcessFlow() {
	}

	public CleaningProcessFlow(Long id) {
		this.id = id;
	}
}
