package com.sw.mes.itemclean.clean.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

/**
 * <p>
 * 破碎下料
 * </p>
 *
 * @author liuzemin
 * @since 2022-11-10
 */
@Getter
@Setter
@TableName("material_broken_down")
@ApiModel(value = "MaterialBrokenDown对象", description = "破碎下料")
public class MaterialBrokenDown implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("主键")
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    @ApiModelProperty("重量")
    private BigDecimal weight;

    @ApiModelProperty("成箱箱号-下料小箱批次")
    private String materialBoxNo;

    @ApiModelProperty("清洗批次号")
    private String productBatchNo;

    @ApiModelProperty("物料编号")
    private String materialCode;

    @ApiModelProperty("物料名称")
    private String materialName;

    @ApiModelProperty("物料等级")
    private String materialLevel;

    @ApiModelProperty("物料型号")
    private String materialModel;

    @ApiModelProperty("物料档位")
    private String materialGear;

    @ApiModelProperty("破碎id")
    private Integer brokenId;

    @ApiModelProperty("下料人")
    private String downUser;

    @ApiModelProperty("下料时间")
    private LocalDateTime downTime;

    @ApiModelProperty("创建人")
    private String createUser;

    @ApiModelProperty("创建时间")
    private LocalDateTime createTime;

    @ApiModelProperty("更新人")
    private String updateUser;

    @ApiModelProperty("更新时间")
    private LocalDateTime updateTime;

    @ApiModelProperty("逻辑删除标记")
    @TableLogic
    private Integer delFlag;

    @ApiModelProperty("备注")
    private String remark;

    @ApiModelProperty("状态: 0 破碎成箱未组托 1 破碎成箱组托")
    private Integer status;

    @ApiModelProperty("设备号")
    private String deviceNo;

}
