package com.sw.mes.itemclean.clean.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

/**
 * <p>
 * 分选拆箱
 * </p>
 *
 * @author liuzemin
 * @since 2022-11-10
 */
@Getter
@Setter
@TableName("material_unpacking")
@ApiModel(value = "MaterialUnpacking对象", description = "分选拆箱")
public class MaterialUnpacking implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("主键")
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    @ApiModelProperty("成箱号-分选批号")
    private String materialBoxNo;

    @ApiModelProperty("成箱重量")
    private BigDecimal weight;

    @ApiModelProperty("物料编号")
    private String materialCode;

    @ApiModelProperty("物料名称")
    private String materialName;

    @ApiModelProperty("物料等级")
    private String materialLevel;

    @ApiModelProperty("物料型号")
    private String materialModel;

    @ApiModelProperty("电阻档位")
    private String materialGear;

    @ApiModelProperty("领料的生产批次")
    private String productBatchNo;

    @ApiModelProperty("分选pp批次")
    private String fxProductBatchNo;

    @ApiModelProperty("物料属性：1原生多晶、2回收料、3返工料、4落地料、5清洗料、6破碎料")
    /**
     * {@link com.sw.mes.core.enums.ItemCleanEnums.MaterialType}
     */
    private Integer materialType;

    @ApiModelProperty("暂存标记")
    private Integer stagingFlag;

    @ApiModelProperty("逻辑删除标记")
    @TableLogic
    private Integer delFlag;

    @ApiModelProperty("创建人")
    private String createUser;

    @ApiModelProperty("创建时间")
    private LocalDateTime createTime;

    @ApiModelProperty("更新人")
    private String updateUser;

    @ApiModelProperty("更新时间")
    private LocalDateTime updateTime;

    @ApiModelProperty(value = "卡板箱号")
    private String boxNo;

    @ApiModelProperty("载具皮重")
    private String boxWeight;

    @ApiModelProperty("载具类型")
    private String typeName;

    @ApiModelProperty("已使用重量")
    private BigDecimal usedWeight;

    @ApiModelProperty("剩余重量")
    private BigDecimal unusedWeight;

    @ApiModelProperty("领料表中拆箱箱号")
    private String unpackingBoxNo;

    @ApiModelProperty("其他异物重量")
    private BigDecimal otherWeight;

    @ApiModelProperty("使用状态 0未使用 1已使用 2已合批 3已清空")
    private Integer useStatus;

    @ApiModelProperty("ERP工单")
    private String aufnr;

    @ApiModelProperty("去向")
    private String hasGone;

    @ApiModelProperty("实际重量(分选后合批前)")
    private BigDecimal actualWeight;

    @ApiModelProperty("合批父id")
    Integer parentId;

    @ApiModelProperty("合批批次号")
    private String blendingProductBatchNo;

    @ApiModelProperty("合批人")
    private String blendingUser;

    @ApiModelProperty("合批时间")
    private LocalDateTime blendingTime;

    @ApiModelProperty(value = "余料每日生产批次号")
    private String dateProduceBatchNo;

    @ApiModelProperty("备注")
    private String remark;
}
