/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.itemclean.clean.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.Column;
import java.io.Serializable;
import java.math.BigDecimal;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Getter
@Setter
@TableName("report_erp_xl_input_record_detail")
@ApiModel(value = "ReportErpXlInputRecordDetail对象", description = "拉取详情")
public class ReportErpXlInputRecordDetail implements Serializable {

	private static final long serialVersionUID = 1L;

	@ApiModelProperty("主键")
	@TableId(value = "id", type = IdType.AUTO)
    private Long id;
    
	/**
	 * 主表id
	 */
    @Column(length=19)
    private Long rid;
    
	/**
	 * 业务表id
	 */
    @Column(length=19)
    private Long bid;
    
	/**
	 * 重量
	 */
    @Column(length=19)
    private BigDecimal weight;
    
	/**
	 * 生产批次号,回收料批次
	 */
    @Column(length=100)
    private String batchNo;
    
	/**
	 * 物料名称
	 */
    @Column(length=100)
    private String materialName;
    
	/**
	 * 箱号
	 */
    @Column(length=100)
    private String boxNo;
    
	/**
	 * 0未上报，1已上报
	 */
    @Column(length=10)
    private Integer pushed;
    
	/**
	 * 物料编号
	 */
    @Column(length=100)
    private String materialCode;
    

	public ReportErpXlInputRecordDetail() {
	}

	public ReportErpXlInputRecordDetail(Long id) {
		this.id = id;
	}
}
