/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.itemclean.clean.domain;

import java.util.Date;
import java.math.BigDecimal;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import javax.persistence.*;

import lombok.Getter;
import lombok.Setter;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@TableName("washing_plan")
@Getter
@Setter
@ApiModel(value = "WashingPlan对象", description = "洗料计划")
public class WashingPlan {
	private static final long serialVersionUID = 1L;

	@ApiModelProperty("主键")
	@TableId(value = "id", type = IdType.AUTO)
	private Integer id;
    
	/**
	 * 物料名称
	 */
    @Column(length=64)
    private String materialName;
    
	/**
	 * 物料编号
	 */
    @Column(length=64)
    private String materialCode;
    
	/**
	 * 开始时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date startTime;
    
	/**
	 * 结束时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date endTime;
    
	/**
	 * 计划重量
	 */
    @Column(length=12)
    private BigDecimal plannedWeight;
    
	/**
	 * 创建人
	 */
    @Column(length=32)
    private String createUser;
    
	/**
	 * 创建时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createTime;
    
	/**
	 * 更新人
	 */
    @Column(length=32)
    private String updateUser;
    
	/**
	 * 更新时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date updateTime;
    

	public WashingPlan() {
	}

	public WashingPlan(Integer id) {
		this.id = id;
	}
}
