package com.sw.mes.itemclean.clean.dto;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * @author liuzemin
 * @date 2022/11/18 13:31
 * @description
 */
@Data
public class BrokenToPackDto {

    @ApiModelProperty("箱盒号")
    private String materialBoxNo;

    @ApiModelProperty("重量")
    private BigDecimal weight;

    @ApiModelProperty("生产分选批次号")
    private String productBatchNo;

    @ApiModelProperty("物料编号")
    private String materialCode;

    @ApiModelProperty("物料名称")
    private String materialName;

    @ApiModelProperty("物料等级")
    private String materialLevel;

    @ApiModelProperty("物料型号")
    private String materialModel;

    @ApiModelProperty("物料档位")
    private String materialGear;

    @ApiModelProperty("破碎id")
    private Integer brokenId;

    @ApiModelProperty("下料人")
    private String downUser;

    @ApiModelProperty("下料时间")
    private LocalDateTime downTime;

    @ApiModelProperty("创建人")
    private String createUser;

    @ApiModelProperty("创建时间")
    private LocalDateTime createTime;

    @ApiModelProperty("更新人")
    private String updateUser;

    @ApiModelProperty("更新时间")
    private LocalDateTime updateTime;

    @ApiModelProperty("逻辑删除标记")
    @TableLogic
    private Integer delFlag;

    @ApiModelProperty("备注")
    private String remark;

    @ApiModelProperty("小箱箱数")
    private Integer boxNum;

    @ApiModelProperty("设备号")
    private String deviceNo;

    @ApiModelProperty("上料花篮/箱号")
    private String boxNo;

    @ApiModelProperty(value = "粒径范围")
    private String suppliesGrain;

    @ApiModelProperty("破碎下料备注")
    private String downRemark;

    @ApiModelProperty("小箱详情备注")
    private String detailRemark;
}
