package com.sw.mes.itemclean.clean.dto;

import com.alibaba.excel.annotation.ExcelProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.sw.mes.itemclean.clean.utils.LocalDateStringConverter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * <p>
 * 组托明细
 * </p>
 *
 * @author liuzemin
 * @since 2022-11-10
 */
@Getter
@Setter
@ApiModel(value = "MaterialGroupToDetailDto对象", description = "关联组托主表的组托明细")
public class MaterialGroupToDetailDto implements Serializable {

    private static final long serialVersionUID = 1L;

     @ApiModelProperty("主键")
     private Integer id;

    @ApiModelProperty("生产批次")
    @ExcelProperty(value = "生产批次")
    private String productBatchNo;

    @ApiModelProperty("物料名称")
    @ExcelProperty(value = "物料名称")
    private String materialName;

    @ApiModelProperty("物料编号")
    @ExcelProperty(value = "物料编号")
    private String materialCode;

    @ApiModelProperty("物料等级")
    @ExcelProperty(value = "物料等级")
    private String materialLevel;

    @ApiModelProperty("物料型号")
    @ExcelProperty(value = "物料型号")
    private String materialModel;

    @ApiModelProperty("电阻档位")
    @ExcelProperty(value = "电阻档位")
    private String materialGear;

    @ApiModelProperty("组托重量（总计）")
    @ExcelProperty(value = "组托重量（总计）")
    private BigDecimal totalWeight;

    @ApiModelProperty("小箱重量")
    @ExcelProperty(value = "小箱重量")
    private BigDecimal weight;

    @ApiModelProperty("设备号")
    @ExcelProperty(value = "设备号")
    private String deviceNo;

    @ApiModelProperty("身份号")
    @ExcelProperty(value = "身份号")
    private String downUser;

    @ApiModelProperty("小箱箱号")
    @ExcelProperty(value = "小箱箱号")
    private String materialBoxNo;

    // @ApiModelProperty("组托id")
    // private Integer groupId;

    @ApiModelProperty("小箱备注")
    @ExcelProperty(value = "小箱备注")
    private String remark;

    @ApiModelProperty("托号")
    @ExcelProperty(value = "托号")
    private String groupNo;

    @ApiModelProperty("创建人")
    @ExcelProperty(value = "组托人")
    private String createUser;

    @ApiModelProperty("创建时间")
    @ExcelProperty(value = "组托时间", converter = LocalDateStringConverter.class)
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime createTime;

    //    @ApiModelProperty("更新人")
//    private String updateUser;
//
//    @ApiModelProperty("更新时间")
//    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
//    private LocalDateTime updateTime;
//
//    @ApiModelProperty("逻辑删除标记")
//    private Integer delFlag;


    @ExcelProperty(value = "ERP上报状态，0 未上报，1 已上报")
    @ApiModelProperty("ERP上报状态，0 未上报，1 已上报")
    private Integer reportedState;

    @ApiModelProperty("小箱成箱时间")
    @ExcelProperty(value = "小箱成箱时间", converter = LocalDateStringConverter.class)
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime boxTime;

    @ApiModelProperty("成箱操作人")
    @ExcelProperty(value = "成箱操作人")
    private String boxUser;

    @ApiModelProperty("ERP工单")
    private String aufnr;

    @ApiModelProperty("erp上报时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime erpTime;

}
