package com.sw.mes.itemclean.clean.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * <p>
 * 线边仓传入清洗数据
 * </p>
 *
 * @author liuzemin
 * @since 2022-11-10
 */
@Getter
@Setter
@ApiModel(value = "MaterialStoreSignBox对象", description = "打签箱待存（待扫码领料）")
public class MaterialStoreSignBoxFromWarehouseDto implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("主键")
    private Integer id;

    @ApiModelProperty("重量")
    private BigDecimal weight;

    @ApiModelProperty("成箱箱号")
    private String materialBoxNo;

    @ApiModelProperty("生产批次号")
    private String productBatchNo;

    @ApiModelProperty(value = "回收料托号")
    private String trayNo;

    @ApiModelProperty("物料编号")
    private String materialCode;

    @ApiModelProperty("物料名称")
    private String materialName;

    @ApiModelProperty("物料等级")
    private String materialLevel;

    @ApiModelProperty("物料型号")
    private String materialModel;

    @ApiModelProperty("物料档位")
    private String materialGear;

    @ApiModelProperty("物料类型 1原生多晶2回收料3落地料4返工料5清洗料6破碎料")
    private Integer materialType;

    @ApiModelProperty("是否被领料 1是 0否  (被领料的才能进入加工工序)")
    private Integer pickingStatus;

    @ApiModelProperty("创建人")
    private String createUser;

    @ApiModelProperty("创建时间")
//    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime createTime;

    @ApiModelProperty("更新人")
    private String updateUser;

    @ApiModelProperty("更新时间")
//    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime updateTime;

    @ApiModelProperty("逻辑删除标记")
    private Integer delFlag;

    @ApiModelProperty("是否成箱 0否 1是")
    private Integer isPack;

    @ApiModelProperty("是否空箱 0否 1是")
    private Integer isEmptyBox;

    @ApiModelProperty("ERP订单编号")
    private String aufnr;

    @ApiModelProperty(value = "卡板箱号")
    String boxNo;

    @ApiModelProperty("已使用重量")
    private BigDecimal usedWeight;

    @ApiModelProperty("剩余重量")
    private BigDecimal unusedWeight;

    @ApiModelProperty("审核状态 0 待审核 1 已接收 2已拒收")
    private Integer status;

    @ApiModelProperty("使用状态 1是 0否")
    private Integer useStatus;

    @ApiModelProperty("合批父id")
    Integer parentId;
    @ApiModelProperty("合批批次号")
    private String blendingProductBatchNo;

    @ApiModelProperty("合批人")
    private String blendingUser;

    @ApiModelProperty("合批时间")
    private LocalDateTime blendingTime;

    @ApiModelProperty("审核人")
    private String examineUser;

    @ApiModelProperty("审核时间")
    private LocalDateTime examineTime;

    @ApiModelProperty("发起人")
    private String initiateUser;

    @ApiModelProperty("发起时间")
    private LocalDateTime initiateTime;

    @ApiModelProperty("去向")
    private String hasGone;

    @ApiModelProperty(value = "物料主数据供应商")
    private String supplier;

    @ApiModelProperty(value = "物料主数据供应商Code")
    private String supplierCode;

}
