package com.sw.mes.itemclean.clean.dto;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;


/**
 * @description 硅料在制明细Dto
 */
@Data
@ApiModel(value = "硅料在制明细Dto")
public class WorkInCleanProgressDetailDto {
    @ExcelIgnore
    @ApiModelProperty(value = "在制类型1 待分选重量waitUnpackingWeight,2 待清洗重量waitCleanWeight,3 无尘待收货量waitDustFreeWeight,4 已清洗重量cleanWeight,5 无尘收货重量dustFreeWeight 6无尘成品重量dustFreeFinishWeight")
    private String type;

    @ExcelProperty(value = "在制类型", index = 3)
    @ApiModelProperty(value = "在制类型1 待分选重量waitUnpackingWeight,2 待清洗重量waitCleanWeight,3 无尘待收货量waitDustFreeWeight,4 已清洗重量cleanWeight,5 无尘收货重量dustFreeWeight 6无尘成品重量dustFreeFinishWeight")
    private String typeName;

    @ExcelProperty(value = "物料编码", index = 0)
    @ApiModelProperty(value = "物料号")
    private String materialCode;

    @ExcelProperty(value = "物料名称", index = 1)
    @ApiModelProperty(value = "物料号名称")
    private String materialName;

    @ExcelProperty(value = "分选pp号", index = 2)
    @ApiModelProperty(value = "分选pp号")
    private String fxProductBatchNo;

    @ExcelProperty(value = "重量", index = 4)
    @ApiModelProperty("重量")
    private BigDecimal weight;

    @ExcelProperty(value = "物料等级", index = 5)
    @ApiModelProperty("物料等级")
    private String materialLevel;

    @ExcelProperty(value = "电阻档位", index = 6)
    @ApiModelProperty("电阻档位")
    private String materialGear;


}
