package com.sw.mes.itemclean.clean.mapper;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.sw.mes.itemclean.clean.domain.MaterialGroupDetail;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.sw.mes.itemclean.clean.dto.GroupDetailParamQuery;
import com.sw.mes.itemclean.clean.dto.MaterialGroupToBoxDetailDto;
import com.sw.mes.itemclean.clean.dto.MaterialGroupToDetailDto;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * <p>
 * 组托明细 Mapper 接口
 * </p>
 *
 * @author liuzemin
 * @since 2022-11-10
 */
@Repository
public interface MaterialGroupDetailMapper extends BaseMapper<MaterialGroupDetail> {

    IPage<MaterialGroupToDetailDto> queryList(@Param("iPage") IPage<MaterialGroupToDetailDto> iPage, @Param("query") GroupDetailParamQuery query);

    List<MaterialGroupToDetailDto> queryListByParam(@Param("query") GroupDetailParamQuery query);

    List<MaterialGroupDetail> findList(@Param("query") GroupDetailParamQuery query);

    List<MaterialGroupToBoxDetailDto> queryBoxList(@Param("query") GroupDetailParamQuery query);

    IPage<MaterialGroupToBoxDetailDto> queryBoxList(@Param("iPage") IPage<MaterialGroupToBoxDetailDto> iPage, @Param("query") GroupDetailParamQuery query);

}
