package com.sw.mes.itemclean.clean.vo;

import com.alibaba.excel.annotation.ExcelProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.sw.mes.itemclean.clean.domain.MaterialUnpackingDetail;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.util.List;

/**
 * <p>
 * 分选拆箱
 * </p>
 *
 * @author liuzemin
 * @since 2022-11-10
 */
@Getter
@Setter
@ApiModel(value = "MaterialUnpackingVo对象", description = "分选拆箱vo")
public class MaterialUnpackingVo implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("主键")
    private Integer id;

    @ApiModelProperty("成箱号")
    private String materialBoxNo;

    @ApiModelProperty("领料表中物料箱号")
    private String orderMaterialBoxNo;

    @ApiModelProperty("成箱重量")
    private BigDecimal weight;

    @ApiModelProperty("物料编号")
    private String materialCode;

    @ApiModelProperty("物料名称")
    private String materialName;

    @ApiModelProperty("物料等级")
    private String materialLevel;

    @ApiModelProperty("物料型号")
    private String materialModel;

    @ApiModelProperty("电阻档位")
    private String materialGear;

    @ApiModelProperty("生产批次")
    private String productBatchNo;

    @ApiModelProperty("暂存标记")
    private Integer stagingFlag;

    @ApiModelProperty("逻辑删除标记")
    private Integer delFlag;

    @ApiModelProperty("创建人")
    private String createUser;

    @ApiModelProperty("物料属性：1原生多晶、2回收料、3返工料、4落地料、5清洗料、6破碎料")
    /**
     * {@link com.sw.mes.core.enums.ItemCleanEnums.MaterialType}
     */
    private Integer materialType;

    @ApiModelProperty("创建时间")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private LocalDateTime createTime;

    @ApiModelProperty("更新人")
    private String updateUser;

    @ApiModelProperty("更新时间")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private LocalDateTime updateTime;

    @ApiModelProperty("分选拆箱详情信息")
    private List<MaterialUnpackingDetail> materialUnpackingDetails;

    @ApiModelProperty("拆箱箱号")
    private String unpackingBoxNo;

    @ApiModelProperty(value = "卡板箱号")
    private String boxNo;

    @ApiModelProperty("载具皮重")
    private String boxWeight;

    @ApiModelProperty("载具类型")
    private String typeName;

    @ApiModelProperty("已使用重量")
    private BigDecimal usedWeight;

    @ApiModelProperty("剩余重量")
    private BigDecimal unusedWeight;

    @ApiModelProperty("其他异物重量")
    private BigDecimal otherWeight;

    @ApiModelProperty("ERP工单")
    private String aufnr;

    @ApiModelProperty("去向")
    private String hasGone;

    @ApiModelProperty("备注")
    private String remark;


   /* *//**
     * 导电型号
     *//*
    private String conductionType;

    *//**
     * 掺杂剂
     *//*
    private String dopant;

    *//**
     * 定向标识
     *//*
    private String directionalSign;
*/
}
