package com.sw.mes.fb.aio.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@Data
@ApiModel(value = "EAP磨削加工记录上传Dto")
public class EapGoldBreakDto {

      private Long id;
      @ApiModelProperty(value = "设备类型" )
      String equipType;
      @ApiModelProperty(value = "晶棒编号" )
      String sn;
      @ApiModelProperty(value = "设备编号" )
      String equipNo;
      @ApiModelProperty(value = "浪费前线量" )
      BigDecimal lenBefore;
      @ApiModelProperty(value = "浪费后线量" )
      BigDecimal lenAfter;
      @ApiModelProperty(value = "浪费线量" )
      BigDecimal wasteLen;
      @ApiModelProperty(value = "断线原因 切方断线原因：边皮砸断，压线断线,线量不符， 导轮深槽， 滑轮晃动，" +
              "多线头，摆角抱死，无原点， 切入边皮提刀断线，跳线，切割能力不足排旧线， 炸线断线、 水帘堵塞，导轮轴异常，" +
              " 设备原因， 断电/闪停，脱线， 单晶内存在钢线 , 出刀口断线  入刀口断线  中主轴伺服故障" )
      String wasteReason;
      @ApiModelProperty(value = "操作人员" )
      String operator;
      @ApiModelProperty(value = "创建日期" )
      @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
      Date createdTime;
}