package com.sw.mes.fb.aio.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@ApiModel(value = "磨削下料上传Dto")
public class GrindingBlankingDto {

    private Long id;
     @ApiModelProperty(value = "分区|模块")
     String area;
     @ApiModelProperty(value = "系列")
     String series;
     @ApiModelProperty(value = "磨削机编号" )
     String equipNo;
     @ApiModelProperty(value = "方棒sn" )
     String sn;
     @ApiModelProperty(value = "磨面机编号（A01-C/D/E" )
     String grindingNo;
     @ApiModelProperty(value = "磨面顺序号" )
     String grindingOrder;
     @ApiModelProperty(value = "磨前平面头部1面中点值" )
     BigDecimal side1;
     @ApiModelProperty(value = "磨前平面头部2面中点值" )
     BigDecimal side2;
     @ApiModelProperty(value = "磨前平面头部3面中点值" )
     BigDecimal side3;
     @ApiModelProperty(value = "磨前平面头部4面中点值" )
     BigDecimal side4;
     @ApiModelProperty(value = "磨前平面尾部1面中点值" )
     BigDecimal side5;
     @ApiModelProperty(value = "磨前平面尾部2面中点值" )
     BigDecimal side6;
     @ApiModelProperty(value = "磨前平面尾部3面中点值" )
     BigDecimal side7;
     @ApiModelProperty(value = "磨前平面尾部4面中点值" )
     BigDecimal side8;
     @ApiModelProperty(value = "磨前平面头部中点1-2差值" )
     BigDecimal side9;
     @ApiModelProperty(value = "磨前平面头部中点3-4差值" )
     BigDecimal side10;
     @ApiModelProperty(value = "磨前平面尾部中点1-2值" )
     BigDecimal side11;
     @ApiModelProperty(value = "磨前平面尾部中点3-4值" )
     BigDecimal side12;
     @ApiModelProperty(value = "下料完成" )
     BigDecimal side13;
     @ApiModelProperty(value = "磨削刀数" )
     Integer knife;
     @ApiModelProperty(value = "磨削完成时边长" )
     BigDecimal finalSide;
     @ApiModelProperty(value = "实际长度值" )
     BigDecimal finalLen;
     @ApiModelProperty(value = "4M标识（0:无,1:接班后,2:停水停电3:换线砂轮后首颗)" )
     Integer flag4M;
     @ApiModelProperty(value = "创建日期" )
     @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
     Date createdTime;
     @ApiModelProperty(value = "磨后检测平面头部1面中点值" )
     BigDecimal afterhead1;
     @ApiModelProperty(value = "磨后检测平面头部2面中点值" )
     BigDecimal afterhead2;
     @ApiModelProperty(value = "磨后检测平面头部3面中点值" )
     BigDecimal afterhead3;
     @ApiModelProperty(value = "磨后检测平面头部4面中点值" )
     BigDecimal afterhead4;
     @ApiModelProperty(value = "磨后检测平面尾部1面中点值" )
     BigDecimal aftertail1;
     @ApiModelProperty(value = "磨后检测平面尾部2面中点值" )
     BigDecimal aftertail2;
     @ApiModelProperty(value = "磨后检测平面尾部3面中点值" )
     BigDecimal aftertail3;
     @ApiModelProperty(value = "磨后检测平面尾部4面中点值" )
     BigDecimal aftertail4;
     @ApiModelProperty(value = "头部1点+3点直径（切方开方磨削机）" )
     BigDecimal headadd13;
     @ApiModelProperty(value = "头部2点+4点直径（切方开方磨削机）" )
     BigDecimal headadd24;
     @ApiModelProperty(value = "尾部1点+3点直径（切方开方磨削机）" )
     BigDecimal tailadd13;
     @ApiModelProperty(value = "尾部2点+4点直径（切方开方磨削机）" )
     BigDecimal tailadd24;
     @ApiModelProperty(value = "磨前平面头部中点1-2差值（磨削开方磨削机）" )
     BigDecimal beforeheadd12;
     @ApiModelProperty(value = "磨前平面头部中点3-4差值（磨削开方磨削机）" )
     BigDecimal beforeheadd34;
     @ApiModelProperty(value = "磨前平面尾部中点1-2差值（磨削开方磨削机）" )
     BigDecimal beforetaild12;
     @ApiModelProperty(value = "磨前平面尾部中点3-4差值（磨削开方磨削机）" )
     BigDecimal beforetaild34;
     @ApiModelProperty(value = "磨后平面头部中点1-2差值（磨削开方磨削机）" )
     BigDecimal afterheadd12;
     @ApiModelProperty(value = "磨后平面头部中点3-4差值（磨削开方磨削机）" )
     BigDecimal afterheadd34;
     @ApiModelProperty(value = "磨后平面尾部中点1-2差值（磨削开方磨削机）" )
     BigDecimal aftertaild12;
     @ApiModelProperty(value = "磨后平面尾部中点3-4差值（磨削开方磨削机）" )
     BigDecimal aftertaild34;
     @ApiModelProperty(value = "磨前平面头部上点1-2差值" )
     BigDecimal beforhud12;
     @ApiModelProperty(value = "磨前平面头部下点1-2差值" )
     BigDecimal beforhdd12;
     @ApiModelProperty(value = "磨前平面头部上点3-4差值" )
     BigDecimal beforhud34;
     @ApiModelProperty(value = "磨前平面头部下点3-4差值" )
     BigDecimal beforhdd34;
     @ApiModelProperty(value = "磨前平面尾部上点1-2差值" )
     BigDecimal befortud12;
     @ApiModelProperty(value = "磨前平面尾部下点1-2差值" )
     BigDecimal befortdd12;
     @ApiModelProperty(value = "磨前平面尾部上点3-4差值" )
     BigDecimal befortud34;
     @ApiModelProperty(value = "磨前平面尾部下点3-4差值" )
     BigDecimal befortdd34;
     @ApiModelProperty(value = "磨后平面头部上点1-2差值" )
     BigDecimal afterhud12;
     @ApiModelProperty(value = "磨后平面头部下点1-2差值" )
     BigDecimal afterhdd12;
     @ApiModelProperty(value = "磨后平面头部上点3-4差值" )
     BigDecimal afterhud34;
     @ApiModelProperty(value = "磨后平面头部下点3-4差值" )
     BigDecimal afterhdd34;
     @ApiModelProperty(value = "磨后平面尾部上点1-2差值" )
     BigDecimal aftertud12;
     @ApiModelProperty(value = "磨后平面尾部下点1-2差值" )
     BigDecimal aftertdd12;
     @ApiModelProperty(value = "磨后平面尾部上点3-4差值" )
     BigDecimal aftertud34;
     @ApiModelProperty(value = "磨后平面尾部下点3-4差值" )
     BigDecimal aftertdd34;
     @ApiModelProperty(value = "上电标识, 平时是0断电是1" )
     String turnonflag;
     @ApiModelProperty(value = "EAP直径max(mm)" )
     BigDecimal eapDiameterMax;
     @ApiModelProperty(value = "EAP直径min(mm)" )
     BigDecimal eapDiameterMin;
     @ApiModelProperty(value = "EAP边长1(mm)" )
     BigDecimal eapSide1;
     @ApiModelProperty(value = "EAP边长2(mm)" )
     BigDecimal eapSide2;
     @ApiModelProperty(value = "EAP边长3(mm)" )
     BigDecimal eapSide3;
     @ApiModelProperty(value = "EAP边长4(mm)" )
     BigDecimal eapSide4;
     @ApiModelProperty(value = "EAP边长5(mm)" )
     BigDecimal eapSide5;
     @ApiModelProperty(value = "EAP边长6(mm)" )
     BigDecimal eapSide6;
}