package com.sw.mes.fb.aio.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @Author wanghao
 * @Date: 2022/4/29
 * @Modified By:
 */
@Data
@ApiModel(value = "画线记录(晶段样片)详情表Dto")
public class ProductionPaintingLineDetailDto {

    private Integer id;
    @ApiModelProperty(value = "", required = true)
    Integer operateReversecutDrawId;
    @ApiModelProperty(value = "画线记录id（画线/反切画线）", required = true)
    Integer operateDrawId;
    @ApiModelProperty(value = "单晶id", required = true)
    Integer crystalId;
    @ApiModelProperty(value = "晶段序号", required = true)
    Integer sequence;
    @ApiModelProperty(value = "(0,头回收料) (1,尾回收料),(2,回收料)\n" +
            "        ,(3,样片),(4,头样片),(5,尾样片)\n" +
            "        ,(6,尾片),(7,尾头片),(8,晶段) ", required = true)
    Integer type;
    @ApiModelProperty(value = "父id（则为晶段id）", required = true)
    Integer parentId;
    @ApiModelProperty(value = "创建时间", required = true)
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date createTime;
    @ApiModelProperty(value = "晶段编号/样片编号", required = true)
    String no;
    @ApiModelProperty(value = "晶段长度")
    BigDecimal length;
    @ApiModelProperty(value = "晶段重量")
    BigDecimal weight;
    @ApiModelProperty(value = "0:未切断，1:以切断", required = true)
    Integer status;
    @ApiModelProperty(value = "直径")
    String diameter;

    @ApiModelProperty(value = "晶段类型")
    String segmentType;

    @ApiModelProperty(value = "备注")
    String remark;

    @ApiModelProperty(value = "0:是反切，1:不是反切", required = true)
    Integer isCut;

    // 圆方棒标识 0圆棒  1是方棒
    @ApiModelProperty(value = "0:是圆棒，1:方棒", required = true)
    Integer crystalType;
}
