package com.sw.mes.fb.aio.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @Author wanghao
 * @Date: 2022/4/29
 * @Modified By:
 */
@Data
@ApiModel(value = "划线记录Dto")
public class ProductionPaintingLineDto {


    private Long id;
    @ApiModelProperty(value = "炉次号")
    String lotNo;
    @ApiModelProperty(value = "单晶编号")
    String crystalNo;
    @ApiModelProperty(value = "画线人员")
    String userName;
    @ApiModelProperty(value = "是否见锅底 (0代表是,1代表否)")
    Integer isSeeBottom;
    @ApiModelProperty(value = "温度")
    String temperature;
    @ApiModelProperty(value = "打磨电阻率")
    String resistivity;
    @ApiModelProperty(value = "掺杂剂")
    String dopant;
    @ApiModelProperty(value = "最小直径")
    BigDecimal minDiam;
    @ApiModelProperty(value = "最大直径")
    BigDecimal maxDiam;
    @ApiModelProperty(value = "是否收尾")
    Integer isWindUp;
    @ApiModelProperty(value = "送验长度")
    BigDecimal submitLength;
    @ApiModelProperty(value = "画线有效长度")
    BigDecimal validLength;
    @ApiModelProperty(value = "画线去头长度")
    BigDecimal noTopLength;
    @ApiModelProperty(value = "样片数")
    Integer pieceNum;
    @ApiModelProperty(value = "画线段数")
    Integer lineNum;
    @ApiModelProperty(value = "班次")
    String classNo;
    @ApiModelProperty(value = "班组")
    String teamGroup;
    @ApiModelProperty(value = "投料量")
    BigDecimal materialCount;
    @ApiModelProperty(value = "去头原因")
    String topCause;
    @ApiModelProperty(value = "去尾原因")
    String endCause;
    @ApiModelProperty(value = "开始时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date startTime;
    @ApiModelProperty(value = "结束时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date endTime;
    @ApiModelProperty(value = "尾部返切长度")
    BigDecimal unEndLength;
    @ApiModelProperty(value = "断苞长度")
    BigDecimal bractLength;
    @ApiModelProperty(value = "其他直径异常")
    String otherDiam;
    @ApiModelProperty(value = "其他直径异常损失长度")
    BigDecimal lossLength;
    @ApiModelProperty(value = "实验备注")
    String experRemark;
    @ApiModelProperty(value = "打印张数")
    Integer printNum;
    @ApiModelProperty(value = "载具编号")
    String vehicleCode;
    @ApiModelProperty(value = "备注")
    String remark;
    @ApiModelProperty(value = "画线去尾长度")
    BigDecimal lineTailLength;
    @ApiModelProperty(value = "是否孪晶(1是  0否)")
    Integer isTwinCrystal;
    @ApiModelProperty(value = "孪晶位置")
    String twinCrystalSite;
    @ApiModelProperty(value = "孪晶长度")
    BigDecimal twinCrystalLength;
    @ApiModelProperty(value = "画线实验标记")
    String drawLine;
    @ApiModelProperty(value = "标签打印类型")
    Integer printType;
    @ApiModelProperty(value = "等径长度")
    BigDecimal isometricLength;
    /**
     * 划线类型
     */
    @ApiModelProperty(value = "划线类型")
    String program;
}
