package com.sw.mes.fb.aio.dto;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@ApiModel(value = "截断机上报记录报表")
public class TurnStoreOtherVo {
     @ApiModelProperty(value = "单晶id" )@ExcelProperty(value = "id")
     Long crystalId;
     @ApiModelProperty(value = "单晶编号" )@ExcelProperty(value = "单晶编号")
     String roundSN;
     @ApiModelProperty(value = "划线长度" )@ExcelProperty(value = "划线长度")
     BigDecimal roundLength;
     @ApiModelProperty(value = "理论重量" )@ExcelProperty(value = "理论重量")
     BigDecimal theoryWeight;
     @ApiModelProperty(value = "产品类型" )@ExcelProperty(value = "产品类型")
     String productType;
     @ApiModelProperty(value = "规格" )@ExcelProperty(value = "规格")
     String specs;
     @ApiModelProperty(value = "边长")@ExcelProperty(value = "边长")
     String sideLengthRange;
     @ApiModelProperty(value = "截断设备编号" )@ExcelProperty(value = "截断设备编号")
     String equipNo;
     @ApiModelProperty(value = "工时" )@ExcelProperty(value = "工时")
     Integer manHour;
     @ApiModelProperty(value = "正常刀数" )@ExcelProperty(value = "正常刀数")
     Integer normalNum;
     @ApiModelProperty(value = "反切刀数" )@ExcelProperty(value = "反切刀数")
     Integer reverseNum;
     @ApiModelProperty(value = "段数" )@ExcelProperty(value = "段数")
     Integer lineNum;
     @ApiModelProperty(value = "晶段数" )@ExcelProperty(value = "切割数")
     Integer knifeNum;
     @ApiModelProperty(value = "晶片数" )@ExcelProperty(value = "样片数量")
     Integer sliceNum;
     @ApiModelProperty(value = "反切原因" )@ExcelProperty(value = "反切原因")
     String cause;
     @ApiModelProperty(value = "截断上料时间" )@ExcelProperty(value = "截断上料时间")
     @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
     Date startCut;
     @ApiModelProperty(value = "截断下料时间" )@ExcelProperty(value = "截断下料时间")
     @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
     Date endCut;
     @ApiModelProperty(value = "上料用户名称" )@ExcelProperty(value = "上料用户名称")
     String cutUpOperator;
     @ApiModelProperty(value = "下料用户名称" )@ExcelProperty(value = "下料用户名称")
     String cutOperator;
     @ApiModelProperty(value = "班长姓名" )@ExcelIgnore
     String userRealName;
     @ApiModelProperty(value = "是否反切画线0:是反切 ,1不是反切" )@ExcelProperty(value = "是否反切画线")
     String isCut;
     @ApiModelProperty(value = "圆方棒标识:0,圆棒 ,1是方棒" )@ExcelProperty(value = "圆方棒标识")
     String crystalType;
     @ApiModelProperty(value = "完结标识")
     @ExcelProperty(value = "完结标识")
     String closureIdentification;
     @ApiModelProperty(value = "收尾方式")
     @ExcelProperty(value = "收尾方式")
     String windUp;

}