/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.fb.aio.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.util.Date;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@Entity
@Table(name = "interface_eap_cut_process_record")
@DynamicUpdate
@DynamicInsert
public class CutProcessRecord {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 创建时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createTime;
    
	/**
	 * 设备编号
	 */
    @Column(length=30)
    private String deviceCode;
    
	/**
	 * 上料毛棒晶编
	 */
    @Column(length=50)
    private String crystalNo;
    
	/**
	 * 开始切割：1开始
	 */
    @Column(length=10)
    private Integer cuttingStart;
    
	/**
	 * 切割完成：1完成
	 */
    @Column(length=10)
    private Integer cuttingEnd;
    
	/**
	 * 截断工时（min）
	 */
    @Column(length=10)
    private Double cuttingHour;
    
	/**
	 * 轮系1环线1寿命
	 */
    @Column(length=10)
    private Double data7;
    
	/**
	 * 轮系1环线2寿命
	 */
    @Column(length=10)
    private Double data8;
    
	/**
	 * 轮系2环线1寿命
	 */
    @Column(length=10)
    private Double data9;
    
	/**
	 * 轮系3环线1寿命
	 */
    @Column(length=10)
    private Double data10;
    
	/**
	 * 轮系4环线1寿命
	 */
    @Column(length=10)
    private Double data11;
    
	/**
	 * 轮系5环线1寿命
	 */
    @Column(length=10)
    private Double data12;
    
	/**
	 * 轮系6环线1寿命
	 */
    @Column(length=10)
    private Double data13;
    
	/**
	 * 轮系6环线2寿命
	 */
    @Column(length=10)
    private Double data14;
    
	/**
	 * 轮系7环线1寿命
	 */
    @Column(length=10)
    private Double data15;
    
	/**
	 * 轮系8环线1寿命
	 */
    @Column(length=10)
    private Double data16;
    
	/**
	 * 轮系9环线1寿命
	 */
    @Column(length=10)
    private Double data17;
    
	/**
	 * 轮系9环线2寿命
	 */
    @Column(length=10)
    private Double data18;
    
	/**
	 * 轮系1环线1点新线信号
	 */
    @Column(length=10)
    private Double data19;
    
	/**
	 * 轮系1环线2点新线信号
	 */
    @Column(length=10)
    private Double data20;
    
	/**
	 * 轮系2环线1点新线信号
	 */
    @Column(length=10)
    private Double data21;
    
	/**
	 * 轮系3环线1点新线信号
	 */
    @Column(length=10)
    private Double data22;
    
	/**
	 * 轮系4环线1点新线信号
	 */
    @Column(length=10)
    private Double data23;
    
	/**
	 * 轮系5环线1点新线信号
	 */
    @Column(length=10)
    private Double data24;
    
	/**
	 * 轮系6环线1点新线信号
	 */
    @Column(length=10)
    private Double data25;
    
	/**
	 * 轮系6环线2点新线信号
	 */
    @Column(length=10)
    private Double data26;
    
	/**
	 * 轮系7环线1点新线信号
	 */
    @Column(length=10)
    private Double data27;
    
	/**
	 * 轮系8环线1点新线信号
	 */
    @Column(length=10)
    private Double data28;
    
	/**
	 * 轮系9环线1点新线信号
	 */
    @Column(length=10)
    private Double data29;
    
	/**
	 * 轮系9环线2点新线信号
	 */
    @Column(length=10)
    private Double data30;
    

	public CutProcessRecord() {
	}

	public CutProcessRecord(Long id) {
		this.id = id;
	}
}
