/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.fb.aio.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="interface_eap_evolution_rack")
@DynamicUpdate
@DynamicInsert
public class EapEvolutionRack {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;
    
	/**
	 * 开方机编号
	 */
    @Column(nullable=false, length=50)
    private String equipNo;
    
	/**
	 * 圆棒SN
	 */
    @Column(nullable=false, length=20)
    private String sn;
    
	/**
	 * 创建日期
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createdTime;

	/**
	 * 人工上料标识
	 */
	@Column(length=20)
	private String headLoading;

	public EapEvolutionRack() {
	}

	public EapEvolutionRack(Integer id) {
		this.id = id;
	}
}
