/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.fb.aio.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.math.BigDecimal;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="interface_eap_evolution_record")
@DynamicUpdate
@DynamicInsert
public class EapEvolutionRecord {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private Long id;

	/**
	 * 开方机编号
	 */
	@Column(nullable=false, length=50)
	private String equipNo;

	/**
	 * 方棒SN
	 */
	@Column(nullable=false, length=50)
	private String sn;

	/**
	 * 开方员工号
	 */
	@Column(nullable=false, length=20)
	private String trimmingMan;

	/**
	 * 人员代码
	 */
	@Column(length=20)
	private String trimmingManCode;

	/**
	 * 班次
	 */
	@Column(length=50)
	private String classNoName;

	/**
	 * 切割开始时间
	 */
	@Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
	private Date startTrimming;

	/**
	 * 切割结束时间
	 */
	@Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
	private Date endTrimming;

	/**
	 * 圆棒切割工时
	 */
	@Column(length=20)
	private BigDecimal trimmingHours;

	/**
	 * 开始切方张力
	 */
	@Column(length=20)
	private BigDecimal tension;

	/**
	 * 开始切方线速度
	 */
	@Column(length=20)
	private BigDecimal sLinearSpeed;

	/**
	 * 开始切方切割速度
	 */
	@Column(length=20)
	private BigDecimal sCuttingSpeed;

	/**
	 * 开始切方水流量
	 */
	@Column(length=20)
	private BigDecimal sTrimmingFlow;

	/**
	 * 实际单颗用线量
	 */
	@Column(length=20)
	private BigDecimal actualQty;

	/**
	 * 加工规格
	 */
	@Column(length=20)
	private String spec;

	/**
	 * PN型
	 */
	@Column(length=20)
	private String pnType;

	/**
	 * 设定边长
	 */
	@Column(length=20)
	private BigDecimal sideLen;

	/**
	 * 产品等级
	 */
	@Column(length=20)
	private String productRank;

	/**
	 * 拼接
	 */
	@Column(length=20)
	private String splitJoint;

	/**
	 * 是否指定订单
	 */
	@Column(length=3)
	private Integer isAssign;

	/**
	 * 创建时间
	 */
	@Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
	private Date createdTime;


	public EapEvolutionRecord() {
	}

	public EapEvolutionRecord(Long id) {
		this.id = id;
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getEquipNo() {
		return equipNo;
	}

	public void setEquipNo(String equipNo) {
		this.equipNo = equipNo;
	}

	public String getSn() {
		return sn;
	}

	public void setSn(String sn) {
		this.sn = sn;
	}

	public String getTrimmingMan() {
		return trimmingMan;
	}

	public void setTrimmingMan(String trimmingMan) {
		this.trimmingMan = trimmingMan;
	}

	public String getTrimmingManCode() {
		return trimmingManCode;
	}

	public void setTrimmingManCode(String trimmingManCode) {
		this.trimmingManCode = trimmingManCode;
	}

	public String getClassNoName() {
		return classNoName;
	}

	public void setClassNoName(String classNoName) {
		this.classNoName = classNoName;
	}

	public Date getStartTrimming() {
		return startTrimming;
	}

	public void setStartTrimming(Date startTrimming) {
		this.startTrimming = startTrimming;
	}

	public Date getEndTrimming() {
		return endTrimming;
	}

	public void setEndTrimming(Date endTrimming) {
		this.endTrimming = endTrimming;
	}

	public BigDecimal getTrimmingHours() {
		return trimmingHours;
	}

	public void setTrimmingHours(BigDecimal trimmingHours) {
		this.trimmingHours = trimmingHours;
	}

	public BigDecimal getTension() {
		return tension;
	}

	public void setTension(BigDecimal tension) {
		this.tension = tension;
	}

	public BigDecimal getsLinearSpeed() {
		return sLinearSpeed;
	}

	public void setsLinearSpeed(BigDecimal sLinearSpeed) {
		this.sLinearSpeed = sLinearSpeed;
	}

	public BigDecimal getsCuttingSpeed() {
		return sCuttingSpeed;
	}

	public void setsCuttingSpeed(BigDecimal sCuttingSpeed) {
		this.sCuttingSpeed = sCuttingSpeed;
	}

	public BigDecimal getsTrimmingFlow() {
		return sTrimmingFlow;
	}

	public void setsTrimmingFlow(BigDecimal sTrimmingFlow) {
		this.sTrimmingFlow = sTrimmingFlow;
	}

	public BigDecimal getActualQty() {
		return actualQty;
	}

	public void setActualQty(BigDecimal actualQty) {
		this.actualQty = actualQty;
	}

	public String getSpec() {
		return spec;
	}

	public void setSpec(String spec) {
		this.spec = spec;
	}

	public String getPnType() {
		return pnType;
	}

	public void setPnType(String pnType) {
		this.pnType = pnType;
	}

	public BigDecimal getSideLen() {
		return sideLen;
	}

	public void setSideLen(BigDecimal sideLen) {
		this.sideLen = sideLen;
	}

	public String getProductRank() {
		return productRank;
	}

	public void setProductRank(String productRank) {
		this.productRank = productRank;
	}

	public String getSplitJoint() {
		return splitJoint;
	}

	public void setSplitJoint(String splitJoint) {
		this.splitJoint = splitJoint;
	}

	public Integer getIsAssign() {
		return isAssign;
	}

	public void setIsAssign(Integer isAssign) {
		this.isAssign = isAssign;
	}

	public Date getCreatedTime() {
		return createdTime;
	}

	public void setCreatedTime(Date createdTime) {
		this.createdTime = createdTime;
	}
}
