/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.fb.aio.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.math.BigDecimal;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="interface_eap_gold_break")
@DynamicUpdate
@DynamicInsert
public class EapGoldBreak {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private Long id;

	/**
	 * 设备类型
	 */
	@Column(length=50)
	private String equipType;

	/**
	 * 晶棒编号
	 */
	@Column(length=50)
	private String sn;

	/**
	 * 设备编号
	 */
	@Column(length=50)
	private String equipNo;

	/**
	 * 浪费前线量
	 */
	@Column(length=20)
	private BigDecimal lenBefore;

	/**
	 * 浪费后线量
	 */
	@Column(length=20)
	private BigDecimal lenAfter;

	/**
	 * 浪费线量
	 */
	@Column(length=20)
	private BigDecimal wasteLen;

	/**
	 * 断线原因
	 切方断线原因：边皮砸断，压线断线,线量不符， 导轮深槽， 滑轮晃动，多线头，摆角抱死，无原点， 切入边皮提刀断线，跳线，切割能力不足排旧线， 炸线断线、 水帘堵塞，导轮轴异常， 设备原因， 断电/闪停，脱线， 单晶内存在钢线 , 出刀口断线  入刀口断线  中主轴伺服故障
	 */
	@Column(length=50)
	private String wasteReason;

	/**
	 * 操作人员
	 */
	@Column(length=50)
	private String operator;

	/**
	 * 创建日期
	 */
	@Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
	private Date createdTime;


	public EapGoldBreak() {
	}

	public EapGoldBreak(Long id) {
		this.id = id;
	}
}
