/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.fb.aio.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.math.BigDecimal;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="interface_eap_grinding_machine")
@DynamicUpdate
@DynamicInsert
public class EapGrindingMachine {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;

	/**
	 * 磨削机编号
	 */
    @Column(length=50)
    private String equipNo;

	/**
	 * 方棒SN
	 */
    @Column(length=50)
    private String sn;

	/**
	 * 磨面员工号
	 */
    @Column(length=20)
    private String grindingMan;

	/**
	 * 人员代码
	 */
	@Column(length=20)
	private String grindingManCode;

	/**
	 * 班次
	 */
	@Column(length=50)
	String classNoName;

	/**
	 * 开始磨削时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date startGrinding;

	/**
	 * 结束磨削时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date endGrinding;

	/**
	 * 方棒磨削工时
	 */
    @Column(length=20)
    private BigDecimal grindingHours;

	/**
	 * 磨削开始时的水流量
	 */
    @Column(length=20)
    private BigDecimal sGrindingFlow;

	/**
	 * 加工规格
	 */
	@Column(length=20)
	private String spec;

	/**
	 * PN型
	 */
	@Column(length=20)
	private String pnType;

	/**
	 * 设定边长
	 */
	@Column(length=20)
	private BigDecimal sideLen;



	/**
	 * EAP直径max(mm)
	 */
	@Column(length=19)
	private BigDecimal eapDiameterMax;

	/**
	 * EAP直径min(mm)
	 */
	@Column(length=19)
	private BigDecimal eapDiameterMin;

	/**
	 * EAP边长1(mm)
	 */
	@Column(length=19)
	private BigDecimal eapSide1;

	/**
	 * EAP边长2(mm)
	 */
	@Column(length=19)
	private BigDecimal eapSide2;

	/**
	 * EAP边长1(mm)
	 */
	@Column(length=19)
	private BigDecimal eapSide3;

	/**
	 * EAP边长2(mm)
	 */
	@Column(length=19)
	private BigDecimal eapSide4;

	/**
	 * EAP边长1(mm)
	 */
	@Column(length=19)
	private BigDecimal eapSide5;

	/**
	 * EAP边长2(mm)
	 */
	@Column(length=19)
	private BigDecimal eapSide6;





	/**
	 * 产品等级
	 */
	@Column(length=20)
	private String productRank;

	/**
	 * 拼接
	 */
	@Column(length=20)
	private String splitJoint;

	/**
	 * 是否指定订单
	 */
	@Column(length=3)
	private Integer isAssign;

	/**
	 * 一体机编码
	 */
	@Column(length=50)
	private String oneBodyMachineCode;

	/**
	 * 创建日期
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createdTime;

	public BigDecimal getsGrindingFlow() {
		return sGrindingFlow;
	}

	public void setsGrindingFlow(BigDecimal sGrindingFlow) {
		this.sGrindingFlow = sGrindingFlow;
	}

	public EapGrindingMachine() {
	}

	public EapGrindingMachine(Integer id) {
		this.id = id;
	}
}
