/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.fb.aio.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="interface_eap_grinding_task")
@DynamicUpdate
@DynamicInsert
public class EapGrindingTask {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 开方磨削机编号
	 */
    @Column(length=50)
    private String equipNo;
    
	/**
	 * 设备类型
	 */
    @Column(length=10)
    private String equipType;
    
	/**
	 * 触发信号（水流量低、断线、空线、停水、停气、停电、砂轮加工长度（4500mm）检测
	 */
    @Column(length=20)
    private String triggerType;
    
	/**
	 * 创建时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createdTime;
    

	public EapGrindingTask() {
	}

	public EapGrindingTask(Long id) {
		this.id = id;
	}
}
