/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.fb.aio.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @Author
 * @Description：圆棒反切记录表
 * @Date: Create in
 * @Modified By:
 */
@Data
@Entity
@Table(name = "production_back_cutting_record")
@DynamicUpdate
@DynamicInsert
public class ProductionBackCuttingRecord {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    /**
     * 晶段编号
     */
    @Column(length = 100)
    private String segmentNo;


    /**
     * 晶段长度
     */
    @Column(length = 19)
    private BigDecimal barLength;

    /**
     * 画线开始时间
     */
    @Column(length = 19)
    @Temporal(TemporalType.TIMESTAMP)
    private Date lineStartTime;

    /**
     * 画线结束时间
     */
    @Column(length = 19)
    @Temporal(TemporalType.TIMESTAMP)
    private Date lineEndTime;

    /**
     * 反切后长度
     */
    @Column(length = 19)
    private BigDecimal backLength;

    /**
     * 操作人员
     */
    @Column(length = 50)
    private String userName;

    /**
     * 班次
     */
    @Column(length = 50)
    private String classNo;

    /**
     * 班组
     */
    @Column(length = 50)
    private String teamGroup;

    /**
     * 返切长度
     */
    @Column(length = 19)
    private BigDecimal cutLength;

    /**
     * 返切原因
     */
    @Column(length = 256)
    private String cause;

    /**
     * 是否取样片
     */
    @Column(length = 19)
    private Long isTakeSample;

    /**
     * 反切刀数
     */
    @Column(length = 10)
    private Integer knifeNum;

    /**
     * 备注
     */
    @Column(length = 256)
    private String remark;

    /**
     * 截断状态 0：未截断，1：已截断
     */
    @Column
    private Boolean status;

    /**
     * 是否为分段反切
     */
    @Column
    private Boolean backCutType;

    public ProductionBackCuttingRecord() {
    }

    public ProductionBackCuttingRecord(Long id) {
        this.id = id;
    }
}
