package com.sw.mes.fb.aio.service;


import com.sw.mes.core.base.BaseService;
import com.sw.mes.core.dto.EapCutCraftDto;
import com.sw.mes.core.response.ResponsePage;
import com.sw.mes.core.response.Result;
import com.sw.mes.core.utils.RequestPage;
import com.sw.mes.fb.aio.dto.*;
import com.sw.mes.fb.aio.entity.EapCutCraft;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
* @Author
* @Description：
* @Date:
* @Modified By:
*/
public interface EapCutCraftService extends BaseService<EapCutCraft> {
    ResponsePage<TurnStoreOtherDto> getCutRecordListPage(String crystalType, String search_gte_startCut, String search_lt_startCut, String search_gte_endCut, String search_lt_endCut, String search_like_roundSN, String search_like_equipNo, Pageable pageable);

    EapCutCraft getCutCraftByRoundSn(String roundSn);

    ResponsePage<EapGoldBreakReportDto> getGoldBreakListPage(String search_eq_equipType, String search_like_equipNo,
                                                             String search_like_sn, String search_lt_startTime,
                                                             String search_lt_endTime, Pageable pageable);

    ResponsePage<EapSpecificationReportDto> specificationListPage(String search_like_equip, String search_like_lotNo,
                                                                  String search_gte_startTrimming, String search_lt_startTrimming,
                                                                  String search_gte_endTrimming, String search_lt_endTrimming, Pageable pageable);

    ResponsePage<EapGrindingHoursReportDto> grindingReportListPage(String search_like_equip, String search_like_sn, String search_gte_startGrinding, String search_lt_startGrinding, String search_gte_endGrinding, String search_lt_endGrinding, Pageable pageable);

    List<TurnStoreOtherVo> getCutRecordList(String crystalType, String search_gte_startCut, String search_lt_startCut, String search_gte_endCut, String search_lt_endCut, String search_like_roundSN, String search_like_equipNo, RequestPage requestPage);

    Result saveEapCutCraftInfo(EapCutCraftDto eapCutCraftDto ,Integer isAuto);

    /**
     * 更新旧数据
     * @param staId
     * @param endId
     */
    void updateOld(Long staId ,Long endId);
}
