package com.sw.mes.fb.checkout.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@ApiModel(value = "方棒抽检Dto")
public class PickUpCheckDto {

    private Integer id;
     @ApiModelProperty(value = "设备号" )
     String equipmentCode;
     @NotNull(message = "晶棒编号sectionNo不能空")
     @ApiModelProperty(value = "晶棒编号" )
     String sectionNo;
     @ApiModelProperty(value = "规格" )
     String specification;
     @ApiModelProperty(value = "检验类型 （抽检）" )
     String checkType;
     @ApiModelProperty(value = "边距max" )
     BigDecimal marginMax;
     @ApiModelProperty(value = "边距min" )
     BigDecimal marginMin;
     @ApiModelProperty(value = "直径max" )
     BigDecimal diameterMax;
     @ApiModelProperty(value = "直径min" )
     BigDecimal diameterMin;
     @ApiModelProperty(value = "玄宽" )
     BigDecimal xuankuan;
     @ApiModelProperty(value = "有效长度" )
     BigDecimal effectiveLength;
     @ApiModelProperty(value = "粗糙度" )
     BigDecimal roughness;
     @ApiModelProperty(value = "未磨到" )
     BigDecimal notGrinded;
     @ApiModelProperty(value = "裂痕" )
     BigDecimal crack;
     @ApiModelProperty(value = "砂轮印" )
     BigDecimal grindingWheelMark;
     @ApiModelProperty(value = "⁮线痕" )
     BigDecimal lineMarks;
     @ApiModelProperty(value = "斜面" )
     BigDecimal inclinedPlane;
     @ApiModelProperty(value = "崩边" )
     BigDecimal chipping;
     @ApiModelProperty(value = "其他" )
     String other;
     @ApiModelProperty(value = "合格判定" )
     Integer enable;
     @ApiModelProperty(value = "备注" )
     String remark;
     @ApiModelProperty(value = "创建人" )
     String createUser;
     @ApiModelProperty(value = "创建时间" )
     @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
     Date createTime;
     @ApiModelProperty(value = "修改人" )
     String updateUser;
     @ApiModelProperty(value = "修改时间" )
     @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
     Date updateTime;
}