/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.fb.checkout.entity;

import java.util.Date;
import java.math.BigDecimal;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="zhxx_fb_operate_fbjoin")
@DynamicUpdate
@DynamicInsert
public class FbJoin{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;
    
	/**
	 * 方棒编号
	 */
    @Column(length=60)
    private String sectionNoFb;
    
	/**
	 * 拼棒组号
	 */
    @Column(length=400)
    private String sectionNoGroup;
    
	/**
	 * 方棒产品等级
	 */
    @Column(length=40)
    private String productLevelFb;
    
	/**
	 * 拼数
	 */
    @Column(length=10)
    private Integer stickCount;
    
	/**
	 * 拼棒总理论重量
	 */
    @Column(length=19)
    private BigDecimal theoryWeight;

	/**
	 * 方棒理论重量（kg）
	 */
	@Column(length=19)
	private BigDecimal theoryWeightFb;
    
	/**
	 * 拼棒总长度
	 */
    @Column(length=19)
    private BigDecimal totalLength;
    
	/**
	 * 单根单晶拼接长度 ,隔开
	 */
    @Column(length=100)
    private String lengthGroup;

	/**
	 * 规格
	 */
	@Column(length=100)
	private String specification;

	/**
	 * 导电类型
	 */
	@Column(length=100)
	private String conductionType;

	/**
	 * 方棒入库长度
	 */
	@Column(length=19)
	private BigDecimal inStoreLengthFb;
    
	/**
	 * 绑定人
	 */
    @Column(length=40)
    private String bindUser;
    
	/**
	 * 绑定时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date bindTime;
    
	/**
	 * 解绑人
	 */
    @Column(length=40)
    private String unbindUser;
    
	/**
	 * 解绑时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date unbindTime;
    
	/**
	 * 状态 0未解绑 1已解绑
	 */
    @Column(length=10)
    private Integer state;

	/**
	 * 送检状态 0未送检 1已送检
	 */
	@Column(length=10)
	private Integer isSend;

	/**
	 * 解绑原因
	 */
	@Column(length=255)
	private String relieveReason;
	
	
	/**
	 * 拼缝总长
	 */
	@Column(length=19)
	private BigDecimal gapTotal;
    

	public FbJoin() {
	}

	public FbJoin(Integer id) {
		this.id = id;
	}
}
