/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.fb.checkout.entity;

import java.util.Date;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="field_extension_record")
@DynamicUpdate
@DynamicInsert
public class FieldExtensionRecord{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 关联表Id
	 */
    @Column(length=19)
    private Long associatedId;
    
	/**
	 * 字段名
	 */
    @Column(length=20)
    private String fieldName;
    
	/**
	 * 字段值
	 */
	@Column(length=20)
	private String fieldValue;

	/**
	 * 序号
	 */
	@Column(length=2)
	private Integer orderNo;



    
	/**
	 * 创建时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreate;
    

	public FieldExtensionRecord() {
	}

	public FieldExtensionRecord(Long id) {
		this.id = id;
	}
}
