/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.fb.checkout.entity;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@Entity
@Table(name = "zhxx_operate_check_out_data_log")
@DynamicUpdate
@DynamicInsert
public class OperateCheckOutDataLog {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;




    /**
     * 晶段编号(圆)
     */
    @Column(length = 100)
    private String ybSectionNo;

    /**
     * 晶段编号(方棒)
     */
    @Column(length = 100)
    private String fbSectionNo;


    /**
     * 单晶组合
     */
    @Column(length = 255)
    private String fbNoGroup;


    /**
     * 单晶段号(新)
     */
    @Column(length = 50)
    private String segmentNo;

    /**
     * 检验线编号
     */
    @Column(length = 20)
    private String checkLineNo;

    /**
     * 方棒评级\入库类别
     */
    @Column(length = 255)
    private String productLevelFb;

    /**
     * 规格
     */
    @Column(length = 100)
    private String specification;

    // 掺杂剂
    @Column(length = 25)
    private String dopant;

    /**
     * 导电型号
     */
    @Column(length = 100)
    private String conductionType;


    /**
     * 是否外发【0：默认，否；1：是；】(新）
     */
    @Column(length = 3)
    private Integer outGoing;

    /**
     * 产品等级/产品等级
     */
    @Column(length = 100)
    private String productLevel;

    /**
     * 检验类型
     */
    @Column(length = 100)
    private String checkoutName;

    /**
     * 外观检验返切【0：默认，否；1：是；】（新）
     */
    @Column(length = 2)
    private Integer appearanceBackCut;


    /**
     * 复检次数（新）
     */
    @Column(length = 3)
    private Integer retestNo;

    /**
     * 评级时间(新)
     */
    @Column(length = 19)
    @Temporal(TemporalType.TIMESTAMP)
    private Date ratingTime;

    /**
     * 检验时间
     */
    @Column(length = 19)
    @Temporal(TemporalType.TIMESTAMP)
    private Date checkTime;

    /**
     * 检验日期（新）
     */
    @Column(length=20)
    private String checkDate;


    /**
     * 方棒减长长度(损耗)(新）
     */
    @Column(length = 19)
    private BigDecimal reducedLength;


    /**
     * 圆棒入库长度(mm)
     */
    @Column(length = 19)
    private BigDecimal instoreLengthYb;

    /**
     * 方棒长度
     */
    @Column(length = 19)
    private BigDecimal length;

    /**
     * 方棒理论重量（kg）
     */
    @Column(length = 19)
    private BigDecimal theoryWeightFb;

    /**
     * 方棒实际重量
     */
    @Column(length = 19)
    private BigDecimal weight;

    /**
     * 拼棒总长(mm)
     */
    @Column(length = 19)
    private BigDecimal spellBarLength;


    /**
     * 拼数
     */
    @Column(length = 10)
    private Integer sticksCount;

    /**
     * 晶段类型
     */
    @Column(length = 40)
    private String sectionType;

    /**
     * 是否返切【0：默认，否；1：是；】（新）
     */
    @Column(length = 2)
    private Integer backCut;

    /**
     * 直径max
     */
    @Column(length = 19)
    private BigDecimal diameterMax;

    /**
     * 直径min
     */
    @Column(length = 19)
    private BigDecimal diameterMin;

    /**
     * 等级码（新）
     */
    @Column(length=100)
    private String levelCode;

    /**
     * 损耗长度
     */
    @Column(length = 19)
    private BigDecimal consumeLengthYb;

    /**
     * 损耗类型(新)
     */
    @Column(length = 20)
    private String consumeType;

    /**
     * A电阻率均值（新）
     */
    @Column(length = 19,name = "mean_resistivity_a")
    private BigDecimal meanResistivityA;

    /**
     * B电阻率均值（新）
     */
    @Column(length = 19,name = "mean_resistivity_b")
    private BigDecimal meanResistivityB;

    /**
     * A少子寿命均值（新）
     */
    @Column(length = 19,name = "mean_carrier_lifetime_a")
    private BigDecimal meanCarrierLifetimeA;

    /**
     * B少子寿命均值（新）
     */
    @Column(length = 19,name = "mean_carrier_lifetime_b")
    private BigDecimal meanCarrierLifetimeB;


    /**
     * T段电阻率（新）
     */
    @Column(length = 19)
    private BigDecimal tResistivity;

    /**
     * w段电阻率（新）
     */
    @Column(length = 19)
    private BigDecimal wResistivity;

    /**
     * T段少子寿命（新）
     */
    @Column(length = 19)
    private BigDecimal tCarrierLifetime;

    /**
     * w段少子寿命（新）
     */
    @Column(length = 19)
    private BigDecimal wCarrierLifetime;

    /**
     * T段氧含量（新）
     */
    @Column(length = 19)
    private BigDecimal tOxygenContent;

    /**
     * w段氧含量（新）
     */
    @Column(length = 19)
    private BigDecimal wOxygenContent;

    /**
     * T段碳含量（新）
     */
    @Column(length = 19)
    private BigDecimal tCarbonContent;

    /**
     * w段碳含量（新）
     */
    @Column(length = 19)
    private BigDecimal wCarbonContent;

    /**
     * 棱孔距头位置（新）
     */
    @Column(length = 11)
    private Integer holePosition;

    /**
     * 棱孔长度（新）
     */
    @Column(length = 11)
    private Integer holeLength;

    /**
     * 崩边距头位置（新）
     */
    @Column(length = 11)
    private Integer chipPosition ;

    /**
     * 崩边长度（新）
     */
    @Column(length = 11)
    private Integer chipLength;

    /**
     * 未磨出距头位置（新）
     */
    @Column(length = 11)
    private Integer unfinishedPosition;

    /**
     * 未磨出长度（新）
     */
    @Column(length = 11)
    private Integer unfinishedLength;

    /**
     * 线痕距头位置（新）
     */
    @Column(length = 11)
    private Integer linePosition;

    /**
     * 线痕长度（新）
     */
    @Column(length = 11)
    private Integer lineLength;

    /**
     * 磨轮印距头位置（新）
     */
    @Column(length = 11)
    private Integer sealPosition;

    /**
     * 磨轮印长度（新）
     */
    @Column(length = 11)
    private Integer sealLength;


    /**
     *  刀痕/划伤距头位置（新）
     */
    @Column(length = 11)
    private Integer scratchesPosition;

    /**
     *  刀痕/划伤长度（新）
     */
    @Column(length = 11)
    private Integer scratchesLength;


    /**
     *  面内踏陷距头位置（新）
     */
    @Column(length = 11)
    private Integer stepPosition;

    /**
     *  面内踏陷长度（新）
     */
    @Column(length = 11)
    private Integer stepLength;

    /**
     * 对角线max
     */
    @Column(length = 19)
    private BigDecimal chordLengthMax;

    /**
     * 对角线min
     */
    @Column(length = 19)
    private BigDecimal chordLengthMin;

    /**
     * 边长max
     */
    @Column(length = 19)
    private BigDecimal sideLengthMax;

    /**
     * 边长min
     */
    @Column(length = 19)
    private BigDecimal sideLengthMin;

    /**
     * 边宽max（新）
     */
    @Column(length = 19)
    private BigDecimal sideWideMax;

    /**
     * 边宽min（新）
     */
    @Column(length = 19)
    private BigDecimal sideWideMin;



    /**
     * 倒角max(新）
     */
    @Column(length = 19)
    private BigDecimal chamferMax;

    /**
     * 倒角min(新）
     */
    @Column(length = 19)
    private BigDecimal chamferMin;


    /**
     * 垂直度max
     */
    @Column(length = 19)
    private BigDecimal verticalityMax;

    /**
     * 垂直度min
     */
    @Column(length = 19)
    private BigDecimal verticalityMin;

    /**
     * 单晶拉制异常（新）
     */
    @Column(length = 50)
    private String crystalAbnormal;

    /**
     * 完结标识（新）
     */
    @Column(length = 50)
    private String closureIdentification;


    /**
     * 模块（拉晶车间）（新）
     */
    @Column(length = 50)
    private String crystalWorkshop;


    /**
     * 片区（新）
     */
    @Column(length = 20)
    private String area;

    /**
     * 炉台类型【0:默认；0-量产;2-研发;】（新）
     */
    @Column(length = 3)
    private Integer furnaceType;

    /**
     * 工厂（新）
     */
    @Column(length = 100)
    private String factory;


    /**
     * 炉次号（新）
     */
    @Column(length = 80)
    private String lotNo;

    /**
     *   工单类型(开方工单 )(新)
     */
    @Column(length = 80)
    private String workOrderType;


    /**
     * 工单编号(新)
     */
    @Column(length=100)
    private String workOrderNo;

    /**
     * 物料编码（新）
     */
    @Column(length = 150)
    private String materialCode;

    /**
     * 产品简称(新)
     */
    @Column(length=120)
    private String  abbreviation;

    /**
     * 产品配方(新)
     */
    @Column(length=120)
    private String  formulation;

    /**
     * 评级标准版本(新)
     */
    @Column(length = 50)
    private String gradeVersion;


    /**
     * 检验人员
     */
    @Column(length = 40)
    private String checkUserName;

    /**
     * 检验班组（新）
     */
    @Column(length = 40)
    private String checkClass;

    /**
     * 检验类型id
     */
    @Column(length = 10)
    private Integer checkoutId;

    /**
     * 复检类型
     */
    @Column(length = 40)
    private String reCheckType;


    /**
     * 方棒入库长度
     */
    @Column(length = 19)
    private BigDecimal instoreLengthFb;

    /**
     * 圆棒长度
     */
    @Column(length = 19)
    private BigDecimal actualLength;


    /**
     * 崩损(mm)
     */
    @Column(length = 19)
    private BigDecimal collapseLoss;


    /**
     * 长度斜(mm)
     */
    @Column(length = 19)
    private BigDecimal lengthSlope;

    /**
     * 方棒备注
     */
    @Column(length = 2000)
    private String squareRodRemark;

    /**
     * 产品最终评级
     */
    @Column(length = 50)
    private String ybLevel;

    /**
     * 实验最终评级
     */
    @Column(length = 20)
    private String experiLevel;

    /**
     * 圆棒实验等级
     */
    @Column(length = 100)
    private String ybExperiLevel;

    /**
     * 方棒实验等级
     */
    @Column(length = 100)
    private String fbExperiLevel;

    /**
     * 料号
     */
    @Column(length = 80)
    private String materialNumber;

    /**
     * 订单号
     */
    @Column(length = 50)
    private String orderNo;

    /**
     * 晶体灰皮长度(mm)
     */
    @Column(length = 19)
    private BigDecimal crystalGrayness;

    /**
     * 方棒灰皮长度(mm)
     */
    @Column(length = 19)
    private BigDecimal squareRodGrayness;

    /**
     * 线痕长度(mm)
     */
    @Column(length = 19)
    private BigDecimal lineScratch;

    /**
     * 刀痕长度(mm)
     */
    @Column(length = 19)
    private BigDecimal knifeScratch;

    /**
     * 色差
     */
    @Column(length = 19)
    private BigDecimal colourDifference;

    /**
     * 阴阳面
     */
    @Column(length = 19)
    private BigDecimal yinYangFace;

    /**
     * 水印
     */
    @Column(length = 19)
    private BigDecimal waterMark;

    /**
     * 平面手感
     */
    @Column(length = 19)
    private BigDecimal flatHandle;

    /**
     * 外圆手感
     */
    @Column(length = 19)
    private BigDecimal roundHandle;

    /**
     * 砂轮印
     */
    @Column(length = 19)
    private BigDecimal wheelMark;

    /**
     * 滚轮印
     */
    @Column(length = 19)
    private BigDecimal rollerPrint;

    /**
     * 划痕长度(mm)
     */
    @Column(length = 19)
    private BigDecimal scratch;

    /**
     * 头斜(mm)
     */
    @Column(length = 19)
    private BigDecimal headSlope;

    /**
     * 尾斜(mm)
     */
    @Column(length = 19)
    private BigDecimal tailSlope;

    /**
     * 弧长投影max
     */
    @Column(length = 19)
    private BigDecimal projectionMax;

    /**
     * 弧长投影min
     */
    @Column(length = 19)
    private BigDecimal projectionMin;


    /**
     * 平面锥度max
     */
    @Column(length = 19)
    private BigDecimal planeTaperMax;

    /**
     * 平面锥度min
     */
    @Column(length = 19)
    private BigDecimal planeTaperMin;

    /**
     * 平边晶向
     */
    @Column(length = 50)
    private String flatOrientation;

    /**
     * 晶体晶向
     */
    @Column(length = 10)
    private String orientation;

    /**
     * 放行长度
     */
    @Column(length = 19)
    private BigDecimal concessionLength;

    /**
     * 返切长度(mm)
     */
    @Column(length = 19)
    private BigDecimal recutLength;

    /**
     * 未磨到长度(mm)
     */
    @Column(length = 19)
    private BigDecimal noFriction;


    /**
     * 缝宽(mm)
     */
    @Column(length = 19)
    private BigDecimal crackWidth;

    /**
     * 其他备注
     */
    @Column(length = 255)
    private String otherRemark;

    /**
     * 塌边
     */
    @Column(length = 19)
    private BigDecimal collapse;

    /**
     * 崩损灰皮非边缘
     */
    @Column(length = 19)
    private BigDecimal brokenGreyNoEdge;

    /**
     * 灰皮非边缘
     */
    @Column(length = 19)
    private BigDecimal greyHideCenter;

    /**
     * 灰皮边缘
     */
    @Column(length = 19)
    private BigDecimal greyHideEdge;

    /**
     * 亮斑
     */
    @Column(length = 19)
    private BigDecimal hotSpot;

    /**
     * 砂轮亮点
     */
    @Column(length = 19)
    private BigDecimal wheelHighLights;

    /**
     * 尺寸异常长度(mm)
     */
    @Column(length = 19)
    private BigDecimal sizeException;

    /**
     * 棱崩
     */
    @Column(length = 19)
    private BigDecimal ridgeBroken;

    /**
     * 裂纹
     */
    @Column(length = 19)
    private BigDecimal crack;

    /**
     * 领料来源值
     */
    @Column(length = 100)
    private String materialSourceValue;

    /**
     * 方棒类型尺寸
     */
    @Column(length = 50)
    private String sizeType;

    /**
     * 订单类型【1:量产；2:试验；3:送样；4:返工；】
     */
    @Column(length = 11)
    private String orderType;

    /**
     * 崩损灰皮总和
     */
    @Column(length = 19)
    private BigDecimal damageGreySum;

    /**
     * 异常总和
     */
    @Column(length = 19)
    private BigDecimal abnormalSum;

    /**
     * 崩损灰皮边缘
     */
    @Column(length = 19)
    private BigDecimal damageGreyHideEdge;

    /**
     * 方棒边长差
     */
    @Column(length = 19)
    private BigDecimal sideLengthDiffer;

    /**
     * 一体机编号
     */
    @Column(length = 40)
    private String deviceNo;

    /**
     * 温度
     */
    @Column(length = 16)
    private String temperature;

    /**
     * 计划订单号
     */
    @Column(length = 100)
    private String planOrderNo;

    /**
     * 计划订单类型
     */
    @Column(length = 8)
    private String planOrderType;

    /**
     * 计划物料编码
     */
    @Column(length = 50)
    private String planMaterialCode;

    /**
     * 计划产品等级
     */
    @Column(length = 20)
    private String planGrade;

    /**
     * 计划拼数
     */
    @Column(length = 20)
    private String planStickCount;

    /**
     * 计划长度范围
     */
    @Column(length = 20)
    private String planLenRange;

    /**
     * 计划掺杂剂
     */
    @Column(length = 20)
    private String planDopant;

    /**
     * 计划导电型号
     */
    @Column(length = 8)
    private String planConductiveType;

    /**
     * 计划电阻率
     */
    @Column(length = 255)
    private String planResistivity;

    /**
     * 计划规格
     */
    @Column(length = 20)
    private String planSpecs;

    /**
     * 方棒减长
     */
    @Column(length = 19)
    private BigDecimal lengthPrep;

    /**
     * 检验类型
     */
    @Column(length = 100)
    private String checkType;

    /**
     * 拼缝处崩
     */
    @Column(length = 19)
    private BigDecimal patchworkCollapse;

    /**
     * 拼缝处裂
     */
    @Column(length = 19)
    private BigDecimal patchworkCrack;

    /**
     * 晶棒编号
     */
    @Column(length = 150)
    private String crystalNo;

    /**
     * 直径判定
     */
    @Column(length = 80)
    private String diamDecide;

    /**
     * 方棒尺寸是否抽检【0：默认，否；1：是；】
     */
    @Column(length = 3)
    private Integer isFbSizeCheck;

    /**
     * 单晶组合
     */
    @Column(length = 150)
    private String sectionCompose;

    /**
     * 减异常入库长度
     */
    @Column(length = 19)
    private BigDecimal abnormalLength;

    /**
     * 一二三类方行(异常)长度
     */
    @Column(length = 19)
    private BigDecimal classAbnormalLength;

    /**
     * 一二三类方行(异常)长度理论
     */
    @Column(length = 19)
    private BigDecimal theoryAbnormalLength;

    /**
     * 合计长度
     */
    @Column(length = 19)
    private BigDecimal totalLength;

    /**
     * 合计理论重量
     */
    @Column(length = 19)
    private BigDecimal theoryTotalLength;

    /**
     * 修改人
     */
    @Column(length = 50)
    private String updateUser;

    /**
     * 修改时间
     */
    @Column(length = 19)
    @Temporal(TemporalType.TIMESTAMP)
    private Date updateTime;

    /**
     * 操作类型:0新增，1修改
     */
    @Column(length = 10)
    private Integer operateType;

    /**
     * 操作备注
     */
    @Column(length = 250)
    private String remarks;

    /**
     * 操作人
     */
    @Column(length = 50)
    private String operator;

    /**
     * 操作时间
     */
    @Column(length = 19)
    @Temporal(TemporalType.TIMESTAMP)
    private Date operateTime;

    /**
     * 4M标识 - 抽检标识
     */
    @Column(length = 20)
    private String flag4M;

    //外观异常数据===========
    /**
     * 缺陷代码
     */
    @Column(length = 30)
    private String defectCode;

    /**
     * 缺陷描述
     */
    @Column(length = 1000)
    private String defectDescription;

    /**
     * 缺陷位置
     */
    @Column(length = 80)
    private String defectSite;

    /**
     * 抽检合格 1为合格，0为不合格
     */
    @Column
    private Integer enableCheck;


    /**
     * 方棒边长
     */
    @ApiModelProperty(value = "方棒边长")
    private String sideLengthRange;

    /**
     * 方棒边长上限
     */
    @ApiModelProperty(value = "方棒边长上限")
    private String sideLengthRangeMax;

    /**
     * 方棒边长下限
     */
    @ApiModelProperty(value = "方棒边长下限")
    private String sideLengthRangeMin;


    /**
     * 色差距头位置（新）
     */
    @Column(length = 11)
    private Integer difcolorPosition;

    /**
     * 色差长度（新）
     */
    @Column(length = 11)
    private Integer difcolorLength;

    /**
     * 加工工艺（新）
     */
    @Column(length = 40)
    private String grindCrafts;


    /**
     * 总体缺陷长度（新）
     */
    @Column(length = 19)
    private BigDecimal totoal;

    /**
     * 视觉检测晶棒总长度（新）
     */
    @Column(length = 19)
    private BigDecimal ccdLength;


    /**
     * 缝宽+斜（新）
     */
    @Column(length = 19)
    private BigDecimal crackAndSlope;
    /**
     * 长端长度（新）
     */
    @Column(length = 19)
    private BigDecimal longLength;
    /**
     * 短端长度（新）
     */
    @Column(length = 19)
    private BigDecimal shortLength;

    /**
     * 检测工站号（新）
     */
    @Column(length = 40)
    private String checkStation;

    /**
     * 复检标记，0为未复检，1为已复检，3为跳过复检（新）
     */
    @Column(length = 11)
    private Integer recheckFlag;
    /**
     *复检工站号，0-9，代表10个复检工站（新）
     */
    @Column(length = 11)
    private Integer recheckStation;


    /**
     * 复检时间（新）
     */
    @Column(length = 40)
    private String recheckTime;

    /**
     * 复检员工姓名（新）
     */
    @Column(length = 40)
    private String recheckName;
    /**
     * 复核原因（新）
     */
    @Column(length = 40)
    private String recheckReason;

    /**
     *复检标记，0表示OK，1表示NG（新）
     */
    @Column(length = 11)
    private Integer recheckResult;

    /**
     * 立即进入人工复核线:0表示按复检提交数据处理，1表示直接进入人工复核线复核确认（新）
     */
    @Column(length = 11)
    private Integer recheckImediate;

    /**
     * 线痕长度（新）
     */
    @Column(length = 11)
    private Integer sawLength;
    /**
     * 磨轮印（新）
     */
    @Column(length = 11)
    private Integer wheelLength;
    /**
     * 刀痕（新）
     */
    @Column(length = 11)
    private Integer toolLength;
    /**
     * 面内缺陷（新）
     */
    @Column(length = 11)
    private Integer defectLength;
    /**
     * 划痕（新）
     */
    @Column(length = 11)
    private Integer scratchLength;
    /**
     * 粗磨未磨出（新）
     */
    @Column(length = 11)
    private Integer polishunfinishedLength;

    /**
     * 来料少长度（新）
     */
    @Column(length = 11)
    private Integer insufficientLength;


    public OperateCheckOutDataLog() {
    }

    public OperateCheckOutDataLog(Long id) {
        this.id = id;
    }
}
