/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.fb.instoreapply.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="zhxx_fb_instore_apply")
@DynamicUpdate
@DynamicInsert
public class InstoreApply {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;

	/**
	 * 入库批次
	 */
    @Column(length=80)
    private String orderNo;

	/**
	 * 入库时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date time;

	/**
	 * 入库日期
	 */
    @Column(length=10)
	@Temporal(TemporalType.DATE)
    private Date date;

	/**
	 * 排序
	 */
    @Column(length=10)
    private Integer sort;

	/**
	 * 单晶颗数
	 */
    @Column(length=10)
    private Integer count;

	/**
	 * 备注
	 */
    @Column(length=255)
    private String remark;

	/**
	 * 入库人
	 */
    @Column(length=80)
    private String user;

	/**
	 * 产品等级
	 */
    @Column(length=80)
    private String productLevelName;

	/**
	 * 状态(未打印、已打印)
	 */
	@Column(length = 20)
	private String state;

	/**
	 * 去向
	 */
	@Column(length=80)
	private String hasGone;

	/**
	 * 综计是否接收(1:已经接受)
	 */
	@Column(length=10)
	private Integer isConfirm;


	public InstoreApply() {
	}

	public InstoreApply(Integer id) {
		this.id = id;
	}
}
