package com.sw.mes.fb.quality.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@Data
@ApiModel(value = "方棒代加工拉取Dto")
public class CrystalMaterialPullDto {

    @ApiModelProperty(value = "序号")
    Integer id;

    @ApiModelProperty(value = "厂牌")
    String brand;


    @ApiModelProperty(value = "领料批次号")
    String trayno;

    @ApiModelProperty(value = "单晶领取时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date datetime;

    @ApiModelProperty(value = "单晶条码编号")
    String sn;

    @ApiModelProperty(value = "拼棒组号")
    String combineno;

    @ApiModelProperty(value = "SAP订单号")
    String rodorderno;

    @ApiModelProperty(value = "物料编号")
    String rodmaterialcode;

    @ApiModelProperty(value = "库位")
    String location;

    @ApiModelProperty(value = "物料类型")
    String materialtype;

    @ApiModelProperty(value = "状态")
    String state;

    @ApiModelProperty(value = "产品类型")
    String producttype;

    @ApiModelProperty(value = "产品等级")
    String rodgrade;

    @ApiModelProperty(value = "产品实验等级")
    String rodcustomergrade;

    @ApiModelProperty(value = "导电型号")
    String conductivitytype;

    @ApiModelProperty(value = "单晶直径")
    String rodspecifications;

    @ApiModelProperty(value = "圆棒长度（mm）")
    BigDecimal rodtotallength;

    @ApiModelProperty(value = "圆棒拼棒总长度（mm）")
    BigDecimal combinelength;

    @ApiModelProperty(value = "圆棒入库长度（mm）")
    BigDecimal rodstoragelength;

    @ApiModelProperty(value = "称重(kg)")
    BigDecimal weight;

    @ApiModelProperty(value = "入库重量(kg)")
    BigDecimal rodcalcweight;

    @ApiModelProperty(value = "崩晶线（mm）")
    BigDecimal brokenline;

    @ApiModelProperty(value = "细减长（mm）")
    BigDecimal diameterlesslimitlength;

    @ApiModelProperty(value = "细总长（mm）")
    BigDecimal diameterlesstotallength;

    @ApiModelProperty(value = "扭曲")
    String Distortion;

    @ApiModelProperty(value = "晶段类型")
    String crystaltype;

    @ApiModelProperty(value = "去向")
    String rodwhereabouts;

    @ApiModelProperty(value = "合格证备注")
    String remark;

    @ApiModelProperty(value = "中心点头")
    BigDecimal resistivityheadcenter;

    @ApiModelProperty(value = "边缘点头1")
    BigDecimal resistivityheadedge1;

    @ApiModelProperty(value = "边缘点头4")
    BigDecimal resistivityheadedge4;

    @ApiModelProperty(value = "中心点尾")
    BigDecimal resistivitytailcenter;

    @ApiModelProperty(value = "边缘点尾1")
    BigDecimal resistivitytailedge1;

    @ApiModelProperty(value = "边缘点尾4")
    BigDecimal resistivitytailedge4;

    @ApiModelProperty(value = "平均电阻率")
    BigDecimal resistivity;

    @ApiModelProperty(value = "少子寿命头中心")
    BigDecimal sitionlifeheadcenter;

    @ApiModelProperty(value = "少子寿命头边缘1")
    BigDecimal sitionlifeheadedge1;

    @ApiModelProperty(value = "少子寿命头边缘2")
    BigDecimal sitionlifeheadedge2;

    @ApiModelProperty(value = "少子寿命头边缘3")
    BigDecimal sitionlifeheadedge3;

    @ApiModelProperty(value = "少子寿命头边缘4")
    BigDecimal sitionlifeheadedge4;

    @ApiModelProperty(value = "少子寿命尾中心")
    BigDecimal sitionlifetailcenter;

    @ApiModelProperty(value = "少子寿命尾边缘1")
    BigDecimal sitionlifetailedge1;

    @ApiModelProperty(value = "少子寿命尾边缘2")
    BigDecimal sitionlifetailedge2;

    @ApiModelProperty(value = "少子寿命尾边缘3")
    BigDecimal sitionlifetailedge3;

    @ApiModelProperty(value = "少子寿命尾边缘4")
    BigDecimal sitionlifetailedge4;

    @ApiModelProperty(value = "氧含量头")
    BigDecimal oxygenheadcenter;

    @ApiModelProperty(value = "氧含量尾")
    BigDecimal oxygentailcenter;

    @ApiModelProperty(value = "碳含量头")
    BigDecimal carbonheadcenter;

    @ApiModelProperty(value = "碳含量尾")
    BigDecimal carbontailcenter;

    @ApiModelProperty(value = "头部中心退火电阻率")
    BigDecimal resistivityhcavg;

    @ApiModelProperty(value = "头部边缘退火电阻率")
    BigDecimal resistivityheavg;

    @ApiModelProperty(value = "尾部中心退火电阻率")
    BigDecimal resistivitytcavg;

    @ApiModelProperty(value = "尾部边缘退火电阻率")
    BigDecimal resistivityteavg;

    @ApiModelProperty(value = "微缺陷头")
    String headdefects;

    @ApiModelProperty(value = "微缺陷尾")
    String taildefects;

    @ApiModelProperty(value = "位错W")
    String dislocation;

    @ApiModelProperty(value = "实验类型值")
    String customertypevalue;

    @ApiModelProperty(value = "复投次数")
    Integer feedtimes;

    @ApiModelProperty(value = "晶段段数(第几段)")
    Integer rodsorder;

    @ApiModelProperty(value = "段数是否是V")
    String isv;

    @ApiModelProperty(value = "段数是否是V")
    String isw;

    @ApiModelProperty(value = "见埚底尾")
    String isbottom;

    @ApiModelProperty(value = "投料量")
    BigDecimal feedingamount;

    @ApiModelProperty(value = "寿命/电阻率T中心")
    BigDecimal liferesistivityratiohc;

    @ApiModelProperty(value = "寿命/电阻率T边缘")
    BigDecimal liferesistivityratiohe;

    @ApiModelProperty(value = "寿命/电阻率W中心")
    BigDecimal liferesistivityratiotc;

    @ApiModelProperty(value = "寿命/电阻率W边缘")
    BigDecimal liferesistivityratiote;

    @ApiModelProperty(value = "最大直径")
    BigDecimal diametermax;

    @ApiModelProperty(value = "最小直径")
    BigDecimal diametermin;

    @ApiModelProperty(value = "掺杂剂")
    String dopingagent;

    @ApiModelProperty(value = "崩边长度")
    BigDecimal brokenskin;

    @ApiModelProperty(value = "头斜")
    BigDecimal obliquehead;

    @ApiModelProperty(value = "尾斜")
    BigDecimal obliquetail;

    @ApiModelProperty(value = "加工类型")
    String machiningtype;
}
