package com.sw.mes.fb.turnstore.dto;

import com.alibaba.excel.annotation.ExcelProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @author lf
 * @description 方棒组托明细导出dto
 * @date 2024/3/8 10:27
 */
@Data
public class ExportFbTurnstoreTrayItemDto {
    @ApiModelProperty(value = "工厂代码")
    @ExcelProperty(value = "工厂代码")
    String factoryName;
    @ApiModelProperty(value = "批次号")
    @ExcelProperty(value = "批次号")
    private String batchNo;
    @ApiModelProperty(value = "托号")
    @ExcelProperty(value = "托号")
    String trayNo;
    @ApiModelProperty(value = "炉台号")
    @ExcelProperty(value = "炉台号")
    String equipmentCode;
    @ApiModelProperty(value = "方棒编号")
    @ExcelProperty(value = "方棒编号")
    String sectionNo;
    @ApiModelProperty(value = "理论重量")
    @ExcelProperty(value = "理论重量")
    BigDecimal theoryWeightFb;
    @ApiModelProperty("单位")
    @ExcelProperty(value = "单位")
    private String unit="KG";
    @ApiModelProperty(value = "方棒长度")
    @ExcelProperty(value = "方棒长度")
    BigDecimal length;
    @ApiModelProperty(value = "有效长度")
    @ExcelProperty(value = "有效长度")
    private BigDecimal effectiveLength;
    @ApiModelProperty(value = "等级码")
    @ExcelProperty(value = "等级码")
    private String productLevel;
    @ApiModelProperty(value = "工单编号")
    @ExcelProperty(value = "工单编号")
    private String orderNo;
    @ApiModelProperty(value = "物料号")
    @ExcelProperty(value = "物料号")
    String materialNumber;
    @ApiModelProperty(value = "物料描述")
    @ExcelProperty(value = "物料描述")
    String materialDesc;
    @ApiModelProperty(value = "头电阻")
    @ExcelProperty(value = "头电阻")
    BigDecimal tradialCentre;
    @ApiModelProperty(value = "尾电阻")
    @ExcelProperty(value = "尾电阻")
    @JsonProperty("wRadialCentre")
    BigDecimal wradialCentre;
    @ApiModelProperty(value = "头少子")
    @ExcelProperty(value = "头少子")
    private BigDecimal life;
    @ApiModelProperty(value = "尾少子")
    @ExcelProperty(value = "尾少子")
    private BigDecimal wlife;
    @ApiModelProperty(value = "头氧含量")
    @ExcelProperty(value = "头氧含量")
    BigDecimal oxygenContentHead;
    @ApiModelProperty(value = "尾碳含量")
    @ExcelProperty(value = "尾碳含量")
    BigDecimal carbonContentTail;
    @ApiModelProperty(value = "备注")
    @ExcelProperty(value = "备注")
    String squareRodRemark;
    @ApiModelProperty(value = "组托时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ExcelProperty(value = "组托时间")
    Date time;
    @ApiModelProperty(value = "去向")
    @ExcelProperty(value = "去向")
    String hasGone;
    @ApiModelProperty(value = "状态")
    @ExcelProperty(value = "状态")
    String state;

    @ApiModelProperty(value = "操作人")
    @ExcelProperty(value = "操作人")
    String user;
    @ApiModelProperty(value = "操作时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ExcelProperty(value = "操作时间")
    Date operationTime;
    @ApiModelProperty(value = "是否完结")
    @ExcelProperty(value = "是否完结")
    String isDone;

    @ApiModelProperty(value = "发起入库日期")
//    @JsonFormat(pattern = "yyyy-MM-dd")
    @ExcelProperty(value = "发起入库日期")
    String toWmsDate;

    @ApiModelProperty(value = "发起入库时间")
//    @JsonFormat(pattern = "HH:mm:ss")
    @ExcelProperty(value = "发起入库时间")
    String toWmsTime;
    @ApiModelProperty(value = "头尾识别")
    @ExcelProperty(value = "头尾识别")
    String headTailRecognition;
    @ApiModelProperty(value = "复投次数")
    @ExcelProperty(value = "复投次数")
    Integer againNum;
    @ApiModelProperty(value = "产品简称")
    @ExcelProperty(value = "产品简称")
    String abbreviation;
    @ApiModelProperty(value = "入库操作人")
    @ExcelProperty(value = "入库操作人")
    String toWmsUser;

}
