package com.sw.mes.fb.turnstore.dto;

import io.swagger.annotations.ApiModel;
import lombok.Data;

import javax.persistence.Column;
import java.math.BigDecimal;

/**
 * @zhaoyayun
 * @20230506
 * @v1.0.0
 **/
@Data
@ApiModel(value = "方棒信息Dto")
public class FbInfoDto {

    /**
     * 编号(方棒)
     */
    @Column(length = 100)
    private String fbSectionNo;

    /**
     * 编号(圆棒)
     */
    @Column(length = 100)
    private String ybSectionNo;

    /**
     * 长棒编号
     */
    @Column(length = 80)
    private String crystalNo;

    /**
     * 掺杂剂
     */
    @Column(length = 10)
    private String dopant;


    /**
     * 规格/实际规格
     */
    @Column(length = 40)
    private String productTypeSecond;

    /**
     * T氧含量中心
     */
    @Column(length = 19)
    private BigDecimal oxygenContentHead;

    /**
     * W氧含量中心
     */
    @Column(length = 19)
    private BigDecimal oxygenContentTail;

    /**
     * T碳含量中心
     */
    @Column(length = 19)
    private BigDecimal carbonContentHead;

    /**
     * W碳含量中心
     */
    @Column(length = 19)
    private BigDecimal carbonContentTail;

    /**
     * W中心寿命
     */
    @Column(length = 19)
    private BigDecimal wCentreLife;

    /**
     * T中心寿命
     */
    @Column(length = 19)
    private BigDecimal tCentreLife;

    /**
     * 毛棒尾部少子（完结标识为W圆棒的W中心寿命）
     */
    @Column(length = 19)
    private BigDecimal WYCentreLife;

    /**
     * 产品类别
     */
    @Column(length = 20)
    private String productType;

    /**
     * 完结标识
     */
    @Column(length = 50)
    private String closureIdentification;

    /**
     * 产品等级
     */
    private String productLevel;



}
