package com.sw.mes.fb.turnstore.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.sw.mes.fb.turnstore.entity.FbToMkWmsDetail;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@ApiModel(value = "方棒MK-WMS入库接收Dto")
public class FbToMkWmsReceiptDto {

    @ApiModelProperty(value = "单据号")
    String PlanNo;

    //@ApiModelProperty(value = "生产日期")
    //String ProductDT;

    @ApiModelProperty(value = "发货日期")
    String DeliveryDT;

    @ApiModelProperty(value = "托盘号")
    String TrayNo;

    @ApiModelProperty(value = "班次")
    String Shift;

    @ApiModelProperty(value = "规则")
    String Rule;

    @ApiModelProperty(value = "试验")
    String Test;

    @ApiModelProperty(value = "操作人")
    String Operator;

    @ApiModelProperty(value = "操作时间")
    String OperateDT;

    @ApiModelProperty(value = "备注")
    String Remark;

    /**
     * 厂区
     */
    private String workShop;


    @ApiModelProperty(value = "详情数据")
    List<FbToMkWmsDetail> Detail;


    @ApiModelProperty(value = "配棒规则识别码")
    private String identifyingCode;

    @ApiModelProperty(value = "配棒规则识别名称")
    private String identifyingName;

    @ApiModelProperty(value = "边宽")
    private String borderWidth;


//    /**
//     * tRadialCentre径向电阻率T中心点
//     */
//    @ApiModelProperty(value = "头部电阻")
//    BigDecimal headResistance;
//
//
//    /**
//     * wRadialCentre径向电阻率W中心点
//     */
//    @ApiModelProperty(value = "尾部单租")
//    BigDecimal tailResistance;
}
