package com.sw.mes.fb.turnstore.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@ApiModel(value = "方棒退库复检接收Dto")
public class RecheckInspectReceiveDetailDto {

    private Integer id;
    @ApiModelProperty(value = "退库复检接收ID(fb_recheck_inspect_receive.id)")
    Integer recheckReceiveId;
    @ApiModelProperty(value = "托号")
    String trayNo;
    @ApiModelProperty(value = "晶段编码")
    String crystalNo;
    @ApiModelProperty(value = "圆棒产品等级")
    String ybProductLevel;
    @ApiModelProperty(value = "方棒产品等级")
    String fbProductLevel;
    @ApiModelProperty(value = "实验等级")
    String experGrade;
    @ApiModelProperty(value = "规格")
    String specs;
    @ApiModelProperty(value = "状态【0：默认，待确认；1：已入库；2：拒收；】")
    Integer state;
    @ApiModelProperty(value = "长度(mm)")
    BigDecimal length;
    @ApiModelProperty(value = "称重(KG)")
    BigDecimal weight;
    @ApiModelProperty(value = "理论重量(KG)")
    BigDecimal theoryWeight;
    @ApiModelProperty(value = "导电型号/型号")
    String conductiveType;
    @ApiModelProperty(value = "崩损(mm)")
    BigDecimal collapseLoss;
    @ApiModelProperty(value = "长度斜(mm)")
    BigDecimal lengthSlope;
    @ApiModelProperty(value = "晶体灰皮长度(mm)")
    BigDecimal crystalGrayness;
    @ApiModelProperty(value = "方棒灰皮长度(mm)")
    BigDecimal fbCrystalGrayness;
    @ApiModelProperty(value = "线痕长度(mm)")
    BigDecimal lineScratch;
    @ApiModelProperty(value = "划痕长度(mm)")
    BigDecimal scratch;
    @ApiModelProperty(value = "未磨到长度(mm)")
    BigDecimal noFriction;
    @ApiModelProperty(value = "尺寸异常长度(mm)")
    BigDecimal sizeException;
    @ApiModelProperty(value = "方棒备注")
    String squareRodRemark;
    @ApiModelProperty(value = "检验类型")
    String checkoutName;
    @ApiModelProperty(value = "入库类别")
    String inputType;
    @ApiModelProperty(value = "退料备注")
    String returnRemark;
    @ApiModelProperty(value = "确认人")
    String confirmUser;
    @ApiModelProperty(value = "确认时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date confirmTime;
    @ApiModelProperty(value = "退料类型")
    String quitType;


    /**
     * 新增  20220830
     */

    /**
     * 料号
     */
    @ApiModelProperty(value = "存货编号")
    private String materialNumber;

    /**
     * 产品等级
     */
    @ApiModelProperty(value = "产品等级")
    private String productLevel;

    /**
     * 掺杂剂
     */
    @ApiModelProperty(value = "掺杂剂")
    private String dopant;


    /**
     * 产品类型
     */
    @ApiModelProperty(value = "产品类型")
    private String productType;

    /**
     规格
     */
    @ApiModelProperty(value = "规格")
    private String specification;

    /**
     * 检验时间
     */
    @ApiModelProperty(value = "生产日期")
    private Date checkTime;
    /**
     * 工单定向标识
     */
    @ApiModelProperty(value = "工单定向标识")
    private String workOrderDirectionalIdentification;
    /**
     * 库存地点
     */
    @ApiModelProperty(value = "库存地点")
    private String warehouseCode;
    /**
     * 批次号
     */
    @ApiModelProperty(value = "批次号")
    private String batchNo;
    /**
     * sap返工工单
     */
    @ApiModelProperty(value = "sap返工工单")
    private String sapWorkOrder;
}
