package com.sw.mes.fb.turnstore.dto;

import com.alibaba.excel.annotation.ExcelProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @Author wanghao
 * @Date: 2022/6/2
 * @Modified By:
 */
@Data
@ApiModel(value = "方棒退库明细dto")
public class ReturnDetailsOfSquareRodDto {
    @ApiModelProperty(value = "退料单号")@ExcelProperty(value = "退料单号")
    String outOrderNo;
    @ApiModelProperty(value = "状态【0：默认，待确认；1：已入库；2：拒收；】")@ExcelProperty(value = "状态")
    String state;
    @ApiModelProperty(value = "退料类型")@ExcelProperty(value = "退料类型")
    String quitType;
    @ApiModelProperty(value = "晶段编码")@ExcelProperty(value = "晶段编码")
    String crystalNo;
    @ApiModelProperty(value = "圆棒产品等级")@ExcelProperty(value = "圆棒产品等级")
    String ybProductLevel;
    @ApiModelProperty(value = "方棒产品等级")@ExcelProperty(value = "方棒产品等级")
    String fbProductLevel;
    @ApiModelProperty(value = "实验等级")@ExcelProperty(value = "实验等级")
    String experGrade;
    @ApiModelProperty(value = "操作人")@ExcelProperty(value = "操作人")
    String user;
    @ApiModelProperty(value = "操作时间")@ExcelProperty(value = "操作时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date time;
    @ApiModelProperty(value = "确认人")@ExcelProperty(value = "确认人")
    String confirmUser;
    @ApiModelProperty(value = "确认时间")@ExcelProperty(value = "确认时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date confirmTime;
    @ApiModelProperty(value = "规格")@ExcelProperty(value = "规格")
    String specs;
    @ApiModelProperty(value = "长度(mm)")@ExcelProperty(value = "长度")
    BigDecimal length;
    @ApiModelProperty(value = "称重(KG)")@ExcelProperty(value = "称重")
    BigDecimal weight;
    @ApiModelProperty(value = "理论重量(KG)")@ExcelProperty(value = "理论重量")
    BigDecimal theoryWeight;
    @ApiModelProperty(value = "导电型号")@ExcelProperty(value = "导电型号")
    String conductiveType;
    @ApiModelProperty(value = "崩损(mm)")@ExcelProperty(value = "崩损(mm)")
    BigDecimal collapseLoss;
    @ApiModelProperty(value = "长度斜(mm)")@ExcelProperty(value = "长度斜(mm)")
    BigDecimal lengthSlope;
    @ApiModelProperty(value = "晶体灰皮长度(mm)")@ExcelProperty(value = "晶体灰皮长度(mm)")
    BigDecimal crystalGrayness;
    @ApiModelProperty(value = "方棒灰皮长度(mm)")@ExcelProperty(value = "方棒灰皮长度(mm)")
    BigDecimal fbCrystalGrayness;
    @ApiModelProperty(value = "线痕长度(mm)")@ExcelProperty(value = "线痕长度(mm)")
    BigDecimal lineScratch;
    @ApiModelProperty(value = "划痕长度(mm)")@ExcelProperty(value = "划痕长度(mm)")
    BigDecimal scratch;
    @ApiModelProperty(value = "未磨到长度(mm)")@ExcelProperty(value = "未磨到长度(mm)")
    BigDecimal noFriction;
    @ApiModelProperty(value = "尺寸异常长度(mm)")@ExcelProperty(value = "尺寸异常长度(mm)")
    BigDecimal sizeException;
    @ApiModelProperty(value = "方棒备注")@ExcelProperty(value = "方棒备注")
    String squareRodRemark;
    @ApiModelProperty(value = "检验类型")@ExcelProperty(value = "检验类型")
    String checkoutName;
    @ApiModelProperty(value = "入库类别")@ExcelProperty(value = "入库类别")
    String inputType;
    @ApiModelProperty(value = "退料备注")@ExcelProperty(value = "退料备注")
    String returnRemark;


//    @ApiModelProperty(value = "托号")@ExcelProperty(value = "托号")
//    String trayNo;

}
