package com.sw.mes.fb.turnstore.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.math.BigDecimal;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@Entity
@Table(name = "fb_raw_material_receiving_detail")
@DynamicUpdate
@DynamicInsert
public class RawMaterialReceivingDetail {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;

    /**
     * 托号
     */
    @Column(length = 50)
    private String trayNo;

    /**
     * 晶段编号(短棒)
     */
    @Column(length = 32)
    private String sectionNo;

    /**
     * 状态【0：默认，待确认；1：已接收；2：拒收;】
     */
    @Column(length = 10)
    private Integer state;

    /**
     * 导电型号
     */
    @Column(length = 5)
    private String conductiveType;

    /**
     * 规格
     */
    @Column(length = 50)
    private String specification;

    /**
     * 产品等级
     */
    @Column(length = 80)
    private String productLevel;

    /**
     * 晶段类型
     */
    @Column(length = 40)
    private String sectionType;

    /**
     * 实验等级
     */
    @Column(length = 40)
    private String productLevelExperiment;

    /**
     * 实际称重(KG)
     */
    @Column(length = 19)
    private BigDecimal actualWeight;

    /**
     * 入库长度(mm)
     */
    @Column(length = 19)
    private BigDecimal wareHouseLength;

    /**
     * 硅棒长度(mm)
     */
    @Column(length = 19)
    private BigDecimal actualLength;

    /**
     * 备注
     */
    @Column(length = 255)
    private String remark;

    /**
     * 崩边长度(mm)
     */
    @Column(length = 19)
    private BigDecimal edgeBark;

    /**
     * 崩晶线(mm)
     */
    @Column(length = 19)
    private BigDecimal collapseLine;

    /**
     * 斜【0：默认，否；1：是；】
     */
    @Column(length = 10)
    private Integer isBevel;

    /**
     * 细
     */
    @Column(length = 19)
    private BigDecimal fineDiameter;

    /**
     * 细减长(mm)
     */
    @Column(length = 19)
    private BigDecimal fineCutLength;

    /**
     * 扭【0：默认，否；1：是；】
     */
    @Column(length = 10)
    private Integer twist;

    /**
     * 棒寿命分档
     */
    @Column(length = 50)
    private String lifeGrading;

    /**
     * 异常
     */
    @Column(length = 50)
    private String errorMsg;

    /**
     * fb_raw_material_receiving.id(主表ID)
     */
    @Column(length = 10)
    private Integer trayId;


    public RawMaterialReceivingDetail() {
    }

    public RawMaterialReceivingDetail(Integer id) {
        this.id = id;
    }
}
