package com.sw.mes.fb.turnstore.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="fb_recheck_inspect_receive")
@DynamicUpdate
@DynamicInsert
public class RecheckInspectReceive{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;

	/**
	 * 托号
	 */
    @Column(length=50)
    private String trayNo;

	/**
	 * 出库单号
	 */
    @Column(length=50)
    private String outOrderNo;

	/**
	 * 料号
	 */
    @Column(length=50)
    private String productCode;

	/**
	 * 单晶个数
	 */
    @Column(length=10)
    private Integer crystalNum;

	/**
	 * 状态【0：默认，待确认；1：已入库；2：拒收；】
	 */
    @Column(length=10)
    private Integer state=0;

	/**
	 * 是否复检【0：默认，否；1：是；】
	 */
    @Column(length=10)
    private Integer isRecheck;

	/**
	 * 出库类型
	 */
    @Column(length=16)
    private String outType;

	/**
	 * 来源
	 */
    @Column(length=50)
    private String source;

	/**
	 * 申请时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date applyTime;

	/**
	 * 确认人
	 */
    @Column(length=50)
    private String confirmUser;

	/**
	 * 确认时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date confirmTime;

	/**
	 * 退库备注
	 */
    @Column(length=100)
    private String returnRemark;
	/**
	 * 备注
	 */
	@Column(length=100)
	private String remark;
	/**
	 * 拒收原因
	 */
	@Column(length=100)
	private String reasonRejection;

	/**
	 * 申请人
	 */
	@Column(length = 80)
	private String user;

	/**
	 * 客户
	 */
	@Column(length = 80)
	private String customer;

	/**
	 * 去向
	 */
	@Column(length=40)
	private String hasGone;

	/**
	 * 切片mes退回结果
	 */
	@Column(columnDefinition = "json")
	private String sectionMesReturnResult;
	/**
	 * sap返工工单
	 */
	@Column(length=50)
	private String sapWorkOrder;
	public RecheckInspectReceive() {
	}

	public RecheckInspectReceive(Integer id) {
		this.id = id;
	}
}
