package com.sw.mes.fb.turnstore.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="zhxx_turnstore_send")
@DynamicUpdate
@DynamicInsert
public class TurnStoreSend {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 送验单号
	 */
    @Column(length=40)
    private String sendNo;
    
	/**
	 * 送检去向
	 */
    @Column(length=40)
    private String sendType;
    
	/**
	 * 拼数
	 */
    @Column(length=10)
    private Integer stickCount;
    
	/**
	 * 状态(1:待确认，2:已确认，3:拒收)
	 */
    @Column(length=3)
    private Integer state;
    
	/**
	 * 操作人用户id
	 */
    @Column(length=10)
    private Integer userId;
    
	/**
	 * 操作人用户名称
	 */
    @Column(length=40)
    private String userName;
    
	/**
	 * 确认人用户id
	 */
    @Column(length=10)
    private Integer updateUserId;
    
	/**
	 * 确认人用户名称
	 */
    @Column(length=40)
    private String updateUserName;

	/**
	 * 方棒拼棒id集合
	 */
	@Column(length=255)
	private String fid;

	/**
	 * 备注
	 */
    @Column(length=2147483647)
    private String remark;
    
	/**
	 * 创建时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createTime;

	@Temporal(TemporalType.TIMESTAMP)
	private Date updateTime;
    

	public TurnStoreSend() {
	}

	public TurnStoreSend(Long id) {
		this.id = id;
	}
}
