package com.sw.mes.fls.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@ApiModel(value = "绑定托盘Dto")
public class ProductionBindingTrayDto {

    private Long id;
    @ApiModelProperty(value = "托盘编号")
    String trayNo;
    @ApiModelProperty(value = "单晶编号")
    String crystalNo;
    @ApiModelProperty(value = "是否绑定【0-自动绑定；1-人工绑定(记录绑定人）；】")
    Integer isBinding;
    @ApiModelProperty(value = "绑定时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date bindingTime;
    @ApiModelProperty(value = "绑定地点(自定义名称)")
    String bindingSite;
    @ApiModelProperty(value = "绑定人")
    String bindingPeople;
    @ApiModelProperty(value = "托盘工位号(送验车为例:1,2)")
    String locationNo;

    @ApiModelProperty(value = "上料点位")
    String point;

    @ApiModelProperty(value = "班组")
    String className;

    @ApiModelProperty(value = "班次名")
    String classNoName;

    @ApiModelProperty(value = "去向")
    String toWhere;


    // 类型 :圆棒 方棒
    @ApiModelProperty(value = "类型 :圆棒 方棒")
    String type;


    // 单晶头方向
    @ApiModelProperty(value = "单晶头方向")
    String crystalDirection;
}
