/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.fls.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="production_binding_tray_log")
@DynamicUpdate
@DynamicInsert
public class ProductionBindingTrayLog{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

	/**
	 * 托盘编号
	 */
    @Column(length=100)
    private String trayNo;

	/**
	 * 单晶编号
	 */
    @Column(length=100)
    private String crystalNo;

	/**
	 * 操类型【0-自动绑定；1-人工绑定(记录绑定人）；2-解除绑定；】
	 */
    @Column(length=3)
    private Integer isBinding;

	/**
	 * 操作时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date bindingTime;

	/**
	 * 绑定地点(自定义名称)
	 */
    @Column(length=100)
    private String bindingSite;

	/**
	 * 操作人
	 */
    @Column(length=50)
    private String bindingPeople;

	/**
	 * 托盘工位号(送验车为例:1,2)
	 */
    @Column(length=50)
    private String locationNo;

	/**
	 * 班次名(中文)
	 */
    @Column(length=50)
    private String classnoname;

	/**
	 * 班组名称
	 */
    @Column(length=50)
    private String className;

	/**
	 * 记录时间
	 */
    @Column(nullable=false, length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreate;

	/**
	 * 所属系列
	 */
    @Column(length=50)
    private String series;

	/**
	 * 所属模块
	 */
    @Column(length=50)
    private String area;

	/**
	 * 解绑原因
	 */
	@Column(length=255)
	private String reason;






	public ProductionBindingTrayLog() {
	}

	public ProductionBindingTrayLog(Long id) {
		this.id = id;
	}
}
