/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.fls.entity;


import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="temp_turnstore_tray_item")
@DynamicUpdate
@DynamicInsert
public class TempTurnstoreTrayItem{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;
    
	/**
	 * 打托单晶号
	 */
    @Column(length=255)
    private String sectionNo;
    
	/**
	 * 当前颗次
	 */
    @Column(length=10)
    private Integer currentPosition;
    
	/**
	 * temp_turnstore_tray.id
	 */
    @Column(length=10)
    private Integer trayId;

    /**
     * 创建时间
     */
    @Column(length=19)
    @Temporal(TemporalType.TIMESTAMP)
    private Date createTime;



    public TempTurnstoreTrayItem() {
	}

	public TempTurnstoreTrayItem(Integer id) {
		this.id = id;
	}

    public TempTurnstoreTrayItem(String sectionNo, Integer currentPosition, Integer trayId) {
        this.sectionNo = sectionNo;
        this.currentPosition = currentPosition;
        this.trayId = trayId;
    }

    public TempTurnstoreTrayItem(String sectionNo, Integer currentPosition, Integer trayId, Date createTime) {
        this.sectionNo = sectionNo;
        this.currentPosition = currentPosition;
        this.trayId = trayId;
        this.createTime = createTime;
    }
}
