/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.grade.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="grade_fb_rule_test_data")
@DynamicUpdate
@DynamicInsert
public class RuleTestData {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;
    
	/**
	 * 评级测试id
	 */
    @Column(length=19)
    private Long ruleTestId;
    
	/**
	 * 晶段编号
	 */
    @Column(length=30)
    private String sectionNo;
    
	/**
	 * 测试状态
	 */
    @Column(length=10)
    private Integer status;

    /**
     * 测试过程
     */
    @Column(length=0)
    private String process;
    
	/**
	 * 评级结果
	 */
    @Column(length=32)
    private String grade;

    /**
     * 评级结果（旧）
     */
    @Column(length=32)
    private String gradeOld;

    /**
     * 评级数据
     */
    @Column(length=32)
    private String gradeData;
    
	/**
	 * 创建/修改人
	 */
    @Column(length=20)
    private String userUpdate;
    
	/**
	 * 创建/修改时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date gmtUpdate;
    

	public RuleTestData() {
	}

	public RuleTestData(Integer id) {
		this.id = id;
	}
}
