package com.sw.mes.plan.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.persistence.Column;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;

@Data
public class ProductionOrderCountDto {
    @ApiModelProperty(value = "订单id")
    Long fbProductionOrderId;
    @ApiModelProperty(value = "产品id")
    Integer fbProductModelId;
    @ApiModelProperty(value = "订单类型")
    String orderType;
    @ApiModelProperty(value = "研发唯一标识")
    String rdonlylogo;

    @ApiModelProperty(value = " 导电类型", required = true)
    @NotNull(message = "导电类型，不能为空")
    String conductionType;
    @ApiModelProperty(value = "规格", required = true)
    @NotNull(message = "规格，不能为空")
    String specification;
    @ApiModelProperty(value = "产品等级", required = true)
    @NotNull(message = "产品等级，不能为空")
    String productRank;
    @ApiModelProperty(value = "掺杂剂", required = true)
    @NotNull(message = "掺杂剂，不能为空")
    String dopant;
    @ApiModelProperty(value = "边长", required = true)
    @NotNull(message = "边长，不能为空")
    BigDecimal sideLength;
    @ApiModelProperty(value = "是否整棒（0：无限制，1：整棒，2：拼棒）", required = true)
    @NotNull(message = "是否整棒，不能为空")
    Integer stickCount;
    @ApiModelProperty(value = "产品类别")
    String productType;
    @ApiModelProperty(value = "车间")
    String workShop;
    @ApiModelProperty(value = "工作中心")
    Integer workType;
    @ApiModelProperty(value = "拼数")
    String sticksCount;
    @ApiModelProperty(value = "电阻率")
    String resistivity;
    @ApiModelProperty(value = "方棒长度范围")
    String sideLengthRange;
    @ApiModelProperty(value = "工单定向标识")
    String zorientationind;

}
