package com.sw.mes.crucible.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.util.Date;

/**
 * @author lf
 * @description 坩埚管理
 * @date 2024/1/6 13:56
 */
@Data
@Entity
@Table(name = "crucible")
@DynamicUpdate
@DynamicInsert
public class Crucible {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;
    /**
     * 批次号
     */
    @Column(length = 50)
    private String batchNumber;
    /**
     * 料号
     */
    @Column(length = 50)
    private String code;
    /**
     * 料号名称
     */
    @Column(length = 50)
    private String codeName;
    /**
     * 尺寸
     */
    @Column(length = 50)
    private String dimension;
    /**
     * 品类
     */
    @Column(length = 50)
    private String category;
    /**
     * 等级
     */
    @Column(length = 20)
    private String level;
    /**
     * 厂家
     */
    @Column(length = 50)
    private String manufacturer;
    /**
     * 是否锁定0是1否，默认是
     */
    @Column(length = 1)
    private Integer isLock;
    /**
     * 创建人
     */
    @Column(length = 50)
    private String createUser;

    /**
     * 创建时间
     */
    @Column(length = 19)
    @Temporal(TemporalType.TIMESTAMP)
    private Date createDate;

    /**
     * 修改人
     */
    @Column(length = 50)
    private String updateUser;
    /**
     * 修改时间
     */
    @Column(length = 19)
    @Temporal(TemporalType.TIMESTAMP)
    private Date updateDate;
}
