package com.sw.mes.dingTalk.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

/**
 * @author lf
 * @description 钉钉消息记录表
 * @date 2024/1/26 14:06
 */
@Data
@Entity
@Table(name = "ding_talk_message_log")
@DynamicUpdate
@DynamicInsert
public class DingTalkMessageLog {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;
    /**
     * 消息内容
     */
    @Column
    private String content;
    /**
     * 机器人使用场景
     */
    @Column
    private String scene;
    /**
     * 发送人群（0人和群都发，1只群发，2只发人）
     */
    @Column
    private Integer status;
    /**
     * 消息来源
     */
    @Column
    private String source;
    /**
     * 群名称
     */
    @Column
    private String groupName;
    /**
     * 创建时间
     */
    @Column
    @Temporal(TemporalType.TIMESTAMP)
    private Date createDate;
}
