package com.sw.mes.inspect.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.util.Date;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@Entity
@Table(name = "yb_inspect_data_log")
@DynamicUpdate
@DynamicInsert
public class YbInspectDataLog {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    /**
     * 检验数据库id
     */
    @Column
    private Long inspectDataId;

    /**
     * 晶段编号(短棒)
     */
    @Column(length = 80)
    private String sectionNo;

    @Column
    private String dataLog;

    /**
     * 创建时间
     */
    @Column(nullable=false, length=19)
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtUpdate;

    /**
     * 创建者
     */
    @Column(nullable=false, length=32)
    private String userUpdate;

    public YbInspectDataLog() {
    }

    public YbInspectDataLog(Long id) {
        this.id = id;
    }
}
