package com.sw.mes.issue.dto;

import com.alibaba.excel.annotation.ExcelProperty;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.Column;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

@Getter
@Setter
@ApiModel(value = "YbIssueToDetailDto对象", description = "关联发料详情以及圆棒检验明细表dto")
public class YbIssueToDetailDto implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("托号")
    //@ExcelProperty(value = "托号")
    private String trayNo;

    @ApiModelProperty("单晶编号")
    // @ExcelProperty(value = "单晶编号")
    private String crystalNo;

    /**
     * 状态:0, "待出库";1, "取消",2, "待确认",3, "已确认"
     */
    @ApiModelProperty("入库状态")
    // @ExcelProperty(value = "入库状态")
            Integer status;

//    @ApiModelProperty("入库状态名称")
//    @ExcelProperty(value = "入库状态")
//    String statusName;

    @ApiModelProperty("操作时间")
    //@ExcelProperty(value = "操作时间")
    private Date time;

    /**
     * 规格/实际规格
     */
    @ApiModelProperty("规格")
    //@ExcelProperty(value = "规格")
    private String productTypeSecond;

    /**
     * 掺杂剂
     */
    @ApiModelProperty("掺杂剂")
    //@ExcelProperty(value = "掺杂剂")
    private String dopant;

    /**
     * 导电型号/型号
     */
    @ApiModelProperty("导电型号")
    //@ExcelProperty(value = "导电型号")
    private String conductiveType;


    /**
     * 产品等级
     */
    @ApiModelProperty("产品等级")
    // @ExcelProperty(value = "产品等级")
    private String productLevel;

    /**
     * 直径Min
     */
    @ApiModelProperty("最小直径")
    // @ExcelProperty(value = "最小直径")
    private BigDecimal diameterMin;

    /**
     * 直径Max
     */
    @ApiModelProperty("最大直径")
    //@ExcelProperty(value = "最大直径")
    private BigDecimal diameterMax;


    /**
     * 订单号
     */

    @ApiModelProperty("订单号")
    // @ExcelProperty(value = "订单号")
    private String orderNo;
    /**
     * 物料编码
     */
    @ApiModelProperty("物料编码")
    // @ExcelProperty(value = "物料编码")
    private String materialCode;

    /**
     * 理论重量
     */
    @ApiModelProperty("入库重量")
    //  @ExcelProperty(value = "入库重量")
    private BigDecimal theoryWeight;

    /**
     * 圆棒长度(mm)
     */
    @ApiModelProperty("入库长度")
    // @ExcelProperty(value = "入库长度")
    private BigDecimal actualLength;
}
