/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.issue.entity;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import lombok.Data;
import lombok.experimental.Accessors;

/**
 * @Author @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@Entity
@Table(name = "yb_issue")
@DynamicUpdate
@DynamicInsert
@Accessors(chain = true)
public class YbIssue {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    /**
     * 托号
     */
    @Column(length = 50)
    private String trayNo;

    /**
     * 数量
     */
    @Column(length = 10)
    private Integer num;

    /**
     * 操作人
     */
    @Column(length = 50)
    private String name;

    /**
     * 操作时间
     */
    @Column(length = 19)
    @Temporal(TemporalType.TIMESTAMP)
    private Date time;

    /**
     * 当前站点
     */
    @Column(length = 50)
    private String currentSite;

    /**
     * 下一站点
     */
    @Column(length = 50)
    private String nextSite;

    /**
     * 去向
     */
    @Column(length = 50)
    private String destination;

    /**
     * 状态:0, "待出库";1, "取消",2, "待确认",3, "已确认"
     */
    @Column(length = 20)
    Integer status;

    public YbIssue() {
    }

    public YbIssue(Long id) {
        this.id = id;
    }
}