package com.sw.mes.issue.entity;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import lombok.Data;
import lombok.experimental.Accessors;

/**
 * @author wangjingyu
 * @datetime 2023年9月6日 下午4:38:01
 * @description
 */
@Data
@Entity
@Table(name = "yb_issue_record")
@DynamicUpdate
@DynamicInsert
@Accessors(chain = true)
public class YbIssueRecord {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    /**
     * 晶段编号
     */
    @Column(length=32)
    private String sectionNo;

    /**
     * 状态：0未入；1已入；2异常
     */
    @Column(length=1)
    private Integer status;

    /**
     * 托号
     */
    @Column(length=64)
    private String trayNo;

    /**
     * 数据删除标识: 0 未删 ; 1 已删
     */
    @Column(length=1)
    private Integer isDeleted;

    /**
     * 创建时间
     */
    @Column(length = 19)
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreate;

    /**
     * 更新时间
     */
    @Column(length = 19)
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtUpdate;

    /**
     * 车号
     */
    @Column(length=64)
    private String branchCode;

    /**
     * 发料状态：0未发 1 已发
     */
    @Column(length=1)
    private Integer sendStatus;

    /**
     * 小车上的工位顺序编号
     */
    @Column(length=11)
    private Integer numNo;
}