/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.kanban.entity;

import java.util.Date;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="kanban_device")
@DynamicUpdate
@DynamicInsert
public class KanbanDevice{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 设备编号
	 */
    @Column(length=40)
    private String deviceNo;
    
	/**
	 * 设备名称
	 */
    @Column(length=80)
    private String deviceName;
    
	/**
	 * IP
	 */
    @Column(length=40)
    private String deviceIp;
    
	/**
	 * MAC
	 */
    @Column(length=40)
    private String deviceMac;
    
	/**
	 * IMEI
	 */
    @Column(length=80)
    private String deviceImei;
    
	/**
	 * 接入时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createTime;
    
	/**
	 * 更新时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date updateTime;
    
	/**
	 * 在线状态
	 */
    @Column(length=1)
    private Boolean onlineStatus;
    
	/**
	 * 上一个显示页面
	 */
    @Column(length=255)
    private String prePage;
    
	/**
	 * 当前显示页面
	 */
    @Column(length=255)
    private String curPage;
    
	/**
	 * 下一个显示页面
	 */
    @Column(length=255)
    private String nextPage;
    
	/**
	 * 页面刷新时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date pageUpdateTime;
    
	/**
	 * 当前页显示时长
	 */
    @Column(length=19)
    private Long curShowTime;
    

	public KanbanDevice() {
	}

	public KanbanDevice(Long id) {
		this.id = id;
	}
}
