package com.sw.mes.mmcs.entity;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import lombok.Data;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="mmcs_distribution_plan")
@DynamicUpdate
@DynamicInsert
public class MmcsDistributionPlan{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 设备号
	 */
    @Column(length=100)
    private String equipmentCode;
    
	/**
	 * 剩料重量
	 */
    @Column(length=50)
    private String residualWeight;
    
	/**
	 * 是否断取
	 */
    @Column(length=10)
    private String disconnectOrNot;
    
	/**
	 * 事件类型    0：装料 1：初始复投 2：取段复投
	 */
    @Column(length=80)
    private String type;
    
	/**
	 * 创建时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createTime;
    
	/**
	 *预计启动时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date estimate;
    
    /**
     * 是否发送
     */
    @Column(length=1)
    private Boolean sended = false;
    
    /**
	 *发送时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date sendTime;
}
