package com.sw.mes.outside.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;

@Data
public class SendEapSignalDto {
    /**
     * 开炉
     */
    private static final String OPEN_FURNACE = "OpenFurnace";
    /**
     * 抽真空
     */
    public static final String VACUUM_PUMPING = "VacuumPumping";
    /**
     * 熔料
     */
    public static final String MOLTEN_MATERIAL = "MoltenMaterial";
    /**
     * 取段结晶
     */
    public static final String CLOSE_METHOD = "CloseMethod";
    /**
     * 取段稳温
     */
    public static final String SEGMENTED_STABLE_TEMPERATURE = "SegmentedStableTemperature";
    /**
     * 停炉
     */
    public static final String SHUTDOWN_FURNACE = "ShutdownFurnace";

    @ApiModelProperty(value = "设备号")
    @NotBlank(message = "设备号，不能为空")
    String equipmentCode;
    /**
     * 取段结晶 1 开始新的炉次，延时发送装料信号
     * 熔料 2
     * 延时发送初始复投信号
     * 开炉 3
     * 开始新的炉次，延时发送装料信号
     * 停炉 4 当前炉次结束
     * 抽真空 5
     * 取段稳温 6
     * 焖锅漏硅 7
     */
    @ApiModelProperty(value = "eap信号")
    @NotBlank(message = "eap信号，不能为空")
    Integer signal;

    @ApiModelProperty(value = "单晶信息") //取段结晶，取段稳温，停炉 时传值
    CrystalInfoDto crystalInfoDto;

    @ApiModelProperty(value = "是否产出")
    Boolean outputCrystal;
}
