package com.sw.mes.outside.dto;

import com.alibaba.fastjson.annotation.JSONField;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.Date;
import java.util.Map;

/**
 * <p>
 * 传递 MES 消息实体
 * </p>
 */
@Data
public class SendSurplusData {

    /**
     * 设备编号
     */
    @NotBlank(message = "设备名称，不能为空")
    private String deviceNo;

    /**
     * 余料类型
     */
    @NotBlank(message = "余料类型，不能为空")
    private String surplusType;

    /**
     * 余料重量
     */
    @NotNull(message = "余料重量，不能为空")
    private BigDecimal weight;

}
