/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.outside.entity;

import java.util.Date;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@Entity
@Table(name = "alarm_data")
@DynamicUpdate
@DynamicInsert
public class AlarmData {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 设备类型
	 */
    @Column(length=30)
    private String deviceType;
    
	/**
	 * 设备名称
	 */
    @Column(length=255)
    private String deviceNo;
    
	/**
	 * 事故描述
	 */
    @Column(length=150)
    private String description;
    
	/**
	 * 报警code
	 */
    @Column(length=50)
    private String code;
    
	/**
	 * 创建时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createTime;
    

	public AlarmData() {
	}

	public AlarmData(Long id) {
		this.id = id;
	}
}
