/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.outside.entity;

import java.util.Date;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="zhxx_device_stop_stove_info")
@DynamicUpdate
@DynamicInsert
public class DeviceStopStoveInfo{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;
    
	/**
	 * 设备编号
	 */
    @Column(length=50)
    private String deviceNo;
    
	/**
	 * 停炉时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date stopStoveTime;
    
	/**
	 * 清罐时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date clearPotTime;
    
	/**
	 * 创建时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createTime;
    

	public DeviceStopStoveInfo() {
	}

	public DeviceStopStoveInfo(Integer id) {
		this.id = id;
	}
}
