package com.sw.mes.production.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.persistence.Column;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@ApiModel(value = "配方物料分类明细Dto")
public class FormulaMaterialClassDetailDto {
    private Long id;
    @NotNull(message = "配方物料分类id不能为空")
    Long formulaMaterialClassId;
    @NotBlank(message = "物料编号不能为空")
    @ApiModelProperty(value = "物料编号", required = true)
    String materialCode;
    @NotBlank(message = "物料名称不能为空")
    @ApiModelProperty(value = "物料编号", required = true)
    String materialName;
    @NotBlank(message = "物料类型名称不能为空")
    @ApiModelProperty(value = "物料类型名称", required = true)
    String materialTypeName;
    @NotBlank(message = "厂家不能为空")
    @ApiModelProperty(value = "厂家", required = true)
    String factory;
    @NotBlank(message = "定向标识不能为空")
    @ApiModelProperty(value = "定向标识")
    String directionalSign;
    @NotBlank(message = "等级不能为空")
    @ApiModelProperty(value = "等级")
    String level;
    @NotNull(message = "电阻率下限不能为空")
    @ApiModelProperty(value = "电阻率下限")
    BigDecimal resistivityLower;
    @NotNull(message = "电阻率上限不能为空")
    @ApiModelProperty(value = "电阻率上限")
    BigDecimal resistivityUpper;
    @ApiModelProperty(value = "创建人", required = true)
    String userCreate;
    @ApiModelProperty(value = "创建时间", required = true)
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date gmtCreate;
    @ApiModelProperty(value = "修改人")
    String userUpdate;
    @ApiModelProperty(value = "修改时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date gmtUpdate;
    @ApiModelProperty(value = "粒经下限")
    BigDecimal grainSizeLower;
    @ApiModelProperty(value = "粒经上限")
    BigDecimal grainSizeUpper;
}