package com.sw.mes.production.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.validator.constraints.*;

import javax.validation.constraints.*;

import java.math.BigDecimal;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@ApiModel(value = "配方方案明细Dto")
public class FormulaSchemeDetailDto {

    private Long id;
     @ApiModelProperty(value = "配方方案id" )
     Long formulaSchemeId;
     @ApiModelProperty(value = "优先级" )
     Integer priority;
     @ApiModelProperty(value = "物料种类" )
     String materialType;
     @ApiModelProperty(value = "物料分类" )
     String materialClassName;
     @ApiModelProperty(value = "物料编号" , required = true)
     String materialCode;
     @ApiModelProperty(value = "物料名称" , required = true)
     String materialName;
     @ApiModelProperty(value = "物料类型名称" , required = true)
     String materialTypeName;
     @ApiModelProperty(value = "厂家" )
     String factory;
     @ApiModelProperty(value = "定向标识" )
     String directionalSign;
     @ApiModelProperty(value = "等级" )
     String level;
     @ApiModelProperty(value = "电阻率下限" )
     BigDecimal resistivityLower;
     @ApiModelProperty(value = "电阻率上限" )
     BigDecimal resistivityUpper;
     @ApiModelProperty(value = "创建人" , required = true)
     String userCreate;
     @ApiModelProperty(value = "创建时间" , required = true)
     @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
     Date gmtCreate;
     @ApiModelProperty(value = "修改人" )
     String userUpdate;
     @ApiModelProperty(value = "修改时间" )
     @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
     Date gmtUpdate;
}