/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.production.entity;

import java.util.Date;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="production_formula_material_class")
@DynamicUpdate
@DynamicInsert
public class FormulaMaterialClass{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 物料分类名称
	 */
    @Column(length=20)
    private String name;
    
	/**
	 * 创建/修改人
	 */
    @Column(nullable=false, length=20)
    private String userCreate;
    
	/**
	 * 创建/修改时间
	 */
    @Column(nullable=false, length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreate;
    
	/**
	 * 
	 */
    @Column(length=20)
    private String userUpdate;
    
	/**
	 * 
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date gmtUpdate;
    

	public FormulaMaterialClass() {
	}

	public FormulaMaterialClass(Long id) {
		this.id = id;
	}
}
