/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.production.entity;

import java.util.Date;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="production_formula_product_scheme")
@DynamicUpdate
@DynamicInsert
public class FormulaProductScheme{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 设备号
	 */
    @Column(nullable=false, length=50)
    private String equipmentCode;
    
	/**
	 * 产品料号
	 */
    @Column(nullable=false, length=50)
    private String productModeCode;
    
	/**
	 * 产品名称
	 */
    @Column(nullable=false, length=50)
    private String productName;
    
	/**
	 * 拆桶方案id
	 */
    @Column(nullable=false, length=10)
    private Long decompositionSchemeId;
    
	/**
	 * 拆桶方案名称
	 */
    @Column(nullable=false, length=50)
    private String decompositionSchemeName;
    
	/**
	 * 初始配方id
	 */
    @Column(nullable=false, length=10)
    private Long initialFormulaId;
    
	/**
	 * 初始配方名称
	 */
    @Column(nullable=false, length=50)
    private String initialFormulaName;
    
	/**
	 * 初始复投方案id
	 */
    @Column(nullable=false, length=10)
    private Long initialReinvestmentId;
    
	/**
	 * 初始复投方案名称
	 */
    @Column(nullable=false, length=50)
    private String initialReinvestmentName;
    
	/**
	 * 取段复投方案id
	 */
    @Column(nullable=false, length=10)
    private Long reinvestmentId;
    
	/**
	 * 取段复投方案名称
	 */
    @Column(nullable=false, length=50)
    private String reinvestmentName;
    
	/**
	 * 状态
	 */
    @Column(nullable=false, length=50)
    private Integer status;
    
	/**
	 * 下炉次生效信息
	 */
    @Column(length=0)
    private String nextFurnaceEffective;
    
	/**
	 * 创建人
	 */
    @Column(length=20)
    private String userCreate;
    
	/**
	 * 创建时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreate;
    
	/**
	 * 修改人
	 */
    @Column(length=20)
    private String userUpdate;
    
	/**
	 * 修改时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date gmtUpdate;
    

	public FormulaProductScheme() {
	}

	public FormulaProductScheme(Long id) {
		this.id = id;
	}
}
