/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.production.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="production_formula_product_scheme_detail")
@DynamicUpdate
@DynamicInsert
public class FormulaProductSchemeDetail{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 产品配方ID
	 */
	@ApiModelProperty(value = "产品配方ID")
    @Column(nullable=false, length=19)
    private Long formulaProductSchemeId;
    
	/**
	 * 投料加次
	 */
	@ApiModelProperty(value = "投料加次")
    @Column(nullable=false, length=10)
    private Integer againNum;
    
	/**
	 * 投料加次名称
	 */
	@ApiModelProperty(value = "投料加次名称" )
    @Column(length=20)
    private String againNumName;

	/**
	 * 重量方案ID
	 */
	@ApiModelProperty(value = "重量方案ID")
	@Column(nullable=false, length=19)
	Long weightSchemeId;

	/**
	 * 重量方案名称
	 */
	@ApiModelProperty(value = "重量方案名称")
	@Column(nullable=false, length=50)
	String weightSchemeName;
    
	/**
	 * 配方ID
	 */
	@ApiModelProperty(value = "配方ID")
    @Column(nullable=false, length=19)
    private Long formulaSchemeId;
    
	/**
	 * 配方名称
	 */
	@ApiModelProperty(value = "配方名称")
    @Column(nullable=false, length=50)
    private String formulaSchemeName;
    
	/**
	 * 创建时间
	 */
	@ApiModelProperty(value = "创建时间" )
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createTime;
    
	/**
	 * 状态(0:异常, 1:正常)
	 */
	@ApiModelProperty(value = "状态(0:异常, 1:正常)" )
    @Column(length=10)
    private Integer status;
    

	public FormulaProductSchemeDetail() {
	}

	public FormulaProductSchemeDetail(Long id) {
		this.id = id;
	}
}
