/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.production.entity;

import java.util.Date;
import java.math.BigDecimal;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="production_formula_scheme_detail")
@DynamicUpdate
@DynamicInsert
public class FormulaSchemeDetail{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 配方方案id
	 */
    @Column(length=19)
    private Long formulaSchemeId;
    
	/**
	 * 优先级
	 */
    @Column(length=10)
    private Integer priority;
    
	/**
	 * 物料种类
	 */
    @Column(length=50)
    private String materialType;
    
	/**
	 * 物料分类
	 */
    @Column(length=50)
    private String materialClassName;
    
	/**
	 * 物料编号
	 */
    @Column(nullable=false, length=50)
    private String materialCode;
    
	/**
	 * 物料名称
	 */
    @Column(nullable=false, length=255)
    private String materialName;
    
	/**
	 * 物料类型名称
	 */
    @Column(nullable=false, length=50)
    private String materialTypeName;
    
	/**
	 * 厂家
	 */
    @Column(length=50)
    private String factory;
    
	/**
	 * 定向标识
	 */
    @Column(length=50)
    private String directionalSign;
    
	/**
	 * 等级
	 */
    @Column(length=20)
    private String level;
    
	/**
	 * 电阻率下限
	 */
    @Column(length=18)
    private BigDecimal resistivityLower;
    
	/**
	 * 电阻率上限
	 */
    @Column(length=18)
    private BigDecimal resistivityUpper;
    
	/**
	 * 创建人
	 */
    @Column(nullable=false, length=20)
    private String userCreate;
    
	/**
	 * 创建时间
	 */
    @Column(nullable=false, length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreate;
    
	/**
	 * 修改人
	 */
    @Column(length=20)
    private String userUpdate;
    
	/**
	 * 修改时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date gmtUpdate;
    

	public FormulaSchemeDetail() {
	}

	public FormulaSchemeDetail(Long id) {
		this.id = id;
	}
}
