/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.production.entity;

import java.util.Date;
import java.math.BigDecimal;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="production_material_preparation_rules")
@DynamicUpdate
@DynamicInsert
public class MaterialPreparationRules{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 设备号
	 */
    @Column(nullable=false, length=50)
    private String equipmentCode;
    
	/**
	 * 等径长度
	 */
    @Column(length=18)
    private BigDecimal length;
    
	/**
	 * 复投总重量
	 */
    @Column(length=18)
    private BigDecimal repeatWeight;
    
	/**
	 * 创建人
	 */
    @Column(length=20)
    private String userCreate;
    
	/**
	 * 创建时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreate;
    
	/**
	 * 修改人
	 */
    @Column(length=20)
    private String userUpdate;
    
	/**
	 * 修改时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date gmtUpdate;
    

	public MaterialPreparationRules() {
	}

	public MaterialPreparationRules(Long id) {
		this.id = id;
	}
}
