package com.sw.mes.production.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;

/**
 * @Author: xushu
 * @Date: 2023/05/08/9:59
 * @Description: 
 */
/**
    * 复投任务灌料方案
    */
@Data
@Entity
@Table(name = "production_again_task_recipe")
@DynamicUpdate
@DynamicInsert
public class ProductionAgainTaskRecipe {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    /**
    * 复投任务Id
    */
    @Column(length = 30)
    private Long againTaskId;

    /**
    * 配方类型
    */
    @Column(length = 100)
    private String recipeKind;

    /**
    * 物料类型名称
    */
    @Column(length = 100)
    private String suppliesName;

    /**
    * 物料类型编码
    */
    @Column(length = 100)
    private String suppliesCode;

    /**
    * 物料分类
    */
    @Column(length = 100)
    private String suppliesType;

    /**
    * 掺杂剂
    */
    @Column(length = 50)
    private String suppliesDopant;

    /**
    * 电阻率最大值
    */
    @Column(length = 50)
    private String suppliesResistanceMax;

    /**
    * 电阻率最小值
    */
    @Column(length = 50)
    private String suppliesResistanceMin;

    /**
    * 重量
    */
    @Column(length = 19)
    private BigDecimal weight;

    /**
    * 10kg箱数
    */
    @Column(length = 10)
    private Integer bucketTen;

    /**
    * 40kg箱数
    */
    @Column(length = 10)
    private Integer bucketForty;

    /**
     * 替代的物料分类
     */
    @Column(length = 25)
    private String suppliesTypes;


    /**
    * 创建时间
    */
    @Column(nullable = false, length = 19)
    @Temporal(TemporalType.TIMESTAMP)
    private Date createTime;

    /**
    * 创建人
    */
    @Column(length = 50)
    private String createBy;
}