package com.sw.mes.production.service;

import com.sw.mes.core.base.BaseService;
import com.sw.mes.production.entity.FormulaProductSchemeDetail;

import java.util.List;

/**
* @Author
* @Description：
* @Date:
* @Modified By:
*/
public interface FormulaProductSchemeDetailService extends BaseService<FormulaProductSchemeDetail> {
    /**
     * 查询明细
     * @param fpsId
     * @return
     */
    List<FormulaProductSchemeDetail> getListByFpsId(Long fpsId);

    /**
     * 根据产品方案和重量方案查询
     * @param fpsId
     * @param wsId
     * @return
     */
    List<FormulaProductSchemeDetail> getListByFpsIdAndWsId(Long fpsId, Long wsId);

    /**
     * 删除明细
     * @param fpsId
     */
    void deleteByFpsId(Long fpsId);

    /**
     * 查询加次配方方案
     * @param fpsId
     * @param againNum
     * @return
     */
    FormulaProductSchemeDetail findByFpsIdAndAgainNum(Long fpsId, Integer againNum);

    /**
     * 查询重量，加次，配方方案
     * @param fpsId
     * @param againNum
     * @return
     */
    FormulaProductSchemeDetail findByFpsIdAndWsIdAndAgainNum(Long fpsId, Long wsId,  Integer againNum);
}
