package com.sw.mes.sap.dto;

import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;


/**
 * 晶科SAP下发生产工单通信记录对象 log_sap_mes_interactive
 * 
 * @author liru
 * @date 2023-12-29
 */
@Data
@ApiModel(value = "晶科SAP下发生产工单通信记录Dto")
public class LogSapMesInteractiveDto
{
    /** ID */
    @ApiModelProperty(value = "ID" )
    private Long id;

    /** 处理控制器名称 */
    @ApiModelProperty(value = "处理控制器名称" )
    private String controllerName;

    /** 操作方法 */
    @ApiModelProperty(value = "操作方法" )
    private String oprMethod;

    /** 报文内容 */
    @ApiModelProperty(value = "报文内容" )
    private String context;

    /** 方向 */
    @ApiModelProperty(value = "方向" )
    private String dataDirection;
    
    @ApiModelProperty(value = "返回报文内容" )
    private String returnContext;

    /** 创建时间 */
    @ApiModelProperty(value = "创建时间" )
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;

}
