package com.sw.mes.sap.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@ApiModel(value = "拉取长晶棒信息【已切断】上报erp记录主表Dto")
public class ReportErpSquareOutputRecordDto {

    private Long id;
     @ApiModelProperty(value = "单据编号" )
     String code;
     @ApiModelProperty(value = "订单单号" )
     String orderNo;
     @ApiModelProperty(value = "仓库编码" )
     String warehouseCode;
     @ApiModelProperty(value = "收发类型编码" )
     String receiveCode;
     @ApiModelProperty(value = "部门编码" )
     String departmentCode;
     @ApiModelProperty(value = "存货编码" )
     String inventoryCode;
     @ApiModelProperty(value = "数量" )
     BigDecimal quantity;
     @ApiModelProperty(value = "件数" )
     BigDecimal number;
     @ApiModelProperty(value = "金额" )
     BigDecimal cost;
     @ApiModelProperty(value = "批号" )
     String serial;
     @ApiModelProperty(value = "上报批号" )
     String pushSerial;
     @ApiModelProperty(value = "创建时间" )
     @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
     Date createTime;
     @ApiModelProperty(value = "上报时间" )
     @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
     Date pushTime;
     @ApiModelProperty(value = "发起人" )
     String pushUser;
     @ApiModelProperty(value = "0未上报，1已上报" )
     Integer pushed;
     @ApiModelProperty(value = "类型(0单晶，1机加，3洗料)" )
     Integer type;
     @ApiModelProperty(value = "备注" )
     String memory;
}