package com.sw.mes.sap.dto.productionorder;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <pre>
 * PRODUCTION_ORDER_ID : 56002369
 * ORDER_TYPE : ZP42
 * PRODUCTION_ID : 26001773
 * PRODUCTION_DIS : JKM550M-72HL4-V/Silver/F35/A级
 * PLANT_ID : 1595
 * PLANNED_QTY1 : 1331.000
 * UOM1 : PC
 * PLAN_START_DATE : 20231124
 * PLAN_END_DATE : 20231127
 * SO_ID : 50041000
 * RSO_ID : 1099243
 * SO_ITEM_ID : 10
 * RSO_ITEM_ID : 10
 * WORK_CENTER_ID : MN0013
 * WORKE_CNTER_TEXT : 马来6车间1.8GW新车间2
 * CUSTOMER_ID : 1016016
 * S01 : 12*1400*1100*1086
 * S02 : JKM-PM-72M-1356
 * S03 : T001002
 * S03_DIS : T002001
 * S04 : T003001
 * S04_DIS : T004002
 * S05 : T005006
 * S05_DIS : T006001
 * S06 : T007006
 * S06_DIS : T008004
 * S07 : T009005
 * S07_DIS : T010003
 * S08 : T011001
 * S08_DIS : T012001
 * S09 : T013003
 * S09_DIS : T014002
 * S10 : T015010
 * S10_DIS : T016001
 * S11 : T016002
 * S11_DIS : T016003
 * S12 :
 * S12_DIS : T017004
 * S13 : T018002
 * S13_DIS : T019007
 * S14 :
 * S14_DIS : E71
 * S15 : E24
 * S15_DIS :
 * S21 : D26
 * S21_DIS : 182P型+半片+白色EVA+白背板+0.3MM焊带
 * CUSTOMER_DESC : Taiwan Rolling stock台湾备库
 * IS_ADD : false
 * OLD_CHILD_NUM : 0
 * PRODUCT_REV :
 * PRODUCT_ROR : false
 * </pre>
 */
@Data
public class WorkOrderItemDto {
    @JsonProperty("PRODUCTION_ORDER_ID")
    private String PRODUCTION_ORDER_ID;
    @JsonProperty("ORDER_TYPE")
    private String ORDER_TYPE;
    @JsonProperty("PRODUCTION_ID")
    private String PRODUCTION_ID;
    @JsonProperty("PRODUCTION_DIS")
    private String PRODUCTION_DIS;
    @JsonProperty("PLANT_ID")
    private String PLANT_ID;
    @JsonProperty("PLANNED_QTY1")
    private String PLANNED_QTY1;
    @JsonProperty("UOM1")
    private String UOM1;
    @JsonProperty("PLAN_START_DATE")
    private String PLAN_START_DATE;
    @JsonProperty("PLAN_END_DATE")
    private String PLAN_END_DATE;
    @JsonProperty("SO_ID")
    private String SO_ID;
    @JsonProperty("RSO_ID")
    private String RSO_ID;
    @JsonProperty("SO_ITEM_ID")
    private String SO_ITEM_ID;
    @JsonProperty("RSO_ITEM_ID")
    private String RSO_ITEM_ID;
    @JsonProperty("WORK_CENTER_ID")
    private String WORK_CENTER_ID;
    @JsonProperty("WORKE_CNTER_TEXT")
    private String WORKE_CNTER_TEXT;
    @JsonProperty("CUSTOMER_ID")
    private String CUSTOMER_ID;
    @JsonProperty("S01")
    private String S01;
    @JsonProperty("S02")
    private String S02;
    @JsonProperty("S03")
    private String S03;
    @JsonProperty("S03_DIS")
    private String S03_DIS;
    @JsonProperty("S04")
    private String S04;
    @JsonProperty("S04_DIS")
    private String S04_DIS;
    @JsonProperty("S05")
    private String S05;
    @JsonProperty("S05_DIS")
    private String S05_DIS;
    @JsonProperty("S06")
    private String S06;
    @JsonProperty("S06_DIS")
    private String S06_DIS;
    @JsonProperty("S07")
    private String S07;
    @JsonProperty("S07_DIS")
    private String S07_DIS;
    @JsonProperty("S08")
    private String S08;
    @JsonProperty("S08_DIS")
    private String S08_DIS;
    @JsonProperty("S09")
    private String S09;
    @JsonProperty("S09_DIS")
    private String S09_DIS;
    @JsonProperty("S10")
    private String S10;
    @JsonProperty("S10_DIS")
    private String S10_DIS;
    @JsonProperty("S11")
    private String S11;
    @JsonProperty("S11_DIS")
    private String S11_DIS;
    @JsonProperty("S12")
    private String S12;
    @JsonProperty("S12_DIS")
    private String S12_DIS;
    @JsonProperty("S13")
    private String S13;
    @JsonProperty("S13_DIS")
    private String S13_DIS;
    @JsonProperty("S14")
    private String S14;
    @JsonProperty("S14_DIS")
    private String S14_DIS;
    @JsonProperty("S15")
    private String S15;
    @JsonProperty("S15_DIS")
    private String S15_DIS;
    @JsonProperty("S21")
    private String S21;
    @JsonProperty("S21_DIS")
    private String S21_DIS;
    @JsonProperty("CUSTOMER_DESC")
    private String CUSTOMER_DESC;
    @JsonProperty("IS_ADD")
    private boolean IS_ADD;
    @JsonProperty("OLD_CHILD_NUM")
    private int OLD_CHILD_NUM;
    @JsonProperty("PRODUCT_REV")
    private String PRODUCT_REV;
    @JsonProperty("PRODUCT_ROR")
    private boolean PRODUCT_ROR;

    private List<BomItemDto> bomItemDtos = new ArrayList<>();
}
