/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.sap.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.math.BigDecimal;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="report_erp_input_record")
@DynamicUpdate
@DynamicInsert
public class ReportErpInputRecord{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 工单编号
	 */
    @Column(length=100)
    private String code;
    
	/**
	 * 订单单号
	 */
    @Column(length=100)
    private String orderNo;
    
	/**
	 * 仓库编码
	 */
    @Column(length=100)
    private String warehouseCode;
    
	/**
	 * 收发类型编码
	 */
    @Column(length=100)
    private String receiveCode;
    
	/**
	 * 部门编码
	 */
    @Column(length=100)
    private String departmentCode;
    
	/**
	 * 存货编码
	 */
    @Column(length=100)
    private String inventoryCode;
    
	/**
	 * 数量
	 */
    @Column(length=19)
    private BigDecimal quantity;
    
	/**
	 * 件数
	 */
    @Column(length=19)
    private BigDecimal number;
    
	/**
	 * 金额
	 */
    @Column(length=19)
    private BigDecimal cost;
    
	/**
	 * 批号
	 */
    @Column(length=100)
    private String serial;
    
	/**
	 * 创建时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createTime;
    
	/**
	 * 上报时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date pushTime;
    
	/**
	 * 发起人
	 */
    @Column(length=100)
    private String pushUser;
    
	/**
	 * 0未上报，1已上报
	 */
    @Column(length=10)
    private Integer pushed;
    
	/**
	 * 类型(0单晶，1机加，3洗料)
	 */
    @Column(length=10)
    private Integer type;
    
	/**
	 * 备注
	 */
    @Column(length=100)
    private String memory;
    

	public ReportErpInputRecord() {
	}

	public ReportErpInputRecord(Long id) {
		this.id = id;
	}
}
