/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.sap.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.math.BigDecimal;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="report_erp_input_record_detail")
@DynamicUpdate
@DynamicInsert
public class ReportErpInputRecordDetail{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 主表id
	 */
    @Column(length=19)
    private Long rid;
    
	/**
	 * 业务表id
	 */
    @Column(length=19)
    private Long bid;
    
	/**
	 * 重量
	 */
    @Column(length=19)
    private BigDecimal weight;
    
	/**
	 * 批次号
	 */
    @Column(length=100)
    private String batchNo;
    
	/**
	 * 物料名称
	 */
    @Column(length=100)
    private String materialName;
    
	/**
	 * 0未上报，1已上报
	 */
    @Column(length=10)
    private Integer pushed;
    
	/**
	 * 0配料，1灌料
	 */
    @Column(length=10)
    private Integer type;

	/**
	 * 物料料号
	 */
	@Column(length=100)
	private String materialCode;

	/**
	 * 物料料号
	 */
	@Column(length=50)
	private String lotNo;

	/**
	 * erp库位
	 */
	@Column(length=100)
	private String erpWarehouseCode;

	/**
	 * erp批次号
	 */
	@Column(length=100)
	private String erpBatchNo;

    

	public ReportErpInputRecordDetail() {
	}

	public ReportErpInputRecordDetail(Long id) {
		this.id = id;
	}
}
