/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.sap.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.math.BigDecimal;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="report_erp_output_record_detail")
@DynamicUpdate
@DynamicInsert
public class ReportErpOutputRecordDetail {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

	/**
	 * 主表id
	 */
    @Column(length=19)
    private Long rid;

	/**
	 * 长晶棒表id
	 */
	@Column(length=19)
	private Long bid;

	/**
	 * 长晶棒表orderNo
	 */
	@Column(length = 50)
	private String orderNo;

	/**
	 * 重量
	 */
    @Column(length=19)
    private BigDecimal weight;

	/**
	 * 炉次号
	 */
    @Column(length=100)
    private String lotNo;

	/**
	 * 长晶棒编号
	 */
    @Column(length=100)
    private String crystalNo;

	/**
	 * 车间
	 */
	@Column(length=100)
	private String workShop;

	/**
	 * 长度
	 */
	@Column(length=19)
	private BigDecimal length;

	/**
	 * 晶棒类型
	 */
	@Column(length=50)
	private String crystalType;

	/**
	 * 产品类别
	 */
	@Column(length=50)
	private String productType;

	/**
	 * 规格
	 */
	@Column(length=50)
	private String specs;

	/**
	 * 批号
	 */
	@Column(length=50)
	private String batchNo;

	/**
	 * 上报批号
	 */
	@Column(length=50)
	private String pushBatchNo;

	/**
	 * 上报时间
	 */
	@Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
	private Date reportWorkTime;

	/**
	 * 0未上报，1已上报
	 */
	@Column(length=10)
	private Integer reportWorkState;

	/**
	 * 冲销时间
	 */
	@Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
	private Date writeOffAccountsTime;

	/**
	 * 冲销人
	 */
	@Column(length=50)
	private String writeOffAccountsUser;

	/**
	 * 划线时间
	 */
	@Column(length = 19)
	@Temporal(TemporalType.TIMESTAMP)
	private Date startTime;



	public ReportErpOutputRecordDetail() {
	}

	public ReportErpOutputRecordDetail(Long id) {
		this.id = id;
	}
}
