package com.sw.mes.sap.entity;

import java.math.BigDecimal;
import java.util.Date;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import lombok.Data;


/**
 * 物料凭证查询接口对象 report_sap_mblnr_query
 * 
 * @author liru
 * @date 2024-04-15
 */
@Data
@Entity
@Table(name="report_sap_mblnr_query")
@DynamicUpdate
@DynamicInsert
public class ReportSapMblnrQuery
{

    /** ID */
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    /** 物料凭证编号 */
    private String mblnr;

    /** 物料凭证年度 */
    private Integer mjahr;

    /** 物料凭证中的项目 */
    private Integer zeile;

    /** 移动类型（库存管理） */
    
    private String bwart;

    /** 物料号 */
    private String matnr;

    /** 工厂 */
    private String werks;

    /** 工厂名称 */
    private String txtmd;

    /** 库存地点 */
    private String lgort;

    /** 批号 */
    private String charg;

    /** 库存类型 */
    private String insmk;

    /** 特殊库存标识 */
    private String sobkz;

    /** 供应商帐户号 */
    private String lifnr;

    /** 客户的帐户号 */
    private String kunnr;

    /** 销售订单数 */
    private String kdauf;

    /** 销售订单中的项目编号 */
    private Integer kdpos;

    /** 按本位币计的金额 */
    private BigDecimal dmbtr;

    /** 数量 */
    private BigDecimal menge;

    /** 单位 */
    private String meins;

    /** 采购订单编号 */
    private String ebeln;

    /** 采购凭证的项目编号 */
    private Integer ebelp;

    /** 订单号 */
    private String aufnr;

    /** 公司代码 */
    private String bukrs;

    /** 预留/相关需求的编号 */
    private String rsnum;

    /** 预留/相关需求的项目编号 */
    private Integer rspos;

    /** 收货/发货物料 */
    private String ummat;

    /** 收货/发货工厂 */
    private String umwrk;

    /** 收货/发货库存地点 */
    private String umlgo;

    /** 交货单 */
    private String vbelnIm;

    /** 交货项目 */
    private Integer vbelpIm;

    /** 凭证中的过帐日期 */
    @Temporal(TemporalType.DATE)
    private Date budatMkpf;

    /** 会计凭证输入日期 */
    @Temporal(TemporalType.DATE)
    private Date cpudtMkpf;

    /** 输入时间 */
    private String cputmMkpf;

    /** 事务代码 */
    private String tcode2Mkpf;

    /** 物料描述 */
    private String maktx;

    /** 以录入项单位表示的数量 */
    private BigDecimal erfmg;

    /** 录入单位 */
    private String erfme;

    /** 借/贷标识 */
    private String shkzg;

    /** 成本中心 */
    private String kostl;

    /** 参考凭证的凭证号 */
    private String lfbnr;

    /** 参考凭证项目 */
    private Integer lfpos;

    /** 参考凭证会计年度 */
    private Integer lfbja;

    /** 货币码 */
    private String waers;

    /** 项目文本 */
    private String sgtxt;

    /** 收货数量 */
    private BigDecimal wemng;

    /** 箱号(原材料PDA扫描后传输到SAP) */
    private String zboxno;

    /** 送货单 */
    private String dlvno;

    /** 主要资产编号 */
    private String anln1;

    /** 资产子编号 */
    private String anln2;

    /** 凭证中的凭证日期 */
    @Temporal(TemporalType.DATE)
    private Date bldat;

    /** 交易/事件类型 */
    private String vgartMkpf;

    /** 用户名 */
    private String usnamMkpf;

    /** 凭证抬头文本 */
    private String bktxt;

    /** 是否入线边库 */
    private String zsfrxlk;

    /** 线边库编码 */
    private String zcjqx;

    /** 线边库存编码描述 */
    private String zcjqxms;

    /** 标准档位 */
    private String wempf;

    /** 批次特性明细表 */
    private String chartlist;
    
    /** 是否同步 */
    private Boolean syned;

}
