package com.sw.mes.sap.entity;

import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import com.sw.mes.core.annotation.Jinko;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;
import javax.persistence.*;


/**
 * 晶科库存位置信息对象 jinko_warehouse_location
 * 
 * @author liru
 * @date 2024-01-02
 */
@Data
@Entity
@Table(name="jinko_warehouse_location")
@DynamicUpdate
@DynamicInsert
@Jinko(value="晶科库存位置信息对象",author = "liru")
public class WarehouseLocation
{
    /** ID */
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    /** 工厂代码 */
    private String werks;

    /** 工厂名称 */
    private String name1;

    /** 仓库代码 */
    private String lgort;

    /** 仓库描述 */
    private String lgobe;

    /** 创建时间 */
    @Temporal(TemporalType.TIMESTAMP)
    private Date createTime;

}
