package com.sw.mes.sto.dto;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.alibaba.nacos.common.utils.UuidUtils;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.sw.mes.core.utils.DateUtil;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/** 
 * STO Dto
 * @author liru
 *
 */
@Data
public class StoDto {
	//为了解耦MES和SAP，所以调拨数据发到SAP后，SAP会立即通知接收成功，接口断开，后续SAP内部进行STO创建；所以该DATA_ID也用于后续人工在MES中操作进行对应冲销的匹配
	@ApiModelProperty(value = "数据ID")
	@JsonProperty("DATA_ID")
	private String data_id = UuidUtils.generateUuid();
	@ApiModelProperty(value = "发送日期")
	@JsonProperty("DATE")
	private String date = DateUtil.formatDate(new Date(),DateUtil.shortFormat2);
	@ApiModelProperty(value = "是否保税  X 保税 空 非保税")
	@JsonProperty("ZBONDED")
	private String zbonded = "";
	@ApiModelProperty(value = "操作：C 创建 D冲销")
	@JsonProperty("ACTION")
	private String action  = "C";
	@ApiModelProperty(value = "发送时间戳")
	@JsonProperty("TIMESTAMP")
	private String timestamp = new Date().getTime()+"";
	@ApiModelProperty(value = "发送时间")
	@JsonProperty("TIME")
	private String time = DateUtil.formatDate(new Date(),DateUtil.timeFormat);
	@ApiModelProperty(value = "是否定向(X定向 空 非定向)")
	@JsonProperty("ZSFDX")
	private String zsfdx = "";
	@JsonProperty("ITEMS")
	private List<StoItemDto> items = new ArrayList<StoItemDto>();
	
}
