package com.sw.mes.webservice.entity;

import java.util.Date;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;


import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Data
@ApiModel(value="com-sap-www-sapmaster-entity-MaterialNumber")
public class MaterialNumberOutPut {
	@ApiModelProperty(value="")
    private Long id;

    /**
    * 0:Success;  Others:Fail
    */
    @ApiModelProperty(value="0:Success;  Others:Fail")
    private String result;

    /**
    * Success:""; Fail: "Error Description"
    */
    @ApiModelProperty(value="Success:''; Fail: 'Error Description'")
    private String errorDesc;

    /**
    * 物料类型,一级分类
    */
    @ApiModelProperty(value="物料类型,一级分类")
    //private String mtart;
    private String MTART;

    /**
    * 物料类型描述
    */
    @ApiModelProperty(value="物料类型描述")
    //private String mtbez;
    private String MTBEZ;

    /**
    * 物料编码
    */
    @ApiModelProperty(value="物料编码")
    //private String matnr;
    private String MATNR;
    /**
    * 物料描述
    */
    @ApiModelProperty(value="物料描述")
    //private String maktx;
    private String MAKTX;

    /**
    * 物料组，三级分类
    */
    @ApiModelProperty(value="物料组，三级分类")
    //private String matkl;
    private String MATKL;

    /**
    * 物料组描述
    */
    @ApiModelProperty(value="物料组描述")
    //private String wgbez;
    private String WGBEZ;

    /**
    * 外部物料组，二级分类
    */
    @ApiModelProperty(value="外部物料组，二级分类")
    //private String extwg;
    private String EXTWG;

    /**
    * 外部物料组描述
    */
    @ApiModelProperty(value="外部物料组描述")
    //private String ewbez;
    private String EWBEZ;
    /**
    * 计量单位
    */
    @ApiModelProperty(value="计量单位")
    //private String meins;
    private String MEINS;

    /**
    * 旧物料号
    */
    @ApiModelProperty(value="旧物料号")
    //private String bismt;
    private String BISMT;

    /**
    * 工厂编码
    */
    @ApiModelProperty(value="工厂编码")
    //private String werks;
    private String WERKS;

    /**
    * 工厂描述
    */
    @ApiModelProperty(value="工厂描述")
    //private String name1;
    private String NAME1;

    /**
    * 物料状态
    */
    @ApiModelProperty(value="物料状态")
    //private String mstae;
    private String MSTAE;

    /**
    * 删除标识，X代表删除
    */
    @ApiModelProperty(value="删除标识，X代表删除")
    //private String lvorm;
    private String LVORM;

    /**
    * 集采属性（集采、集采VMI、自采，物料工厂视图找1个字段）
    */
    @ApiModelProperty(value="集采属性（集采、集采VMI、自采，物料工厂视图找1个字段）")
    //private String loggr;
    private String LOGGR;
    
    /**
     * 中环集采属性描述
     */
    @ApiModelProperty(value="中环集采属性描述")
    private String LTEXT;

    /**
    * 采购组（具体到人）
    */
    @ApiModelProperty(value="采购组（具体到人）")
    //private String ekgrp;
    private String EKGRP;
    
    /**
     *工厂的批次标识
     */
     @ApiModelProperty(value="工厂的批次标识")
    private String XCHPF;
    
    
    /**
    * 是否启用批号标识（值为X，则代表启用批号管理）
    */
    @ApiModelProperty(value="是否启用批号标识（值为X，则代表启用批号管理）")
    //private String charg;
    private String CHARG;

    /**
    * 其他单位（如果物料存在多个单位，维护其他单位）
    */
    @ApiModelProperty(value="其他单位（如果物料存在多个单位，维护其他单位）")
    //private String meinh;
    private String MEINH;

    /**
    * 单位转换关系分子（如果维护其他单位，此项必填）
    */
    @ApiModelProperty(value="单位转换关系分子（如果维护其他单位，此项必填）")
    //private String umren;
    private String UMREN;

    /**
    * 单位转换关系分母（如果维护其他单位，此项必填）
    */
    @ApiModelProperty(value="单位转换关系分母（如果维护其他单位，此项必填）")
    //private String umrez;
    private String UMREZ;

    /**
    * MPQ舍入值（最小包装数量）
    */
    @ApiModelProperty(value="MPQ舍入值（最小包装数量）")
    //private String bstrf;
    private String BSTRF;
    
    /**
     * 业务类型01-新增；02-修改
     */
    @ApiModelProperty(value="业务类型01-新增；02-修改")
    private String ZBTY;
    

    /**
    * 同步时间(各外围系统抓取，上次同步时间到当前的所有数据)
    */
    @ApiModelProperty(value="同步时间(各外围系统抓取，上次同步时间到当前的所有数据)")
    //private String ztime;
    private String ZTIME;

    @ApiModelProperty(value="")
    private Date createDate;
	
	
}
