/**   
 * @Title: SapRequestYieldHoursLog.java 
 * @Package com.sw.mes.webservice.entity 
 * @Description: TODO(用一句话描述该文件做什么) 
 * @author 中环 keily  
 * @date 2022年2月28日 下午1:50:40 
 * @version V1.0   
 */   
     
package com.sw.mes.webservice.entity;

import java.math.BigDecimal;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/** 
 * @ClassName: SapRequestYieldHoursLog 
 * @Description: 向sap发送的gr圆棒入库数据记录表
 * @author 中环 keily
 * @date 2022年2月28日 下午1:50:40 
 *  
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@Entity
@Table(name="send_sap_warehousing_statistics_info_yb")
@DynamicUpdate
@DynamicInsert
public class SendSapWarehousingStatisticsInfoYb {
	
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;
	
	/**
     * MES DATA Key ID Number
     */
    @Column(length = 64)
    private String zmesid;
    
    /**
     * 订单号
     */
    @Column(length=150)
    private String orderNo;
    
    /**
     * 料号
     */
    @Column(length=50)
    private String materialCode;
    
    /**
     * 工厂编码
     */
    @Column(length = 10)
    private String werks;
	
    /**
     * 理论重量
     */
    @Column(length = 19)
    private BigDecimal theoryWeight;

    /**
     * 基本单位
     */
    @Column(length = 10)
    private String meins;

    /**
     * 产品批次信息
     */
    @Column(length = 10)
    private String charg;
    

    /**
     * 货物接收日期
     */
    @Column(length = 10)
    private String grdate;

    /**
     * 货物接收时间
     */
    @Column(length = 10)
    private String grtime;
    
    /**
     * 产品等级
     */
    @Column(length = 10)
    private String grade;
    

    /**
     * 业务类型
     */
    @Column(length = 10)
    private String bty;
    

    /**
     * 收货库存地点
     */
    @Column(length = 10)
    private String lgort;
    
    
    /**
     * 批次特性1
     */
    @Column(length=50)
    private String batchval1;
    
    /**
     * 批次特性2
     */
    @Column(length=50)
    private String batchval2;
    

    /**
     * 批次特性3
     */
    @Column(length=50)
    private String batchval3;
    

    /**
     * 批次特性4
     */
    @Column(length=50)
    private String batchval4;
    

    /**
     * 批次特性5
     */
    @Column(length=50)
    private String batchval5;
    

    /**
     * 批次特性6
     */
    @Column(length=50)
    private String batchval6;

    /**
     * 批次特性7
     */
    @Column(length=50)
    private String batchval7;
    

    /**
     * 批次特性8
     */
    @Column(length=50)
    private String batchval8;
    
    /**
     * 创建时间
     */
    @Column(length = 19)
    @Temporal(TemporalType.TIMESTAMP)
    private Date createTime;
    
    /**
   	 * 状态（0：失败；1：成功）
   	 */
   @Column(length=40)
   private String status;
    
    /**
     * 晶段编号(短棒)
     */
    @Column(length = 50)
    private String sectionNo;
    
    
}
