/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.wms.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.math.BigDecimal;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="report_wms_record")
@DynamicUpdate
@DynamicInsert
public class ReportWmsRecord{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;
    
	/**
	 * 编号
	 */
    @Column(length=64)
    private String no;
    
	/**
	 * 1毛棒 2圆晶段
	 */
    @Column(length=10)
    private Integer type;
    
	/**
	 * 1报工成功  0报工失败
	 */
    @Column(length=10)
    private Integer status;
    
	/**
	 * 创建时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createTime;
    
	/**
	 * 创建人
	 */
    @Column(length=32)
    private String createUser;
    
	/**
	 * 单据号
	 */
    @Column(length=64)
    private String planNo;
    
	/**
	 * 料号
	 */
    @Column(length=64)
    private String materialNo;
    
	/**
	 * 数量
	 */
    @Column(length=19)
    private BigDecimal materialQty;
    
	/**
	 * 规格
	 */
    @Column(length=64)
    private String specification;
    
	/**
	 * 单位
	 */
    @Column(length=32)
    private String unit;
    
	/**
	 * 总长度
	 */
    @Column(length=19)
    private BigDecimal length;
    
	/**
	 * 总重量
	 */
    @Column(length=19)
    private BigDecimal width;
    
	/**
	 * 备注
	 */
    @Column(length=255)
    private String remark;

    /**
     * 失败原因
     */
    @Column
    private String reason;

	public ReportWmsRecord() {
	}

	public ReportWmsRecord(Integer id) {
		this.id = id;
	}
}
