package com.sw.mes.yb.accessory.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotNull;
import java.util.Date;

@Data
@ApiModel(value = "辅料更换申请dto")
public class AccessoryApplyDto extends SpareDto {

    private Long id;

//    /** 辅料类型字典名称 **/
//    @ApiModelProperty(value = "辅料类型字典名称")
//    private String accessoryTypeName;
//
//    /** 辅料类型字典值 **/
//    @ApiModelProperty(value = "辅料类型字典值")
//    private String accessoryTypeValue;
//
//    @ApiModelProperty(value = "料号")
//    private String codes;

    @ApiModelProperty(value = "热场监控id")
    Integer equipmentAccessoryId;

    @ApiModelProperty(value = "辅料模型id" , required = true)
    Long materialId;
    @ApiModelProperty(value = "热场名称")
    String materialName;

    @NotNull(message = "热场编码不能空")
    @ApiModelProperty(value = "热场编码（料号）")
    String materialCodes;

    @ApiModelProperty(value = "单位")
    String materialUnitName;

    @ApiModelProperty(value = "设备ID" , required = true)
    Long equipmentId;

    @NotNull(message = "设备编号不能空")
    @ApiModelProperty(value = "设备编号")
    String equipmentCode;

    @ApiModelProperty(value = "申请人")
    String applyUser;

    @ApiModelProperty(value = "申请时间" )
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date applyDate;

    @ApiModelProperty(value = "申请人工号")
    String applyUserNo;

    @ApiModelProperty(value = "状态更新时间" )
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date stateDate;

    @ApiModelProperty(value = "状态")
    String state;

    @ApiModelProperty(value = "物料编号")
    String goodsCode;

    AccessoryMaterialDto materialDto;

    @ApiModelProperty(value = "数量")
    Integer num;

    @ApiModelProperty(value = "申请原因")
    String reason;

    @ApiModelProperty(value = "申请单号")
    String pickNo;
}
