package com.sw.mes.yb.accessory.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.Digits;
import javax.validation.constraints.Min;
import javax.validation.constraints.NotNull;

/**
 * @author liuzemin
 * @date 2022/8/10 8:56
 * @description
 */
@Data
public class MaterialOutDto {
    @NotNull(message = "设备号不能空")
    @ApiModelProperty(value = "设备号" )
    String deviceNo;
    @NotNull(message = "热场料号不能空")
    @ApiModelProperty(value = "热场料号" )
    String productNo;
    @Min(value = 1,message = "数量得大于等于1")
    @Digits(integer = 9, fraction = 0, message = "num数量请填整数") //整数位上限9位，小数位上限0位
    @ApiModelProperty(value = "数量" )
    Integer num;
    @ApiModelProperty(value = "单位" )
    String unitName;
    @ApiModelProperty(value = "备注" )
    String reamrk;
    @NotNull(message = "唯一编码不能空")
    @ApiModelProperty(value = "唯一编码(热场条码)" )
    String uniqueCode;
    @ApiModelProperty(value = "供应商" )
    String supplierName;
    @ApiModelProperty(value = "批次" )
    String batchNum;
    @ApiModelProperty(value = "领用人工号" )
    String receiverCode;
    @ApiModelProperty(value = "领用人名称" )
    String receiverName;
    @NotNull(message = "领料单号不能空")
    @ApiModelProperty(value = "领料单号" )
    String pickNo;
}
