/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.accessory.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="zhxx_accessory_log")
@DynamicUpdate
@DynamicInsert
public class AccessoryLog {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;
    
	/**
	 * 请求内容
	 */
    @Column(length=65535)
    private String content;
    
	/**
	 * 创建时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createTime;
    
	/**
	 * 用户id
	 */
    @Column(length=10)
    private Integer createUserId;
    
	/**
	 * 用户名称
	 */
    @Column(length=50)
    private String createUserName;
    
	/**
	 * 方法名
	 */
    @Column(length=255)
    private String methodName;
    
	/**
	 * 日志名称
	 */
    @Column(length=250)
    private String name;
    
	/**
	 * 返回结果
	 */
    @Column(length=65535)
    private String result;
    
	/**
	 * 日志类型：info,error,warn,trace
	 */
    @Column(length=50)
    private String type;
    

	public AccessoryLog() {
	}

	public AccessoryLog(Integer id) {
		this.id = id;
	}
}
