package com.sw.mes.yb.agv.dto;

import javax.validation.constraints.NotBlank;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 *       取消AGV任务DTO
 * @Author 李儒
 * @Description：具体传入参数参考AGV配置对应关键字内容
 * @Date: Create in
 * @Modified By:
 */
@Data
@ApiModel(value = "AgvCancelDto")
public class AgvCancelDto {
	
	@ApiModelProperty(value = "关键字（用于查找avg配置信息）")
	@NotBlank(message = "请输入关键字(对应AGV配置中的关键字)")
	private String keyword;
	@ApiModelProperty(value = "请求编号(取消AGV任务专用)" )
    private String reqCode;
    @ApiModelProperty(value = "任务编号(对应呼叫成功返回结果，记录表字段 otherTaskId)" )
    private String taskCode;
    
}