package com.sw.mes.yb.agv.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.validator.constraints.*;

import javax.validation.constraints.*;

import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@ApiModel(value = "AgvDispatchDeployRecordDto")
public class AgvDispatchDeployRecordDto {

    private Long id;
     @ApiModelProperty(value = "请求地址" )
     String url;
     @ApiModelProperty(value = "关键字（用于查找avg配置信息）" )
     String keyword;
     @ApiModelProperty(value = "接口数据JSON格式" )
     String interfaceData;
     @ApiModelProperty(value = "返回结果" )
     String results;
     @ApiModelProperty(value = "调用时间" , required = true)
     @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
     Date callTime;
     @ApiModelProperty(value = "用时（单位:ms）" )
     Integer useTime;
     @ApiModelProperty(value = "调用人员" )
     String dispatchUser;
     @ApiModelProperty(value = "记录当前任务自动重发第几次" )
     Integer autoResend;
     @ApiModelProperty(value = "对应记录ID" )
     Long recordId;
     @ApiModelProperty(value = "是否调用成功【1：是，默认；0：否；】" )
     Integer isSuccess;
     @ApiModelProperty(value = "agv_dispatch_deploy.id主键" )
     Long dispatchDeployId;
     @ApiModelProperty(value = "自动生成时间，不需要记录,用于分区" , required = true)
     @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
     Date gmtTime;
     
     @ApiModelProperty(value = "接口类型(AGV任务派发/取消AGV任务)" )
     private String type;
     @ApiModelProperty(value = "回调接口地址(格式: http://ip:port/url)" )
     private String callbackMsg;
     @ApiModelProperty(value = "请求编号(取消AGV任务专用)" )
     private String reqCode;
     @ApiModelProperty(value = "任务编号(取消AGV任务专用)" )
     private String taskCode;
}