/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.agv.entity;

import java.util.Date;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="agv_dispatch_deploy")
@DynamicUpdate
@DynamicInsert
public class AgvDispatchDeploy{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 请求地址
	 */
    @Column(length=500)
    private String url;
    
	/**
	 * 接口数据JSON格式
	 */
    @Column(length=0)
    private String interfaceData;
    
	/**
	 * 编码生成方式（任务编码）
	 */
    @Column(length=50)
    private String otherTaskId;
    
	/**
	 * 优先级
	 */
    @Column(length=16)
    private String priority;
    
	/**
	 * 起始位置编码
	 */
    @Column(length=32)
    private String startCode;
    
	/**
	 * 开始工作位
	 */
    @Column(length=32)
    private String startPoint;
    
	/**
	 * 结束位置编号
	 */
    @Column(length=32)
    private String endCode;
    
	/**
	 * 结束工作位
	 */
    @Column(length=32)
    private String targetPoint;
    
	/**
	 * 任务类型
	 */
    @Column(length=16)
    private String agvTaskType;
    
	/**
	 * 载具编号
	 */
    @Column(length=32)
    private String frockCode;
    
	/**
	 * 载具类型
	 */
    @Column(length=32)
    private String frockType;
    
	/**
	 * 单晶编号
	 */
    @Column(length=50)
    private String crystalNo;
    
	/**
	 * 配方ID
	 */
    @Column(length=16)
    private String recipeId;
    
	/**
	 * 重量ID
	 */
    @Column(length=16)
    private String weightId;
    
    
    /**
	 * 接口类型(AGV任务派发/取消AGV任务)
	 */
    @Column(length=80)
    private String type;
    
    /**
	 * 回调接口地址(格式: http://ip:port/url)
	 */
    @Column(length=80)
    private String callbackMsg;
    
    
    /**
	 * 请求编号(取消AGV任务专用)
	 */
    @Column(length=80)
    private String reqCode;
    
    /**
	 * 任务编号(取消AGV任务专用)
	 */
    @Column(length=80)
    private String taskCode;
    
    
	/**
	 * 关键字（用于查找avg配置信息）
	 */
    @Column(length=50)
    private String keyword;
    
	/**
	 * 自动生成时间，不需要记录，用于分区
	 */
    @Column(nullable=false, length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date gmtTime;
    
	/**
	 * 自动重发次数
	 */
    @Column(nullable=false, length=10)
    private Integer againTime;
    
	/**
	 * 超时时间(单位：ms )
	 */
    @Column(nullable=false, length=10)
    private Integer timeout;
    
    
    /**
	 * 库位锁定状态(0：解锁；1：锁定)
	 */
    @Column(length=10)
    private String locked;
    
    
    /**
	 * 位置编号(需操作的目标)
	 */
    @Column(length=40)
    private String posCode;

	public AgvDispatchDeploy() {
	}

	public AgvDispatchDeploy(Long id) {
		this.id = id;
	}
}
