package com.sw.mes.yb.alloy.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.List;

/**
 * @author lf
 * @description 炉台号相关信息
 * @date 2024/1/15 14:27
 */
@Data
@ApiModel(value = "炉台号相关信息Dto")
public class FurnaceBedDto {
    /**
     * 工号
     */
    @ApiModelProperty("工号")
    private String workNumber;
    /**
     * 姓名
     */
    @ApiModelProperty("姓名")
    private String userName;
    /**
     * 炉台号
     */
    @ApiModelProperty("炉台号")
    private String furnaceCode;
    /**
     * 炉次号
     */
    @ApiModelProperty("炉次号")
    private String lotNo;
    /**
     * 加次
     */
    @ApiModelProperty("加次")
    private Integer addTime;
    /**
     * 报料主产品
     */
    @ApiModelProperty(value = "报料主产品")
    private String informationMainProduct;
    /**
     * 工单号
     */
    @ApiModelProperty(value = "工单号")
    private String workOrderNumber;
    /**
     * 报料信息
     */
    @ApiModelProperty(value = "报料信息")
    private String informationMessage;
    /**
     * 上一棒重量
     */
    @ApiModelProperty(value = "上一棒重量")
    private BigDecimal upBarWeight;
    /**
     * 留锅量
     */
    @ApiModelProperty(value = "留锅量")
    private BigDecimal remainingPotCapacity;
    /**
     * 上一棒电阻
     */
    @ApiModelProperty(value = "上一棒电阻")
    private BigDecimal upBarResistance;
    /**
     * 是否完结（0是1否）
     */
    @ApiModelProperty(value = "是否完结（0是1否）")
    private Integer isEnd;
    /**
     * 本棒电阻
     */
    @ApiModelProperty(value = "本棒电阻")
    private BigDecimal resistanceOfThisRod;
    /**
     * 热场尺寸
     */
    @ApiModelProperty(value = "热场尺寸")
    private String heatDimension;
    /**
     * 多晶硅电阻
     */
    @ApiModelProperty(value = "多晶硅电阻")
    private BigDecimal polysiliconResistance;
    /**
     * 多晶硅重量
     */
    @ApiModelProperty(value = "多晶硅重量")
    private BigDecimal polysiliconWeight;
    /**
     * 循环料1电阻
     */
    @ApiModelProperty(value = "循环料1电阻")
    private BigDecimal recycledMaterialOneResistance;
    /**
     * 循环料1重量
     */
    @ApiModelProperty(value = "循环料1重量")
    private BigDecimal recycledMaterialOneWeight;
    /**
     * 循环料2电阻
     */
    @ApiModelProperty(value = "循环料2电阻")
    private BigDecimal recycledMaterialTwoResistance;
    /**
     * 循环料2重量
     */
    @ApiModelProperty(value = "循环料2重量")
    private BigDecimal recycledMaterialTwoWeight;
    /**
     * 循环料3电阻
     */
    @ApiModelProperty(value = "循环料3电阻")
    private BigDecimal recycledMaterialThreeResistance;
    /**
     * 循环料3重量
     */
    @ApiModelProperty(value = "循环料3重量")
    private BigDecimal recycledMaterialThreeWeight;
    /**
     * 循环料4电阻
     */
    @ApiModelProperty(value = "循环料4电阻")
    private BigDecimal recycledMaterialFourResistance;
    /**
     * 循环料4重量
     */
    @ApiModelProperty(value = "循环料4重量")
    private BigDecimal recycledMaterialFourWeight;
    /**
     * 循环料5电阻
     */
    @ApiModelProperty(value = "循环料5电阻")
    private BigDecimal recycledMaterialFiveResistance;
    /**
     * 循环料5重量
     */
    @ApiModelProperty(value = "循环料5重量")
    private BigDecimal recycledMaterialFiveWeight;
    /**
     * 循环料6电阻
     */
    @ApiModelProperty(value = "循环料6电阻")
    private BigDecimal recycledMaterialSixResistance;
    /**
     * 循环料6重量
     */
    @ApiModelProperty(value = "循环料6重量")
    private BigDecimal recycledMaterialSixWeight;
    /**
     * 循环料7电阻
     */
    @ApiModelProperty(value = "循环料7电阻")
    private BigDecimal recycledMaterialSevenResistance;
    /**
     * 循环料7重量
     */
    @ApiModelProperty(value = "循环料7重量")
    private BigDecimal recycledMaterialSevenWeight;
//    /**
//     * 循环料重量和电阻
//     */
//    @ApiModelProperty("循环料重量和电阻")
//    private List<RecycledMaterialDto> recycledMaterialDtoList;
    /**
     * 修正值
     */
    @ApiModelProperty("修正值")
    private BigDecimal correcting;
    /**
     * 修正后电阻
     */
    @ApiModelProperty("修正后电阻")
    private BigDecimal correctingAfterResistance;
    /**
     * 检验列表
     */
    @ApiModelProperty("检验列表")
    private List<InspectionListDto> inspectionListDtoList;
    /**
     * 修正记录
     */
    @ApiModelProperty("修正记录")
    private List<CorrectingRecordDto> correctingRecordDtoList;
    /**
     * 配方信息
     */
    @ApiModelProperty(value = "配方信息")
    private String recipeInformation;
    /**
     * 计算上一棒重量的留锅量
     */
    @ApiModelProperty(value = "计算上一棒重量的留锅量")
    private BigDecimal upBarWeightRemainingPotCapacity;
    /**
     * 上一棒重量的投料量
     */
    @ApiModelProperty(value = "计算上一棒重量的投料量")
    private BigDecimal headMaterialQuantity;
}
