/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.alloy.entity;


import lombok.Data;

import javax.persistence.*;

import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@Entity
@Table(name = "alloy_raw_material_level")
@DynamicUpdate
@DynamicInsert
public class RawMaterialLevel {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;

    /**
     * 物料号
     */
    @Column(nullable = false, length = 50)
    private String materialCode;

    /**
     * 物料名称
     */
    @Column(length = 255)
    private String materialName;

    /**
     * 电阻档位
     */
    @Column(length = 20)
    private String resistanceGear;

    /**
     * 电阻值
     */
    @Column(length = 20)
    private BigDecimal resistanceValue;

    /**
     * 创建人
     */
    @Column
    private String createUser;
    /**
     * 创建时间
     */
    @Column
    @Temporal(TemporalType.TIMESTAMP)
    private Date createDate;
    /**
     * 修改人
     */
    @Column
    private String updateUser;
    /**
     * 修改时间
     */
    @Column
    @Temporal(TemporalType.TIMESTAMP)
    private Date updateDate;

    public RawMaterialLevel() {
    }

    public RawMaterialLevel(Integer id) {
        this.id = id;
    }
}
