/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.alloy.entity;

import java.math.BigDecimal;
import java.util.Date;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="alloy_resistance_of_this_rod")
@DynamicUpdate
@DynamicInsert
public class ResistanceOfThisRod{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;
    
	/**
	 * 炉台号
	 */
    @Column(length=50)
    private String furnaceCode;
    
	/**
	 * 热场
	 */
    @Column(length=20)
    private String heatField;
    
	/**
	 * 加次
	 */
    @Column(length=20)
    private Integer addTime;
    
	/**
	 * 物料简称
	 */
    @Column(length=50)
    private String materialShortName;
    
	/**
	 * 本棒电阻
	 */
    @Column(length=20)
    private BigDecimal resistanceOfThisRod;
	/**
	 * 创建人
	 */
	@Column
	private String createUser;
	/**
	 * 创建时间
	 */
	@Column
	@Temporal(TemporalType.TIMESTAMP)
	private Date createDate;
	/**
	 * 修改人
	 */
	@Column
	private String updateUser;
	/**
	 * 修改时间
	 */
	@Column
	@Temporal(TemporalType.TIMESTAMP)
	private Date updateDate;
    

	public ResistanceOfThisRod() {
	}

	public ResistanceOfThisRod(Integer id) {
		this.id = id;
	}
}
