/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.check.entity;

import java.util.Date;
import java.math.BigDecimal;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@Entity
@Table(name = "oxygen_reversal_log")
@DynamicUpdate
@DynamicInsert
public class OxygenReversalLog {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 检验时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date checkTime;
    
	/**
	 * 单晶编号
	 */
    @Column(length=100)
    private String motherCrystalNo;
    
	/**
	 * 炉次号
	 */
    @Column(length=50)
    private String lotNo;
    
	/**
	 * 片区
	 */
    @Column(length=50)
    private String area;
    
	/**
	 * 车间
	 */
    @Column(length=50)
    private String workShop;
    
	/**
	 * 头氧含量中心
	 */
    @Column(length=19)
    private BigDecimal headOxyenContents;
    
	/**
	 * 尾氧含量中心
	 */
    @Column(length=19)
    private BigDecimal tailOxyenContents;
    

	public OxygenReversalLog() {
	}

	public OxygenReversalLog(Long id) {
		this.id = id;
	}
}
