package com.sw.mes.yb.check.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 【圆棒生产域—检验数据】样片检验【新】
 * @TableName zhxx_operate_piece_check
 */
@Table(name="auto_zhxx_operate_piece_check")
@Data
@Entity
@DynamicUpdate
@DynamicInsert
public class ZhxxOperatePieceCheck implements Serializable {
    /**
     * 主键
     */
    @Id
    private Long id;

    /**
     * 碳含量
     */
    @Column(name = "c_contents")
    private BigDecimal cContents;

    /**
     * 检验时间
     */
    @Column(name = "check_time")
    private Date checkTime;

    /**
     * 设备编号
     */
    @Column(name = "device_no")
    private String deviceNo;

    /**
     * 样片编号
     */
    @Column(name = "piece_no")
    private String pieceNo;

    /**
     * 氧含量中心
     */
    @Column(name = "o_contents")
    private BigDecimal oContents;

    /**
     * 厚度
     */
    @Column(name = "thickness")
    private BigDecimal thickness;

    /**
     * 备注
     */
    @Column(name = "remark")
    private String remark;

    /**
     * 记录人ID
     */
    @Column(name = "user_id")
    private String userId;

    /**
     * 记录人
     */
    @Column(name = "user_name")
    private String userName;

    /**
     * 单晶编号
     */
    @Column(name = "mother_crystal_no")
    private String motherCrystalNo;

    /**
     * 拉取状态 0是否，1是是
     */
    @Column(name = "type")
    private String type;

    private static final long serialVersionUID = 1L;

}