/**
 * There are liru code generation
 */
package com.sw.mes.yb.check.entity.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @Author liru
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@ApiModel(value = "入库明细Dto")
public class StoreInputItemDto {
    private Integer id;

    /**
     * 物品条码
     **/
    @ApiModelProperty(value = "物品条码", required = true)
    String goodsCode;

    /**
     * 物品批次号
     **/
    @ApiModelProperty(value = "物品批次号", required = true)
    String goodsNo;

    /**
     * 数量
     **/
    @ApiModelProperty(value = "数量")
    BigDecimal count;

    /**
     * 物料模型id
     **/
    @ApiModelProperty(value = "物料模型id")
    Integer materialModelId;
    /**
     * 物料模型名称
     **/
    @ApiModelProperty(value = "物料模型名称", required = true)
    String materialModelName;

    /**
     * 物料模型编码
     **/
    @ApiModelProperty(value = "物料模型编码", required = true)
    String materialModelCode;


    /**
     * 物料模型规格
     **/
    @ApiModelProperty(value = "物料模型规格", required = true)
    String materialModelSpecification;

    /**
     * 所属类别
     **/
    @ApiModelProperty(value = "所属类别", required = true)
    String materialModelMaterialTypeName;

    @ApiModelProperty(value = "单位", required = true)
    String materialModelUnitName;

    @ApiModelProperty(value = "入库单号", required = true)
    String storeInputBillCode;

    @ApiModelProperty(value = "入库类型", required = true)
    String storeInputBillInputTypeDictName;

    @ApiModelProperty(value = "入库类型id", required = true)
    Integer storeInputBillInputTypeDictId;

    @ApiModelProperty(value = "入库时间", required = true)
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date storeInputBillCreateTime;

    @ApiModelProperty(value = "录入人", required = true)
    String storeInputBillCreateUserName;

    @ApiModelProperty(value = "申请单号", required = true)
    String storeInputBillStoreInputApplyCode;

    /**
     * 扩展属性
     **/
    @ApiModelProperty(value = "扩展属性", required = true)
    String properties;

    /**
     * 库位id
     **/
    @ApiModelProperty(value = "库位id", required = true)
    Integer storeLocationId;
    /**
     * 库位名称
     **/
    @ApiModelProperty(value = "库位名称", required = true)
    String storeLocationName;
    /**
     * 备注
     **/
    @ApiModelProperty(value = "备注", required = true)
    String remark;

    /**
     * 入库单id
     **/
    @ApiModelProperty(value = "入库单id")
    Integer storeInputBillId;


    /**
     * 炉次号
     **/
    @ApiModelProperty(value = "炉次号")
    String lotNo;

}
