/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.deviceCheck.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.math.BigDecimal;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="zhxx_operate_device_clean_record")
@DynamicUpdate
@DynamicInsert
public class DeviceCleanRecord{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;
    
	/**
	 * 系列
	 */
    @Column(length=20)
    private String deviceSeries;
    
	/**
	 * 设备编号
	 */
    @Column(length=50)
    private String deviceNo;
    
	/**
	 * 炉次号
	 */
    @Column(length=255)
    private String lotNo;
    
	/**
	 * 拆清操作人1
	 */
    @Column(length=255)
    private String cleanOpertor1;
    
	/**
	 * 拆清操作人2
	 */
    @Column(length=255)
    private String cleanOpertor2;
    
	/**
	 * 拆清开始时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date cleanStartTime;
    
	/**
	 * 转单时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date transferTime;
    
	/**
	 * 拆清结束时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date cleanEndTime;
    
	/**
	 * 拆清耗时
	 */
    @Column(length=50)
    private BigDecimal cleanHour;
    
	/**
	 * 捅管道开始时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date pokeStartTime;
    
	/**
	 * 捅管道结束时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date pokeEndTime;
    
	/**
	 * 捅管管道操作人
	 */
    @Column(length=255)
    private String pokeOpertor;
    
	/**
	 * 打磨人
	 */
    @Column(length=255)
    private String polishOpertor;
    
	/**
	 * 开始打磨时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date polishStartTime;
    
	/**
	 * 结束打磨时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date polishEndTime;
    

	public DeviceCleanRecord() {
	}

	public DeviceCleanRecord(Integer id) {
		this.id = id;
	}
}
