package com.sw.mes.yb.fls.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * @Author: GaoXinJian
 * @Date: 2022-01-13 10:51
 */
@Data
@ApiModel(value = "画线数据请求接口Dto")
public class PaintingLineInfoDto {
    @ApiModelProperty(value = "工位号" )
    String locationNo;
    @ApiModelProperty(value = "晶棒SN" )
    String crystalNo;
    @ApiModelProperty(value = "收尾方式" )
    String windUp;
    @ApiModelProperty(value = "单晶重量")
    BigDecimal weight;
    @ApiModelProperty("单晶规格（直径）")
    String  specification;
    @ApiModelProperty(value = "单晶长度")
    BigDecimal  length;
    @ApiModelProperty(value = "是否反切")
    Integer    recut;
    @ApiModelProperty(value = "导电类型")
    String conductionType;
    @ApiModelProperty(value = "长晶棒产出时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date time;
    @ApiModelProperty(value = "画线方向。0从头到尾，1从尾到头")
    Integer direc;
    @ApiModelProperty(value = "画线明细")
    List<PaintingLineInfoDetailDto> paintingLineInfoDetailDtoList;
}
