
package com.sw.mes.yb.fls.entity;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.util.Date;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@Entity
@Accessors(chain = true)
@Table(name = "recycled_wait_record")
@DynamicUpdate
@DynamicInsert
public class RecycledWaitRecord {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    @ApiModelProperty("单晶编号")
    private String sectionNo;
    @ApiModelProperty("载具车号")
    private String pailNum;
    @ApiModelProperty("载具车工位号")
    private String locationNo;
    @ApiModelProperty("地码编号")
    private String landmarkCode;
    @ApiModelProperty("状态(1待上传fls，2已上传fls)")
    private Integer status;
    @ApiModelProperty("回收料类型(回收料,样片)")
    private String materialType;
    @ApiModelProperty("创建时间")
    private Date createTime;
    @ApiModelProperty("创建人")
    private String createUser;
    @ApiModelProperty("修改人时间")
    private Date updateTime;
    @ApiModelProperty("修改人")
    private String updateUser;
    @ApiModelProperty("备用字段1")
    private String remark1;
    @ApiModelProperty("备用字段2")
    private String remark2;

}
