package com.sw.mes.yb.ipc.dto;

import java.util.HashMap;
import java.util.Map;

import javax.persistence.Column;
import javax.validation.constraints.NotBlank;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Data
@ApiModel(value = "按钮操作参数Dto")
public class ButtonClickDto {
	
	@ApiModelProperty(value = "设备编号" )
	@NotBlank(message = "设备编号为空")
    private String equipmentCode;
	
	@ApiModelProperty(value = "当前炉次号" )
	private String lotNo;
	
	@ApiModelProperty(value = "当前系列")
    private String series;
	
	@ApiModelProperty(value = "模块(非必填)")
    private String area;
	
	@ApiModelProperty(value = "按钮名称" )
	@NotBlank(message = "按钮名称为空")
	private String buttonName;
	
	@ApiModelProperty(value = "操作人")
	@NotBlank(message = "操作人为空")
	private String userName;
	
	@ApiModelProperty(value = "班次" )
	@NotBlank(message = "班次为空")
    String classNo;
	
    @ApiModelProperty(value = "班组" )
    @NotBlank(message = "班组为空")
    String teamGroup;
    
    @ApiModelProperty(value = "当前复投任务Id" )
    String againTaskId;
    
    @ApiModelProperty(value = "当前灌料任务Id" )
    String detailTaskId;
	
	@ApiModelProperty(value = "参数" )
	private Map<String,Object> params = new HashMap<String,Object>();
	
}
