package com.sw.mes.yb.ipc.dto;

import com.sw.mes.base.factory.init.dto.Equipment.EquipmentDto;
import com.sw.mes.yb.deviceCheck.dto.DeviceCheckTimeRecordInfo;
import com.sw.mes.yb.production.dto.EquipmentClickLogDto;
import com.sw.mes.yb.production.dto.EquipmentExtendStateDto;
import com.sw.mes.yb.production.dto.AgainTask.AgainTaskDto;
import com.sw.mes.yb.production.dto.AgainTaskDetail.AgainTaskDetailDto;
import com.sw.mes.yb.report.dto.CrystalPullingInfoDto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
* @Author 李儒
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@ApiModel(value = "工控机数据Dto")
public class IpcDataDto {
	@ApiModelProperty(value = "设备信息" )
    private EquipmentDto equipmentDto;
	@ApiModelProperty(value = "设备扩展信息(登录人信息,液位杆,设备状态)" )
	private EquipmentExtendStateDto equipmentExtendState;
    @ApiModelProperty(value = "复投桶使用情况)" )
    private BucketUseInfoDto bucketUseInfo;
    @ApiModelProperty(value = "当前颗次信息(当前任务)" )
    private ProductionTaskDto currentTask;
    @ApiModelProperty(value = "下一颗次信息(当前任务)" )
    private ProductionTaskDto nextTask;
    @ApiModelProperty(value = "复投信息" )
    private AgainTaskInfoDto againTaskInfoDto;
    @ApiModelProperty(value = "最新操作记录" )
    private EquipmentClickLogDto equipmentClickLogDto;
    @ApiModelProperty(value = "拉晶情况" )
    private CrystalPullingInfoDto crystalPullingInfoDto;
    @ApiModelProperty(value = "库位锁定状态" )
    private Boolean storeLock = false;
    @ApiModelProperty(value = "当前炉次号" )
    private String lotNo;
    @ApiModelProperty(value = "当前复投任务" )
    private AgainTaskDto againTask;
    @ApiModelProperty(value = "当前灌料任务" )
    private AgainTaskDetailDto detailTask;
    @ApiModelProperty(value = "拆清点检info")
    private DeviceCheckTimeRecordInfo deviceCheckTimeRecordInfo;
}
