/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.ipc.entity;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import lombok.Data;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="production_bucket_use_info")
@DynamicUpdate
@DynamicInsert
public class BucketUseInfo{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 系列
	 */
    @Column(length=50)
    private String series;
    
	/**
	 * 模块
	 */
    @Column(length=50)
    private String area;
    
	/**
	 * 总数量
	 */
    @Column(length=10)
    private Integer totalNum;
    
	/**
	 * 使用数
	 */
    @Column(length=10)
    private Integer useNum;
    
	/**
	 * 空闲数
	 */
    @Column(length=10)
    private Integer idleNum;
    
	/**
	 * 记录时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createTime;
    

	public BucketUseInfo() {
	}

	public BucketUseInfo(Long id) {
		this.id = id;
	}
}
