package com.sw.mes.yb.mcs.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

/**
 * @Author wanghao
 * @Date: 2022/6/8
 * @Modified By:
 */
@Data
@ApiModel(value = "头尾料分类信息")
public class HeadTailMaterialTypeDto {
    @ApiModelProperty(value = "托位号" )
    private Integer bracketNo;

    @ApiModelProperty(value = "回收料名称" )
    private String recoveryName;

    /**
     * 晶段编号
     */
    @ApiModelProperty(value = "晶段编号" )
    private String sectionNo;

    /**
     * 径向电阻率中心点
     */
    @ApiModelProperty(value = "径向电阻率中心点" )
    private BigDecimal tempRadialCentre;

    /**
     * 径向电阻率边缘1
     */
    @ApiModelProperty(value = "径向电阻率边缘" )
    private BigDecimal tempRadialEdge1;

    /**
     * sition中心寿命
     */
    @ApiModelProperty(value = "sition中心寿命" )
    private BigDecimal centreLife;

    /**
     * sitionT边缘寿命
     */
    @ApiModelProperty(value = "sitionT边缘寿命" )
    private BigDecimal lifeEdge1;

    /**
     * 碳含量中心
     */
    @ApiModelProperty(value = "碳含量中心" )
    private BigDecimal carbonContent;

    /**
     * 碳含量边缘
     */
    @ApiModelProperty(value = "碳含量边缘" )
    private BigDecimal carbonContentBorder;

    /**
     * T氧含量中心
     */
    @ApiModelProperty(value = "T氧含量中心" )
    private BigDecimal oxygenContentHead;

    /**
     * 产品等级
     */
    @ApiModelProperty(value = "产品等级" )
    private String productLevel;

}
