package com.sw.mes.yb.mcs.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

/**
 * @Author: GaoXinJian
 * @Date: 2022-01-12 17:19
 */
@Data
@ApiModel(value = "拼棒托盘绑定Dto")
public class SpellBindingDto {
    @ApiModelProperty(value = "托盘编号")
    String trayCode;
    @ApiModelProperty(value = "拼棒新编号")
    String sectionNo;
    @ApiModelProperty(value = "晶段编号1")
    String sectionNo1;
    @ApiModelProperty(value = "晶段编号2")
    String sectionNo2;
    @ApiModelProperty(value = "晶段类型（拼棒）")
    String type;

    @ApiModelProperty(value = "规格")
    private String productType;
    @ApiModelProperty(value = "导电型号")
    private String pn;
    @ApiModelProperty(value = "产品等级")
    private String productRank;
    @ApiModelProperty(value = "晶段编号组")
    private String sectionNos;

    @ApiModelProperty(value = "拼数")
    private Integer spellCount;
    @ApiModelProperty(value = "总长度")
    private BigDecimal totalLength;
    @ApiModelProperty(value = "总重量")
    private BigDecimal totalWeight;
    @ApiModelProperty(value = "各长度值，’,‘隔开")
    private String spellLength;
    @ApiModelProperty(value = "各重量值，’,‘隔开")
    private String spellWeight;
}
