package com.sw.mes.yb.mcs.dto.fillingMaterial;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * @author wanghao
 * @version 1.0
 * @date 2024/3/21 14:11
 */
@Data
@ApiModel(value = "推送mcs装罐料生产任务Dto")
public class IssueMoToMcsDto {
    @ApiModelProperty(value = "任务编号")
    private String orderNo;

    @ApiModelProperty(value = "任务名称")
    private String orderName;

    @ApiModelProperty(value = "任务类型0初始装料1初始复投2取段复投3预装料")
    private Integer orderType;

    @ApiModelProperty(value = "配方ID")
    private Long formulaSchemeId;

    @ApiModelProperty(value = "配方编号")
    private String formulaSchemeCode;

    @ApiModelProperty(value = "重量方案ID")
    private Long formulaWeightSchemeId;

    @ApiModelProperty(value = "模块")
    private String area;

    @ApiModelProperty(value = "任务编号")
    private String series;

    @ApiModelProperty(value = "炉台编号")
    private String equipmentCode;

    @ApiModelProperty(value = "炉次号")
    private String lotNo;

    @ApiModelProperty(value = "复投次数")
    private Integer againNum;


//    @ApiModelProperty(value = "任务优先级")
//    private String priority;
    @ApiModelProperty(value = "预计投料时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date againTime;

    @ApiModelProperty(value = "A桶重量方案")
    private List<WeightSchemeDto> weightSchemeA;

    @ApiModelProperty(value = "A桶总重量")
    private BigDecimal weightA;

    @ApiModelProperty(value = "B桶重量方案")
    private List<WeightSchemeDto> weightSchemeB;

    @ApiModelProperty(value = "B桶总重量")
    private BigDecimal weightB;

    @ApiModelProperty(value = "桶规格")
    private BigDecimal barrelSpecs;

}
