package com.sw.mes.yb.mcs.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import java.io.Serializable;
import java.util.Date;

/**
 * 晶段线体绑定记录表
 * @TableName segment_bind_info
 */
@Entity
@Table(name="segment_bind_info")
@Data
@DynamicInsert
public class SegmentBindInfo implements Serializable {
    /**
     * 
     */
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;

    /**
     * 单晶编号(短棒)
     */
    @Column(name = "segment_no")
    private String segmentNo;

    /**
     * 截断机编号
     */
    @Column(name = "device_no")
    private String deviceNo;

    /**
     * 创建时间
     */
    @Column(name = "create_time")
    private Date createTime;

    /**
     * 创建者姓名
     */
    @Column(name = "create_user_name")
    private String createUserName;


}