/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.mcs.entity;

import java.util.Date;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="mcs_segment_inspection_pass_point_record")
@DynamicUpdate
@DynamicInsert
public class SegmentInspectionPassPointRecord{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 晶段编号
	 */
    @Column(length=50)
    private String sectionNo;
    
	/**
	 * 位置代码
	 */
    @Column(length=50)
    private String site;
    
	/**
	 * 检验线编号
	 */
    @Column(length=50)
    private String checkLineNo;
    
	/**
	 * 上下线标识:0上线，1下线
	 */
    @Column(length=1)
    private String identification;
    
	/**
	 * 创建时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createTime;
    
	/**
	 * 修改时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date updateTime;
    

	public SegmentInspectionPassPointRecord() {
	}

	public SegmentInspectionPassPointRecord(Long id) {
		this.id = id;
	}
}
