package com.sw.mes.yb.mcs.event;

import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.context.ApplicationEvent;
import org.springframework.stereotype.Component;



/**
 * Spring 实现的事件发布组件
 * @author gao
 */

@Component("eventPublishService")
public class EventPublishServiceImpl implements EventPublishService<ApplicationEvent>, ApplicationContextAware {
    private ApplicationContext applicationContext;

    @Override
    public void publishEvent(ApplicationEvent event) {
        applicationContext.publishEvent(event);
    }

    @Override
    public void setApplicationContext(ApplicationContext applicationContext) throws BeansException {
        this.applicationContext = applicationContext;
    }
}
