package com.sw.mes.yb.pad.dto;

import com.sw.mes.base.factory.inspect.entity.PaintingLine;
import com.sw.mes.base.factory.inspect.entity.PickingRule;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.List;

@Data
@ApiModel("圆棒画线匹配入参")
public class DrawLineParamDto {
    @ApiModelProperty(name = "晶体编号",required = true)
    private String crystalNo;
    @ApiModelProperty("托盘")
    private String trayNo;
    @ApiModelProperty(name = "有效长度",required = true)
    private int effectiveLength;
    @ApiModelProperty(name = "已选择的画线规则",required = true)
    private List<PaintingLine> paintingLine;
    @ApiModelProperty(name = "已选择取片规则，没有传就取默认",required = true)
    private List<PickingRule> pickingRule ;
    @ApiModelProperty(name = "中间段异常",required = true)
    private List<DrawLineExceptionDto> midExeceptionLen;
    @ApiModelProperty("去头长度")
    private int headLength;
    @ApiModelProperty("去尾长度")
    private int tailLength;
    @ApiModelProperty(name = "长度",required = true)
    private int length;

    @ApiModelProperty(value = "等径长度")
    BigDecimal isometricLength;

    @ApiModelProperty(value = "型号")
    String conductiveType;
    @ApiModelProperty(value = "重量")
    BigDecimal weight;
    @ApiModelProperty(value = "头长度")
    BigDecimal headLen;

    @ApiModelProperty(value = "尾长度")
    BigDecimal tailLen;

    @ApiModelProperty(value = "是否氧化【0：默认，否；1：是；】")
    Integer oxidate;

    @ApiModelProperty(value = "是否发白【0：默认，否；1：是；】")
    Integer turnPale;

    @ApiModelProperty(value = "是否完结【0：默认，否；1：是；】")
    Integer complete;

    @ApiModelProperty(value = "最小直径")
    BigDecimal minDiam;

    @ApiModelProperty(value = "最大直径")
    BigDecimal maxDiam;


    @ApiModelProperty(value = "结果判定")
    private String assessment;

    @ApiModelProperty("高氧晶棒【0：默认，否；1：是；】")
    Integer highOxygen;

}
