package com.sw.mes.yb.pad.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

@Data
public class RecutDto {

    @ApiModelProperty(value = "id")
    private Long id;

    /**
     * 晶段编号
     */
    @ApiModelProperty(value = "晶段编号")
    private String segmentNo;

    /**
     * 晶段长度
     */
    @ApiModelProperty(value = "晶段长度")
    private BigDecimal segmentNoLength;


    /**
     * 反切长度
     */
    @ApiModelProperty(value = "反切长度")
    private BigDecimal recutLength;

    /**
     * 画线人姓名
     */
    @ApiModelProperty(value = "画线人姓名")
    private String operateUser;

    /**
     * 规格
     */
    @ApiModelProperty(value = "规格")
    private String specs;

    /**
     * 产品等级
     */
    @ApiModelProperty(value = "产品等级")
    private String productLevel;

    /**
     * 段数
     */
    @ApiModelProperty(value = "段数")
    private String cutNum;


    /**
     * 开始时间
     */
    @ApiModelProperty(value = "开始时间")
    private Date startTime;


    /**
     * 班组
     */
    @ApiModelProperty(value = "班组")
    private String className;

    /**
     * 班次
     */
    @ApiModelProperty(value = "班次")
    private String classNo;

    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String remark;

    /**
     * 返切原因
     */
    @ApiModelProperty(value = "返切原因")
    private String reason;

    @ApiModelProperty(value = "反切类型 : 1不合格反切 ,2分段反切")
    private Integer cutType;

    @ApiModelProperty(value = "工序 : 刀刨、磨削、方棒检验用于返切回站")
    private String processCode;

    @ApiModelProperty(value = "画线明细【示例： index:序号；type:分段类型(1:晶段 2样片 3回收料)；value:长度】", required = true)
    List<RecutInfoFbDetailInfo> detail;
}
