/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.pad.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.math.BigDecimal;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="check_sheet")
@DynamicUpdate
@DynamicInsert
public class CheckSheet {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

	/**
	 * 晶棒编号
	 */
    @Column(length=30)
    private String sectionNo;

	/**
	 * 长度
	 */
	@Column(length = 19)
	private BigDecimal length;

	/**
	 * 重量
	 */
	@Column(length = 19)
	private BigDecimal weight;

	/**
	 * 等级
	 */
	@Column(length=20)
	private String level;

	/**
	 * 尺寸
	 */
	@Column(length=20)
	private String spec;

	/**
	 * 掺杂剂
	 */
	@Column(length=20)
	private String dopant;

	/**
	 * 物料类型
	 */
	@Column(length=20)
	private String materialType;

	/**
	 * 物料状态
	 */
	@Column(length=20)
	private String materialStatus;

	/**
	 * 创建人
	 */
    @Column(length=50)
    private String createUser;

	/**
	 * 创建时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createDate;

	/**
	 * 盘点区位
	 */
	@Column(length=20)
	private String location;

	/**
	 * 工序
	 */
	@Column(length=20)
	private String process;


	public CheckSheet() {
	}

	public CheckSheet(Long id) {
		this.id = id;
	}
}
