/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.pad.entity;

import java.util.Date;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="production_pad_furnace_agv")
@DynamicUpdate
@DynamicInsert
public class PadFurnaceAgv{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 物料条码(坩埚编号)
	 */
    @Column(length=100)
    private String materialCode;
    
	/**
	 * 设备号(目标设备)
	 */
    @Column(length=100)
    private String equipmentCode;
    
	/**
	 * 库位编号
	 */
    @Column(length=40)
    private String storeCode;
    
	/**
	 * 操作人
	 */
    @Column(length=60)
    private String userName;
    
	/**
	 * 操作时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date operationTime;
    
	/**
	 * 装料记录id(production_loading_task.id)
	 */
    @Column(nullable=false, length=19)
    private Long blastFurnaceId;
    
	/**
	 * 请求地址
	 */
    @Column(length=255)
    private String requestUrl;
    
	/**
	 * 请求参数
	 */
    @Column(length=65535)
    private String requestParam;
    
	/**
	 * 请求状态(待定，默认200成功)
	 */
    @Column(length=20)
    private String requestState;
    
	/**
	 * 请求结果
	 */
    @Column(length=65535)
    private String requestMsg;
    
	/**
	 * 请求时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date requestTime;
    
    
    /**
	 * 班次
	 */
    @Column(length=50)
    private String classNo;
    /**
	 * 班组
	 */
    @Column(length=80)
    private String teamGroup;
    /**
	 *模块
	 */
    @Column(length=50)
    private String area;
    
    

	public PadFurnaceAgv() {
	}

	public PadFurnaceAgv(Long id) {
		this.id = id;
	}
}
