package com.sw.mes.yb.pad.entity;

import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 晶段/样片信息画线信息
 */
@Entity
@Table(name = "zhxx_operate_section_detail")
@DynamicUpdate
@DynamicInsert
public class SectionDetail {

    public static final String PIECETYPE_TOU="T";
    public static final String PIECETYPE_WEI="W";
    public static final String PIECETYPE_FAN="F";

    public static final String BAR = "晶段";
    public static final String PIECE = "样片";

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    /**
     * 设备编号
     */
    @Column(length=40)
    private String deviceNo;

    /**
     * 炉次号
     */
    @Column(length=80)
    private String lotNo;

    /**
     * 单晶编号
     */
    @Column
    private String crystalNo;

    /**
     * 晶段或者样片编号
     */
    @Column
    private String sectionNo;

    /**
     * 晶段或者样片
     */
    @Column(length = 100)
    private String barOrPiece;

    /**
     * 单晶类型-产品类型
     */
    @Column(length=40)
    private String crystalType;

    /**
     * 晶段长度
     */
    @Column(length = 20)
    private BigDecimal barLength;

    /**
     * 晶段信息编号
     */
    @Column
    private String barCode;

    /**
     * 切断时间
     */
    @Column(length=19)
    @Temporal(TemporalType.TIMESTAMP)
    private Date cutTime;

    /**
     * 检验时间
     */
    @Column(length=19)
    @Temporal(TemporalType.TIMESTAMP)
    private Date checkTime;

    /**
     * 投料量
     * 2019-10-17
     */
    @Column
    private BigDecimal materialCount;

    /**
     * 实验备注
     * 2019-11-15
     */
    @Column(length = 100)
    private String experimentRemark;

    /**
     * 画线备注
     * 2019-11-15
     */
    @Column(length = 80)
    private String remark;


    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getCrystalNo() {
        return crystalNo;
    }

    public void setCrystalNo(String crystalNo) {
        this.crystalNo = crystalNo;
    }

    public String getSectionNo() {
        return sectionNo;
    }

    public void setSectionNo(String sectionNo) {
        this.sectionNo = sectionNo;
    }

    public String getBarOrPiece() {
        return barOrPiece;
    }

    public void setBarOrPiece(String barOrPiece) {
        this.barOrPiece = barOrPiece;
    }

    public BigDecimal getBarLength() {
        return barLength;
    }

    public void setBarLength(BigDecimal barLength) {
        this.barLength = barLength;
    }

    public String getBarCode() {
        return barCode;
    }

    public void setBarCode(String barCode) {
        this.barCode = barCode;
    }

    public String getDeviceNo() {
        return deviceNo;
    }

    public void setDeviceNo(String deviceNo) {
        this.deviceNo = deviceNo;
    }

    public String getLotNo() {
        return lotNo;
    }

    public void setLotNo(String lotNo) {
        this.lotNo = lotNo;
    }

    public String getCrystalType() {
        return crystalType;
    }

    public void setCrystalType(String crystalType) {
        this.crystalType = crystalType;
    }

    public Date getCutTime() {
        return cutTime;
    }

    public void setCutTime(Date cutTime) {
        this.cutTime = cutTime;
    }

    public Date getCheckTime() {
        return checkTime;
    }

    public void setCheckTime(Date checkTime) {
        this.checkTime = checkTime;
    }

    public BigDecimal getMaterialCount() {
        return materialCount;
    }

    public void setMaterialCount(BigDecimal materialCount) {
        this.materialCount = materialCount;
    }

    public String getExperimentRemark() {
        return experimentRemark;
    }

    public void setExperimentRemark(String experimentRemark) {
        this.experimentRemark = experimentRemark;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }
}
