/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.pad.entity.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
public class CheckSheetDto {

	private Long id;

	@ApiModelProperty(value = "晶棒编号")
	String sectionNo;

	@ApiModelProperty(value = "长度")
	BigDecimal length;

	@ApiModelProperty(value = "重量")
	BigDecimal weight;

	@ApiModelProperty(value = "等级")
	String level;

	@ApiModelProperty(value = "尺寸")
	String spec;

	@ApiModelProperty(value = "掺杂剂")
	String dopant;

	@ApiModelProperty(value = "物料类型")
	String materialType;

	@ApiModelProperty(value = "物料状态")
	String materialStatus;

	@ApiModelProperty(value = "创建人")
	@NotNull(message = "创建人不能为空！")
	String createUser;

	@ApiModelProperty(value = "创建时间")
	@Temporal(TemporalType.TIMESTAMP)
    Date createDate;

	@ApiModelProperty(value = "盘点区位")
	String location;

	@ApiModelProperty(value = "工序")
	String process;


	public CheckSheetDto() {
	}

	public CheckSheetDto(Long id) {
		this.id = id;
	}
}
