/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.pad.entity.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
public class EapCheckSheetDto {

//	@NotNull(message = "晶棒编号为空")
//	@ApiModelProperty(value = "晶棒编号")
//	String sectionNo;
//
//	@ApiModelProperty(value = "机台号")
//	String deviceCode;
//
//	/**
//	 * 物料类型【0：无棒，1：圆棒，3：半方棒，4：方棒，5：粗磨前，6：粗磨后，7：精磨过面，8：全部精磨，9：精磨测量过】
//	 */
//	@NotNull(message = "物料类型为空")
//	@ApiModelProperty(value = "物料类型")
//	int status;

	@ApiModelProperty(value = "信号代码")
	@NotBlank(message = "信号代码，不能为空")
	String taskCode;

	@ApiModelProperty(value = "信号名称")
	@NotBlank(message = "信号名称，不能为空")
	String taskName;

	@ApiModelProperty(value = "设备类型")
	String deviceType;

	@ApiModelProperty(value = "设备号")
	@NotBlank(message = "设备号，不能为空")
	String deviceCode;

	@ApiModelProperty(value = "收集信息")
	Map<String, Object> startCollectionData=new HashMap<>();

	@ApiModelProperty(value = "触发信息")
	Map<String, Object> startValidateMap;

	@ApiModelProperty(value = "上传时间")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	Date startTime;


	public EapCheckSheetDto() {
	}
}
