package com.sw.mes.yb.pc.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@Data
@ApiModel(value = "配合金记录")
public class AlloyApplyRecordDto {

    private Long id;

    @ApiModelProperty(value = "设备编号")
    private String deviceNo;

    @ApiModelProperty(value = "炉次号")
    private String lotNo;

    @ApiModelProperty(value = "状态" )
    private Integer state;

    @ApiModelProperty(value = "复投桶数" )
    private Integer rechargeNum;

    @ApiModelProperty(value = "申请时间" )
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date applyTime;

    @ApiModelProperty(value = "创建时间" )
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;

    @ApiModelProperty(value = "配料时间" )
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date mixTime;

    @ApiModelProperty(value = "合金浓度")
    private String alloyPotency;

    @ApiModelProperty(value = "合金重量")
    private BigDecimal alloyWeight;

    @ApiModelProperty(value = "目标电阻率")
    private String mbdzl;

    @ApiModelProperty(value = "称量者")
    private String weightUser;

    @ApiModelProperty(value = "申请ID" )
    private Integer applyId;

    @ApiModelProperty(value = "库位Id" )
    private Integer locationId;

    @ApiModelProperty(value = "物品编码" )
    private String goodsCode;

    @ApiModelProperty(value = "创建人" )
    private String createUser;
}
