package com.sw.mes.yb.pc.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;


@Data
@ApiModel(value = "坩埚点检Dto")
public class CrucibleCheckDataDto {

    private Long id;
    
	/** 坩埚编号 **/
    @ApiModelProperty(value = "坩埚编号" , required = true)
    String code;

    /** 炉次号 **/
    @ApiModelProperty(value = "炉次号" , required = true)
    String lotNo;

    /** 装料人 **/
    @ApiModelProperty(value = "装料人" , required = true)
    String operateUser;

    /** 装料班长 **/
    @ApiModelProperty(value = "装料班长" , required = true)
    String operateMonitor;
    
	/** 装料时间 **/
    @ApiModelProperty(value = "装料时间" , required = true)
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date operateTime;

    /** 班组 **/
    @ApiModelProperty(value = "班组" )
    String className;

    /** 班次 **/
    @ApiModelProperty(value = "班次" )
    String classNo;

    /** 产地 **/
    @ApiModelProperty(value = "产地" )
    String codePlace;

    /** 重量 **/
    @ApiModelProperty(value = "重量")
    Double weight;

    @ApiModelProperty(value = "点检是否通过")
    Boolean pass;

    @ApiModelProperty(value = "点检结果明细")
    List<CrucibleCheckDataItemDto> crucibleCheckDataItemDtos = new ArrayList<>();

}