package com.sw.mes.yb.pc.dto;

import com.alibaba.excel.annotation.ExcelProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@Data
public class ExportDataBaseDto {
    @ApiModelProperty(value = "单晶编号(整棒)")@ExcelProperty(value = "单晶编号")
    String crystalNo;
    @ApiModelProperty(value = "晶段编号(短棒)")@ExcelProperty(value = "单晶编号")
    String sectionNo;
    @ApiModelProperty(value = "晶段类型")@ExcelProperty(value = "晶段类型")
    String sectionType;
    @ApiModelProperty(value = "头尾识别")@ExcelProperty(value = "头尾识别")
    String headTailRecognition;
    @ApiModelProperty(value = "复投次数")@ExcelProperty(value = "复投次数")
    Integer againNum;
    @ApiModelProperty(value = "复投后颗数")@ExcelProperty(value = "复投后颗数")
    Integer againPiece;
    @ApiModelProperty(value = "掺杂剂")@ExcelProperty(value = "掺杂剂")
    String dopant;
    @ApiModelProperty(value = "拉制状态【Y：表示不断苞;N：表示断苞;W：表示未断苞见埚底单晶;V：表示断苞见埚底单晶】")@ExcelProperty(value = "拉制状态")
    String pullType;
    @ApiModelProperty(value = "库别【0-正常；1-直径不良单晶；2-退料；】")@ExcelProperty(value = "库别")
    String kube;
    @ApiModelProperty(value = "是否反切【0：默认，否；1：是；】", required = true)@ExcelProperty(value = "是否反切")
    Integer isCutBack;
    @ApiModelProperty(value = "圆棒检验类型")@ExcelProperty(value = "圆棒检验类型")
    String checkoutName;
    @ApiModelProperty(value = "复检类别")@ExcelProperty(value = "复检类别")
    String reCheckType;
    @ApiModelProperty(value = "规格/实际规格")@ExcelProperty(value = "规格")
    String productTypeSecond;
    @ApiModelProperty(value = "是否转规格【0：默认，否；1：是；】")@ExcelProperty(value = "是否转规格")
    Integer isChangeSpecs;
    @ApiModelProperty(value = "圆棒入库长度")@ExcelProperty(value = "圆棒入库长度")
    BigDecimal wareHouseLength;
    @ApiModelProperty(value = "圆棒长度")@ExcelProperty(value = "圆棒长度")
    BigDecimal actualLength;
    @ApiModelProperty(value = "实际称重/实测重量")@ExcelProperty(value = "实际称重")
    BigDecimal actualWeight;
    @ApiModelProperty(value = "理论重量")@ExcelProperty(value = "理论重量")
    BigDecimal theoryWeight;
    @ApiModelProperty(value = "直径Min")@ExcelProperty(value = "直径Min")
    BigDecimal diameterMin;
    @ApiModelProperty(value = "直径Max")@ExcelProperty(value = "直径Max")
    BigDecimal diameterMax;
    @ApiModelProperty(value = "直径判定")@ExcelProperty(value = "直径判定")
    String diamDecide;
    @ApiModelProperty(value = "细")@ExcelProperty(value = "细")
    BigDecimal fineDiameter;
    @ApiModelProperty(value = "细减长")@ExcelProperty(value = "细减长")
    BigDecimal fineCutLength;
    @ApiModelProperty(value = "崩边长度")@ExcelProperty(value = "崩边长度")
    BigDecimal edgeBark;
    @ApiModelProperty(value = "崩晶线")@ExcelProperty(value = "崩晶线")
    BigDecimal collapseLine;
    @ApiModelProperty(value = "斜【0：默认，否；1：是；】")@ExcelProperty(value = "斜")
    Integer isBevel;
    @ApiModelProperty(value = "晶线分叉【0：默认，否；1：是；】")@ExcelProperty(value = "晶线分叉")
    Integer isFork;
    @ApiModelProperty(value = "裂纹")@ExcelProperty(value = "裂纹")
    BigDecimal crack;
    @ApiModelProperty(value = "孪晶【0：默认，否；1：是；】")@ExcelProperty(value = "孪晶")
    Integer isTwinCrystal;
    @ApiModelProperty(value = "孪晶长度")@ExcelProperty(value = "孪晶长度")
    BigDecimal twinLength;
    @ApiModelProperty(value = "头斜")@ExcelProperty(value = "头斜")
    BigDecimal headSlope;
    @ApiModelProperty(value = "尾斜")@ExcelProperty(value = "尾斜")
    BigDecimal tailSlope;
    @ApiModelProperty(value = "扭过大(0否 1是")@ExcelProperty(value = "扭过大")
    Integer distortionBig;
    @ApiModelProperty(value = "扭")@ExcelProperty(value = "扭")
    BigDecimal distortion;
    @ApiModelProperty(value = "产品等级")@ExcelProperty(value = "产品等级")
    String productLevel;
    @ApiModelProperty(value = "实验等级")@ExcelProperty(value = "实验等级")
    String productLevelExperiment;
    @ApiModelProperty(value = "评级时间")@ExcelProperty(value = "评级时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date levelTime;
    @ApiModelProperty(value = "圆棒备注")@ExcelProperty(value = "圆棒备注")
    String remark;
    @ApiModelProperty(value = "圆棒最终评级/评级")@ExcelProperty(value = "圆棒最终评级")
    String level;
    @ApiModelProperty(value = "最终实验等级/实验等级")@ExcelProperty(value = "最终实验等级")
    String experiLevel;
    @ApiModelProperty(value = "导电型号/型号")@ExcelProperty(value = "导电型号")
    String conductiveType;
    @ApiModelProperty(value = "电阻率范围min")@ExcelProperty(value = "电阻率范围min")
    BigDecimal resistivityMin;
    @ApiModelProperty(value = "电阻率范围max")@ExcelProperty(value = "电阻率范围max")
    BigDecimal resistivityMax;
    @ApiModelProperty(value = "T寿命min")@ExcelProperty(value = "T寿命min")
    BigDecimal tLifeMin;
    @ApiModelProperty(value = "W寿命min")@ExcelProperty(value = "W寿命min")
    BigDecimal wLifeMin;
    @ApiModelProperty(value = "径向电阻率T中心点")@ExcelProperty(value = "径向电阻率T中心点")
    BigDecimal tRadialCentre;
    @ApiModelProperty(value = "径向电阻率T边缘1")@ExcelProperty(value = "径向电阻率T边缘1")
    BigDecimal tRadialEdge1;
    @ApiModelProperty(value = "径向电阻率T边缘2")@ExcelProperty(value = "径向电阻率T边缘2")
    BigDecimal tRadialEdge2;
    @ApiModelProperty(value = "径向电阻率T边缘3")@ExcelProperty(value = "径向电阻率T边缘3")
    BigDecimal tRadialEdge3;
    @ApiModelProperty(value = "径向电阻率T边缘4")@ExcelProperty(value = "径向电阻率T边缘4")
    BigDecimal tRadialEdge4;
    @ApiModelProperty(value = "径向电阻率T边缘5")@ExcelProperty(value = "径向电阻率T边缘5")
    BigDecimal tRadialEdge5;
    @ApiModelProperty(value = "径向电阻率T边缘6")@ExcelProperty(value = "径向电阻率T边缘6")
    BigDecimal tRadialEdge6;
    @ApiModelProperty(value = "径向电阻率T边缘7")@ExcelProperty(value = "径向电阻率T边缘7")
    BigDecimal tRadialEdge7;
    @ApiModelProperty(value = "径向电阻率T边缘8")@ExcelProperty(value = "径向电阻率T边缘8")
    BigDecimal tRadialEdge8;
    @ApiModelProperty(value = "径向电阻率W中心点")@ExcelProperty(value = "径向电阻率W中心点")
    BigDecimal wRadialCentre;
    @ApiModelProperty(value = "径向电阻率W边缘1")@ExcelProperty(value = "径向电阻率W边缘1")
    BigDecimal wRadialEdge1;
    @ApiModelProperty(value = "径向电阻率W边缘2")@ExcelProperty(value = "径向电阻率W边缘2")
    BigDecimal wRadialEdge2;
    @ApiModelProperty(value = "径向电阻率W边缘3")@ExcelProperty(value = "径向电阻率W边缘3")
    BigDecimal wRadialEdge3;
    @ApiModelProperty(value = "径向电阻率W边缘4")@ExcelProperty(value = "径向电阻率W边缘4")
    BigDecimal wRadialEdge4;
    @ApiModelProperty(value = "径向电阻率W边缘5")@ExcelProperty(value = "径向电阻率W边缘5")
    BigDecimal wRadialEdge5;
    @ApiModelProperty(value = "径向电阻率W边缘6")@ExcelProperty(value = "径向电阻率W边缘6")
    BigDecimal wRadialEdge6;
    @ApiModelProperty(value = "径向电阻率W边缘7")@ExcelProperty(value = "径向电阻率W边缘7")
    BigDecimal wRadialEdge7;
    @ApiModelProperty(value = "径向电阻率W边缘8")@ExcelProperty(value = "径向电阻率W边缘8")
    BigDecimal wRadialEdge8;
    @ApiModelProperty(value = "电阻率头尾中心边缘4点均值")@ExcelProperty(value = "电阻率头尾中心边缘4点均值")
    BigDecimal endCentreEdgeAvg4;
    @ApiModelProperty(value = "电阻率头中心边缘平均")@ExcelProperty(value = "电阻率头中心边缘平均")
    BigDecimal topCentreEdgeAvg;
    @ApiModelProperty(value = "电阻率尾中心边缘平均")@ExcelProperty(value = "电阻率尾中心边缘平均")
    BigDecimal endCentreEdgeAvg;
    @ApiModelProperty(value = "电阻率头均值")@ExcelProperty(value = "电阻率头均值")
    String resistivityTopAvg;
    @ApiModelProperty(value = "电阻率尾均值")@ExcelProperty(value = "电阻率尾均值")
    BigDecimal resistivityEndAvg;
    @ApiModelProperty(value = "出货电阻率")@ExcelProperty(value = "出货电阻率")
    BigDecimal sellResistivity;
    @ApiModelProperty(value = "电阻率结论")@ExcelProperty(value = "电阻率结论")
    String resistivityConclusion;
    @ApiModelProperty(value = "见锅底【0：默认，否；1：是；】")@ExcelProperty(value = "见锅底")
    Integer isSeeBottom;
    @ApiModelProperty(value = "电阻率反翘")@ExcelProperty(value = "电阻率反翘")
    String resistivityWarping;
    @ApiModelProperty(value = "T中心寿命")@ExcelProperty(value = "T中心寿命")
    BigDecimal tCentreLife;
    @ApiModelProperty(value = "T边缘寿命1")@ExcelProperty(value = "T边缘寿命1")
    BigDecimal tLifeEdge1;
    @ApiModelProperty(value = "T边缘寿命2")@ExcelProperty(value = "T边缘寿命2")
    BigDecimal tLifeEdge2;
    @ApiModelProperty(value = "T边缘寿命3")@ExcelProperty(value = "T边缘寿命3")
    BigDecimal tLifeEdge3;
    @ApiModelProperty(value = "T边缘寿命4")@ExcelProperty(value = "T边缘寿命4")
    BigDecimal tLifeEdge4;
    @ApiModelProperty(value = "T边缘寿命5")@ExcelProperty(value = "T边缘寿命5")
    BigDecimal tLifeEdge5;
    @ApiModelProperty(value = "T边缘寿命6")@ExcelProperty(value = "T边缘寿命6")
    BigDecimal tLifeEdge6;
    @ApiModelProperty(value = "T边缘寿命7")@ExcelProperty(value = "T边缘寿命7")
    BigDecimal tLifeEdge7;
    @ApiModelProperty(value = "T边缘寿命8")@ExcelProperty(value = "T边缘寿命8")
    BigDecimal tLifeEdge8;
    @ApiModelProperty(value = "W中心寿命")@ExcelProperty(value = "W中心寿命")
    BigDecimal wCentreLife;
    @ApiModelProperty(value = "W边缘寿命1")@ExcelProperty(value = "W边缘寿命1")
    BigDecimal wLifeEdge1;
    @ApiModelProperty(value = "W边缘寿命2")@ExcelProperty(value = "W边缘寿命2")
    BigDecimal wLifeEdge2;
    @ApiModelProperty(value = "W边缘寿命3")@ExcelProperty(value = "W边缘寿命3")
    BigDecimal wLifeEdge3;
    @ApiModelProperty(value = "W边缘寿命4")@ExcelProperty(value = "W边缘寿命4")
    BigDecimal wLifeEdge4;
    @ApiModelProperty(value = "W边缘寿命5")@ExcelProperty(value = "W边缘寿命5")
    BigDecimal wLifeEdge5;
    @ApiModelProperty(value = "W边缘寿命6")@ExcelProperty(value = "W边缘寿命6")
    BigDecimal wLifeEdge6;
    @ApiModelProperty(value = "W边缘寿命7")@ExcelProperty(value = "W边缘寿命7")
    BigDecimal wLifeEdge7;
    @ApiModelProperty(value = "W边缘寿命8")@ExcelProperty(value = "W边缘寿命8")
    BigDecimal wLifeEdge8;
    @ApiModelProperty(value = "单晶减长长度")@ExcelProperty(value = "单晶减长长度")
    BigDecimal reduceCrystalLength;
    @ApiModelProperty(value = "拉晶车间")@ExcelProperty(value = "拉晶车间")
    String crystalWorkshop;
    @ApiModelProperty(value = "T氧含量中心")@ExcelProperty(value = "T氧含量中心")
    BigDecimal oxygenContentHead;
    @ApiModelProperty(value = "T氧含量边缘")@ExcelProperty(value = "T氧含量边缘")
    BigDecimal oxygenContentBorder;
    @ApiModelProperty(value = "T碳含量中心")@ExcelProperty(value = "T碳含量中心")
    BigDecimal carbonContentHead;
    @ApiModelProperty(value = "T碳含量边缘")@ExcelProperty(value = "T碳含量边缘")
    BigDecimal carbonContentBorder;
    @ApiModelProperty(value = "W氧含量中心")@ExcelProperty(value = "W氧含量中心")
    BigDecimal oxygenContentTail;
    @ApiModelProperty(value = "W氧含量边缘")@ExcelProperty(value = "W氧含量边缘")
    BigDecimal oxygenContentBorderTail;
    @ApiModelProperty(value = "W碳含量中心")@ExcelProperty(value = "W碳含量中心")
    BigDecimal carbonContentTail;
    @ApiModelProperty(value = "W碳含量边缘")@ExcelProperty(value = "W碳含量边缘")
    BigDecimal carbonContentBorderTail;
    @ApiModelProperty(value = "T缺陷")@ExcelProperty(value = "T缺陷")
    String headDefectGrade;
    @ApiModelProperty(value = "W缺陷")@ExcelProperty(value = "W缺陷")
    String tailDefect;
    @ApiModelProperty(value = "位错【0：默认，无；1：有；】")@ExcelProperty(value = "位错")
    Integer isMalposition;
    @ApiModelProperty(value = "T样片中心退火电阻率")@ExcelProperty(value = "T样片中心退火电阻率")
    BigDecimal tCenterAnneal;
    @ApiModelProperty(value = "W样片中心退火电阻率")@ExcelProperty(value = "W样片中心退火电阻率")
    BigDecimal wcenterAnneal;
    @ApiModelProperty(value = "T样片边缘退火电阻率")@ExcelProperty(value = "T样片边缘退火电阻率")
    BigDecimal tBorderAnneal;
    @ApiModelProperty(value = "W样片边缘退火电阻率")@ExcelProperty(value = "W样片边缘退火电阻率")
    BigDecimal wBorderAnneal;
    @ApiModelProperty(value = "异常汇总")@ExcelProperty(value = "异常汇总")
    String anomaly;
    @ApiModelProperty(value = "检验人员")@ExcelProperty(value = "检验人员")
    String inspector;
    @ApiModelProperty(value = "检验日期")@ExcelProperty(value = "检验日期")
    String hasGone;
    @ApiModelProperty(value = "订单号")@ExcelProperty(value = "订单号")
    String orderNo;
    @ApiModelProperty(value = "计划规格")@ExcelProperty(value = "计划规格")
    String planSpecs;
    @ApiModelProperty(value = "计划订单号")@ExcelProperty(value = "计划订单号")
    private String planOrderNo;
    @ApiModelProperty(value = "物料编码")@ExcelProperty(value = "物料编码")
    private String materialCode;
    @ApiModelProperty(value = "物料名称")@ExcelProperty(value = "物料名称")
    private String materialName;
    @ApiModelProperty(value = "计划物料编码")@ExcelProperty(value = "计划物料编码")
    String planMaterialCode;
    // 温度
    @ApiModelProperty(value = "温度")@ExcelProperty(value = "温度")
    private String temperature;

    @ApiModelProperty(value = "订单类型（1:量产；2:试验；3:送样;4:返工）")@ExcelProperty(value = "订单类型")
    String orderType;
    @ApiModelProperty(value = "炉台类型【0:默认；0-量产;1-在建;2-研发;】")@ExcelProperty(value = "炉台类型")
    Integer furnaceType;
    @ApiModelProperty(value = "炉台号")@ExcelProperty(value = "炉台号")
    String deviceNo;
    @ApiModelProperty(value = "系列")@ExcelProperty(value = "系列")
    String series;
    @ApiModelProperty(value = "炉次号")@ExcelProperty(value = "炉次号")
    String lotNo;
    @ApiModelProperty(value = "投料量")@ExcelProperty(value = "投料量")
    Integer materialCount;
    @ApiModelProperty(value = "T寿命/电阻率中心")@ExcelProperty(value = "T寿命/电阻率中心")
    BigDecimal sintonCenter;
    @ApiModelProperty(value = "W寿命/电阻率中心")@ExcelProperty(value = "W寿命/")
    BigDecimal sintonTail;
    @ApiModelProperty(value = "01W寿命")@ExcelProperty(value = "01W寿命")
    Integer lifeSpanw1;
    @ApiModelProperty(value = "01W电阻率")@ExcelProperty(value = "01W电阻率")
    BigDecimal resistivityw1;
    @ApiModelProperty(value = "02T寿命")@ExcelProperty(value = "02T寿命")
    Integer lifeSpant2;
    @ApiModelProperty(value = "02T电阻率")@ExcelProperty(value = "02T电阻率")
    BigDecimal resistivityt2;
    @ApiModelProperty(value = "单晶段号")@ExcelProperty(value = "单晶段号")
    Integer piecewiseNum;
    @ApiModelProperty(value = "创建时间")@ExcelProperty(value = "创建时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date createTime;
    @ApiModelProperty(value = "更新时间")@ExcelProperty(value = "更新时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date updateTime;
    @ApiModelProperty(value = "画线实验标记")@ExcelProperty(value = "画线实验标记")
    Integer drawLine;
    @ApiModelProperty(value = "单晶拉制异常")@ExcelProperty(value = "单晶拉制异常")
    String crystalAbnormal;
    @ApiModelProperty(value = "单晶组合")@ExcelProperty(value = "单晶组合")
    String sectionCompose;
    @ApiModelProperty(value = "拼数")@ExcelProperty(value = "拼数")
    Integer sticksCount;
    @ApiModelProperty(value = "工厂")@ExcelProperty(value = "工厂")
    String factory;
    @ApiModelProperty(value = "库存地点")@ExcelProperty(value = "库存地点")
    String stockPlace;
    @ApiModelProperty(value = "头部评级")@ExcelProperty(value = "头部评级")
    String headLevel;
    @ApiModelProperty(value = "尾部评级")@ExcelProperty(value = "尾部评级")
    String tailLevel;
    @ApiModelProperty(value = "评级标准名称")@ExcelProperty(value = "评级标准名称")
    String gradeName;
    @ApiModelProperty(value = "评级标准版本")@ExcelProperty(value = "评级标准版本")
    String gradeVersion;
    @ApiModelProperty(value = "实验等级标准名称")@ExcelProperty(value = "实验等级标准名称")
    String planGradeName;
    @ApiModelProperty(value = "实验等级标准版本")@ExcelProperty(value = "实验等级标准版本")
    String planGradeVersion;
    @ApiModelProperty(value = "外观检验返切")@ExcelProperty(value = "外观检验返切")
    String checkReback;
    @ApiModelProperty(value = "检验线编号")@ExcelProperty(value = "检验线编号")
    String checkLineNo;

    @ApiModelProperty(value = "温度补偿后径向电阻率T中心点")@ExcelProperty(value = "补偿径向电阻率头中心点")
    BigDecimal tTempRadialCentre;
    @ApiModelProperty(value = "温度补偿后径向电阻率T边缘1")@ExcelProperty(value = "补偿径向电阻率头边缘1")
    BigDecimal tTempRadialEdge1;
//    @ApiModelProperty(value = "温度补偿后径向电阻率T边缘2")@ExcelProperty(value = "单晶编号")
//    BigDecimal tTempRadialEdge2;
//    @ApiModelProperty(value = "温度补偿后径向电阻率T边缘3")@ExcelProperty(value = "单晶编号")
//    BigDecimal tTempRadialEdge3;
//    @ApiModelProperty(value = "温度补偿后径向电阻率T边缘4")@ExcelProperty(value = "单晶编号")
//    BigDecimal tTempRadialEdge4;
//    @ApiModelProperty(value = "温度补偿后径向电阻率T边缘5")@ExcelProperty(value = "单晶编号")
//    BigDecimal tTempRadialEdge5;
//    @ApiModelProperty(value = "温度补偿后径向电阻率T边缘6")@ExcelProperty(value = "单晶编号")
//    BigDecimal tTempRadialEdge6;
//    @ApiModelProperty(value = "温度补偿后径向电阻率T边缘7")@ExcelProperty(value = "单晶编号")
//    BigDecimal tTempRadialEdge7;
//    @ApiModelProperty(value = "温度补偿后径向电阻率T边缘8")@ExcelProperty(value = "单晶编号")
    BigDecimal tTempRadialEdge8;
    @ApiModelProperty(value = "温度补偿后径向电阻率W中心点")@ExcelProperty(value = "补偿径向电阻率边缘尾中心点")
    BigDecimal wTempRadialCentre;
    @ApiModelProperty(value = "温度补偿后径向电阻率W边缘1")@ExcelProperty(value = "补偿径向电阻率尾边缘1")
    BigDecimal wTempRadialEdge1;
//    @ApiModelProperty(value = "温度补偿后径向电阻率W边缘2")@ExcelProperty(value = "单晶编号")
//    BigDecimal wTempRadialEdge2;
//    @ApiModelProperty(value = "温度补偿后径向电阻率W边缘3")@ExcelProperty(value = "单晶编号")
//    BigDecimal wTempRadialEdge3;
//    @ApiModelProperty(value = "温度补偿后径向电阻率W边缘4")@ExcelProperty(value = "单晶编号")
//    BigDecimal wTempRadialEdge4;
//    @ApiModelProperty(value = "温度补偿后径向电阻率W边缘5")@ExcelProperty(value = "单晶编号")
//    BigDecimal wTempRadialEdge5;
//    @ApiModelProperty(value = "温度补偿后径向电阻率W边缘6")@ExcelProperty(value = "单晶编号")
//    BigDecimal wTempRadialEdge6;
//    @ApiModelProperty(value = "温度补偿后径向电阻率W边缘7")@ExcelProperty(value = "单晶编号")
//    BigDecimal wTempRadialEdge7;
//    @ApiModelProperty(value = "温度补偿后径向电阻率W边缘8")@ExcelProperty(value = "温度补偿后径向电阻率W边缘8")
//    BigDecimal wTempRadialEdge8;
    @ApiModelProperty(value = "单晶头方向")@ExcelProperty(value = "单晶头方向")
    String crystalDirection;
    // 计划产品等级
    @ApiModelProperty(value = "计划产品等级")@ExcelProperty(value = "计划产品等级")
    private String planGrade;

    // 计划拼数
    @ApiModelProperty(value = "计划拼数")@ExcelProperty(value = "计划拼数")
    private String planStickCount;

    // 计划长度范围
    @ApiModelProperty(value = "计划长度范围")@ExcelProperty(value = "计划长度范围")
    private String planLenRange;


    // 计划掺杂剂
    @ApiModelProperty(value = "计划掺杂剂")@ExcelProperty(value = "计划掺杂剂")
    private String planDopant;

    // 计划导电型号
    @ApiModelProperty(value = "计划导电型号")@ExcelProperty(value = "计划导电型号")
    private String planConductiveType;
}
