package com.sw.mes.yb.pc.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@ApiModel(value = "InspectDataBaseDto")
public class InspectDataBaseDto {

    private Long id;
    @ApiModelProperty(value = "单晶编号(整棒)")
    String crystalNo;
    @ApiModelProperty(value = "晶段编号(短棒)")
    String sectionNo;
    @ApiModelProperty(value = "晶段类型")
    String sectionType;
    @ApiModelProperty(value = "头尾识别")
    String headTailRecognition;
    @ApiModelProperty(value = "复投次数")
    Integer againNum;
    @ApiModelProperty(value = "复投后颗数")
    Integer againPiece;
    @ApiModelProperty(value = "掺杂剂")
    String dopant;
    @ApiModelProperty(value = "拉制状态【Y：表示不断苞;N：表示断苞;W：表示未断苞见埚底单晶;V：表示断苞见埚底单晶】")
    String pullType;
    @ApiModelProperty(value = "库别【0-正常；1-直径不良单晶；2-退料；】")
    String kube;
    @ApiModelProperty(value = "是否反切【0：默认，否；1：是；】", required = true)
    Integer isCutBack;
    @ApiModelProperty(value = "圆棒检验类型")
    String checkoutName;
    @ApiModelProperty(value = "复检类别")
    String reCheckType;
    @ApiModelProperty(value = "规格/实际规格")
    String productTypeSecond;
    @ApiModelProperty(value = "是否转规格【0：默认，否；1：是；】")
    Integer isChangeSpecs;
    @ApiModelProperty(value = "圆棒入库长度")
    BigDecimal wareHouseLength;
    @ApiModelProperty(value = "圆棒长度")
    BigDecimal actualLength;
    @ApiModelProperty(value = "实际称重/实测重量")
    BigDecimal actualWeight;
    @ApiModelProperty(value = "理论重量")
    BigDecimal theoryWeight;
    @ApiModelProperty(value = "直径Min")
    BigDecimal diameterMin;
    @ApiModelProperty(value = "直径Max")
    BigDecimal diameterMax;
    @ApiModelProperty(value = "直径判定")
    String diamDecide;
    @ApiModelProperty(value = "细")
    BigDecimal fineDiameter;
    @ApiModelProperty(value = "细减长")
    BigDecimal fineCutLength;
    @ApiModelProperty(value = "崩边皮")
    BigDecimal edgeBark;
    @ApiModelProperty(value = "崩晶线")
    BigDecimal collapseLine;
    @ApiModelProperty(value = "直径差")
    String demcMax;
    @ApiModelProperty(value = "平均直径")
    BigDecimal avgDiameter;
    @ApiModelProperty(value = "整颗平均直径")
    BigDecimal allAvgDiameter;

    @ApiModelProperty(value = "斜【0：默认，否；1：是；】")
    Integer isBevel;
    @ApiModelProperty(value = "晶线分叉【0：默认，否；1：是；】")
    Integer isFork;
    @ApiModelProperty(value = "是否带彩【0：默认，否；1：是；】")
    Integer colorful;
    @ApiModelProperty(value = "裂纹")
    BigDecimal crack;
    @ApiModelProperty(value = "孪晶【0：默认，否；1：是；】")
    Integer isTwinCrystal;
    @ApiModelProperty(value = "孪晶长度")
    BigDecimal twinLength;
    @ApiModelProperty(value = "头斜")
    BigDecimal headSlope;
    @ApiModelProperty(value = "尾斜")
    BigDecimal tailSlope;
    @ApiModelProperty(value = "扭过大(0否 1是)")
    Integer distortionBig;
    @ApiModelProperty(value = "扭")
    BigDecimal distortion;
    @ApiModelProperty(value = "产品评级")
    String productLevel;
    @ApiModelProperty(value = "实验评级")
    String productLevelExperiment;
    @ApiModelProperty(value = "评级时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date levelTime;
    @ApiModelProperty(value = "圆棒备注")
    String remark;
    @ApiModelProperty(value = "圆棒最终评级/评级")
    String level;
    @ApiModelProperty(value = "最终实验评级/实验评级")
    String experiLevel;
    @ApiModelProperty(value = "导电型号/型号")
    String conductiveType;
    @ApiModelProperty(value = "电阻率范围min")
    BigDecimal resistivityMin;
    @ApiModelProperty(value = "电阻率范围max")
    BigDecimal resistivityMax;
    @ApiModelProperty(value = "T寿命min")
    BigDecimal tLifeMin;
    @ApiModelProperty(value = "W寿命min")
    BigDecimal wLifeMin;
    @ApiModelProperty(value = "径向电阻率T中心点")
    BigDecimal tRadialCentre;
    @ApiModelProperty(value = "径向电阻率T边缘1")
    BigDecimal tRadialEdge1;
    @ApiModelProperty(value = "径向电阻率T边缘2")
    BigDecimal tRadialEdge2;
    @ApiModelProperty(value = "径向电阻率T边缘3")
    BigDecimal tRadialEdge3;
    @ApiModelProperty(value = "径向电阻率T边缘4")
    BigDecimal tRadialEdge4;
    @ApiModelProperty(value = "径向电阻率T边缘5")
    BigDecimal tRadialEdge5;
    @ApiModelProperty(value = "径向电阻率T边缘6")
    BigDecimal tRadialEdge6;
    @ApiModelProperty(value = "径向电阻率T边缘7")
    BigDecimal tRadialEdge7;
    @ApiModelProperty(value = "径向电阻率T边缘8")
    BigDecimal tRadialEdge8;
    @ApiModelProperty(value = "径向电阻率W中心点")
    BigDecimal wRadialCentre;
    @ApiModelProperty(value = "径向电阻率W边缘1")
    BigDecimal wRadialEdge1;
    @ApiModelProperty(value = "径向电阻率W边缘2")
    BigDecimal wRadialEdge2;
    @ApiModelProperty(value = "径向电阻率W边缘3")
    BigDecimal wRadialEdge3;
    @ApiModelProperty(value = "径向电阻率W边缘4")
    BigDecimal wRadialEdge4;
    @ApiModelProperty(value = "径向电阻率W边缘5")
    BigDecimal wRadialEdge5;
    @ApiModelProperty(value = "径向电阻率W边缘6")
    BigDecimal wRadialEdge6;
    @ApiModelProperty(value = "径向电阻率W边缘7")
    BigDecimal wRadialEdge7;
    @ApiModelProperty(value = "径向电阻率W边缘8")
    BigDecimal wRadialEdge8;
    @ApiModelProperty(value = "电阻率头尾中心边缘4点均值")
    BigDecimal endCentreEdgeAvg4;
    @ApiModelProperty(value = "电阻率头中心边缘平均")
    BigDecimal topCentreEdgeAvg;
    @ApiModelProperty(value = "电阻率尾中心边缘平均")
    BigDecimal endCentreEdgeAvg;
    @ApiModelProperty(value = "电阻率头均值")
    String resistivityTopAvg;
    @ApiModelProperty(value = "电阻率尾均值")
    BigDecimal resistivityEndAvg;
    @ApiModelProperty(value = "出货电阻率")
    BigDecimal sellResistivity;
    @ApiModelProperty(value = "电阻率结论")
    String resistivityConclusion;
    @ApiModelProperty(value = "是否见锅底 1是0否")
    Integer isSeeBottom;
    @ApiModelProperty(value = "电阻率反翘")
    String resistivityWarping;
    @ApiModelProperty(value = "sitionT中心寿命")
    BigDecimal tCentreLife;
    @ApiModelProperty(value = "sitionT边缘寿命1")
    BigDecimal tLifeEdge1;
    @ApiModelProperty(value = "sition寿命T边缘2")
    BigDecimal tLifeEdge2;
    @ApiModelProperty(value = "sition寿命T边缘3")
    BigDecimal tLifeEdge3;
    @ApiModelProperty(value = "sition寿命T边缘4")
    BigDecimal tLifeEdge4;
    @ApiModelProperty(value = "sition寿命W中心寿命")
    BigDecimal wCentreLife;
    @ApiModelProperty(value = "sition寿命W边缘1")
    BigDecimal wLifeEdge1;
    @ApiModelProperty(value = "sition寿命W边缘2")
    BigDecimal wLifeEdge2;
    @ApiModelProperty(value = "sition寿命W边缘3")
    BigDecimal wLifeEdge3;
    @ApiModelProperty(value = "sition寿命W边缘4")
    BigDecimal wLifeEdge4;
    @ApiModelProperty(value = "单晶减长长度")
    BigDecimal reduceCrystalLength;
    @ApiModelProperty(value = "拉晶车间")
    String crystalWorkshop;
    @ApiModelProperty(value = "T氧含量中心")
    BigDecimal oxygenContentHead;
    @ApiModelProperty(value = "T氧含量边缘")
    BigDecimal oxygenContentBorder;
    @ApiModelProperty(value = "T碳含量中心")
    BigDecimal carbonContentHead;
    @ApiModelProperty(value = "T碳含量边缘")
    BigDecimal carbonContentBorder;
    @ApiModelProperty(value = "W氧含量中心")
    BigDecimal oxygenContentTail;
    @ApiModelProperty(value = "W氧含量边缘")
    BigDecimal oxygenContentBorderTail;
    @ApiModelProperty(value = "W碳含量中心")
    BigDecimal carbonContentTail;
    @ApiModelProperty(value = "W碳含量边缘")
    BigDecimal carbonContentBorderTail;
    @ApiModelProperty(value = "T缺陷")
    String headDefectGrade;
    @ApiModelProperty(value = "W缺陷")
    String tailDefect;
    @ApiModelProperty(value = "头位错【0：默认，无；1：有；】")
    Integer isMalpositionHead;
    @ApiModelProperty(value = "尾位错【0：默认，无；1：有；】")
    Integer isMalpositionTail;
    @ApiModelProperty(value = "T样片中心退火电阻率")
    BigDecimal tCenterAnneal;
    @ApiModelProperty(value = "W样片中心退火电阻率")
    BigDecimal wcenterAnneal;
    @ApiModelProperty(value = "T样片边缘退火电阻率")
    BigDecimal tBorderAnneal;
    @ApiModelProperty(value = "W样片边缘退火电阻率")
    BigDecimal wBorderAnneal;
    @ApiModelProperty(value = "异常汇总")
    String anomaly;
    @ApiModelProperty(value = "检验人员")
    String inspector;
    @ApiModelProperty(value = "检验日期")
    String hasGone;
    @ApiModelProperty(value = "订单号")
    String orderNo;
    @ApiModelProperty(value = "计划规格")
    String planSpecs;
    @ApiModelProperty(value = "计划订单号")
    private String planOrderNo;
    @ApiModelProperty(value = "物料编码")
    private String materialCode;

    @ApiModelProperty(value = "计划物料编码")
    String planMaterialCode;

    // 头温度
    @ApiModelProperty(value = "头温度")
    private String temperature;

    // 尾温度
    @ApiModelProperty(value = "尾温度")
    private String temperatureEnd;

    @ApiModelProperty(value = "订单类型（1:量产；2:试验；3:送样;4:返工）")
    String orderType;


    @ApiModelProperty(value = "计划订单类型（1:量产；2:试验；3:送样;4:返工）")
    private String planOrderType;
    @ApiModelProperty(value = "炉台类型【0:默认；0-量产;1-在建;2-研发;】")
    Integer furnaceType;
    @ApiModelProperty(value = "炉台号")
    String deviceNo;
    @ApiModelProperty(value = "系列")
    String series;
    @ApiModelProperty(value = "炉次号")
    String lotNo;
    @ApiModelProperty(value = "投料量")
    Integer materialCount;
    @ApiModelProperty(value = "T寿命/电阻率中心")
    BigDecimal sintonCenter;
    @ApiModelProperty(value = "W寿命/电阻率中心")
    BigDecimal sintonTail;
    @ApiModelProperty(value = "01W寿命")
    Integer lifeSpanw1;
    @ApiModelProperty(value = "01W电阻率")
    BigDecimal resistivityw1;
    @ApiModelProperty(value = "02T寿命")
    Integer lifeSpant2;
    @ApiModelProperty(value = "02T电阻率")
    BigDecimal resistivityt2;
    @ApiModelProperty(value = "单晶段号")
    Integer piecewiseNum;
    @ApiModelProperty(value = "创建时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date createTime;
    @ApiModelProperty(value = "更新时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date updateTime;
    @ApiModelProperty(value = "画线实验标记")
    String drawLine;
    @ApiModelProperty(value = "单晶拉制异常")
    String crystalAbnormal;
    @ApiModelProperty(value = "单晶组合")
    String sectionCompose;
    @ApiModelProperty(value = "拼数")
    Integer sticksCount;
    @ApiModelProperty(value = "工厂")
    String factory;
    @ApiModelProperty(value = "头部评级")
    String headLevel;
    @ApiModelProperty(value = "尾部评级")
    String tailLevel;
    @ApiModelProperty(value = "评级标准名称")
    String gradeName;
    @ApiModelProperty(value = "评级标准版本")
    String gradeVersion;
    @ApiModelProperty(value = "实验评级标准名称")
    String planGradeName;
    @ApiModelProperty(value = "实验评级标准版本")
    String planGradeVersion;
    @ApiModelProperty(value = "外观检验返切")
    String checkReback;
    @ApiModelProperty(value = "检验线编号")
    String checkLineNo;
    @ApiModelProperty(value = "温度补偿后径向电阻率T中心点理论值(W段用)")
    BigDecimal tTempRadialCentreTheory;
    @ApiModelProperty(value = "温度补偿后径向电阻率T边缘理论值(W段用)")
    BigDecimal tTempRadialEdgeTheory1;
    @ApiModelProperty(value = "温度补偿后径向电阻率W中心点理论值(T段用)")
    BigDecimal wTempRadialCentreTheory;
    @ApiModelProperty(value = "温度补偿后径向电阻率W边缘理论值(T段用)")
    BigDecimal wTempRadialEdgeTheory1;
    @ApiModelProperty(value = "温度补偿后径向电阻率T中心点")
    BigDecimal tTempRadialCentre;
    @ApiModelProperty(value = "温度补偿后径向电阻率T边缘1")
    BigDecimal tTempRadialEdge1;
    @ApiModelProperty(value = "温度补偿后径向电阻率T边缘2")
    BigDecimal tTempRadialEdge2;
    @ApiModelProperty(value = "温度补偿后径向电阻率T边缘3")
    BigDecimal tTempRadialEdge3;
    @ApiModelProperty(value = "温度补偿后径向电阻率T边缘4")
    BigDecimal tTempRadialEdge4;
    @ApiModelProperty(value = "温度补偿后径向电阻率T边缘5")
    BigDecimal tTempRadialEdge5;
    @ApiModelProperty(value = "温度补偿后径向电阻率T边缘6")
    BigDecimal tTempRadialEdge6;
    @ApiModelProperty(value = "温度补偿后径向电阻率T边缘7")
    BigDecimal tTempRadialEdge7;
    @ApiModelProperty(value = "温度补偿后径向电阻率T边缘8")
    BigDecimal tTempRadialEdge8;
    @ApiModelProperty(value = "温度补偿后径向电阻率W中心点")
    BigDecimal wTempRadialCentre;
    @ApiModelProperty(value = "温度补偿后径向电阻率W边缘1")
    BigDecimal wTempRadialEdge1;
    @ApiModelProperty(value = "温度补偿后径向电阻率W边缘2")
    BigDecimal wTempRadialEdge2;
    @ApiModelProperty(value = "温度补偿后径向电阻率W边缘3")
    BigDecimal wTempRadialEdge3;
    @ApiModelProperty(value = "温度补偿后径向电阻率W边缘4")
    BigDecimal wTempRadialEdge4;
    @ApiModelProperty(value = "温度补偿后径向电阻率W边缘5")
    BigDecimal wTempRadialEdge5;
    @ApiModelProperty(value = "温度补偿后径向电阻率W边缘6")
    BigDecimal wTempRadialEdge6;
    @ApiModelProperty(value = "温度补偿后径向电阻率W边缘7")
    BigDecimal wTempRadialEdge7;
    @ApiModelProperty(value = "温度补偿后径向电阻率W边缘8")
    BigDecimal wTempRadialEdge8;
    @ApiModelProperty(value = "单晶头方向")
    String crystalDirection;
    // 计划产品评级
    @ApiModelProperty(value = "计划产品评级")
    private String planGrade;

    // 计划拼数
    @ApiModelProperty(value = "计划拼数")
    private String planStickCount;

    // 计划长度范围
    @ApiModelProperty(value = "计划长度范围")
    private String planLenRange;


    // 计划掺杂剂
    @ApiModelProperty(value = "计划掺杂剂")
    private String planDopant;

    // 计划导电型号
    @ApiModelProperty(value = "计划导电型号")
    private String planConductiveType;

    @ApiModelProperty(value = "拼棒总长(mm)")
    private BigDecimal spellBarLength;

    @ApiModelProperty(value = "划线实验标记")
    private String lineMarking;

    @ApiModelProperty(value = "修改人")
    private String updateUser;

    /**
     * 补偿01W电阻率
     */
    @ApiModelProperty(value = "补偿01W电阻率")
    private BigDecimal compensateResistivityw1;

    /**
     * 补偿02T电阻率
     */
    @ApiModelProperty(value = "补偿02T电阻率")
    private BigDecimal compensateResistivityt2;

    @ApiModelProperty(value = "头尾数据转换 1:转换；0正常")
    Integer headTailChange;

    /**
     * 复测次数
     */
    @ApiModelProperty(value = "复测次数")
    Integer retestNum;

    /**
     * 是否免检
     * 1：免去电阻率检测 0: 检验
     */
    @ApiModelProperty(value = "是否免检  1：免去电阻率检测 0: 检验")
    Integer isAvoidCheck;
}