/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.pc.entity;

import java.util.Date;
import java.math.BigDecimal;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@Entity
@Table(name = "carrier_config")
@DynamicUpdate
@DynamicInsert
public class CarrierConfig {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;
    
	/**
	 * 载具编号 
	 */
    @Column(length=64)
    private String carrierNo;
    
	/**
	 * 状态 0 未使用 1 使用中
	 */
    @Column(length=10)
    private Integer status;
    
	/**
	 * 载具类型 1 卡板箱 2 纸箱 3 花篮
	 */
    @Column(length=10)
    private Integer type;
    
	/**
	 * 载具皮重
	 */
    @Column(length=19)
    private BigDecimal weight;
    
	/**
	 * 载具规格
	 */
    @Column(length=64)
    private String spec;
    
	/**
	 * 创建人
	 */
    @Column(length=255)
    private String createUser;
    
	/**
	 * 创建时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createTime;
    
	/**
	 * 更新人
	 */
    @Column(length=255)
    private String updateUser;
    
	/**
	 * 更新时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date updateTime;
    
	/**
	 * 第一备用字段
	 */
    @Column(length=64)
    private String remarkFirst;
    
	/**
	 * 第二备用字段
	 */
    @Column(length=64)
    private String remarkSecond;
    
	/**
	 * 是否删除 0否,1是
	 */
    @Column(length=0)
    private Boolean isDeleted;
    

	public CarrierConfig() {
	}

	public CarrierConfig(Integer id) {
		this.id = id;
	}
}
