package com.sw.mes.yb.pc.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.util.Date;

@Entity
@Data
@DynamicUpdate
@DynamicInsert
@Table(name="zhxx_operate_crucible_check_data")
public class CrucibleCheckData {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    /**
     * 坩埚编号
     */
    @Column(length = 100)
    private String code;

    /**
     * 炉次号
     */
    @Column(length = 80)
    private String lotNo;

    /**
     * 装料人
     */
    @Column(length = 40)
    private String operateUser;

    /**
     * 装料班长
     */
    @Column(length = 40)
    private String operateMonitor;

    /**
     * 装料时间
     **/
    @Column(name = "operate_time")
    @Temporal(TemporalType.TIMESTAMP)
    private Date operateTime;

    /**
     * 产地
     */
    @Column
    private String codePlace;

    /**
     * 重量
     */
    @Column
    private Double weight;

    /**
     * 班组
     */
    @Column(length = 100)
    private String className;

    /**
     * 班次
     */
    @Column(length = 100)
    private String classNo;

    /**
     * 点检是否通过
     */
    @Column
    private Boolean pass;
}
