/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.pc.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.math.BigDecimal;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="zhxx_fb_operate_fbjoin")
@DynamicUpdate
@DynamicInsert
public class Fbjoin {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;

	/**
	 * 方棒编号
	 */
    @Column(length=60)
    private String sectionNoFb;

	/**
	 * 拼棒组号
	 */
    @Column(length=400)
    private String sectionNoGroup;

	/**
	 * 方棒产品等级
	 */
    @Column(length=40)
    private String productLevelFb;

	/**
	 * 拼数
	 */
    @Column(length=10)
    private Integer stickCount;

	/**
	 * 拼棒总理论重量
	 */
    @Column(length=19)
    private BigDecimal theoryWeight;

	/**
	 * 拼棒总长度
	 */
    @Column(length=19)
    private BigDecimal totalLength;

	/**
	 * 单根单晶拼接长度 ,隔开
	 */
    @Column(length=100)
    private String lengthGroup;

	/**
	 * 绑定人
	 */
    @Column(length=40)
    private String bindUser;

	/**
	 * 绑定时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date bindTime;

	/**
	 * 解绑人
	 */
    @Column(length=40)
    private String unbindUser;

	/**
	 * 解绑时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date unbindTime;

	/**
	 * 状态 0未解绑 1已解绑
	 */
    @Column(length=10)
    private Integer state;


	public Fbjoin() {
	}

	public Fbjoin(Integer id) {
		this.id = id;
	}
}
