/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.pc.entity;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.util.Date;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@Entity
@Table(name = "head_tail_material_rule")
@DynamicUpdate
@DynamicInsert
public class HeadTailMaterialRule {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;

    /**
     * 托位号
     */
    @Column(length = 32)
    private Integer bracketNo;

    /**
     * 掺杂剂
     */
    @Column(length = 12)
    private String dopant;

    /**
     * 回收料分类名称
     */
    @Column(length = 50)
    private String recoveryName;

    /**
     * 电阻率
     */
    @Column(length = 150)
    private String border;

    /**
     * 少子寿命
     */
    @Column(length = 50)
    private String sinton;

    /**
     * 碳含量
     */
    @Column(length = 32)
    private String carbon;

    /**
     * 创建者
     */
    @Column(nullable = false, length = 32)
    private String userCreate;

    /**
     * 修改者
     */
    @Column(length = 32)
    private String userUpdate;

    /**
     * 创建时间
     */
    @Column(nullable = false, length = 19)
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreate;

    /**
     * 修改时间
     */
    @Column(length = 19)
    @Temporal(TemporalType.TIMESTAMP)
    private Date gmtUpdate;

    /**
     * 线体号
     */
    @Column(length = 32)
    private String line;

    /**
     * 线体区域编码
     */
    @Column(length = 32)
    private String regionCode;
    /**
     * 产品类别
     */
    @Column(length = 32)
    String productType;
    /**
     * 设备编号
     */
    @Column(length = 32)
    String deviceCode;

    /**
     * 回收料托位名称
     */
    String reduceTrayName;
    /**
     * 物料名称
     */
    String materialName;
    /**
     * 物料编码
     */
    String materialCode;
    /**
     * 产品等级
     */
    String productGrade;

    public HeadTailMaterialRule() {
    }

    public HeadTailMaterialRule(Integer id) {
        this.id = id;
    }
}
