package com.sw.mes.yb.pc.entity;

import lombok.Data;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import java.math.BigDecimal;

@Data
@Entity
@Table(name="zhxx_quality_print_bar")
public class QualityPrintBar {
    @Id
    private Long id;

    /**
     * 晶段编号
     */
    @Column(length = 80)
    private String sectionNo;

    /**
     * 实际长度
     */
    @Column(length = 10)
    private BigDecimal actualLength;

    /**
     * 产品等级
     * 二次评级
     */
    @Column
    private String productLevelSecond;

    /**
     * 目标规格
     */
    @Column(length = 40)
    private String productTypeSecond;

    /**
     * 产品等级
     * 实验类型结果
     */
    @Column
    private String productLevelExperiment;

    /**
     * 最大直径
     */
    @Column(length = 10)
    private BigDecimal diameterMax;

    /**
     * 最小直径
     */
    @Column(length = 10)
    private BigDecimal diameterMin;

    /**
     * 碳含量最大值
     */
    @Column(length = 10)
    private BigDecimal carbonContent;

    /**
     * 氧含量最大值
     */
    @Column(length = 10)
    private BigDecimal oxygenContent;

    /**
     * 崩晶线
     */
    @Column(length = 10)
    private BigDecimal collapseLine;


    /**
     * sinton寿命最小值
     */
    @Column(length = 10)
    private BigDecimal sinton;


    /**
     * 平均电阻率
     */
    @Column(length = 10)
    private BigDecimal dzl;

    /**
     * 晶段类型
     */
    @Column(length = 40)
    private String type;

    /**
     * 返切备注
     */
    @Column(length = 40)
    private String remark;

    /**
     * 打印备注
     */
    @Column(length = 80)
    private String printRemark;

}
