/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.pc.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="zhxx_operate_quality_print_log")
@DynamicUpdate
@DynamicInsert
public class QualityPrintLog {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;
    
	/**
	 * 打印操作人
	 */
    @Column(length=50)
    private String userName;
    
	/**
	 * 晶段编号
	 */
    @Column(length=255)
    private String sectionNo;
    
	/**
	 * 打印时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date printTime;
    

	public QualityPrintLog() {
	}

	public QualityPrintLog(Integer id) {
		this.id = id;
	}
}
