package com.sw.mes.yb.pc.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.util.Date;

/**
 * 导入评级结果记录
 */
@Data
@Entity
@Table(name = "zhxx_temp_section_rank")
@DynamicUpdate
@DynamicInsert
public class SectionRank {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    /**
     * 晶段编号
     */
    @Column
    private String sectionNo;

    /**
     * 产品二次等级
     */
    @Column
    private String productLevelSecond;

    /**
     * 产品实验等级
     */
    @Column
    private String productLevelExperiment;

    /**
     * 产品类别
     */
    @Column
    private String productTypeSecond;

    /**
     * 创建时间
     */
    @Column(length = 19)
    @Temporal(TemporalType.TIMESTAMP)
    private Date createTime;

    public SectionRank(){}

    public SectionRank(Long id) {
        this.id = id;
    }

}
