/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.pc.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@Entity
@Table(name = "zhxx_fb_operate_tray_binding_record")
@DynamicUpdate
@DynamicInsert
public class TrayBindingRecord {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;
    /**
     * 托盘编号
     */
    @Column(length = 80)
    String code;

    /**
     * 上料点位
     */
    @Column(length = 255)
    String feedingPoint;

    /**
     * rfid
     */
    @Column(length = 225)
    String rfid;
    /**
     * 晶段编号(拼棒SN)
     */
    @Column(length = 80)
    String sectionNo;
    /**
     * 大规格类型
     */
    @Column(length = 255)
    String bigProductType;
    /**
     * 晶段长度
     */
    @Column(length=22)
    private BigDecimal sectionLength;
    /**
     * 拼数
     */
    @Column(length = 10)
    Integer sectionCount;
    /**
     * 晶段编号组
     */
    @Column(length = 500)
    String sectionNoGroup;
    /**
     * 晶段长度组
     */
    @Column(length = 80)
    String sectionLengthGroup;
    /**
     * 产品规格
     */
    @Column(length = 40)
    String productType;

    /**
     * 产品等级
     */
    @Column(length = 255)
    String productLevel;
    /**
     * 实验等级
     */
    @Column(length = 255)
    String productLevelExperiment;
    /**
     * 创建时间
     **/
    @Column(length = 19)
    Date createTime;
    /**
     * 创建人id
     **/
    @Column(length = 10)
    Integer createUserId;
    /**
     * 创建人姓名
     */
    @Column(length = 255)
    String createUserName;
    /**
     * 解绑时间
     **/
    @Column(length = 19)
    Date unbundlingTime;
    /**
     * 解绑人id
     **/
    @Column(length = 10)
    Integer unbundlingUserId;
    /**
     * 创建人姓名
     **/
    @Column(length = 255)
    String unbundlingUserName;

    /**
     * 是否解绑（0：未解绑，1：已解绑）
     */
    @Column(length = 10)
    Integer status;


    /**
     * 创建人姓名
     **/
    @Column(length = 40)
    String productModelNameFb;

    public TrayBindingRecord() {
    }

    public TrayBindingRecord(Integer id) {
        this.id = id;
    }
}
