package com.sw.mes.yb.plan.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.sw.mes.core.annotation.Jinko;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.validator.constraints.*;

import javax.validation.constraints.*;

import java.util.Date;

@Jinko(value = "炉内转订单记录", author = "wxl")
@Data
@ApiModel(value = "圆棒工单排程记录Dto")
public class ProductionScheduleLogDto {

    private Long id;
     @ApiModelProperty(value = "炉次id" )
     Integer lotId;
     @ApiModelProperty(value = "炉次号" )
     String lotNo;
     @ApiModelProperty(value = "任务编号" )
     String code;
     @ApiModelProperty(value = "设备id" )
     Long deviceId;
     @ApiModelProperty(value = "设备编号" )
     String deviceNo;
     @ApiModelProperty(value = "发料编码" )
     String deliveryNo;
     @ApiModelProperty(value = "圆棒产品模型id" , required = true)
     Integer productModelId;
     @ApiModelProperty(value = "圆棒订单id" , required = true)
     Integer productionOrderId;
     @ApiModelProperty(value = "加工能力信息id" , required = true)
     Integer capacityInfoId;
     @ApiModelProperty(value = "任务状态(0：即将开始,1：进行中,2：已完成,3：已取消)" , required = true)
     Boolean status;
     @ApiModelProperty(value = "状态信息" )
     String statusInfo;
     @ApiModelProperty(value = "创建时间" )
     @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
     Date createTime;
     @ApiModelProperty(value = "数量" )
     Integer count;
     @ApiModelProperty(value = "创建人" )
     String createUserName;
     @ApiModelProperty(value = "创建人ID" )
     Integer createUserId;
     @ApiModelProperty(value = "0:默认；0-量产;1-在建;2-研发;" )
     Integer furnaceType;
     @ApiModelProperty(value = "产品类别" )
     String productType;
}