package com.sw.mes.yb.plan.dto;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.metadata.BaseRowModel;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * @author liuzemin
 * @date 2022/7/27 14:43
 * @description
 */
@Data
public class YbProductionOrderImport extends BaseRowModel {

    @ApiModelProperty(value = "SAP 订单编号 SAP中最多12位")
    @ExcelProperty(value = "订单编号")
    String aufnr;

    @ApiModelProperty(value = "订单类型")
    @ExcelProperty(value = "订单类型")
    String auart;

    @ApiModelProperty(value = " 产品料号")
    @ExcelProperty(value = "产品料号")
    String matnr;

    @ApiModelProperty(value = "数量")
    @ExcelProperty(value = "数量")
    Long menge;

    @ApiModelProperty(value = "1 ~ 9，优先级")
    @ExcelProperty(value = "优先级")
    String aprio;

    @ApiModelProperty(value = "客户信息")
    @ExcelProperty(value = "客户信息")
    String customerid;

    @ApiModelProperty(value = " 计划开始时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ExcelProperty(value = "计划开始时间")
    Date gstrp;

    @ApiModelProperty(value = "计划结束时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ExcelProperty(value = "计划结束时间")
    Date gltrp;

    @ApiModelProperty(value = " 是否生产")
    @ExcelProperty(value = "是否生产")
    Boolean productionStatus;

    /**
     * 研发唯一标识
     */
    @ApiModelProperty(value = "研发唯一标识")
    @ExcelProperty(value = "研发唯一标识")
    String rdonlylogo;

    @ApiModelProperty(value = "产品类别")
    @ExcelProperty(value = "产品类别")
    String productType;
    /**
     * 电阻类型
     */
    @ApiModelProperty(value = "电阻类型")
    @ExcelProperty(value = "电阻类型")
    private String resistanceType;


}
