/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.plan.entity;

import java.util.Date;
import java.math.BigDecimal;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="plan_equipment_output")
@DynamicUpdate
@DynamicInsert
public class PlanEquipmentOutput{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 基地
	 */
    @Column(length=50)
    private String site;
    
	/**
	 * 车间
	 */
    @Column(length=50)
    private String workshop;
    
	/**
	 * 片区1
	 */
    @Column(length=50)
    private String area1;
    
	/**
	 * 片区2
	 */
    @Column(length=50)
    private String area2;
    
	/**
	 * 片区3
	 */
    @Column(length=50)
    private String area3;

	/**
	 * 设备ID
	 */
	@Column(length=19)
	private Long equipmentId;

	/**
	 * 设备号
	 */
    @Column(length=50)
    private String equipmentCode;
    
	/**
	 * 产量日期
	 */
    @Column(length=20)
    private String outputDate;
    
	/**
	 * 计划单产
	 */
    @Column(length=19)
    private BigDecimal outputCount;
    
	/**
	 * 热场尺寸
	 */
    @Column(length=20)
    private String cruSize;
    
	/**
	 * 坩埚品类
	 */
    @Column(length=20)
    private String cruClass;
    
	/**
	 * 规格
	 */
    @Column(length=20)
    private String prodSpec;
    
	/**
	 * 产品简称
	 */
    @Column(length=20)
    private String prodSub;
    
	/**
	 * 创建人
	 */
    @Column(length=50)
    private String createUser;
    
	/**
	 * 创建时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createTime;
    
	/**
	 * 修改人
	 */
    @Column(length=50)
    private String updateUser;
    
	/**
	 * 修改时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date updateTime;
    
	/**
	 * 状态(0:异常, 1:正常)
	 */
    @Column(length=10)
    private Integer status;
    

	public PlanEquipmentOutput() {
	}

	public PlanEquipmentOutput(Long id) {
		this.id = id;
	}
}
