/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.plan.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="plan_water_line_manage")
@DynamicUpdate
@DynamicInsert
public class PlanWaterLineManage {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 水位线名称
	 */
    @Column(length=40)
    private String waterLineName;
    
	/**
	 * 缓存数量
	 */
    @Column(length=10)
    private Integer cacheNum;

//	/**
//	 * 类型
//	 */
//	@Column(length=40)
//	private String strategy;
    
	/**
	 * 用户id
	 */
    @Column(length=10)
    private Integer userId;
    
	/**
	 * 用户名称
	 */
    @Column(length=20)
    private String userName;
    
	/**
	 * 创建时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createTime;
    
	/**
	 * 修改用户名称
	 */
    @Column(length=20)
    private String updateUserName;
    
	/**
	 * 修改时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date updateTime;
    

	public PlanWaterLineManage() {
	}

	public PlanWaterLineManage(Long id) {
		this.id = id;
	}
}
