/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.plan.entity;


import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="plan_water_line_manage_record")
@DynamicUpdate
@DynamicInsert
public class PlanWaterLineManageRecord {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

	/**
	 * 水位拉动id
	 */
    @Column(length=19)
    private Long pid;

	/**
	 * 订单编号
	 */
    @Column(length=12)
    private String aufnr;

	/**
	 * 订单类型
	 */
    @Column(length=40)
    private String auart;

	/**
	 * 产品料号
	 */
    @Column(length=18)
    private String matnr;

	/**
	 * 导电型号
	 */
    @Column(length=10)
    private String conductionType;

	/**
	 * 规格
	 */
    @Column(length=50)
    private String specs;

	/**
	 * 长度范围
	 */
    @Column(length=20)
    private String lenRange;

	/**
	 * 产品等级
	 */
    @Column(length=32)
    private String productGrade;

	/**
	 * 掺杂剂
	 */
    @Column(length=10)
    private String dopant;

	/**
	 * 拼棒数
	 */
    @Column(length=10)
    private Integer sticksCount;

	/**
	 * 百分比
	 */
    @Column(length=10)
    private Integer percent;

	/**
	 * 库发单次任务数
	 */
	@Column(length=10)
	private Integer onceNum;


	private String productType;

	/**
	 * 优先级
	 */
	@Column(length=10)
	private Integer priorityValue;

	/**
	 * 方棒边长范围
	 */
	@Column(length = 50)
	private String sideLengthRange;

	/**
	 * 电阻档位
	 */
	@Column(length = 50)
	private String resistanceLevel;

	/**
	 * 圆棒产品等级
	 */
	private String ybProductGrade;


	public PlanWaterLineManageRecord() {
	}

	public PlanWaterLineManageRecord(Long id) {
		this.id = id;
	}
}
