/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.plan.entity;

import java.util.Date;

import com.sw.mes.core.annotation.Jinko;
import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

@Jinko(value = "炉内转订单记录", author = "wxl")
@Data
@Entity
@Table(name="plan_production_schedule_log")
@DynamicUpdate
@DynamicInsert
public class ProductionScheduleLog{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 炉次id
	 */
    @Column(length=10)
    private Integer lotId;
    
	/**
	 * 炉次号
	 */
    @Column(length=32)
    private String lotNo;
    
	/**
	 * 任务编号
	 */
    @Column(length=32)
    private String code;
    
	/**
	 * 设备id
	 */
    @Column(length=19)
    private Long deviceId;
    
	/**
	 * 设备编号
	 */
    @Column(length=32)
    private String deviceNo;
    
	/**
	 * 发料编码
	 */
    @Column(length=50)
    private String deliveryNo;
    
	/**
	 * 圆棒产品模型id
	 */
    @Column(nullable=false, length=10)
    private Integer productModelId;
    
	/**
	 * 圆棒订单id
	 */
    @Column(nullable=false, length=10)
    private Integer productionOrderId;
    
	/**
	 * 加工能力信息id
	 */
    @Column(nullable=false, length=10)
    private Integer capacityInfoId;
    
	/**
	 * 任务状态(0：即将开始,1：进行中,2：已完成,3：已取消)
	 */
    @Column(nullable=false, length=0)
    private Boolean status;
    
	/**
	 * 状态信息
	 */
    @Column(length=200)
    private String statusInfo;
    
	/**
	 * 创建时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createTime;
    
	/**
	 * 数量
	 */
    @Column(length=10)
    private Integer count;
    
	/**
	 * 创建人
	 */
    @Column(length=50)
    private String createUserName;
    
	/**
	 * 创建人ID
	 */
    @Column(length=10)
    private Integer createUserId;
    
	/**
	 * 0:默认；0-量产;1-在建;2-研发;
	 */
    @Column(length=10)
    private Integer furnaceType;
    
	/**
	 * 产品类别
	 */
    @Column(length=10)
    private String productType;
    

	public ProductionScheduleLog() {
	}

	public ProductionScheduleLog(Long id) {
		this.id = id;
	}
}
