package com.sw.mes.yb.printer.dto;

import com.alibaba.excel.annotation.ExcelProperty;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@ApiModel(value = "FbCheckOutDataDto")
public class FbCheckOutDataDto {

    @ApiModelProperty(value = "SN编码/单晶编号")
    String sectionNo;
    @ApiModelProperty(value = "编号(圆棒)")
    String ybSectionNo;
    @ApiModelProperty(value = "编号(方棒)")
    String fbSectionNo;
    @ApiModelProperty(value = "检验类型id")
    Integer checkoutId;
    @ApiModelProperty(value = "检验类型name")
    String checkoutName;
    @ApiModelProperty(value = "当前提交日期")
    String checkTime;
    @ApiModelProperty(value = "复检类型")
    String reCheckType;
    @ApiModelProperty(value = "一体机编号")
    String deviceNo;
    @ApiModelProperty(value = "检验员")
    String checkUserName;
    @ApiModelProperty(value = "规格")
    String specification;
    @ApiModelProperty(value = "掺杂剂")
    String dopant;
    @ApiModelProperty(value = "方棒长度")
    BigDecimal length;
    @ApiModelProperty(value = "方棒入库长度")
    BigDecimal instoreLengthFb = BigDecimal.ZERO;
    @ApiModelProperty(value = "圆棒长度")
    BigDecimal actualLength=BigDecimal.ZERO;
    @ApiModelProperty(value = "圆棒入库长度(mm)")
    BigDecimal instoreLengthYb=BigDecimal.ZERO;
    @ApiModelProperty(value = "圆棒消耗长度")
    BigDecimal consumeLengthYb=BigDecimal.ZERO;
    @ApiModelProperty(value = "崩损(mm)")
    BigDecimal collapseLoss=BigDecimal.ZERO;
    @ApiModelProperty(value = "方棒称重")
    BigDecimal weight=BigDecimal.ZERO;
    @ApiModelProperty(value = "方棒理论重量（kg）")
    BigDecimal theoryWeightFb=BigDecimal.ZERO;
    @ApiModelProperty(value = "长度斜(mm)")
    BigDecimal lengthSlope=BigDecimal.ZERO;
    @ApiModelProperty(value = "方棒备注")
    String squareRodRemark;
    @ApiModelProperty(value = "产品最终评级")
    String ybLevel;
    @ApiModelProperty(value = "实验最终评级")
    String experiLevel;
    @ApiModelProperty(value = "圆棒实验等级")
    String ybExperiLevel;
    @ApiModelProperty(value = "方棒实验等级")
    String fbExperiLevel;
    @ApiModelProperty(value = "方棒等级/检验入库类别")
    String productLevelFb;
    @ApiModelProperty(value = "料号")
    String materialNumber;
    @ApiModelProperty(value = "订单号")
    String orderNo;
    @ApiModelProperty(value = "订单类型")
    String orderType;
    @ApiModelProperty(value = "计划订单编号")
    String planOrderNo;
    @ApiModelProperty(value = "计划订单类型")
    String planOrderType;
    @ApiModelProperty(value = "计划物料编码")
    String planMaterialCode;
    @ApiModelProperty(value = "计划产品等级")
    String planGrade;
    @ApiModelProperty(value = "计划规格")
    String planSpecs;
    @ApiModelProperty(value = "计划拼数")
    String planStickCount;
    @ApiModelProperty(value = "计划长度范围")
    String planLenRange;
    @ApiModelProperty(value = "计划掺杂剂")
    String planDopant;
    @ApiModelProperty(value = "计划导电型号")
    String planConductiveType;
    @ApiModelProperty(value = "计划电阻率")
    String planResistivity;
    @ApiModelProperty(value = "方棒减长 ")
    BigDecimal lengthPrep;
    @ApiModelProperty(value = "方棒尺寸类型")
    String sizeType;
    @ApiModelProperty(value = "晶体灰皮长度(mm)")
    BigDecimal crystalGrayness=BigDecimal.ZERO;
    @ApiModelProperty(value = "方棒灰皮长度(mm)")
    BigDecimal squareRodGrayness=BigDecimal.ZERO;
    @ApiModelProperty(value = "线痕长度(mm)")
    BigDecimal lineScratch=BigDecimal.ZERO;
    @ApiModelProperty(value = "刀痕长度(mm)")
    BigDecimal knifeScratch=BigDecimal.ZERO;
    @ApiModelProperty(value = "色差")
    BigDecimal colourDifference=BigDecimal.ZERO;
    @ApiModelProperty(value = "阴阳面")
    BigDecimal yinYangFace=BigDecimal.ZERO;
    @ApiModelProperty(value = "水印")
    BigDecimal waterMark=BigDecimal.ZERO;
    @ApiModelProperty(value = "平面手感")
    BigDecimal flatHandle=BigDecimal.ZERO;
    @ApiModelProperty(value = "外圆手感")
    BigDecimal roundHandle=BigDecimal.ZERO;
    @ApiModelProperty(value = "砂轮印")
    BigDecimal wheelMark=BigDecimal.ZERO;
    @ApiModelProperty(value = "滚轮印")
    BigDecimal rollerPrint=BigDecimal.ZERO;
    @ApiModelProperty(value = "划痕长度(mm)")
    BigDecimal scratch=BigDecimal.ZERO;
    @ApiModelProperty(value = "头斜(mm)")
    BigDecimal headSlope=BigDecimal.ZERO;
    @ApiModelProperty(value = "尾斜(mm)")
    BigDecimal tailSlope=BigDecimal.ZERO;
    @ApiModelProperty(value = "检验线编号")
    String checkLineNo;
    @ApiModelProperty(value = "导电型号")
    String conductionType;
    @ApiModelProperty(value = "直径max")

    BigDecimal diameterMax=BigDecimal.ZERO;
    @ApiModelProperty(value = "直径min")

    BigDecimal diameterMin=BigDecimal.ZERO;
    @ApiModelProperty(value = "边长max")

    BigDecimal sideLengthMax=BigDecimal.ZERO;
    @ApiModelProperty(value = "边长min")

    BigDecimal sideLengthMin=BigDecimal.ZERO;
    @ApiModelProperty(value = "垂直度max")

    BigDecimal verticalityMax=BigDecimal.ZERO;
    @ApiModelProperty(value = "垂直度min")

    BigDecimal verticalityMin=BigDecimal.ZERO;
    @ApiModelProperty(value = "弧长投影max")

    BigDecimal projectionMax=BigDecimal.ZERO;
    @ApiModelProperty(value = "弧长投影min")

    BigDecimal projectionMin=BigDecimal.ZERO;
    @ApiModelProperty(value = "弦长max ")

    BigDecimal chordLengthMax=BigDecimal.ZERO;
    @ApiModelProperty(value = "弦长min")

    BigDecimal chordLengthMin=BigDecimal.ZERO;
    @ApiModelProperty(value = "平面锥度max")

    BigDecimal planeTaperMax=BigDecimal.ZERO;
    @ApiModelProperty(value = "平面锥度min")

    BigDecimal planeTaperMin=BigDecimal.ZERO;
    @ApiModelProperty(value = "平边晶向")

    String flatOrientation;
    @ApiModelProperty(value = "晶体晶向")

    String orientation;
    @ApiModelProperty(value = "放行长度")

    BigDecimal concessionLength=BigDecimal.ZERO;
    @ApiModelProperty(value = "返切长度(mm)")

    BigDecimal recutLength=BigDecimal.ZERO;
    @ApiModelProperty(value = "未磨到长度(mm)")

    BigDecimal noFriction=BigDecimal.ZERO;
    @ApiModelProperty(value = "拼数")

    Integer sticksCount=0;
    @ApiModelProperty(value = "拼棒总长(mm)")

    BigDecimal spellBarLength=BigDecimal.ZERO;
    @ApiModelProperty(value = "缝宽(mm)")

    BigDecimal crackWidth=BigDecimal.ZERO;
    @ApiModelProperty(value = "其他备注")

    String otherRemark;
    @ApiModelProperty(value = "塌边")

    BigDecimal collapse=BigDecimal.ZERO;
    @ApiModelProperty(value = "崩损灰皮非边缘")

    BigDecimal brokenGreyNoEdge=BigDecimal.ZERO;
    @ApiModelProperty(value = "崩损灰皮边缘")

    BigDecimal damageGreyHideEdge=BigDecimal.ZERO;
    @ApiModelProperty(value = "崩损灰皮总和")

    BigDecimal damageGreySum=BigDecimal.ZERO;
    @ApiModelProperty(value = "异常总和")

    BigDecimal abnormalSum=BigDecimal.ZERO;
    @ApiModelProperty(value = "方棒边缘差")

    BigDecimal sideLengthDiffer=BigDecimal.ZERO;
    @ApiModelProperty(value = "灰皮非边缘")

    BigDecimal greyHideCenter=BigDecimal.ZERO;
    @ApiModelProperty(value = "灰皮边缘")

    BigDecimal greyHideEdge=BigDecimal.ZERO;
    @ApiModelProperty(value = "亮斑")
    @ExcelProperty(value = "亮斑")
    BigDecimal hotSpot=BigDecimal.ZERO;
    @ApiModelProperty(value = "砂轮亮点")
    @ExcelProperty(value = "砂轮亮点")
    BigDecimal wheelHighLights=BigDecimal.ZERO;
    @ApiModelProperty(value = "尺寸异常长度(mm)")
    @ExcelProperty(value = "尺寸异常长度")
    BigDecimal sizeException = BigDecimal.ZERO;
    @ApiModelProperty(value = "棱崩")
    @ExcelProperty(value = "棱崩")
    BigDecimal ridgeBroken = BigDecimal.ZERO;
    @ApiModelProperty(value = "裂纹")
    @ExcelProperty(value = "裂纹")
    BigDecimal crack = BigDecimal.ZERO;
    @ApiModelProperty(value = "领料来源值")
    @ExcelProperty(value = "领料来源值")
    String materialSourceValue;
    @ExcelProperty(value = "头尾识别")
    @ApiModelProperty(value = "头尾识别")
    private String headTailRecognition;
    @ApiModelProperty(value = "单晶组合")
    private String sectionCompose;
    @ApiModelProperty(value = "边长")
    private String sideLengthRange;

    @ApiModelProperty(value = "物料编码")
    private String materialCode;
    @ApiModelProperty(value = "产品简称")
    private String  abbreviation;
}