package com.sw.mes.yb.printer.dto;

import com.sw.mes.core.annotation.NumberHandler;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * @Author: GaoXinJian
 * @Date: 2022-01-21 15:44
 */
@ApiModel
@Data
@NumberHandler
public class FbCrystalCertificateDto {
    //以下数据从圆棒检验数据库获取，先根据方棒编号查询方棒检验数据，再根据检验数据中的圆棒（短棒）编号查询圆棒检验数据库
    @ApiModelProperty(value = "圆棒规格")
    String specificationYb;
    @ApiModelProperty(value = "导电型号-规格")
    String specification;
    @ApiModelProperty(value = "导电型号")
    String conductionType;
    @ApiModelProperty(value = "产品最终评级")
    String ybLevel;
    @ApiModelProperty(value = "圆棒长度")
    String actualLength;;
    @ApiModelProperty(value = "径向电阻率T中心点")
    String tRadialCentre;
    @ApiModelProperty(value = "径向电阻率T边缘1")
    String tRadialEdge1;
    @ApiModelProperty(value = "径向电阻率W中心点")
    String wRadialCentre;
    @ApiModelProperty(value = "径向电阻率W边缘1")
    String wRadialEdge1;
    @ApiModelProperty(value = "电阻率头尾中心边缘4点均值")
    String endCentreEdgeAvg4;
    @ApiModelProperty(value = "径向电阻率TW边缘1平均" )
    String twRadialEdge1Avg;
    //
//    //223
//    @ApiModelProperty(value = "电阻率头中心边缘平均" )
//    String topCentreEdgeAvg;
//    @ApiModelProperty(value = "电阻率尾中心边缘平均" )
//    String endCentreEdgeAvg;
//    //247 295
    @ApiModelProperty(value = "电阻率头均值")
    String resistivityTopAvg;
    @ApiModelProperty(value = "电阻率尾均值")
    String resistivityEndAvg;
    @ApiModelProperty(value = "实际称重/实测重量")
    String actualWeight;
    @ApiModelProperty(value = "崩边长度")
    String edgeBark;

//产品标准卡信息
    @ApiModelProperty(value = "客户名称" )
    String customerName;
    @ApiModelProperty(value = "直径" )
    String diameter;
    @ApiModelProperty(value = "圆棒直径")
    String diameterYb;
    @ApiModelProperty(value = "边长" )
    String sideLength;
    @ApiModelProperty(value = "垂直度" )
    String verticality;
    @ApiModelProperty(value = "弧长投影" )
    String projection;
    @ApiModelProperty(value = "X锥度" )
    String taperXz;
    @ApiModelProperty(value = "Y锥度" )
    String taperYz;
    @ApiModelProperty(value = "外观异常项")
    String appearanceException;
    @ApiModelProperty(value = "圆棒检验时间")
    String levelTime;
    @ApiModelProperty(value = "圆棒实验等级")
    String ybExperiLevel;


//    ======================


    @ApiModelProperty(value = "单晶编号(整棒)")
    String crystalNo;
    @ApiModelProperty(value = "晶段编号(短棒)")
    String sectionNo;
    @ApiModelProperty(value = "晶段类型")
    String sectionType;
    @ApiModelProperty(value = "头尾识别")
    String headTailRecognition;
    @ApiModelProperty(value = "复投次数")
    Integer againNum;
    @ApiModelProperty(value = "复投后颗数")
    Integer againPiece;
    @ApiModelProperty(value = "掺杂剂")
    String dopant;
    @ApiModelProperty(value = "拉制状态【Y：表示不断苞;N：表示断苞;W：表示未断苞见埚底单晶;V：表示断苞见埚底单晶】")
    String pullType;
    @ApiModelProperty(value = "库别【0-正常；1-直径不良单晶；2-退料；】")
    String kube;
    @ApiModelProperty(value = "是否反切【0：默认，否；1：是；】", required = true)
    Integer isCutBack;
    @ApiModelProperty(value = "圆棒检验类型")
    String checkoutName;
    @ApiModelProperty(value = "复检类别")
    String reCheckType;
    @ApiModelProperty(value = "规格/实际规格")
    String productTypeSecond;
    @ApiModelProperty(value = "是否转规格【0：默认，否；1：是；】")
    Integer isChangeSpecs;
    @ApiModelProperty(value = "圆棒入库长度")
    String wareHouseLength;
    @ApiModelProperty(value = "理论重量")
    String theoryWeight;
    @ApiModelProperty(value = "直径Min")
    String diameterMin;
    @ApiModelProperty(value = "直径Max")
    String diameterMax;
    @ApiModelProperty(value = "直径判定")
    String diamDecide;
    @ApiModelProperty(value = "细")
    String fineDiameter;
    @ApiModelProperty(value = "细减长")
    String fineCutLength;
    @ApiModelProperty(value = "崩晶线")
    String collapseLine;
    @ApiModelProperty(value = "直径差")
    String demcMax;
    @ApiModelProperty(value = "平均直径")
    String avgDiameter;
    @ApiModelProperty(value = "整颗平均直径")
    String allAvgDiameter;

    @ApiModelProperty(value = "斜【0：默认，否；1：是；】")
    Integer isBevel;
    @ApiModelProperty(value = "晶线分叉【0：默认，否；1：是；】")
    Integer isFork;
    @ApiModelProperty(value = "裂纹")
    String crack;
    @ApiModelProperty(value = "孪晶【0：默认，否；1：是；】")
    Integer isTwinCrystal;
    @ApiModelProperty(value = "孪晶长度")
    String twinLength;
    @ApiModelProperty(value = "头斜")
    String headSlope;
    @ApiModelProperty(value = "尾斜")
    String tailSlope;
    @ApiModelProperty(value = "扭过大(0否 1是)")
    Integer distortionBig;
    @ApiModelProperty(value = "扭")
    String distortion;
    @ApiModelProperty(value = "产品等级")
    String productLevel;
    @ApiModelProperty(value = "实验等级")
    String productLevelExperiment;
    @ApiModelProperty(value = "圆棒备注")
    String remark;
    @ApiModelProperty(value = "圆棒最终评级/评级")
    String level;
    @ApiModelProperty(value = "最终实验等级/实验等级")
    String experiLevel;
    @ApiModelProperty(value = "导电型号/型号")
    String conductiveType;
    @ApiModelProperty(value = "电阻率范围min")
    String resistivityMin;
    @ApiModelProperty(value = "电阻率范围max")
    String resistivityMax;
    @ApiModelProperty(value = "T寿命min")
    String tLifeMin;
    @ApiModelProperty(value = "W寿命min")
    String wLifeMin;
    @ApiModelProperty(value = "径向电阻率T边缘2")
    String tRadialEdge2;
    @ApiModelProperty(value = "径向电阻率T边缘3")
    String tRadialEdge3;
    @ApiModelProperty(value = "径向电阻率T边缘4")
    String tRadialEdge4;
    @ApiModelProperty(value = "径向电阻率T边缘5")
    String tRadialEdge5;
    @ApiModelProperty(value = "径向电阻率T边缘6")
    String tRadialEdge6;
    @ApiModelProperty(value = "径向电阻率T边缘7")
    String tRadialEdge7;
    @ApiModelProperty(value = "径向电阻率T边缘8")
    String tRadialEdge8;
    @ApiModelProperty(value = "径向电阻率W边缘2")
    String wRadialEdge2;
    @ApiModelProperty(value = "径向电阻率W边缘3")
    String wRadialEdge3;
    @ApiModelProperty(value = "径向电阻率W边缘4")
    String wRadialEdge4;
    @ApiModelProperty(value = "径向电阻率W边缘5")
    String wRadialEdge5;
    @ApiModelProperty(value = "径向电阻率W边缘6")
    String wRadialEdge6;
    @ApiModelProperty(value = "径向电阻率W边缘7")
    String wRadialEdge7;
    @ApiModelProperty(value = "径向电阻率W边缘8")
    String wRadialEdge8;
    @ApiModelProperty(value = "电阻率头中心边缘平均")
    String topCentreEdgeAvg;
    @ApiModelProperty(value = "电阻率尾中心边缘平均")
    String endCentreEdgeAvg;
    @ApiModelProperty(value = "出货电阻率")
    String sellResistivity;
    @ApiModelProperty(value = "电阻率结论")
    String resistivityConclusion;
    @ApiModelProperty(value = "是否见锅底 1是0否")
    Integer isSeeBottom;
    @ApiModelProperty(value = "电阻率反翘")
    String resistivityWarping;
    @ApiModelProperty(value = "T中心寿命")
    String tCentreLife;
    @ApiModelProperty(value = "T边缘寿命1")
    String tLifeEdge1;
    @ApiModelProperty(value = "T边缘寿命2")
    String tLifeEdge2;
    @ApiModelProperty(value = "T边缘寿命3")
    String tLifeEdge3;
    @ApiModelProperty(value = "T边缘寿命4")
    String tLifeEdge4;
    @ApiModelProperty(value = "W中心寿命")
    String wCentreLife;
    @ApiModelProperty(value = "W边缘寿命1")
    String wLifeEdge1;
    @ApiModelProperty(value = "W边缘寿命2")
    String wLifeEdge2;
    @ApiModelProperty(value = "W边缘寿命3")
    String wLifeEdge3;
    @ApiModelProperty(value = "W边缘寿命4")
    String wLifeEdge4;
    @ApiModelProperty(value = "单晶减长长度")
    String reduceCrystalLength;
    @ApiModelProperty(value = "拉晶车间")
    String crystalWorkshop;
    @ApiModelProperty(value = "T氧含量中心")
    String oxygenContentHead;
    @ApiModelProperty(value = "T氧含量边缘")
    String oxygenContentBorder;
    @ApiModelProperty(value = "T碳含量中心")
    String carbonContentHead;
    @ApiModelProperty(value = "T碳含量边缘")
    String carbonContentBorder;
    @ApiModelProperty(value = "W氧含量中心")
    String oxygenContentTail;
    @ApiModelProperty(value = "W氧含量边缘")
    String oxygenContentBorderTail;
    @ApiModelProperty(value = "W碳含量中心")
    String carbonContentTail;
    @ApiModelProperty(value = "W碳含量边缘")
    String carbonContentBorderTail;
    @ApiModelProperty(value = "T缺陷")
    String headDefectGrade;
    @ApiModelProperty(value = "W缺陷")
    String tailDefect;
    @ApiModelProperty(value = "头位错【0：默认，无；1：有；】")
    Integer isMalpositionHead;
    @ApiModelProperty(value = "尾位错【0：默认，无；1：有；】")
    Integer isMalpositionTail;
    @ApiModelProperty(value = "T样片中心退火电阻率")
    String tCenterAnneal;
    @ApiModelProperty(value = "W样片中心退火电阻率")
    String wcenterAnneal;
    @ApiModelProperty(value = "T样片边缘退火电阻率")
    String tBorderAnneal;
    @ApiModelProperty(value = "W样片边缘退火电阻率")
    String wBorderAnneal;
    @ApiModelProperty(value = "异常汇总")
    String anomaly;
    @ApiModelProperty(value = "检验人员")
    String inspector;
    @ApiModelProperty(value = "检验日期")
    String hasGone;
    @ApiModelProperty(value = "订单号")
    String orderNo;
    @ApiModelProperty(value = "计划规格")
    String planSpecs;
    @ApiModelProperty(value = "计划订单号")
    private String planOrderNo;
    @ApiModelProperty(value = "物料编码")
    private String materialCode;

    @ApiModelProperty(value = "计划物料编码")
    String planMaterialCode;
    // 温度
    @ApiModelProperty(value = "头温度")
    private String temperature;
    @ApiModelProperty(value = "尾温度")
    private String temperatureEnd;
    @ApiModelProperty(value = "订单类型（1:量产；2:试验；3:送样;4:返工）")
    String orderType;


    @ApiModelProperty(value = "计划订单类型（1:量产；2:试验；3:送样;4:返工）")
    private String planOrderType;
    @ApiModelProperty(value = "炉台类型【0:默认；0-量产;1-在建;2-研发;】")
    Integer furnaceType;
    @ApiModelProperty(value = "系列")
    String series;
    @ApiModelProperty(value = "炉次号")
    String lotNo;
    @ApiModelProperty(value = "投料量")
    Integer materialCount;
    @ApiModelProperty(value = "T寿命/电阻率中心")
    String sintonCenter;
    @ApiModelProperty(value = "W寿命/电阻率中心")
    String sintonTail;
    @ApiModelProperty(value = "01W寿命")
    Integer lifeSpanw1;
    @ApiModelProperty(value = "01W电阻率")
    String resistivityw1;
    @ApiModelProperty(value = "02T寿命")
    Integer lifeSpant2;
    @ApiModelProperty(value = "02T电阻率")
    String resistivityt2;
    @ApiModelProperty(value = "单晶段号")
    Integer piecewiseNum;
    @ApiModelProperty(value = "创建时间")
    String createTime;
    @ApiModelProperty(value = "更新时间")
    String updateTime;
    @ApiModelProperty(value = "画线实验标记")
    String drawLine;
    @ApiModelProperty(value = "单晶拉制异常")
    String crystalAbnormal;
    @ApiModelProperty(value = "单晶组合")
    String sectionCompose;
    @ApiModelProperty(value = "拼数")
    String sticksCount;
    @ApiModelProperty(value = "工厂")
    String factory;
    @ApiModelProperty(value = "头部评级")
    String headLevel;
    @ApiModelProperty(value = "尾部评级")
    String tailLevel;
    @ApiModelProperty(value = "评级标准名称")
    String gradeName;
    @ApiModelProperty(value = "评级标准版本")
    String gradeVersion;
    @ApiModelProperty(value = "实验等级标准名称")
    String planGradeName;
    @ApiModelProperty(value = "实验等级标准版本")
    String planGradeVersion;
    @ApiModelProperty(value = "外观检验返切")
    String checkReback;
    @ApiModelProperty(value = "检验线编号")
    String checkLineNo;
    @ApiModelProperty(value = "温度补偿后径向电阻率T中心点")
    String tTempRadialCentre;
    @ApiModelProperty(value = "温度补偿后径向电阻率T边缘1")
    String tTempRadialEdge1;
    @ApiModelProperty(value = "温度补偿后径向电阻率T边缘2")
    String tTempRadialEdge2;
    @ApiModelProperty(value = "温度补偿后径向电阻率T边缘3")
    String tTempRadialEdge3;
    @ApiModelProperty(value = "温度补偿后径向电阻率T边缘4")
    String tTempRadialEdge4;
    @ApiModelProperty(value = "温度补偿后径向电阻率T边缘5")
    String tTempRadialEdge5;
    @ApiModelProperty(value = "温度补偿后径向电阻率T边缘6")
    String tTempRadialEdge6;
    @ApiModelProperty(value = "温度补偿后径向电阻率T边缘7")
    String tTempRadialEdge7;
    @ApiModelProperty(value = "温度补偿后径向电阻率T边缘8")
    String tTempRadialEdge8;
    @ApiModelProperty(value = "温度补偿后径向电阻率W中心点")
    String wTempRadialCentre;
    @ApiModelProperty(value = "温度补偿后径向电阻率W边缘1")
    String wTempRadialEdge1;
    @ApiModelProperty(value = "温度补偿后径向电阻率W边缘2")
    String wTempRadialEdge2;
    @ApiModelProperty(value = "温度补偿后径向电阻率W边缘3")
    String wTempRadialEdge3;
    @ApiModelProperty(value = "温度补偿后径向电阻率W边缘4")
    String wTempRadialEdge4;
    @ApiModelProperty(value = "温度补偿后径向电阻率W边缘5")
    String wTempRadialEdge5;
    @ApiModelProperty(value = "温度补偿后径向电阻率W边缘6")
    String wTempRadialEdge6;
    @ApiModelProperty(value = "温度补偿后径向电阻率W边缘7")
    String wTempRadialEdge7;
    @ApiModelProperty(value = "温度补偿后径向电阻率W边缘8")
    String wTempRadialEdge8;
    @ApiModelProperty(value = "单晶头方向")
    String crystalDirection;
    // 计划产品等级
    @ApiModelProperty(value = "计划产品等级")
    private String planGrade;

    // 计划拼数
    @ApiModelProperty(value = "计划拼数")
    private String planStickCount;

    // 计划长度范围
    @ApiModelProperty(value = "计划长度范围")
    private String planLenRange;


    // 计划掺杂剂
    @ApiModelProperty(value = "计划掺杂剂")
    private String planDopant;

    // 计划导电型号
    @ApiModelProperty(value = "计划导电型号")
    private String planConductiveType;

    @ApiModelProperty(value = "拼棒总长(mm)")
    private String spellBarLength;


    /**
     *
     */
    @ApiModelProperty(value = "划线实验标记")
    private String lineMarking;
//以上数据从圆棒检验数据库获取，先根据方棒编号查询方棒检验数据，再根据检验数据中的圆棒（短棒）编号查询圆棒检验数据库


//    以下数据为方棒检验数据=======================
@ApiModelProperty(value = "编号(方棒)")
String fbSectionNo;

    String deviceNo;

    @ApiModelProperty(value = "直径min")
    String diameterMinMax;
    //    @ApiModelProperty(value = "直径max")
//    @ExcelProperty(value = "单晶编号")
//    String diameterMax;
    @ApiModelProperty(value = "当前提交日期")
    String checkTime;
    @ApiModelProperty(value = "方棒长度-方棒减长")
    String length;
    @ApiModelProperty(value = "方棒实验等级")
    String fbExperiLevel;
    //    @ApiModelProperty(value = "方棒减长 ")
//    private String lengthPrep;
    @ApiModelProperty(value = "方棒备注")
    String squareRodRemark;
    @ApiModelProperty(value = "方棒等级/检验入库类别")
    String productLevelFb;
    @ApiModelProperty(value = "拼数")
    String sticksCountFb;
    @ApiModelProperty(value = "缝宽(mm)")
    String crackWidth;
    @ApiModelProperty(value = "拼棒总长(mm)")
    String spellBarLengthFb;
    @ApiModelProperty(value = "方棒称重")
    String weight;
    @ApiModelProperty(value = "方棒理论重量（kg）")
    String theoryWeightFb;

    @ApiModelProperty(value = "检验员")
    String checkUserName;

    @ApiModelProperty(value = "方棒头斜")
    String headSlopeFb;
    @ApiModelProperty(value = "方棒尾斜")
    String tailSlopeFb;
    @ApiModelProperty(value = "长度斜(mm)")
    String lengthSlope;

    //   以下未拼棒数据----------------
    @ApiModelProperty(value = "单晶组合")
    String sectionList ;
    @ApiModelProperty(value = "除主棒外的其他单晶的长度组合")
    String lengthList ;
    @ApiModelProperty(value = "除主棒外的其他方棒备注")
    String squareRodRemarkList ;
    @ApiModelProperty(value = "除主棒外头斜")
    String headSlopeList ;
    @ApiModelProperty(value = "除主棒外尾斜")
    String tailSlopeList ;
    @ApiModelProperty(value = "除主棒外崩边长度")
    String edgeBarkList ;
    @ApiModelProperty(value = "除主棒外崩晶线")
    String collapseLineList ;
    @ApiModelProperty(value = "除主棒外细减长")
    String fineCutLengthList ;
    @ApiModelProperty(value = "除主棒外细")
    String fineDiameterList ;
    @ApiModelProperty(value = "除主棒外异常汇总")
    String anomalyList ;
    @ApiModelProperty(value = "除主棒外外观异常汇总")
    String appearanceExceptionList ;

}
