package com.sw.mes.yb.printer.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.sw.mes.core.annotation.NumberHandler;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@ApiModel(value = "PrinterLogDto")
@NumberHandler
public class PrinterLogDto {

    private Long id;
    @ApiModelProperty(value = "编码（如：单晶编号、晶段编号）", required = true)
    String code;
    @ApiModelProperty(value = "打印类型（如：画线标签、圆棒合格证）", required = true)
    String type;
    @ApiModelProperty(value = "打印人", required = true)
    String createUser;
    @ApiModelProperty(value = "打印人id", required = true)
    Integer createUserId;
    @ApiModelProperty(value = "打印时间", required = true)
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date createTime;
    @ApiModelProperty(value = "是否删除：0否，1是")
    Boolean isDelete;
    @ApiModelProperty(value = "删除人")
    String deleteUser;
    @ApiModelProperty(value = "删除人id")
    Integer deleteUserId;
    @ApiModelProperty(value = "删除时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date deleteTime;
    @ApiModelProperty(value = "打印详情，json格式字符串")
    String detail;
    @ApiModelProperty(value = "打印是否成功")
    Boolean isSuccessful;
}
