package com.sw.mes.yb.production.dto.AgainTask;

import java.math.BigDecimal;
import java.util.LinkedHashMap;
import java.util.Map;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * @Author @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@ApiModel(value = "复投任务Dto")
public class ConfirmWeightDto {
	
	@ApiModelProperty(value = "AgainTask.id 复投任务ID")
	@NotNull(message="请输入复投任务ID")
	private Long id;
	@ApiModelProperty(value = "复投总重量")
	@NotNull(message="请输入复投总重量")
	private BigDecimal againWeigth;
	
	@ApiModelProperty(value = "剩余重量")
	private BigDecimal surplusWeigth;


	/**
	 * 下次复投是否完结【0：不是; 1 是;】
	 */
	@ApiModelProperty(value = "下次复投是否完结【0：不是; 1 是;】")
	private Integer isNextEnd;

	
	@ApiModelProperty(value = "总装埚料")
	private BigDecimal totalUseWeigth;
	
	@ApiModelProperty(value = "复投确认人员")
	@NotBlank(message="请输入复投确认人员")
	private String userName;
	
	@ApiModelProperty(value = "班次")
	private String classNo;
	@ApiModelProperty(value = "班组")
	private String className;
	@ApiModelProperty(value = "模块")
	private String moduleName;
	@ApiModelProperty(value = "系列")
	private String series;
	
	@ApiModelProperty(value = "拆解方案")
	private Map<Integer,Integer> splittings = new LinkedHashMap<Integer,Integer>();

	@ApiModelProperty(value = "复投次数")
	private Integer againNum;

	@ApiModelProperty(value = "是否完结加料（0：否，1：是）")
	private Integer isFillEnd;
	
}