package com.sw.mes.yb.production.dto.AgainTaskDetail;

import com.alibaba.excel.annotation.ExcelProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import java.math.BigDecimal;
import java.util.Date;

@Data
@ApiModel(value = "投料任务及明细导出模板")
public class TaskDetailExportDto {

    @ExcelProperty(value = "投料任务ID")
    Long taskId;

    @ExcelProperty(value = "投料明细ID")
    String detailId;

    @ExcelProperty(value = "投料类型")
    String rawType;

    @ExcelProperty(value = "订单号")
    String sapNo;

    @ExcelProperty(value = "设备号")
    String equipmentCode;

    @ExcelProperty(value = "炉次号")
    String lotNo;

    @ExcelProperty(value = "复投次数")
    Integer againNum;

    @ExcelProperty(value = "复投总桶数")
    Integer againPailNum;

    @ExcelProperty(value = "当前桶")
    String pailNum;

    @ExcelProperty(value = "桶号")
    String bucketNo;

    @ExcelProperty(value = "物料编号")
    String materialCode;

    @ExcelProperty(value = "物料名称")
    String materialName;

    @ExcelProperty(value = "批次号")
    String batchNo;

    @ExcelProperty(value = "供应商")
    String factoryBrand;

    @ExcelProperty(value = "重量")
    BigDecimal weight;

    @ExcelProperty(value = "物料等级")
    String materialLevel;

    @ExcelProperty(value = "物料粒径")
    String suppliesGrain;

    @ExcelProperty(value = "物料档位")
    String materialGear;

    @ExcelProperty(value = "灌料人")
    String fillUser;

    @ExcelProperty(value = "灌料时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Temporal(TemporalType.TIMESTAMP)
    Date fillTime;

    @ExcelProperty(value = "确认投料")
    String confirm;

    @ExcelProperty(value = "投料确认时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Temporal(TemporalType.TIMESTAMP)
    Date confirmTime;


}
