package com.sw.mes.yb.production.dto;

import com.sw.mes.yb.production.entity.LongCrystal;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.math.BigDecimal;

/**
 * @author wanghao
 * @version 1.0
 * @date 2023/1/5 14:04
 */
@Data
@ApiModel(value = "呼叫取晶车Dto")
public class CallTakeCrystalAgvDto {
    @ApiModelProperty(value = "设备号" )
    @NotBlank(message = "请输入设备号")
    String equipmentCode;
    @ApiModelProperty(value = "所属系列" )
    String series;
    @ApiModelProperty(value = "所属模块" )
    String area;
    @ApiModelProperty(value = "单晶编号" )
    @NotBlank(message = "请输入单晶编号")
    String crystalNo;
    @ApiModelProperty(value = "晶体长度" )
    @NotNull(message = "请输入送验长度")
    BigDecimal length;
    @ApiModelProperty(value = "长晶棒id(production_long_crystal.id)" )
    @NotNull(message = "请输入长晶棒id")
    Long longCrystalId;
    @ApiModelProperty(value = "长晶棒信息(production_long_crystal)" )
    LongCrystal longCrystal;
    @ApiModelProperty(value = "1人工2自动" )
    Integer isAuto = 1;
}
