package com.sw.mes.yb.production.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.math.BigDecimal;
import java.util.Date;
import lombok.Data;

/**
 * @author JS113248
 */
@ApiModel(value = "灌料任务配方方案Dto")
@Data
public class FillingTaskRecipeDto {
    private Long id;

    /**
     * 灌料任务Id
     */
    @ApiModelProperty(value = "灌料任务Id")
    private Long againTaskDetailId;

    /**
     * 配方类型
     */
    @ApiModelProperty(value = "配方类型")
    private String recipeKind;

    /**
     * 物料类型名称
     */
    @ApiModelProperty(value = "物料类型名称")
    private String suppliesName;

    /**
     * 物料类型编码
     */
    @ApiModelProperty(value = "物料类型编码")
    private String suppliesCode;

    /**
     * 物料分类
     */
    @ApiModelProperty(value = "物料分类")
    private String suppliesType;

    /**
     * 掺杂剂
     */
    @ApiModelProperty(value = "掺杂剂")
    private String suppliesDopant;

    /**
     * 电阻率最大值
     */
    @ApiModelProperty(value = "电阻率最大值")
    private String suppliesResistanceMax;

    /**
     * 电阻率最小值
     */
    @ApiModelProperty(value = "电阻率最小值")
    private String suppliesResistanceMin;

    /**
     * 优先级
     */
    @ApiModelProperty(value = "优先级")
    private Integer priority;

    /**
     * 重量
     */
    @ApiModelProperty(value = "重量")
    private BigDecimal weight;

    /**
     * 桶数
     */
    @ApiModelProperty(value = "桶数")
    private Integer bucketNum;

    /**
     * 单桶总重量
     */
    @ApiModelProperty(value = "单桶总重量")
    private Integer gross;

    /**
     * 10kg箱数
     */
    @ApiModelProperty(value = "10kg箱数")
    private Integer bucketTen;

    /**
     * 40kg箱数
     */
    @ApiModelProperty(value = "40kg箱数")
    private Integer bucketForty;

    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private String createBy;
}
