package com.sw.mes.yb.production.dto;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.persistence.Column;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@ApiModel(value = "灌料明细Dto")
public class InputFurnaceDetailDto {

    private Long id;
     @ApiModelProperty(value = "罐料记录id" , required = true)
     private Long inputFurnaceId;
     @ApiModelProperty(value = "罐料任务id" , required = true)
     private Long againTaskDetailId;
     @ApiModelProperty(value = "桶号" )
     private String bucketNo;
     @ApiModelProperty(value = "桶序号" )
     private Integer bucketIndex;
     @ApiModelProperty(value = "物料编码" )
     private String materialCode;
     @ApiModelProperty(value = "料号")
     private String productCode;
     @ApiModelProperty(value = "物料名称" )
     private String materialName;

 	@ApiModelProperty(value = "批次号")
 	private String batchNo;
    @ApiModelProperty(value = "循环料批次号")
    private String crystalNo;
    @ApiModelProperty(value = "物料唯一码")
    private String uniqueCode;
 	@ApiModelProperty(value = "重量 ")
 	private BigDecimal weight;
 	@ApiModelProperty(value = "厂牌 ")
 	private String factoryBrand;
 	@ApiModelProperty(value = "单位")
 	private String unit;
    @ApiModelProperty(value = "物料粒径")
    private String suppliesGrain;
    @ApiModelProperty(value = "物料等级")
    private String materialLevel;
    @ApiModelProperty(value = "电阻档位")
    private String resistanceGear;
    @ApiModelProperty(value = "40kg箱数")
    private Integer bucketForty;
    @ApiModelProperty(value = "10kg箱数")
    private Integer bucketTen;
    @ApiModelProperty(value = "物料类型名称")
    private String materialTypeName;
    @ApiModelProperty(value = "供应商")
    private String supplierName;
    @ApiModelProperty(value = "库位id", required = true)
    private Integer storeLocationId;
    @ApiModelProperty(value = "库位名称", required = true)
    private String storeLocationName;
     
     @ApiModelProperty(value = "照片地址(多个;号隔开)" )
     String imgUrl;
     @ApiModelProperty(value = "详情数据")
 	 private String remark;
    @ApiModelProperty(value = "母合金牌号")
    private String alloyBrand;
    @ApiModelProperty(value = "母合金类型")
    private String alloyType;
    @ApiModelProperty(value = "试投类型")
    private String trialType;
    @ApiModelProperty(value = "erp库位")
    private String erpWarehouseCode;
    @ApiModelProperty(value = "erp批次号")
    private String erpBatchNo;

    @ApiModelProperty(value = "确认投料(0:未确认, 1:已确认)")
    Integer confirm = 0;
    @ApiModelProperty(value = "确认投料时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date confirmTime;

    @ApiModelProperty(value = "箱号")
    private String serialNo;
    @ApiModelProperty(value = "托号")
    private String traceId;
}