package com.sw.mes.yb.production.dto.LoadingTask;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.validation.constraints.NotBlank;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.sw.mes.yb.production.dto.BlastFurnaceDetail.BlastFurnaceDetailDto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * @Author @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@ApiModel(value = "自动完成任务Dto")
public class AutoSuccessTaskDto {
	
	/**正常完成**/
	public static final Integer rawStatus_1 = 1;
	/**异常结束**/
	public static final Integer rawStatus_2 = 2;

	@ApiModelProperty(value = "任务ID")
	@NotBlank(message = "请传入装料任务ID")
	private Long id;
	@ApiModelProperty(value = "装灌料机编号（业务统一编号）")
	String equipmentCode;
	@ApiModelProperty(value = "完工时间")
	@NotBlank(message = "请传入完工时间,格式：yyyy-MM-dd HH:mm:ss")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	Date gmtSuccess;
	@ApiModelProperty(value = "状态【1：正常完成；2：异常结束】", required = true)
	@NotBlank(message = "请传入状态【1：正常完成；2：异常结束】")
	Integer rawStatus;
	
	@ApiModelProperty(value = "扫码详情")
	private List<BlastFurnaceDetailDto> details = new ArrayList<BlastFurnaceDetailDto>();
	
	
	
	
	

}