package com.sw.mes.yb.production.dto.LoadingTask;

import com.alibaba.excel.annotation.ExcelProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.persistence.Column;
import java.math.BigDecimal;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@ApiModel(value = "装料任务记录Dto")
public class LoadingTaskLogDto {

    @ExcelProperty(value = "id")
    private Long id;
     @ApiModelProperty(value = "任务" )
     Long loadingTaskId;
     @ApiModelProperty(value = "设备号" )
     @ExcelProperty(value = "设备号")
     String equipmentCode;
     @ApiModelProperty(value = "炉次号" )
     @ExcelProperty(value = "炉次号")
     String lotNo;
     @ApiModelProperty(value = "所属系列" )
     @ExcelProperty(value = "所属系列")
     String series;
     @ApiModelProperty(value = "所属模块" )
     @ExcelProperty(value = "所属模块")
     String area;
     @ApiModelProperty(value = "叫料类型【0-初始装料;】" )
     @ExcelProperty(value = "叫料类型【0-初始装料;】")
     Integer rawType;
     @ApiModelProperty(value = "创建时间" )
     @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
     @ExcelProperty(value = "创建时间")
     Date gmtCreate;
     @ApiModelProperty(value = "预计装料时间" )
     @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
     @ExcelProperty(value = "预计装料时间")
     Date etTime;
     @ApiModelProperty(value = "延时任务开始时间" )
     @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
     @ExcelProperty(value = "延时任务开始时间")
     Date delayedStartTime;
     @ApiModelProperty(value = "状态【0-新建;1-生产;2-已取消;3-自动完工;4-人工完工;;5-退料】" )
     @ExcelProperty(value = "状态【0-新建;1-生产;2-已取消;3-自动完工;4-人工完工;;5-退料】")
     Integer rawStatus;
     @ApiModelProperty(value = "炉台类型【0-量产;1-在建;2-研发;】" )
     @ExcelProperty(value = "炉台类型【0-量产;1-在建;2-研发;】")
     Integer furnaceType;
     @ApiModelProperty(value = "SAP订单号" )
     @ExcelProperty(value = "SAP订单号")
     String sapNo;
     @ApiModelProperty(value = "料号" )
     @ExcelProperty(value = "料号")
     String productCode;
     @ApiModelProperty(value = "产品等级" )
     @ExcelProperty(value = "产品等级")
     String productGrade;
     @ApiModelProperty(value = "规格" )
     @ExcelProperty(value = "规格")
     String specs;
     @ApiModelProperty(value = "掺杂剂" )
     @ExcelProperty(value = "掺杂剂")
     String dopant;
     @ApiModelProperty(value = "产品类别" )
     @ExcelProperty(value = "产品类别")
     String productType;
     @ApiModelProperty(value = "配方方案ID(production_circle_recipe.id)" )
     Long recipeId;
     @ApiModelProperty(value = "重量方案ID(production_circle_weigth.id)" )
     Long weigthId;
     @ApiModelProperty(value = "更换配方人员" )
     @ExcelProperty(value = "更换配方人员")
     String changeRecipeUserName;
     @ApiModelProperty(value = "更换配方时间" )
     @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
     @ExcelProperty(value = "更换配方时间")
     Date changeRecipeTime;
     @ApiModelProperty(value = "操作人" )
     @ExcelProperty(value = "操作人")
     String userName;
     @ApiModelProperty(value = "操作时间" )
     @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
     @ExcelProperty(value = "操作时间")
     Date operationTime;
     @ApiModelProperty(value = "操作原因" )
     @ExcelProperty(value = "操作原因")
     String operationCause;
     @ApiModelProperty(value = "配料人" )
     @ExcelProperty(value = "配料人")
     String recipeUserName;
     @ApiModelProperty(value = "配料时间" )
     @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
     @ExcelProperty(value = "配料时间")
     Date recipeTime;
     @ApiModelProperty(value = "配料总重量" )
     @ExcelProperty(value = "配料总重量")
     BigDecimal weight;
     @ApiModelProperty(value = "配料实际重量 ")
     private BigDecimal realWeight;
     //配料操作
     @ApiModelProperty(value = "合金牌号")
     private String hjPlate;
     @ApiModelProperty(value = "合金类型")
     private String hjType;
 @ApiModelProperty(value = "合金重量 ")
 private String hjWeight;
 @ApiModelProperty(value = "钡粉重量 ")
 private BigDecimal bfWeight;

     //装料明细
     @ApiModelProperty(value = "装料料号")
     private String itemNumber;
     @ApiModelProperty(value = "物料名称")
     private String material;
     @ApiModelProperty(value = "批次号")
     private String batch;
     @ApiModelProperty(value = "厂牌")
     private String brand;
     @ApiModelProperty(value = "装料重量")
     private BigDecimal zlWeight;
     @ApiModelProperty(value = "40kg箱数")
     private Integer bucketForty;
     @ApiModelProperty(value = "10kg箱数")
     private Integer bucketTen;

     @ApiModelProperty(value = "排程ID")
     private Long scheduleId;
     @ApiModelProperty(value = "产品简称")
     private String simpleName;
     @ApiModelProperty(value = "载具编号")
     private String carrierNo;
     @ApiModelProperty(value = "确认投料(0:未确认, 1:已确认)")
     private Integer confirm;


}
