package com.sw.mes.yb.production.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import javax.validation.constraints.NotNull;
import java.util.Date;
import java.util.Map;

/**
 * @author liuzemin
 * @date 2022/1/25 12:36
 * @description
 */
@Data
public class LongCrystalVO {
    /**
     * 设备类型
     */
    String deviceType;

    /**
     * 设备编号
     */
    @NotNull(message = "设备编号不能空")
    String deviceCode;

    /**
     * 事件编号
     */
    @NotNull(message = "事件编号不能空")
    String taskCode;

    /**
     * 事件名称
     */
    String taskName;

    /**
     * 事件类型：执行任务,结束任务
     */
    String taskType;

    /**
     * 开始执行时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date startTime;

    /**
     * 结束执行时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date endTime;

    /**
     * 开始触发数据集
     */
    Map<String, Object> startValidateMap;

    /**
     * 开始搜集数据集
     */
    Map<String, String> startCollectionData;

    /**
     * 结束触发数据集
     */
    Map<String, Object> endValidateMap;

    /**
     * 结束搜集数据集
     */
    Map<String, String> endCollectionData;
}
