package com.sw.mes.yb.production.dto;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.util.Date;

/**
 * <p>
 * 组托入库
 * </p>
 *
 * @author liuzemin
 * @since 2022-11-10
 */
@Data
@ApiModel(value = "MaterialGroupInfoDto对象", description = "组托入库信息")
public class MaterialGroupInfoDto implements Serializable {


    @ApiModelProperty("重量")
    private BigDecimal weight;

    @ApiModelProperty("硅料大类")
    private String materialCode;

    @ApiModelProperty("硅料名称")
    private String materialName;

    @ApiModelProperty("等级")
    private String materialLevel;

    @ApiModelProperty("档位")
    private String materialGear;

    @ApiModelProperty("余料生产批次")
    private String productBatchNo;

    @ApiModelProperty("托号")
    private String groupNo;

    @ApiModelProperty("操作员")
    private String createUser;

    @ApiModelProperty("生成日期")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date createTime;

    @ApiModelProperty("发起入库时间")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date warehousingTime;

    @ApiModelProperty("备注")
    private String remark;

    @ApiModelProperty(value = "粒径范围")
    String suppliesGrain;
}
