package com.sw.mes.yb.production.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.persistence.Column;
import java.math.BigDecimal;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@ApiModel(value = "ProcessWorkingHoursDto")
public class ProcessWorkingHoursDto {

    private Long id;
     @ApiModelProperty(value = "设备号" )
     String equipmentCode;
     @ApiModelProperty(value = "炉次号" )
     String lotNo;
     @ApiModelProperty(value = "工步发生时间" , required = true)
     @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
     Date startTime;
     @ApiModelProperty(value = "工步结束时间" )
     @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
     Date endTime;
     @ApiModelProperty(value = "工艺名称" )
     String stepName;
     @ApiModelProperty(value = "模块号" )
     String area;
     @ApiModelProperty(value = "系列" )
     String series;
     @ApiModelProperty(value = "时长(ms)" )
     Long timeLong;
     @ApiModelProperty(value = "开始操作人" )
     String startOperatorUser;
     @ApiModelProperty(value = "结束操作人" )
     String endOperatorUser;
     @ApiModelProperty(value = "理论工时(h)" )
     BigDecimal theoryTime;
     @ApiModelProperty(value = "浪费工时(ms)" )
     Long wasteTime;
     
     @ApiModelProperty(value = "复投次数" )
     private Integer againNum;

     @ApiModelProperty(value = "单晶长度(mm)" )
     BigDecimal length;

     @ApiModelProperty(value = "车间" )
     String workshop;

     @ApiModelProperty(value = "片区" )
     String district;
}