package com.sw.mes.yb.production.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.persistence.Column;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * @Author: xushu
 * @Date: 2022/08/17/16:20
 * @Description: 暂时不用
 */
@Data
@ApiModel(value = "余料回收料管理信息Dto")
public class SurplusRecycledMaterialManageDto {


    @ApiModelProperty(value = "id")
    private Long id;

    @ApiModelProperty(value = "托号")
    String trayNo;

    //回收料管理模块新增生产批次号
    @ApiModelProperty(value = "生产批次号")
    String produceBatchNo;

    @ApiModelProperty(value = "炉次号")
    private String lotNo;

    @ApiModelProperty(value = "回收料类型")
    private String recycledMaterialType;

    @ApiModelProperty(value = "来源")
    private String source;

    @ApiModelProperty(value = "产品类别", required = true)
    String productionCategory;

    @ApiModelProperty(value = "等级", required = true)
    String grade;

    @ApiModelProperty(value = "物料编号", required = true)
    String materialCode;

    @ApiModelProperty(value = "物料名称", required = true)
    String materialName;

    @ApiModelProperty(value = "挡位")
    String gear;

    @ApiModelProperty(value = "规格")
    String specification;

    @ApiModelProperty(value = "单位名称")
    String unitName;

    @ApiModelProperty(value = "重量")
    private BigDecimal weight;

    @ApiModelProperty(value = "详情")
    private List<RecycledMaterialManageDetailDto> recycledMaterialMangeDetailDtos;

    @ApiModelProperty(value = "卡板箱号")
    private String boxNo;

    @ApiModelProperty(value = "状态(1待入库，2取消，3待确定，4已接收，5拒收)" )
    Integer status;

    @ApiModelProperty(value = "创建人(组托人)")
    String createBy;

    @ApiModelProperty(value = "创建时间(组托时间)")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date createTime;

    @ApiModelProperty(value = "更新人")
    String updateBy;

    @ApiModelProperty(value = "更新时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date updateTime;

    @ApiModelProperty(value = "成本中心")
    private String kostl;

    @ApiModelProperty(value = "工单号")
    private String workOrderNo;

}
