package com.sw.mes.yb.production.dto;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@ApiModel(value = "送验任务Dto")
public class TransportInspectTaskDto {
	/**0-未送验**/
	public static final Integer crystalStatus_0 = 0;
	/**1-已送验**/
	public static final Integer crystalStatus_1 = 1;

    private Long id;
     @ApiModelProperty(value = "设备号" )
     String equipmentCode;
     @ApiModelProperty(value = "炉次号" )
     String lotNo;
     @ApiModelProperty(value = "单晶编号" )
     String crystalNo;
     @ApiModelProperty(value = "所属系列" )
     String series;
     @ApiModelProperty(value = "所属模块" )
     String area;
     @ApiModelProperty(value = "收尾方式" )
     String windUp;
     @ApiModelProperty(value = "复投次数" )
     Integer againNum;
     @ApiModelProperty(value = "单晶颗数" )
     Integer crystalNum;
     @ApiModelProperty(value = "晶体长度" )
     BigDecimal length;
     @ApiModelProperty(value = "重量" )
     BigDecimal weight;
     @ApiModelProperty(value = "状态【0：默认；0-未送验；1-已送验；】" , required = true)
     Integer crystalStatus;
     @ApiModelProperty(value = "炉台类型【0:默认；0-量产;1-在建;2-研发;】" , required = true)
     Integer furnaceType;
     @ApiModelProperty(value = "料号" )
     String productCode;
     @ApiModelProperty(value = "产品等级" )
     String productGrade;
     @ApiModelProperty(value = "规格" )
     String specs;
     @ApiModelProperty(value = "掺杂剂" )
     String dopant;
     @ApiModelProperty(value = "产品类别" )
     String productType;
     @ApiModelProperty(value = "长晶棒id(production_long_crystal.id)" )
     Long longCrystalId;
     @ApiModelProperty(value = "送验人" )
     String userName;
     @ApiModelProperty(value = "送验时间" )
     @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
     Date operationTime;
     @ApiModelProperty(value = "操作原因" )
     String operationCause;
     @ApiModelProperty(value = "产出时间" )
     @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
     Date createTime;
     @ApiModelProperty(value = "是否发出任务(>1500:true,<=1500:false)" )
     Boolean sendTask;
}