/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.production.entity.AgainTaskPrepare;

import java.util.Date;
import java.math.BigDecimal;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="production_again_task_prepare")
@DynamicUpdate
@DynamicInsert
public class AgainTaskPrepare{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 设备号
	 */
    @Column(length=100)
    private String equipmentCode;
    
	/**
	 * 炉次号
	 */
    @Column(length=100)
    private String lotNo;
    
	/**
	 * 所属系列
	 */
    @Column(length=50)
    private String series;
    
	/**
	 * 所属模块
	 */
    @Column(length=50)
    private String area;
    
	/**
	 * 料号
	 */
    @Column(length=100)
    private String productCode;
    
	/**
	 * 产品评级
	 */
    @Column(length=50)
    private String productGrade;
    
	/**
	 * 规格
	 */
    @Column(length=50)
    private String specs;
    
	/**
	 * 掺杂剂
	 */
    @Column(length=10)
    private String dopant;
    
	/**
	 * 产品类别
	 */
    @Column(length=50)
    private String productType;
    
	/**
	 * SAP订单号
	 */
    @Column(length=100)
    private String sapNo;
    
	/**
	 * 复投次数
	 */
    @Column(length=10)
    private Integer againNum;
    
	/**
	 * 炉台类型【0:默认；0-量产;1-在建;2-研发;】
	 */
    @Column(nullable=false, length=3)
    private Integer furnaceType;
    
	/**
	 * 状态【0：默认；0-新建;1-生产;2-已取消;3-自动完工;4-人工完工;】
	 */
    @Column(nullable=false, length=3)
    private Integer rawStatus;
    
	/**
	 * 复投总重量
	 */
    @Column(length=19)
    private BigDecimal againWeigth;
    
	/**
	 * 复投总桶数
	 */
    @Column(length=10)
    private Integer againPailNum;
    
	/**
	 * 装载总重量
	 */
    @Column(length=19)
    private BigDecimal freightWeigth;
    
	/**
	 * 车上桶数
	 */
    @Column(length=10)
    private Integer num;
    
	/**
	 * 当前桶数(载具上桶顺序号,号分割)
	 */
    @Column(length=10)
    private String pailNum;
    
	/**
	 * 复投重量集合(,分割)
	 */
    @Column(length=255)
    private String taskWeigths;
    
	/**
	 * 配方方案ID(production_formula_scheme.id)
	 */
    @Column(length=19)
    private Long recipeId;
    
	/**
	 * 重量方案ID(production_formula_weight_scheme.id)
	 */
    @Column(length=19)
    private Long weigthId;
    
	/**
	 * 载具编号
	 */
    @Column(length=64)
    private String carrierNo;
    
	/**
	 * 开始灌料时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date startTime;
    
	/**
	 * 结束灌料时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date endTime;
    
	/**
	 * 创建时间
	 */
    @Column(nullable=false, length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date gmtCreate;
    
	/**
	 * 上报时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date reportTime;
    
	/**
	 * 完工时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date feedingEndTime;
    
	/**
	 * 完工方式0自动1手动
	 */
    @Column(length=10)
    private Integer finishType;
    
	/**
	 * 报工类型 0：正常任务1：转人工任务
	 */
    @Column(length=10)
    private Integer reportType;
    

	public AgainTaskPrepare() {
	}

	public AgainTaskPrepare(Long id) {
		this.id = id;
	}
}
