/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.production.entity.AgainTaskPrepare;

import java.math.BigDecimal;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="production_input_task_datail_prepare")
@DynamicUpdate
@DynamicInsert
public class InputTaskDatailPrepare{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 预装料任务id
	 */
    @Column(length=19)
    private Long productionAgainTaskPrepareId;
    
	/**
	 * 桶号
	 */
    @Column(length=50)
    private String bucketNo;
    
	/**
	 * 供应商
	 */
    @Column(length=100)
    private String supplierName;
    
	/**
	 * 物料类型名称
	 */
    @Column(length=19)
    private String materialTypeName;
    
	/**
	 * 库位名
	 */
    @Column(length=64)
    private String storeLocationName;
    
	/**
	 * 库位ID
	 */
    @Column(length=10)
    private Integer storeLocationId;
    
	/**
	 * 物料条码
	 */
    @Column(length=100)
    private String materialCode;
    
	/**
	 * 物料名称
	 */
    @Column(length=100)
    private String materialName;
    
	/**
	 * 批次号
	 */
    @Column(length=100)
    private String batchNo;
    
	/**
	 * 唯一码
	 */
    @Column(length=50)
    private String uniqueCode;
    
	/**
	 * 重量 
	 */
    @Column(length=19)
    private BigDecimal weight;
    
	/**
	 * 厂牌 
	 */
    @Column(length=50)
    private String factoryBrand;
    
	/**
	 * 单位
	 */
    @Column(length=50)
    private String unit;
    

	public InputTaskDatailPrepare() {
	}

	public InputTaskDatailPrepare(Long id) {
		this.id = id;
	}
}
