/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.production.entity;

import java.math.BigDecimal;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import io.swagger.annotations.ApiModelProperty;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import lombok.Data;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="production_blast_furnace_detail")
@DynamicUpdate
@DynamicInsert
public class BlastFurnaceDetail{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 装料记录id(production_loading_task.id)
	 */
    @Column(nullable=false, length=19)
    private Long blastFurnaceId;
    
	/**
	 * 物料条码
	 */
    @Column(length=100)
    private String materialCode;
    
	/**
	 * 料号
	 */
    @Column(length=50)
    private String productCode;
    
	/**
	 * 物料名称
	 */
    @Column(length=100)
    private String materialName;
    
	/**
	 * 批次号
	 */
    @Column(length=100)
    private String batchNo;

	/**
	 * 循环料批次号
	 */
	@Column(length=60)
	private String crystalNo;

	/**
	 * 物料唯一码
	 */
	@Column(length=50)
	private String uniqueCode;
    
	/**
	 * 重量 
	 */
    @Column(length=19)
    private BigDecimal weight;
    
	/**
	 * 厂牌 
	 */
    @Column(length=50)
    private String factoryBrand;
    
	/**
	 * 单位
	 */
    @Column(length=50)
    private String unit;

	/**
	 * 物料粒径
	 */
	@Column(length=30)
	private String suppliesGrain;


	/**
	 * 物料等级
	 */
	@Column(length=30)
	private String materialLevel;


	/**
	 * 电阻档位
	 */
	@Column(length=10)
	private String resistanceGear;
    
    /**
	 * 详情
	 */
    @Column
    private String remark;
    
    
    /**
	 * 配料人
	 */
    @Column(length=50)
	private String userName;
	
    /**
	 * 配料时间
	 */
    @Column(nullable=false, length=19)
	@Temporal(TemporalType.TIMESTAMP)
	private Date installTime;
    
    
    /**
     * 标注坩埚(0:否 1:是)
     */
    @Column(length=1)
    private Boolean markCrucible;

	/**
	 * 40kg箱数
	 */
	@Column(length = 11)
	private Integer bucketForty;


	/**
	 *10kg箱数
	 */
	@Column(length = 11)
	private Integer bucketTen;

	/**
	 * 物料类型名称
	 */
	@Column(length=19)
	private String materialTypeName;

	/**
	 * 供应商
	 */
	@Column(length=100)
	private String supplierName;

	/**
	 * 库位id
	 */
	@Column(length=11)
	private Integer storeLocationId;

	/**
	 * 库位名称
	 */
	@Column(length=64)
	private String storeLocationName;

	/**
	 * 合金牌号
	 */
	@Column(length=15)
	private String alloyBrand;

	/**
	 * 合金类型
	 */
	@Column(length=15)
	private String alloyType;

	/**
	 * 试投类型
	 */
	@Column(length=50)
	private String trialType;

	/**
	 * 是否拉取（0未拉取，1已拉取）
	 */
	@Column(length=2)
	private Integer pulled = 0;

	/**
	 * erp库位
	 */
	@Column(length=100)
	private String erpWarehouseCode;

	/**
	 * erp批次号
	 */
	@Column(length=100)
	private String erpBatchNo;

	/**
	 * 箱号
	 */
	@Column(length=50)
	private String serialNo;

	/**
	 * 托号
	 */
	@Column(length=50)
	private String traceId;



	public BlastFurnaceDetail() {
	}

	public BlastFurnaceDetail(Long id) {
		this.id = id;
	}
}
