/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.production.entity;

import java.util.Date;
import java.math.BigDecimal;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="production_blast_furnace_detail_log")
@DynamicUpdate
@DynamicInsert
public class BlastFurnaceDetailLog{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 装料记录id(production_loading_task.id)
	 */
    @Column(nullable=false, length=19)
    private Long blastFurnaceId;
    
	/**
	 * 物料条码
	 */
    @Column(length=100)
    private String materialCode;
    
	/**
	 * 料号
	 */
    @Column(length=50)
    private String productCode;
    
	/**
	 * 物料名称
	 */
    @Column(length=100)
    private String materialName;
    
	/**
	 * 批次号
	 */
    @Column(length=100)
    private String batchNo;

	/**
	 * 物料唯一码
	 */
	@Column(length=50)
	private String uniqueCode;
    
	/**
	 * 重量 
	 */
    @Column(length=19)
    private BigDecimal weight;
    
	/**
	 * 厂牌 
	 */
    @Column(length=50)
    private String factoryBrand;
    
	/**
	 * 单位
	 */
    @Column(length=50)
    private String unit;
    
	/**
	 * 配料人
	 */
    @Column(length=50)
    private String userName;
    
	/**
	 * 配料时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date installTime;
    
	/**
	 * 标注坩埚(0:否 1:是)
	 */
    @Column(length=1)
    private Boolean markCrucible;
    
	/**
	 * 详情数据
	 */
    @Column(length=65535)
    private String remark;



	/**
	 * 40kg箱数
	 */
	@Column(length = 11)
	private Integer bucketForty;


	/**
	 *10kg箱数
	 */
	@Column(length = 11)
	private Integer bucketTen;

	/**
	 * 物料类型名称
	 */
	@Column(length=19)
	private String materialTypeName;

	/**
	 * 供应商
	 */
	@Column(length=100)
	private String supplierName;

	/**
	 * 库位id
	 */
	@Column(length=11)
	private Integer storeLocationId;

	/**
	 * 库位名称
	 */
	@Column(length=64)
	private String storeLocationName;
    

	public BlastFurnaceDetailLog() {
	}

	public BlastFurnaceDetailLog(Long id) {
		this.id = id;
	}
}
