/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.production.entity;

import java.util.Date;
import java.math.BigDecimal;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="production_configure_alloy")
@DynamicUpdate
@DynamicInsert
public class ConfigureAlloy{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 设备号
	 */
    @Column(length=100)
    private String equipmentCode;
    
	/**
	 * 炉次号
	 */
    @Column(length=100)
    private String lotNo;
    
	/**
	 * 复投总桶数
	 */
    @Column(length=10)
    private Integer againPailNum;
    
	/**
	 * 申请时间
	 */
    @Column(nullable=false, length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date applyCreate;
    
	/**
	 * 配合金时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date operationTime;
    
	/**
	 * 浓度
	 */
    @Column(length=80)
    private String consistence;
    
	/**
	 * 送验重量
	 */
    @Column(nullable=false, length=19)
    private BigDecimal wegith;
    
	/**
	 * 目标电阻
	 */
    @Column(length=80)
    private String targetResistance;
    
	/**
	 * 称重者
	 */
    @Column(length=60)
    private String operationUserName;
    
	/**
	 * 备注
	 */
    @Column(length=255)
    private String remark;
    

	public ConfigureAlloy() {
	}

	public ConfigureAlloy(Long id) {
		this.id = id;
	}
}
