/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.production.entity;

import java.util.Date;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="crystal_batch_operation")
@DynamicUpdate
@DynamicInsert
public class CrystalBatchOperation{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 单晶编号
	 */
    @Column(length=100)
    private String sectionNo;
    
	/**
	 * 母棒编号
	 */
    @Column(length=100)
    private String crystalNo;
    
	/**
	 * 当前位置
	 */
    @Column(length=20)
    private String position;
    
	/**
	 * 状态[0: 默认,锁定;1: 已解锁 ]
	 */
    @Column(length=10)
    private Integer status;
    
	/**
	 * 物料号
	 */
    @Column(length=50)
    private String materialCode;
    
	/**
	 * 物料名称
	 */
    @Column(length=255)
    private String materialName;
    
	/**
	 * 产品简称
	 */
    @Column(length=40)
    private String abbreviation;
    
	/**
	 * 等级码
	 */
    @Column(length=100)
    private String levelCode;
    
	/**
	 * 型号
	 */
    @Column(length=10)
    private String conductiveType;
    
	/**
	 * 规格
	 */
    @Column(length=32)
    private String specs;
    
	/**
	 * 产品等级
	 */
    @Column(length=80)
    private String productLevel;
    
	/**
	 * 掺杂剂
	 */
    @Column(length=20)
    private String dopant;
    
	/**
	 * 配方名称
	 */
    @Column(length=50)
    private String recipeName;
    
	/**
	 * 锁定人
	 */
    @Column(length=32)
    private String lockUser;
    
	/**
	 * 锁定时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date lockTime;
    
	/**
	 * 锁定原因
	 */
    @Column(length=255)
    private String lockReason;
    
	/**
	 * 锁定备注
	 */
    @Column(length=255)
    private String lockRemark;
    
	/**
	 * 解锁人
	 */
    @Column(length=32)
    private String unlockUser;
    
	/**
	 * 解锁时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date unlockTime;
    
	/**
	 * 解锁原因
	 */
    @Column(length=255)
    private String unlockReason;
    
	/**
	 * 解锁备注
	 */
    @Column(length=255)
    private String unlockRemark;
    
	/**
	 * 在制状态（0：待进站；1：已经站；2：已出站）
	 */
    @Column(length=10)
    private Integer siteStatus;
    
	/**
	 * 删除标识[0: 默认;1: 删除 ]
	 */
    @Column(length=10)
    private Integer deleteFlag;
    

	public CrystalBatchOperation() {
	}

	public CrystalBatchOperation(Long id) {
		this.id = id;
	}
}
