/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.production.entity;

import java.util.Date;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="production_equipment_extend_state")
@DynamicUpdate
@DynamicInsert
public class EquipmentExtendState{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 设备号
	 */
    @Column(length=100)
    private String equipmentCode;
    
	/**
	 * 所属系列
	 */
    @Column(length=50)
    private String series;
    
	/**
	 * 所属模块
	 */
    @Column(length=50)
    private String area;
    
	/**
	 * 登录操作人员
	 */
    @Column(length=50)
    private String userName;
    
	/**
	 * 登录操作时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date loginTime;
    
	/**
	 * 设备状态(1:运行,2:待机,3:停机)
	 */
    @Column(length=10)
    private Integer equipmentState;
    
	/**
	 * 液位杆状态
	 */
    @Column(length=1)
    private Boolean levelStickState;
    /**
     * 登录状态
     */
    @Column(length=1)
    private Boolean loginState;
    
    /**
	 *token
	 */
    @Column(length=50)
    private String token;
    
    @Column(length=50)
    private String teamGroup;
    
    @Column(length=50)
    private String classNo;
    

	public EquipmentExtendState() {
	}

	public EquipmentExtendState(Long id) {
		this.id = id;
	}
}
