/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.production.entity;

import java.util.Date;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="production_equipment_work_hours_log")
@DynamicUpdate
@DynamicInsert
public class EquipmentWorkHoursLog{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 设备号
	 */
    @Column(length=100)
    private String equipmentCode;
    
	/**
	 * 所属系列
	 */
    @Column(length=50)
    private String series;
    
	/**
	 * 工步名称
	 */
    @Column(length=80)
    private String workStep;
    
	/**
	 * 所属模块
	 */
    @Column(length=50)
    private String area;
    
	/**
	 * 操作名称
	 */
    @Column(length=120)
    private String buttonName;
    
	/**
	 * 操作时参数
	 */
    @Column(length=65535)
    private String clickParam;
    
	/**
	 * 操作结果
	 */
    @Column(length=65535)
    private String context;
    
	/**
	 * 复投确认人员
	 */
    @Column(length=50)
    private String userName;
    
	/**
	 * 班次
	 */
    @Column(length=50)
    private String classNo;
    
	/**
	 * 班组
	 */
    @Column(length=80)
    private String teamGroup;
    
	/**
	 * 操作路径(from->to)
	 */
    @Column(length=255)
    private String changePath;
    
	/**
	 * 开始时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date startTime;
    
	/**
	 * 结束时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date endTime;
    
	/**
	 * 时长(ms)
	 */
    @Column(length=19)
    private Long timeLong;
    

	public EquipmentWorkHoursLog() {
	}

	public EquipmentWorkHoursLog(Long id) {
		this.id = id;
	}
}
