/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.production.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@Entity
@Table(name = "loading_finished")
@DynamicUpdate
@DynamicInsert
public class LoadingFinished {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;

    /**
     * 炉台号
     */
    @Column(length = 50)
    private String deviceNo;

    /**
     * 任务编号
     */
    @Column(length = 50)
    private String taskCode;

    /**
     * 合金供料机号
     */
    @Column(length = 50)
    private String feedDevNo;

    /**
     * 瓶盖二维码
     */
    @Column(length = 50)
    private String bottleCapCode;

    /**
     * 合金重量
     */
    @Column(length = 50)
    private String alloyWeight;

    /**
     * 合金类型
     */
    @Column(length = 50)
    private String alloyType;


    public LoadingFinished() {
    }

    public LoadingFinished(Integer id) {
        this.id = id;
    }
}
