package com.sw.mes.yb.production.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.math.BigDecimal;
import java.util.Date;


/**
 * @author JS113248
 */
@Data
@Entity
@Table(name="production_loading_task_recipe")
@DynamicUpdate
@DynamicInsert
public class LoadingTaskRecipe {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    /**
     * 灌料任务Id
     */
    @Column(length=19)
    private Long loadingTaskId;

    /**
     * 配方类型
     */
    @Column(length=100)
    private String recipeKind;

    /**
     * 物料类型名称
     */
    @Column(length=100)
    private String suppliesName;

    /**
     * 物料类型编码
     */
    @Column(length=100)
    private String suppliesCode;

    /**
     * 物料分类
     */
    @Column(length=100)
    private String suppliesType;

    /**
     * 掺杂剂
     */
    @Column(length=10)
    private String suppliesDopant;

    /**
     * 电阻率最大值
     */
    @Column(length=50)
    private String suppliesResistanceMax;

    /**
     * 电阻率最小值
     */
    @Column(length=50)
    private String suppliesResistanceMin;

    /**
     * 优先级
     */
    @Column(length=3)
    private Integer priority;

    /**
     * 重量
     */
    @Column(length=19)
    private BigDecimal weight;


    /**
     * 10kg箱数
     */
    @Column(length=5)
    private Integer bucketTen;

    /**
     * 40kg箱数
     */
    @Column(length=5)
    private Integer bucketForty;

    /**
     * 创建时间
     */
    @Column(length=19)
    @Temporal(TemporalType.TIMESTAMP)
    private Date createTime;

    /**
     * 创建人
     */
    @Column(length=20)
    private String createBy;

    public LoadingTaskRecipe(){

    }

    public LoadingTaskRecipe(Long id){
        this.id = id;
    }

}
