/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.production.entity;

import java.util.Date;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@Entity
@Table(name = "production_output_record")
@DynamicUpdate
@DynamicInsert
public class OutputRecord {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 设备编号
	 */
    @Column(length=20)
    private String deviceNo;
    
	/**
	 * 炉次号
	 */
    @Column(length=30)
    private String lotNo;
    
	/**
	 * 复投次数
	 */
    @Column(length=10)
    private Integer againNum;
    
	/**
	 * 复投重量
	 */
    @Column(length=20)
    private Double weigth;
    
	/**
	 * 创建时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createTime;
    

	public OutputRecord() {
	}

	public OutputRecord(Long id) {
		this.id = id;
	}
}
