/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.production.entity;

import java.util.Date;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="production_process_path")
@DynamicUpdate
@DynamicInsert
public class ProcessPath{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 设备号
	 */
    @Column(length=100)
    private String equipmentCode;
    
	/**
	 * 炉次号
	 */
    @Column(length=100)
    private String lotNo;

	/**
	 * 加次
	 */
	@Column(length=20)
	private String againNum;
    
	/**
	 * 工步发生时间
	 */
    @Column(nullable=false, length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date startTime;
    
	/**
	 * 工步结束时间(暂时不用)
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date endTime;
    
	/**
	 * 工艺名称
	 */
    @Column(length=40)
    private String stepName;
    
	/**
	 * 备注(触发信息)
	 */
    @Column(length=255)
    private String remark;
    
	/**
	 * 设备工步发生时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date deviceStartTime;
    
	/**
	 * 设备工步结束时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date deviceEndTime;

	/**
	 * 等径长度
	 */
	@Column(length=10)
    private Double equalDiameterLength;
    

	public ProcessPath() {
	}

	public ProcessPath(Long id) {
		this.id = id;
	}
}
