/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.production.entity;

import java.util.Date;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@Entity
@Table(name="production_circle_dosing_list")
@DynamicUpdate
@DynamicInsert
public class ProductionCircleDosingList{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private Long id;

	/**
	 * 产品料号
	 */
	@Column(length=80)
	private String productName;

	/**
	 * 产品等级
	 */
	@Column(length=80)
	private String productGrade;

	/**
	 * 类型
	 */
	@Column(length=80)
	private String productType;

	/**
	 * 掺杂剂
	 */
	@Column(length=80)
	private String mingleName;

	/**
	 * 导电型号
	 */
	@Column(length=80)
	private String electricConduction;

	/**
	 * 规格
	 */
	@Column(length=80)
	private String specification;

	/**
	 * 配方版本
	 */
	@Column(length=20)
	private Long recipeId;

	/**
	 * 配方重量id
	 */
	@Column(length=20)
	private Long weightId;

	/**
	 * 配方名称
	 */
	@Column(length=80)
	private String recipeName;

	/**
	 * 配方版本
	 */
	@Column(length=10)
	private Integer recipeVersion;

	/**
	 * 重量方案名称
	 */
	@Column(length=80)
	private String weightName;

	/**
	 * 重量方案版本
	 */
	@Column(length=10)
	private Integer weightVersion;

	/**
	 * 拉制方式(字典获取)
	 */
	@Column(length=80)
	private String makeType;

	/**
	 * 晶向类型
	 */
	@Column(length=80)
	private String directionType;

	/**
	 * 用户id
	 */
	@Column(length=10)
	private Integer userId;

	/**
	 * 用户名称
	 */
	@Column(length=10)
	private String userName;

	/**
	 * 状态(1：生效，2失效)
	 */
	@Column(length=10)
	private Integer status;

	/**
	 * 创建时间
	 */
	@Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
	private Date createTime;
	
	/**
	 * 状态(1：删除，0未删除 默认)
	 */
	@Column(length=2)
	private Integer del = 0;
	


	public ProductionCircleDosingList() {
	}

	public ProductionCircleDosingList(Long id) {
		this.id = id;
	}
}
