/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.production.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="production_circle_materiel")
@DynamicUpdate
@DynamicInsert
public class ProductionCircleMateriel{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;
    
	/**
	 * 额定投料量
	 */
    @Column(nullable=false, length=10)
    private Integer ratedFeedQuantity;
    
	/**
	 * 初始投料量
	 */
    @Column(nullable=false, length=10)
    private Integer initialQuantity;
    
	/**
	 * 初始复投单桶量
	 */
    @Column(nullable=false, length=10)
    private Integer initialRepetitionQuantity;
    
	/**
	 * 取段复投单通量
	 */
    @Column(nullable=false, length=10)
    private Integer fetchRepetitionQuantity;
    
	/**
	 * 用户id
	 */
    @Column(length=19)
    private Long createId;
    
	/**
	 * 用户名称
	 */
    @Column(length=11)
    private String userName;
    
	/**
	 * 创建时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createDate;
    
	/**
	 * 修改时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date updateDate;
    

	public ProductionCircleMateriel() {
	}

	public ProductionCircleMateriel(Integer id) {
		this.id = id;
	}
}
