/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.production.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="production_circle_recipe")
@DynamicUpdate
@DynamicInsert
public class ProductionCircleRecipe {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

	/**
	 * 配方名称
	 */
    @Column(nullable=false, length=50)
    private String recipeName;

	/**
	 * 配方编码
	 */
	@Column(nullable=false, length=255)
	private String recipeCode;

	/**
	 * 版本号
	 */
    @Column(length=11)
    private Integer version;

	/**
	 * 状态
	 */
	@Column(length=2)
	private Integer status;

	/**
	 * 用户id
	 */
    @Column(length=10)
    private Integer userId;

	/**
	 * 用户名称
	 */
    @Column(length=20)
    private String userName;

	/**
	 * 创建时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createTime;
    
    /**
	 * 状态(1：删除，0未删除 默认)
	 */
	@Column(length=2)
	private Integer del = 0;


	public ProductionCircleRecipe() {
	}

	public ProductionCircleRecipe(Long id) {
		this.id = id;
	}

}
