/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.production.entity;


import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="production_circle_recipe_detail")
@DynamicUpdate
@DynamicInsert
public class ProductionCircleRecipeDetail {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;
    
	/**
	 * 配方名称
	 */
    @Column(length=50)
    private String recipeName;
    
	/**
	 * 配方编码
	 */
    @Column(length=255)
    private String recipeCode;
    
	/**
	 * 版本号
	 */
    @Column(length=11)
    private Integer version;
    
	/**
	 * 配方用途
	 */
    @Column(length=255)
    private String recipePurpose;

	/**
	 * 配方用途
	 */
	@Column(length=255)
	private String recipeLike;
    
	/**
	 * 配方类型
	 */
    @Column(length=255)
    private String recipeKind;
    
	/**
	 * 物料类型名称
	 */
    @Column(length=255)
    private String suppliesName;
    
	/**
	 * 物料类型编码
	 */
    @Column(length=255)
    private String suppliesCode;
    
	/**
	 * 尺寸(坩埚属性)
	 */
    @Column(length=255)
    private String suppliesSize;
    
	/**
	 * 高度(坩埚属性)
	 */
    @Column(length=255)
    private String suppliesHeight;

	/**
	 * 厂牌(坩埚属性)
	 */
	@Column(length=255)
	private String suppliesBrand;

	/**
	 * 工艺(坩埚属性)
	 */
	@Column(length=255)
	private String suppliesCraft;
    
	/**
	 * 掺杂剂
	 */
    @Column(length=255)
    private String suppliesDopant;

	/**
	 * 电阻率最小值
	 */
	@Column(length=255)
	private String suppliesResistanceMin;

	/**
	 * 电阻率最大值
	 */
    @Column(length=255)
    private String suppliesResistanceMax;
    
	/**
	 * 粒径最小值
	 */
    @Column(length=255)
    private String suppliesGrainMin;

	/**
	 * 粒径最大值
	 */
	@Column(length=255)
	private String suppliesGrainMax;

	/**
	 * 物料类型
	 */
	@Column(length=255)
	private String suppliesType;
    
	/**
	 * 物料id(父id)
	 */
    @Column(length=20)
    private Long recipeId;
    
	/**
	 * 优先级
	 */
    @Column(length=10)
    private Integer priority;
    
    
    /**
	 * 状态(1：删除，0未删除 默认)
	 */
	@Column(length=2)
	private Integer del = 0;
	/**
	 * 重量配比（百分比）
	 */
	@Column(length=10)
	private  Integer weightRatio;

	public ProductionCircleRecipeDetail() {
	}

	public ProductionCircleRecipeDetail(Integer id) {
		this.id = id;
	}
}
