/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.production.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="production_circle_weight")
@DynamicUpdate
@DynamicInsert
public class ProductionCircleWeight {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 重量方案名称
	 */
    @Column(length=50)
    private String weightName;
    
	/**
	 * 重量方案编码
	 */
    @Column(length=50)
    private String weightCode;
    
	/**
	 * 版本号
	 */
    @Column(length=10)
    private Integer version;
    
	/**
	 * 状态(1启用，0：未启用)
	 */
    @Column(length=10)
    private Integer status;
    
	/**
	 * 用户id
	 */
    @Column(length=10)
    private Integer userId;
    
	/**
	 * 用户名称
	 */
    @Column(length=20)
    private String userName;
    
	/**
	 * 创建时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createTime;
    
    /**
	 * 状态(1：删除，0未删除 默认)
	 */
	@Column(length=2)
	private Integer del = 0;
    

	public ProductionCircleWeight() {
	}

	public ProductionCircleWeight(Long id) {
		this.id = id;
	}
}
