package com.sw.mes.yb.production.entity;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @Author: xushu
 * @Date: 2022/08/17/15:51
 * @Description:
 */
@Entity
@Data
@DynamicUpdate
@DynamicInsert
@Table(name="recycled_material_manage_detail")
public class RecycledMaterialManageDetail {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    /**
     * manageId
     */
    @Column(length=50)
    private Long manageId;

    /**
     * 等级
     */
    @Column(length=50)
    private String productLevel;

    /**
     * 回收料编号
     */
    @Column(length=50)
    private String recycleNo;

    /**
     * 产品类型
     */
    @Column(length=50)
    private String productionType;

    @ApiModelProperty(value = "卡板箱号")
    String boxNo;

    @ApiModelProperty(value = "托位号")
    String bracketNo;

    @ApiModelProperty(value = "炉次号")
    private String lotNo;

    @ApiModelProperty("设备号")
    private String deviceNo;

    @ApiModelProperty("重量")
    private BigDecimal weight;

    @ApiModelProperty("追溯标识")
    private String fromMark;

    @ApiModelProperty(value = "组托发送状态 0未接收组托信息 1已接收组托信息")
    Integer status;

    @ApiModelProperty(value = "明细工单号")
    private String workOrderNo;

    @ApiModelProperty(value = "定向标识")
    private String directionalSign;
}
