/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.production.entity;

import java.math.BigDecimal;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="production_weight_input_detail")
@DynamicUpdate
@DynamicInsert
public class WeightInputDetail{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 复投总重量
	 */
    @Column(length=19)
    private BigDecimal againWeigth;
    
	/**
	 * 剩余重量
	 */
    @Column(length=19)
    private BigDecimal surplusWeigth;
    
	/**
	 * 总装埚料
	 */
    @Column(length=19)
    private BigDecimal totalUseWeigth;
    
	/**
	 * 操作人
	 */
    @Column(length=60)
    private String userName;
    
	/**
	 * 班次
	 */
    @Column(length=50)
    private String classNo;
    
	/**
	 * 班组
	 */
    @Column(length=255)
    private String teamGroup;
    
	/**
	 * 所属系列
	 */
    @Column(length=50)
    private String series;
    
	/**
	 * 所属模块
	 */
    @Column(length=50)
    private String area;
    
	/**
	 * 拆解方案(JSON)
	 */
    @Column(length=65535)
    private String remark;
    
	/**
	 * 复投任务ID(AgainTask.id)
	 */
    @Column(nullable=false, length=19)
    private Long taskId;
    

	public WeightInputDetail() {
	}

	public WeightInputDetail(Long id) {
		this.id = id;
	}
}
