package com.sw.mes.yb.production.service;

import com.sw.mes.yb.production.dto.AgainTaskPrepare.AgainTaskPrepareDto;
import com.sw.mes.yb.production.dto.TransportInspectTaskDto;
import com.sw.mes.yb.production.dto.AgainTask.AgainTaskDto;
import com.sw.mes.yb.production.dto.LoadingTask.LoadingTaskDto;
import com.sw.mes.yb.production.entity.AgainTaskPrepare.AgainTaskPrepare;

/**
* @Author 李儒
* @Description：
* @Date:
* @Modified By:
*/
public interface EAPDockingService {

	/**
	 * 发起装料任务
	 * <pre>
	 * 调用传入参数说明 LoadingTaskDto
	 * equipmentCode 设备号
	 * lotNo 炉次号
	 * series 所属系列
	 * area 所属模块
	 * furnaceType 炉台类型【0:默认；0-量产;1-在建;2-研发;】
	 * sapNo SAP订单号
	 * productCode 料号
	 * productGrade 产品等级
	 * specs 规格
	 * dopant 掺杂剂
	 * productType 产品类别
	 * </pre>
	 * 
	 * {@see 赵文杰EAP调用}
	 */
	public void zlTaskCreate(LoadingTaskDto task) throws Exception;

	/**
	 * 发起复投任务
	 * <pre>
	 * 调用传入参数说明 AgainTaskDto
	 * equipmentCode 设备号
	 * lotNo 炉次号
	 * series 所属系列
	 * area 所属模块
	 * furnaceType 炉台类型【0:默认；0-量产;1-在建;2-研发;】
	 * rawType 请设置叫料类型【0:默认;1-初始复投;2-取段复投;】
	 * sapNo SAP订单号
	 * productCode 料号
	 * productGrade 产品等级
	 * specs 规格
	 * dopant 掺杂剂
	 * productType 产品类别
	 * </pre>
	 * 
	 * {@see 赵文杰EAP调用}
	 */
	public void ftTaskCreate(AgainTaskDto task) throws Exception;

	
//	/**
//	 * 发起送验任务
//	 * <pre>
//	 * 调用传入参数说明 TransportInspectTaskDto
//	 * equipmentCode 设备号
//	 * lotNo 炉次号
//	 * series 所属系列
//	 * area 所属模块
//	 * furnaceType 炉台类型【0:默认；0-量产;1-在建;2-研发;】
//	 * sapNo SAP订单号
//	 * productCode 料号
//	 * productGrade 产品等级
//	 * specs 规格
//	 * dopant 掺杂剂
//	 * productType 产品类别
//	 * length 等径长度(单晶长度)  单位：mm
//	 * longCrystalId 长单晶表id(production_long_crystal.id)
//	 * </pre>
//	 * 
//	 * {@see 赵文杰EAP调用}
//	 */
//	public void syTaskCreate(TransportInspectTaskDto task) throws Exception;

	/**
	 * 发起预装料任务
	 * 1创建任务
	 * 2分解任务
	 * 3下发任务(只下发第一车任务)
	 * @param task
	 */
	public void yzlTaskCreate(AgainTaskPrepareDto task);
}
