package com.sw.mes.yb.report.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@ApiModel(value = "CrystalPullingInfoDto")
public class CrystalPullingInfoDto {

    private Long id;
     @ApiModelProperty(value = "系列" )
     String series;
     @ApiModelProperty(value = "炉台号" )
     String deviceNo;
     @ApiModelProperty(value = "炉次号" )
     String lotNo;
     @ApiModelProperty(value = "坩埚规格" )
     String crucible;
     @ApiModelProperty(value = "型号" )
     String conductionType;
     @ApiModelProperty(value = "规格" )
     String specs;
     @ApiModelProperty(value = "投料量" )
     BigDecimal materialCount;
     @ApiModelProperty(value = "剩料重量")
     BigDecimal residualWeight;
     @ApiModelProperty(value = "晶体重量")
     BigDecimal crystalWeight;
     @ApiModelProperty(value = "本次加热电能" )
     BigDecimal useKwh;
     @ApiModelProperty(value = "拉晶情况" )
     String info;
     @ApiModelProperty(value = "数据更新时间" )
     @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
     Date dataUpdateTime;

     @ApiModelProperty(value = "开始时间" )
     @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
     Date startTime;
     @ApiModelProperty(value = "停炉时间" )
     @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
     Date stopTime;
     @ApiModelProperty(value = "划线长度" )
     private BigDecimal lineLength;
     @ApiModelProperty(value = "实时状态" )
     private String realTimeInfo;
     @ApiModelProperty(value = "运行时间" )
     private BigDecimal runTime;
     @ApiModelProperty(value = "片区" )
     String district;
}
