package com.sw.mes.yb.report.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@ApiModel(value = "CrystalPullingInfoLogDto")
public class CrystalPullingInfoLogDto {

    private Long id;
    @ApiModelProperty(value = "系列")
    String series;
    @ApiModelProperty(value = "炉台号")
    String deviceNo;
    @ApiModelProperty(value = "型号")
    String conductionType;
    @ApiModelProperty(value = "规格")
    String specs;
    @ApiModelProperty(value = "炉次号")
    String lotNo;
    @ApiModelProperty(value = "投料量")
    BigDecimal materialCount;
    @ApiModelProperty(value = "剩料重量")
    BigDecimal residualWeight;
    @ApiModelProperty(value = "晶体重量")
    BigDecimal crystalWeight;
    @ApiModelProperty(value = "划线长度")
    BigDecimal lineLength;
    @ApiModelProperty(value = "划线重量")
    BigDecimal lineWeight;
    @ApiModelProperty(value = "划线成晶率")
    BigDecimal lineCompletionRate;
    @ApiModelProperty(value = "开始时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date startTime;
    @ApiModelProperty(value = "停炉时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date stopTime;
    @ApiModelProperty(value = "运行时长")
    Long runTime;
    @ApiModelProperty(value = "拉晶情况")
    String info;
    @ApiModelProperty(value = "耗电量")
    private BigDecimal powerConsumption;
    @ApiModelProperty(value = "单小时产出")
    BigDecimal oneHourOut;

    /**
     * 实际运行时长
     */
    @ApiModelProperty(value = "实际运行时长")
    private BigDecimal runTimeActual;

    @ApiModelProperty(value = "异常待机时长" )
    private BigDecimal standbyTime;

    @ApiModelProperty(value = "异常（拉晶）原因" )
    private String abnormalCause;

    @ApiModelProperty(value = "片区" )
    String district;
}