package com.sw.mes.yb.report.dto;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.metadata.BaseRowModel;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@ApiModel(value = "断苞基础表接口Dto")
public class ScheduleProductionConfigDto extends BaseRowModel {

    private Long id;

    @ApiModelProperty(value = "订单号")
    @ExcelProperty("订单号")
    String orderNo;

    /**
     * 车间
     */
    @ApiModelProperty(value = "车间")
    @ExcelProperty("车间")
    private String workShop;


    @ApiModelProperty(value = "日期")
    @ExcelProperty("日期")
    String date;

    @ApiModelProperty(value = "订单类型")
    @ExcelProperty("订单类型")
    String orderType;

    @ApiModelProperty(value = "产品类别")
    @ExcelProperty("产品类别")
    String productType;

    @ApiModelProperty(value = "边距")
    @ExcelProperty("边距")
    String side;

    @ApiModelProperty(value = "日计划产量")
    @ExcelProperty("日计划产量")
    BigDecimal dayPlan;

    @ApiModelProperty(value = "四小时计划量")
    @ExcelProperty("四小时计划量")
    BigDecimal hourPlan;

    @ApiModelProperty(value = "创建人")
    @ExcelProperty("创建人")
    private String createUser;

    @ApiModelProperty(value = "创建时间")
    @ExcelProperty("创建时间")
    Date createTime;
}