/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.report.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.math.BigDecimal;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="rpt_cast_material_info")
@DynamicUpdate
@DynamicInsert
public class CastMaterialInfo{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 系列
	 */
    @Column(length=20)
    private String series;
    
	/**
	 * 模块
	 */
    @Column(length=30)
    private String area;
    
	/**
	 * 炉台号
	 */
    @Column(length=50)
    private String deviceNo;
    
	/**
	 * 炉次号
	 */
    @Column(length=50)
    private String lotNo;
    
	/**
	 * 投料重量
	 */
    @Column(length=19)
    private BigDecimal materialWeight;
    
	/**
	 * 投料类型
	 */
    @Column(length=30)
    private String materialType;
    
	/**
	 * 时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date date;
    

	public CastMaterialInfo() {
	}

	public CastMaterialInfo(Long id) {
		this.id = id;
	}
}
