/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.report.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.math.BigDecimal;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="rpt_crystal_pulling_info")
@DynamicUpdate
@DynamicInsert
public class CrystalPullingInfo{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

	/**
	 * 系列
	 */
    @Column(length=50)
    private String series;

	/**
	 * 炉台号
	 */
    @Column(length=50)
    private String deviceNo;

	/**
	 * 炉次号
	 */
    @Column(length=80)
    private String lotNo;

	/**
	 * 坩埚规格
	 */
    @Column(length=50)
    private String crucible;

	/**
	 * 型号
	 */
    @Column(length=10)
    private String conductionType;

	/**
	 * 规格
	 */
    @Column(length=50)
    private String specs;

	/**
	 * 投料量
	 */
    @Column(length=19)
    private BigDecimal materialCount;

	/**
	 * 剩料重量
	 */
	@Column(length = 19)
	private BigDecimal residualWeight;

	/**
	 * 晶体重量
	 */
	@Column(length = 19)
	private BigDecimal crystalWeight;

    /**
	 * 本次加热电能
	 */
    @Column(length=19)
    private BigDecimal useKwh;

	/**
	 * 拉晶情况
	 */
    @Column(length=65535)
    private String info;

	/**
	 * 数据更新时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date dataUpdateTime;



	/**
	 * 异常待机时长
	 */
	@Column(length=19)
	private BigDecimal standbyTime;


	/**
	 * 异常待机情况
	 */
	@Column(length = 65535)
	private String abnormalStandbyInfo;





	@Column(length=19)
    private BigDecimal lineLength;

    /**
	 * 开始时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date startTime;

	/**
	 * 停炉时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date stopTime;

	/**
	 * 实时状态
	 */
	@Column(length=65535)
	private String realTimeInfo;


	/**
	 * 运行时间 小时
	 */
	@Column(length=19)
	private BigDecimal runTime;

	/**
	 * 片区 factory_model.name
	 */
	@Column(length=40)
	private String district;

	public CrystalPullingInfo() {
	}

	public CrystalPullingInfo(Long id) {
		this.id = id;
	}
}
