/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.report.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@Entity
@Table(name = "rpt_crystal_pulling_info_log")
@DynamicUpdate
@DynamicInsert
public class CrystalPullingInfoLog {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    /**
     * 系列
     */
    @Column(length = 50)
    private String series;

    /**
     * 炉台号
     */
    @Column(length = 50)
    private String deviceNo;

    /**
     * 型号
     */
    @Column(length = 10)
    private String conductionType;

    /**
     * 规格
     */
    @Column(length = 50)
    private String specs;

    /**
     * 炉次号
     */
    @Column(length = 80)
    private String lotNo;

    /**
     * 投料量
     */
    @Column(length = 19)
    private BigDecimal materialCount;

    /**
     * 剩料重量
     */
    @Column(length = 19)
    private BigDecimal residualWeight;

    /**
     * 晶体重量
     */
    @Column(length = 19)
    private BigDecimal crystalWeight;

    /**
     * 划线长度
     */
    @Column(length = 19)
    private BigDecimal lineLength;

    /**
     * 划线重量
     */
    @Column(length = 19)
    private BigDecimal lineWeight;

    /**
     * 划线成晶率
     */
    @Column(length = 19)
    private BigDecimal lineCompletionRate;

    /**
     * 开始时间
     */
    @Column(length = 19)
    @Temporal(TemporalType.TIMESTAMP)
    private Date startTime;

    /**
     * 停炉时间
     */
    @Column(length = 19)
    @Temporal(TemporalType.TIMESTAMP)
    private Date stopTime;

    /**
     * 运行时长
     */
    @Column(length = 19)
    private BigDecimal runTime;

    /**
     * 拉晶情况
     */
    @Column(length = 65535)
    private String info;

    /**
     * 耗电量
     */
    @Column(length = 19)
    private BigDecimal powerConsumption;

    /**
     * 单小时产出
     */
    @Column(length = 19)
    private BigDecimal oneHourOut;


    /**
     * 实际运行时长
     */
    @Column(length = 19)
    private BigDecimal runTimeActual;



    /**
     * 异常待机情况
     */
    @Column(length = 65535)
    private String abnormalStandbyInfo;


    /**
     * 异常（拉晶）原因
     */
    @Column(length = 200)
    private String abnormalCause;

    /**
     * 异常待机时长
     */
    @Column(length=19)
    private BigDecimal standbyTime;

    /**
     * 片区 factory_model.name
     */
    @Column(length=40)
    private String district;



    public CrystalPullingInfoLog() {
    }

    public CrystalPullingInfoLog(Long id) {
        this.id = id;
    }
}
