/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.report.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.math.BigDecimal;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="recycled_material_plan")
@DynamicUpdate
@DynamicInsert
public class RecycledMaterialPlan {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

	/**
	 * 日期(格式yyyy-MM-dd)
	 */
    @Column(length=50)
	@JsonFormat(pattern = "yyyy-MM-dd")
    private Date date;

	/**
	 * 计划产量
	 */
    @Column(length=20)
    private BigDecimal planValue;

	public RecycledMaterialPlan() {
	}

	public RecycledMaterialPlan(Long id) {
		this.id = id;
	}
}
