/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.report.entity;

import java.util.Date;
import java.math.BigDecimal;

import lombok.Data;
import javax.persistence.*;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="rpt_shoulder_seeding_rate")
@DynamicUpdate
@DynamicInsert
public class ShoulderSeedingRate{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 系列
	 */
    @Column(length=50)
    private String series;
    
	/**
	 * 炉台号
	 */
    @Column(length=50)
    private String deviceNo;
    
	/**
	 * 炉次号
	 */
    @Column(length=80)
    private String lotNo;
    
	/**
	 * 班次
	 */
    @Column(length=10)
    private String classNo;
    
	/**
	 * 引晶成活率
	 */
    @Column(length=19)
    private BigDecimal seedingRate;
    
	/**
	 * 剩余重量
	 */
    @Column(length=19)
    private Double residueWeight;
    
	/**
	 * 引晶长度
	 */
    @Column(length=19)
    private BigDecimal seedingLength;
    
	/**
	 * 引晶时长
	 */
    @Column(length=19)
    private BigDecimal seedingTime;
    
	/**
	 * 进入引晶
	 */
    @Column(length=10)
    private Integer intoSeeding;
    
	/**
	 * 是否引断
	 */
    @Column(length=10)
    private Integer breakTake;
    
	/**
	 * 进入引晶时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date infoSeedingTime;
    
	/**
	 * 进入放肩时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date infoShoulderingTime;
    
	/**
	 * 模块
	 */
    @Column(length=40)
    private String area;
    
	/**
	 * 记录创建时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createTime;
    
    
    /**
     * 引晶功率
     */
    @Column(length=19)
    private BigDecimal crystalPower;

	/**
	 * 车间 factory_model.name
	 */
	@Column(length=50)
	private String workshop;

	/**
	 * 片区 factory_model.name
	 */
	@Column(length=40)
	private String district;

	public ShoulderSeedingRate() {
	}

	public ShoulderSeedingRate(Long id) {
		this.id = id;
	}
}
