/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.report.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.math.BigDecimal;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="zhxx_progress_statistics")
@DynamicUpdate
@DynamicInsert
public class ZhxxProgressStatistics {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

	/**
	 * 晶段编号
	 */
	@Column(length=50)
	private String crystalNo;

	/**
	 * 日期
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date createTime;
    
	/**
	 * 工序
	 */
    @Column(length=50)
    private String processName;
    
	/**
	 * 状态：1待进站；2已进站；3已出站
	 */
    @Column(length=10)
    private Integer status;
    
	/**
	 * 规格
	 */
    @Column(length=50)
    private String specs;
    
	/**
	 * 重量
	 */
    @Column(length=50)
    private BigDecimal weight;
    
	/**
	 * 收尾方式
	 */
    @Column(length=50)
    private String windUp;
	/**
	 * 当天执行时间
	 */
	@Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
	private Date time;
	/**
	 * 产品类别
	 */
	@Column(length=20)
	private String productType;

	public ZhxxProgressStatistics() {
	}

	public ZhxxProgressStatistics(Long id) {
		this.id = id;
	}
}
