package com.sw.mes.yb.seed.dto;

import com.baomidou.mybatisplus.annotation.TableField;
import com.sw.mes.yb.seed.utils.SeedCodeGenerator;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;


/**
 * 籽晶基础数据
 * 对外数据传输对象
 *
 * @Author：wanjia
 * @Date：2024/1/9 16:43
 */
@Data
public class SeedBatchesDto implements Serializable {
    @TableField(exist = false)
    private static final long serialVersionUID = 1L;

    /**
     * 计划单号
     */
    @ApiModelProperty(value = "计划单号",required = true)
    private String planCode;
    /**
     * 物料编码
     */
    @ApiModelProperty(value = "物料编码",required = true)
    private String materialCode;
    /**
     * 数量
     */
    @ApiModelProperty(value = "数量",required = true)
    private Integer count;
    /**
     * 籽晶掏棒机台号
     */
    @ApiModelProperty(value = "籽晶掏棒机台号")
    private String seedCoringDevice;
    /**
     * 籽晶磨棒机台号
     */
    @ApiModelProperty(value = "籽晶磨棒机台号")
    private String seedGrindingDevice;
    /**
     * 籽晶加工长度
     */
    @ApiModelProperty(value = "籽晶加工长度",required = true)
    private long processLength;
    /**
     * 批次号
     */
    @ApiModelProperty(value = "批次号",required = true)
    private String batchNo;
    /**
     * 车间编码
     */
    @ApiModelProperty(value = "车间编码")
    private String workShopCode;

    /**
     * 消耗重量
     */
    @ApiModelProperty(value = "数量",required = true)
    private Double weight;
}
