package com.sw.mes.yb.seed.dto;

import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 籽晶对象
 *
 * @Author：wanjia
 * @Date：2024/1/9 14:41
 */
@Data
public class SeedGroupBracketDetailsDto implements Serializable {

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;

    private Long id;
    /**
     * 父级id
     */
    @ApiModelProperty(value = "父级id")
    private Long parentId;
    /**
     * 籽晶编码
     */
    @ApiModelProperty(value = "籽晶编码")
    private String seedCode;
    /**
     * 计划单号
     */
    @ApiModelProperty(value = "计划单号")
    private String planCode;
    /**
     * 籽晶批次号
     */
    @ApiModelProperty(value = "籽晶批次号")
    private String seedBatchNo;
    /**
     * 批次号
     */
    @ApiModelProperty(value = "批次号")
    private String batchNo;
    /**
     * 锥度
     */
    @ApiModelProperty(value = "锥度")
    private Double taper;
    /**
     *总长度
     */
    @ApiModelProperty(value = "总长度")
    private Double totalLength;
    /**
     *理论重量
     */
    @ApiModelProperty(value = "理论重量")
    private Double theWeight;
    /**
     *总长度大头长度
     */
    @ApiModelProperty(value = "总长度大头长度")
    private Double totalBigLength;
    /**
     *小头长度
     */
    @ApiModelProperty(value = "小头长度")
    private Double smallLength;
    /**
     *小头平均直径
     */
    @ApiModelProperty(value = "小头平均直径")
    private Double smallAverageDiameter;
    /**
     *大头平均直径
     */
    @ApiModelProperty(value = "大头平均直径")
    private Double bigAverageDiameter;
    /**
     *小头直径最小值
     */
    @ApiModelProperty(value = "小头直径最小值")
    private Double smallDiameterMin;
    /**
     *小头直径最大值
     */
    @ApiModelProperty(value = "小头直径最大值")
    private Double smallDiameterMax;
    /**
     *大头直径最小值
     */
    @ApiModelProperty(value = "大头直径最小值")
    private Double bigDiameterMin;
    /**
     *大头直径最大值
     */
    @ApiModelProperty(value = "大头直径最大值")
    private Double bigDiameterMax;
    /**
     *同轴度
     */
    @ApiModelProperty(value = "同轴度")
    private Double coaxiality;
    /**
     *隐裂
     */
    @ApiModelProperty(value = "隐裂")
    private Double subfissure;
    /**
     *是否合格
     */
    @ApiModelProperty(value = "是否合格")
    private Boolean isQualified;
    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private String createBy;

    /**
     * 创建日期
     */
    @ApiModelProperty(value = "创建日期")
    private Date createDate;

    /**
     * 修改人
     */
    @ApiModelProperty(value = "修改人")
    private String updateBy;
    /**
     * 更新时间
     */
    @ApiModelProperty(value = "更新时间")
    private Date updateDate;
    /**
     * 状态
     */
    @ApiModelProperty(value = "状态")
    private String status;
}
