package com.sw.mes.yb.seed.dto;

import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * 籽晶对象
 *
 * @Author：wanjia
 * @Date：2024/1/9 14:41
 */
@Data
public class SeedGroupBracketDto implements Serializable {

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;

    private Long id;
    /**
     * 组托编码
     */
    @ApiModelProperty(value = "组托编码")
    private String code;
    /**
     * 批次号
     */
    @ApiModelProperty(value = "批次号",required = true)
    private String batchNo;
    /**
     * 个数
     */
    @ApiModelProperty(value = "个数")
    private Integer count;
    /**
     * 理论重量
     */
    @ApiModelProperty(value = "理论重量")
    private double theWeight;
    /**
     * 掺杂剂
     */
    @ApiModelProperty(value = "掺杂剂")
    private String dopant;
    /**
     * 状态
     */
    @ApiModelProperty(value = "状态")
    private String status;
    /**
     * 组托人
     */
    @ApiModelProperty(value = "组托人")
    private String createBy;

    /**
     * 组托日期
     */
    @ApiModelProperty(value = "组托日期")
    private Date createDate;

    /**
     * 发起人
     */
    @ApiModelProperty(value = "发起人")
    private String launchBy;
    /**
     * 发起时间
     */
    @ApiModelProperty(value = "发起时间")
    private Date launchDate;
    /**
     *物料id
     */
    @ApiModelProperty(value = "物料id")
    private Integer materialId;
    /**
     *物料编码
     */
    @ApiModelProperty(value = "物料编码")
    private String materialCode;
    /**
     *物料名称
     */
    @ApiModelProperty(value = "物料名称")
    private String materialName;
    /**
     *物料类型
     */
    @ApiModelProperty(value = "物料类型")
    private String materialType;
    /**
     *规格
     */
    @ApiModelProperty(value = "规格")
    private String spec;
    /**
     *物料型号
     */
    @ApiModelProperty(value = "物料型号")
    private String materialModel;
    /**
     *入库单号
     */
    @ApiModelProperty(value = "入库单号")
    private String inputBillCode;
    /**
     * 籽晶当天批次
     */
    @ApiModelProperty(value = "籽晶当天批次")
    private String seedDayBatchNo;
    /**
     * 出库单号
     */
    @ApiModelProperty(value = "出库单号")
    private String outputBillCode;
    /**
     * 车间编码
     */
    @ApiModelProperty(value = "车间编码")
    private String workShopCode;
    /**
     * 明细
     */
    @ApiModelProperty(value = "明细")
    private List<SeedGroupBracketDetailsDto> detailsDtos;

}
