package com.sw.mes.yb.seed.dto;

import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 籽晶判定规则
 * @Author：wanjia
 * @Date：2024/1/9 14:41
 */
@Data
public class SeedPaintingLineDto implements Serializable {
    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
    
    private Long id;

    /**
     * 判定规则名称
     */
    @ApiModelProperty(value = "判定规则名称")
    @NotNull(message = "判定规则名称不能为空")
    private String ruleName;
    /**
     * 规格
     */
    @ApiModelProperty(value = "规格")
    @NotNull(message = "规格不能为空")
    private String specs;

    /**
     * 掺杂剂
     */
    @ApiModelProperty(value = "掺杂剂")
    private String dopant;
    /**
     * 导电型号
     */
    @ApiModelProperty(value = "导电型号")
    private String conductiveType;

    /**
     * 总长度
     */
    @ApiModelProperty(value = "总长度")
    private BigDecimal totalLength;
    /**
     * 定向标识
     */
    @ApiModelProperty(value = "定向标识")
    private String directionalSign;

    /**
     * 段数
     */
    @ApiModelProperty(value = "段数")
    private int lineNum;

    /**
     * 分段数
     */
    @ApiModelProperty(value = "分段数")
    private int segmentNum;

    /**
     * 电阻率
     */
    @ApiModelProperty(value = "电阻率")
    private String resistivity;

    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private String createUser;

    /**
     * 修改人
     */
    @ApiModelProperty(value = "修改人")
    private String updateUser;

    /**
     * 创建日期
     */
    @ApiModelProperty(value = "创建日期")
    private Date createTime;

    /**
     * 更新时间
     */
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;

    /**
     * 寿命
     */
    @ApiModelProperty(value = "寿命")
    private String lifeTime;

}
