package com.sw.mes.yb.seed.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.util.Date;

/**
 * 籽晶对象
 *
 * @Author：wanjia
 * @Date：2024/1/9 14:41
 */
@Data
@Entity
@Table(name = "seed_group_bracket")
@DynamicUpdate
@DynamicInsert
public class SeedGroupBracket {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    /**
     * 组托编码
     */
    @Column
    private String code;
    /**
     * 个数
     */
    @Column
    private Integer count;
    /**
     * 理论重量
     */
    @Column
    private double theWeight;
    /**
     * 掺杂剂
     */
    @Column
    private String dopant;
    /**
     * 状态
     */
    @Column
    private String status;
    /**
     * 组托人
     */
    @Column
    private String createBy;

    /**
     * 组托日期
     */
    @Column
    private Date createDate;

    /**
     * 发起人
     */
    @Column
    private String launchBy;
    /**
     * 发起时间
     */
    @Column
    private Date launchDate;
    /**
     *物料id
     */
    @Column
    private Integer materialId;
    /**
     *物料编码
     */
    @Column
    private String materialCode;
    /**
     *物料名称
     */
    @Column
    private String materialName;
    /**
     *物料类型
     */
    @Column
    private String materialType;
    /**
     *规格
     */
    @Column
    private String spec;
    /**
     *物料型号
     */
    @Column
    private String materialModel;
    /**
     * 入库单号
     */
    @Column
    private String inputBillCode;
    /**
     * 籽晶当天批次
     */
    @Column
    private String seedDayBatchNo;
    /**
     * 出库单号
     */
    @Column
    private String outputBillCode;
}
