/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.spc.app.entity;


import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.util.Date;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@Entity
@Table(name = "spc_app_permission")
@DynamicUpdate
@DynamicInsert
public class AppPermission {
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;
    
	/**
	 * 角色id
	 */
    @Column(length=10)
    private Integer roleId;
    
	/**
	 * 角色名字
	 */
    @Column(length=20)
    private String roleName;
    
	/**
	 * 系列
	 */
    @Column(length=255)
    private String series;

	/**
	 * 权限
	 */
	@Column(length=20)
	private String permission;
    
	/**
	 * 模块名
	 */
    @Column(length=20)
    private String moduleName;

	/**
	 * 人员
	 */
	@Column(length = 10)
	private String user;

	/**
	 * 更新时间
	 */
	@Column(length = 19)
	@Temporal(TemporalType.TIMESTAMP)
	private Date createTime;

	/**
	 * 类型：0 圆棒 1 方棒
	 */
	@Column(length=10)
	private Integer type;

	public AppPermission() {
	}

	public AppPermission(Integer id) {
		this.id = id;
	}
}
