package com.sw.mes.yb.turnstore.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.validator.constraints.*;

import javax.validation.constraints.*;

import java.math.BigDecimal;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@ApiModel(value = "原料库位绑定Dto")
public class MaterialWarehousingBindingDto {

    private Long id;
     @ApiModelProperty(value = "库位编号" )
     String warehouseStock;
     @ApiModelProperty(value = "地码" )
     String forkliftLocationCode;
     @ApiModelProperty(value = "物料批次" )
     String materialBatch;
     @ApiModelProperty(value = "物料编号" )
     String materialNo;
     @ApiModelProperty(value = "物料名称" )
     String materialName;
     @ApiModelProperty(value = "物料类型" )
     String materialType;
     @ApiModelProperty(value = "定向" )
     String directional;
     @ApiModelProperty(value = "数量 " )
     BigDecimal count;
     @ApiModelProperty(value = "档位" )
     String materialGear;
     @ApiModelProperty(value = "等级" )
     String materialLevel;
     @ApiModelProperty(value = "规格" )
     String specification;
     @ApiModelProperty(value = "供应商" )
     String supplier;
     @ApiModelProperty(value = "粒径" )
     String suppliesGrain;
     @ApiModelProperty(value = "唯一码" )
     String uniqueCode;
     @ApiModelProperty(value = "单位" )
     String unit;
     @ApiModelProperty(value = "AGV任务编号" )
     String agvTaskCode;
     @ApiModelProperty(value = "AGV任务装态 0等待创建1已创建2正在执行5已取消9已结束" )
     Integer agvTaskState;
     @ApiModelProperty(value = "AGV任务异常信息" )
     String agvTaskMsg;
     @ApiModelProperty(value = "操作时间" )
     @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
     Date operateTime;
     @ApiModelProperty(value = "操作人" )
     String operateUser;
}