package com.sw.mes.yb.turnstore.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@ApiModel(value = "圆棒退库复检接收详情Dto")
public class RecheckInspectReceiveDetailDto {

    private Long id;
    @ApiModelProperty(value = "托号")
    String trayNo;
    @ApiModelProperty(value = "晶段编码")
    String crystalNo;
    @ApiModelProperty(value = "圆棒产品等级")
    String productLevel;
    @ApiModelProperty(value = "实验等级")
    String experGrade;
    @ApiModelProperty(value = "规格")
    String specs;
    @ApiModelProperty(value = "状态【0：默认，待确认；1：已入库；2：拒收；】")
    Integer state;
    @ApiModelProperty(value = "导电型号")
    String conductiveType;
    @ApiModelProperty(value = "入库长度(mm)")
    BigDecimal inputLength;
    @ApiModelProperty(value = "入库重量(KG)")
    BigDecimal instoreWeight;
    @ApiModelProperty(value = "圆棒重量(KG)")
    BigDecimal weight;
    @ApiModelProperty(value = "圆棒长度(mm)")
    BigDecimal length;
    @ApiModelProperty(value = "细减长(mm)")
    BigDecimal fineCutLength;
    @ApiModelProperty(value = "崩晶线(mm)")
    BigDecimal collapseLine;
    @ApiModelProperty(value = "退料备注")
    String returnRemark;
    @ApiModelProperty(value = "退料类型")
    String quitType;
    @ApiModelProperty(value = "晶段类型")
    String sectionType;
    @ApiModelProperty(value = "复检类型")
    String reCheckType;
    @ApiModelProperty(value = "确认人")
    String confirmUser;
    @ApiModelProperty(value = "确认时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date confirmTime;
}