package com.sw.mes.yb.turnstore.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;
import java.util.List;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@ApiModel(value = "周转库入库申请主表+明细Dto")
public class TurnstoreInPostDto {

    private Integer id;
    @ApiModelProperty(value = "入库类型（圆棒入库、方棒退料、综计退料" )
    String type;
    @ApiModelProperty(value = "入库申请单状态(待入库、已入库、退回)" )
    String state;
    @ApiModelProperty(value = "入库申请单号" )
    String orderNo;
    @ApiModelProperty(value = "入库申请人" )
    String user;
    @ApiModelProperty(value = "确认人" )
    String confirmUser;
    @ApiModelProperty(value = "入库申请时间" )
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date time;
    @ApiModelProperty(value = "单晶总数" )
    Integer count;
    @ApiModelProperty(value = "入库申请日期" )
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date date;
    @ApiModelProperty(value = "入库申请顺序" )
    Integer sort;
    @ApiModelProperty(value = "备注" )
    String remark;
    @ApiModelProperty(value = "圆棒入库批次号" )
    Long batchNo;
    @ApiModelProperty(value = "入库明细list" )
    List<TurnstoreInItemDto> items;
    @ApiModelProperty(value = "原因" )
    String reason;

    @ApiModelProperty(value = "去向" )
    String purpose;
    @ApiModelProperty(value = "退料站点" )
    String returnStation;
}
