package com.sw.mes.yb.turnstore.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@ApiModel(value = "周转库出库申请明细Dto")
public class TurnstoreOutItemDto {

    private Integer id;
     @ApiModelProperty(value = "出库申请主表id" )
     Integer outId;
     @ApiModelProperty(value = " 出库类型（退料到圆棒、出库到方棒、出库到综计）" )
     String type;
     @ApiModelProperty(value = "出库申请单状态(待出库、已出库、退回)" )
     String state;
     @ApiModelProperty(value = "出库申请单号" )
     String orderNo;
     @ApiModelProperty(value = "出库申请人" )
     String user;
     @ApiModelProperty(value = "确认人" )
     String confirmUser;
     @ApiModelProperty(value = "出库申请时间" )
     @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
     Date time;
     @ApiModelProperty(value = "晶段编号" )
     String sectionNo;
     @ApiModelProperty(value = "产品等级" )
     String productLevelSecond;
     @ApiModelProperty(value = "实验等级" )
     String productLevelExperiment;
     @ApiModelProperty(value = "产品规格" )
     String productTypeSecond;
     @ApiModelProperty(value = "入库长度" )
     BigDecimal instoreLength;
     @ApiModelProperty(value = "入库重量" )
     BigDecimal instoreWeight;
     @ApiModelProperty(value = "圆棒长度" )
     BigDecimal actualLength;
     @ApiModelProperty(value = "重量" )
     BigDecimal actualWeight;
     @ApiModelProperty(value = "细减长" )
     BigDecimal fineCutLength;
     @ApiModelProperty(value = "崩晶线" )
     BigDecimal collapseLine;
     @ApiModelProperty(value = "库位名称" )
     String locationName;
     @ApiModelProperty(value = "原因" )
     String reason;
     @ApiModelProperty(value = "晶段类型" )
     String sectionType;
     @ApiModelProperty(value = "去向" )
     String hasGone;
     @ApiModelProperty(value = "单晶不同出库类型的次数(累加)" )
     Integer times;
     @ApiModelProperty(value = "SAP订单号" )
     String sapOrderNo;
     @ApiModelProperty(value = "SAP物料号" )
     String materialNumber;
     @ApiModelProperty(value = "检验人" )
     String inspectUser;
     @ApiModelProperty(value = "复检类型" )
     String reCheckType;
     @ApiModelProperty(value = "细总长" )
     BigDecimal fineDiameter;
     @ApiModelProperty(value = "备注" )
     String remark;
}
