package com.sw.mes.yb.turnstore.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@Data
@ApiModel(value = "圆棒入库统计Dto")
public class WarehousingStatisticsYbDto {

    private Integer id;

    @ApiModelProperty(value = " 晶段编号(短棒)")
    private String sectionNo;

    @ApiModelProperty(value = "托号")
    private String trayNo;

    @ApiModelProperty(value = "单晶组合")
    private String sectionCompose;

    @ApiModelProperty(value = "拉晶车间")
    private String crystalWorkshop;

    @ApiModelProperty(value = "炉台号")
    private String deviceNo;

    @ApiModelProperty(value = "工厂")
    private String factory;

    @ApiModelProperty(value = "系列")
    private String series;

    @ApiModelProperty(value = "圆棒规格")
    private String productTypeSecond;

    @ApiModelProperty(value = "导电型号")
    private String conductiveType;

    @ApiModelProperty(value = "订单号")
    private String orderNo;

    @ApiModelProperty(value = "料号")
    private String materialCode;

    @ApiModelProperty(value = "订单类型（1:量产；2:试验；3:送样;4:返工）")
    private String orderType;

    @ApiModelProperty(value = "产品等级")
    private String productLevel;

    @ApiModelProperty(value = "实验等级")
    private String productLevelExperiment;

    @ApiModelProperty(value = "计划订单号")
    private String planOrderNo;

    @ApiModelProperty(value = "计划订单类型")
    private String planOrderType;

    @ApiModelProperty(value = "计划物料编码")
    private String planMaterialCode;

    @ApiModelProperty(value = "计划产品等级")
    private String planGrade;

    @ApiModelProperty(value = "计划导电型号")
    private String planConductiveType;

    @ApiModelProperty(value = "计划拼数")
    private String planStickCount;

    @ApiModelProperty(value = "计划规格")
    private String planSpecs;

    @ApiModelProperty(value = "计划长度范围")
    private String planLenRange;

    @ApiModelProperty(value = "计划掺杂剂")
    private String planDopant;

    @ApiModelProperty(value = "去向")
    private String hasGone;

    @ApiModelProperty(value = "库别【0-正常；1-直径不良单晶；2-退料；】")
    private String kube;

    @ApiModelProperty(value = "复检类别")
    private String reCheckType;

    @ApiModelProperty(value = "状态【0：默认，待确认；1：已接收；3: 拒收;】")
    private Integer state;

    @ApiModelProperty(value = "操作人")
    private String user;

    @ApiModelProperty(value = "操作时间")
    private Date operationTime;

    @ApiModelProperty(value = "确认时间")
    private Date confirmTime;

    @ApiModelProperty(value = "确认人")
    private String confirmUser;

    @ApiModelProperty(value = "入库长度")
    private BigDecimal wareHouseLength;

    @ApiModelProperty(value = "理论重量")
    private BigDecimal theoryWeight;

    @ApiModelProperty(value = "圆棒长度(mm)")
    private BigDecimal actualLength;

    @ApiModelProperty(value = "单晶减长长度")
    private BigDecimal reduceCrystalLength;

    @ApiModelProperty(value = "圆棒称重")
    private BigDecimal actualWeight;

    @ApiModelProperty(value = "直径Min")
    private BigDecimal diameterMin;

    @ApiModelProperty(value = "直径Max")
    private BigDecimal diameterMax;

    @ApiModelProperty(value = "细总长")
    private BigDecimal fineDiameter;

    @ApiModelProperty(value = "细减长(mm)")
    private BigDecimal fineCutLength;

    @ApiModelProperty(value = "崩边长度")
    private BigDecimal edgeBark;

    @ApiModelProperty(value = "崩晶线")
    private BigDecimal collapseLine;

    @ApiModelProperty(value = "直径判定")
    private String diamDecide;

    @ApiModelProperty(value = "异常汇总")
    private String anomaly;

    @ApiModelProperty(value = "直径差")
    private String demcMax;
}
