package com.sw.mes.yb.turnstore.dto.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @author LingHui
 * @version 1.0.0
 * @ClassName RecheckReceiveVo
 * @Description
 * @createTime 2021/12/24
 */
@Data
@ApiModel(value = "圆棒退库复检导出模板Vo")
public class RecheckReceiveVo {
    @ApiModelProperty(value = "托号" )
    String trayNo;
    @ApiModelProperty(value = "出库单号" )
    String outOrderNo;
    @ApiModelProperty(value = "料号" )
    String productCode;
    @ApiModelProperty(value = "单晶个数" )
    Integer crystalNum;
    @ApiModelProperty(value = "状态【0：默认，待确认；1：已入库；2：拒收；】" )
    Integer state;
    @ApiModelProperty(value = "是否复检【0：默认，否；1：是；】" )
    Integer isRecheck;
    @ApiModelProperty(value = "出库类型" )
    String outType;
    @ApiModelProperty(value = "来源" )
    String source;
    @ApiModelProperty(value = "申请时间" )
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date applyTime;
    @ApiModelProperty(value = "确认人" )
    String confirmUser;
    @ApiModelProperty(value = "确认时间" )
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    Date confirmTime;
    @ApiModelProperty(value = "退库备注" )
    String remark;
    @ApiModelProperty(value = "晶段编码")
    String crystalNo;
    @ApiModelProperty(value = "圆棒产品等级")
    String productLevel;
    @ApiModelProperty(value = "实验等级")
    String experGrade;
    @ApiModelProperty(value = "规格")
    String specs;
    @ApiModelProperty(value = "导电型号")
    String conductiveType;
    @ApiModelProperty(value = "入库长度(mm)")
    BigDecimal inputLength;
    @ApiModelProperty(value = "入库重量(KG)")
    BigDecimal instoreWeight;
    @ApiModelProperty(value = "圆棒重量(KG)")
    BigDecimal weight;
    @ApiModelProperty(value = "圆棒长度(mm)")
    BigDecimal length;
    @ApiModelProperty(value = "细减长(mm)")
    BigDecimal fineCutLength;
    @ApiModelProperty(value = "崩晶线(mm)")
    BigDecimal collapseLine;
    @ApiModelProperty(value = "退料备注")
    String returnRemark;
    @ApiModelProperty(value = "退料类型")
    String quitType;
    @ApiModelProperty(value = "晶段类型")
    String sectionType;
    @ApiModelProperty(value = "复检类型")
    String reCheckType;

}
