package com.sw.mes.yb.turnstore.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="production_binding_tray")
@DynamicUpdate
@DynamicInsert
public class ProductionBindingTray{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    
	/**
	 * 托盘编号
	 */
    @Column(length=100)
    private String trayNo;
    
	/**
	 * 单晶编号
	 */
    @Column(length=100)
    private String crystalNo;
    
	/**
	 * 是否绑定【0-自动绑定；1-人工绑定(记录绑定人）；】
	 */
    @Column(length=3)
    private Integer isBinding;
    
	/**
	 * 绑定时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date bindingTime;
    
	/**
	 * 绑定地点(自定义名称)
	 */
    @Column(length=100)
    private String bindingSite;
    
	/**
	 * 绑定人
	 */
    @Column(length=50)
    private String bindingPeople;
    
	/**
	 * 托盘工位号(送验车为例:1,2)
	 */
    @Column(length=50)
    private String locationNo;


    // 去向
    @Column
	private String toWhere;


    // 类型 :圆棒 方棒
    @Column
	private String type;


    // 单晶头方向
    @Column
    private String crystalDirection;
    

	public ProductionBindingTray() {
	}

	public ProductionBindingTray(Long id) {
		this.id = id;
	}
}
