/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.turnstore.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="zhxx_turnstore_in")
@DynamicUpdate
@DynamicInsert
public class TurnstoreIn{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;

	/**
	 * 入库类型（圆棒入库、方棒退料、综计退料
	 */
    @Column(length=40)
    private String type;

	/**
	 * 入库申请单状态(待入库、已入库、退回)
	 */
    @Column(length=255)
    private String state;

	/**
	 * 入库申请单号
	 */
    @Column(length=255)
    private String orderNo;

	/**
	 * 入库申请人
	 */
    @Column(length=40)
    private String user;

	/**
	 * 确认人
	 */
	@Column(length=40)
	private String confirmUser;

	/**
	 * 入库申请时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date time;

	/**
	 * 单晶总数
	 */
    @Column(length=10)
    private Integer count;

	/**
	 * 入库申请日期
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date date;

	/**
	 * 入库申请顺序
	 */
    @Column(length=10)
    private Integer sort;

	/**
	 * 备注
	 */
    @Column(length=255)
    private String remark;


	/**
	 * 圆棒入库批次号
	 */
	@Column(length=20)
	private Long batchNo;

	/**
	 * 原因
	 */
	@Column(length=255)
	private String reason;

	/**
	 * 去向
	 */
	@Column(length = 20)
	private String purpose;

	/**
	 * 退料站点
	 */
	@Column(length = 32)
	private String returnStation;

	/**
	 * 取消次数
	 */
	@Column(length = 11)
	private Integer cancelNum;

	/**
	 * 取消之前单晶数
	 */
	@Column(length = 11)
	private Integer cancelCrystalNum;

	public TurnstoreIn() {
	}

	public TurnstoreIn(Integer id) {
		this.id = id;
	}
}
