/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.yb.turnstore.entity;

import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.math.BigDecimal;
import java.util.Date;

/**
* @Author
* @Description：
* @Date: Create in
* @Modified By:
*/
@Data
@Entity
@Table(name="zhxx_turnstore_in_item")
@DynamicUpdate
@DynamicInsert
public class TurnstoreInItem{
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;

	/**
	 * 入库申请主表id
	 */
    @Column(length=10)
    private Integer inId;

	/**
	 * 入库类型（圆棒入库、方棒退料、综计退料
	 */
    @Column(length=40)
    private String type;

	/**
	 * 入库申请单状态(待入库、已入库、退回)
	 */
    @Column(length=255)
    private String state;

	/**
	 * 入库申请单号
	 */
    @Column(length=255)
    private String orderNo;

	/**
	 * 入库申请人
	 */
    @Column(length=40)
    private String user;

	/**
	 * 确认人
	 */
	@Column(length=40)
	private String confirmUser;

	/**
	 * 入库申请时间
	 */
    @Column(length=19)
	@Temporal(TemporalType.TIMESTAMP)
    private Date time;

	/**
	 * 晶段编号
	 */
    @Column(length=255)
    private String sectionNo;

	/**
	 * 产品等级
	 */
    @Column(length=40)
    private String productLevelSecond;

	/**
	 * 实验等级
	 */
	@Column(length=40)
	private String productLevelExperiment;
	/**
	 * 产品规格
	 */
	@Column(length=40)
	private String productTypeSecond;

	/**
	 * 入库长度
	 */
    @Column(length=19)
    private BigDecimal instoreLength;

	/**
	 * 入库重量
	 */
    @Column(length=19)
    private BigDecimal instoreWeight;

	/**
	 * 圆棒长度
	 */
    @Column(length=19)
    private BigDecimal actualLength;

	/**
	 * 重量
	 */
    @Column(length=19)
    private BigDecimal actualWeight;

	/**
	 * 细减长
	 */
    @Column(length=19)
    private BigDecimal fineCutLength;

	/**
	 * 崩晶线
	 */
    @Column(length=19)
    private BigDecimal collapseLine;

	/**
	 * 库位名称
	 */
    @Column(length=40)
    private String locationName;

	/**
	 * 原因（退料入周转库时才有用
	 */
    @Column(length=255)
    private String reason;

	/**
	 * 晶段类型
	 */
	@Column(length = 40)
	private String sectionType;

	/**
	 * 圆棒入库批次号
	 */
	@Column(length=20)
	private Long batchNo;

	/**
	 * 复检类别
	 */
	@Column(length = 40)
	private String reCheckType;

	/**
	 * 返切类型
	 */
	@Column(length = 40)
	private String backCutType;

	/**
	 * 单晶不同入库类型的次数(累加)
	 */
	@Column(length=10)
	private Integer times;


	/**
	 * 细总长
	 */
	@Column(length = 10)
	private BigDecimal fineDiameter;

	/**
	 * 外观检验备注
	 */
	@Lob
	private String remark;

	/**
	 * 退库类型(退库复检、退库返切、退库正常)
	 */
	@Column(length=255)
	private String withdrawingType;

	/**
	 * 去向
	 */
	@Column(length = 20)
	private String purpose;

	/**
	 * 退料站点
	 */
	@Column(length = 32)
	private String returnStation;

	public TurnstoreInItem() {
	}

	public TurnstoreInItem(Integer id) {
		this.id = id;
	}
}
