package com.sw.mes.store;

import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.domain.EntityScan;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.cloud.openfeign.EnableFeignClients;
import org.springframework.context.annotation.EnableAspectJAutoProxy;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.transaction.annotation.EnableTransactionManagement;

/**
 * @author JS111816
 */
@SpringBootApplication
@EnableDiscoveryClient
@MapperScan({"com.sw.mes.**.mapper"})
@EnableFeignClients(basePackages = {"com.sw.mes.core.api.*"})
@EnableAsync //开启异步调用
@EntityScan(basePackages = {"com.sw.mes"})
@EnableAspectJAutoProxy
@EnableTransactionManagement
public class MesStoreServerApplication {
    public static void main(String[] args) {
        SpringApplication.run(MesStoreServerApplication.class,args);
    }
}
