package com.sw.mes.store.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@ApiModel(value = "入库单详情DTO")
public class WarehouseInputBillDetailDto {

    private Long id;
    @ApiModelProperty(value = "入库单ID")
    private Long inputBillId;
    @ApiModelProperty(value = "入库单号")
    private String inputBillNo;
    @ApiModelProperty(value = "物料主数据ID", required = true)
    private Long materialModelId;
    @ApiModelProperty(value = "物料主数据料号")
    private String materialModelCode;
    @ApiModelProperty(value = "物料主数据名称")
    private String materialModelName;
    @ApiModelProperty(value = "物料主数据类型")
    private String materialTypeName;
    @ApiModelProperty(value = "物料主数据类别")
    private String materialCategoryName;
    @ApiModelProperty(value = "物料等级")
    private String materialLevel;
    @ApiModelProperty(value = "物料粒径")
    private String suppliesGrain;
    @ApiModelProperty("物料档位")
    private String materialGear;
    @ApiModelProperty(value = "直径")
    private String diameter;
    @ApiModelProperty(value = "唯一码")
    private String uniqueCode;
    @ApiModelProperty(value = "批次号")
    private String batchNo;
    @ApiModelProperty(value = "物料主数据供应商")
    private String supplier;
    @ApiModelProperty(value = "物料主数据规格")
    private String specification;
    @ApiModelProperty(value = "物料主数据图号")
    private String materialTh;
    @ApiModelProperty(value = "入库数量")
    private BigDecimal count;
    @ApiModelProperty(value = "物料单位")
    private String unitName;
    @ApiModelProperty(value = "库位ID")
    private Long warehouseId;
    @ApiModelProperty(value = "库位名称")
    private String warehouseName;
    @ApiModelProperty(value = "库位编码")
    private String warehouseCode;
    @ApiModelProperty(value = "创建人ID")
    private Integer createUserId;
    @ApiModelProperty(value = "创建人姓名")
    private String createUserName;
    @ApiModelProperty(value = "操作人ID")
    private Integer updateUserId;
    @ApiModelProperty(value = "操作人姓名")
    private String updateUserName;
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    @ApiModelProperty(value = "操作时间")
    private Date updateTime;
    @ApiModelProperty(value = "入库类型")
    private String type;
    @ApiModelProperty(value = "单据状态")
    private String status;
    @ApiModelProperty(value = "载具编号")
    private String traceid;
    @ApiModelProperty(value = "SAP工厂")
    private String customer;
    @ApiModelProperty("晶编编码")
    private String crystalNo;
    
    @ApiModelProperty(value = "来源库存地点", required = false)
    private String sourceWarehouse;
    
    /**
     * 是否退料
     */
    @ApiModelProperty("是否退料")
    private boolean returnMaterial;
    //WMS对接
    /**
     *箱号
     */
    private String serialNo;
    /**
     *批次属性01
     */
    private String lotatt01;
    /**
     *批次属性02
     */
    private String lotatt02;
    /**
     *批次属性03
     */
    private String lotatt03;
    /**
     *批次属性04
     */
    private String lotatt04;
    /**
     *批次属性05
     */
    private String lotatt05;
    /**
     *批次属性06
     */
    private String lotatt06;
    /**
     *批次属性07
     */
    private String lotatt07;
    /**
     *质量状态
     */
    private String lotatt08;
    /**
     *批次属性09
     */
    private String lotatt09;
    /**
     *批次属性10
     */
    private String lotatt10;
    /**
     *批次属性11
     */
    private String lotatt11;
    /**
     *批次属性12
     */
    private String lotatt12;
    /**
     *批次属性13
     */
    private String lotatt13;
    /**
     *批次属性14
     */
    private String lotatt14;
    /**
     *额定天数
     */
    private String lotatt15;
    /**
     *使用天数
     */
    private String lotatt16;
    /**
     *批次属性17
     */
    private String lotatt17;
    /**
     *批次属性18
     */
    private String lotatt18;
    /**
     *批次属性19
     */
    private String lotatt19;
    /**
     *批次属性20
     */
    private String lotatt20;
    /**
     *批次属性21
     */
    private String lotatt21;
    /**
     *批次属性22
     */
    private String lotatt22;
    /**
     *批次属性23
     */
    private String lotatt23;
    /**
     *批次属性24
     */
    private String lotatt24;
    /**
     *EDI信息01
     */
    private String dedi01;
    /**
     *EDI信息02
     */
    private String dedi02;
    /**
     *EDI信息03
     */
    private String dedi03;
    /**
     *EDI信息04
     */
    private String dedi04;
    /**
     *EDI信息05
     */
    private String dedi05 ;
    /**
     *预留字段
     */
    private String define1;
    /**
     *预留字段
     */
    private String define2;
    /**
     *预留字段
     */
    private String define3;
    /**
     *预留字段
     */
    private String define4;
    /**
     *预留字段
     */
    private String define5;
    /**
     *皮重
     */
    private BigDecimal tare;
}