package com.sw.mes.store.dto;

import com.sw.mes.core.dto.MaterialModelDto;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.Size;
import java.math.BigDecimal;
import java.util.List;

/**
 * @Description TODO
 * @Author wupeng
 * @Date 2023/7/24 19:09
 **/
@ApiModel(value = "线边仓-物料配置模型")
@Data
public class WarehouseMaterialDto {

    private Long id;

    @ApiModelProperty(value = "物料数据集合")
    @Size(min = 1, max = 10, message = "每次批量操作数量只能在0-10")
    private List<MaterialModelDto> materials;

    @ApiModelProperty(value = "库存下限")
    private BigDecimal lowerLimit;

    @ApiModelProperty(value = "库存上限")
    private BigDecimal upperLimit;

    @ApiModelProperty(value = "安全库存")
    private String safetyStock;

    @ApiModelProperty(value = "停留时间")
    private Integer residenceTime;

    @ApiModelProperty(value = "时间单位")
    private String timeUnit;

    @ApiModelProperty(value = "默认仓库地点")
    private String defaultLocation;

    @ApiModelProperty(value = "默认仓库地点ID")
    private Long defaultLocationId;
    @ApiModelProperty(value = "默认仓库地点编码")
    private String defaultLocationCode;
    @ApiModelProperty(value = "是否开启唯一码管理，1 开启，0 不开启")
    private Boolean uniqueCode;

    @ApiModelProperty(value = "是否开启批次管理，1 开启，0 不开启")
    private Boolean batch;

}
