/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.store.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@TableName(value = "warehouse_allot_record_bill")
public class WarehouseAllotRecordBill implements Serializable {
    @TableId(type = IdType.AUTO)
    private Long id;

    /**
     * 调拨审核单号
     */
    private String recordBillNo;

    /**
     * 单据状态。 待审核，审核成功，审核失败
     */
    private String status;

    /**
     * 调拨库位ID
     */
    private String allotWarehouseId;

    /**
     * 调拨库位名称
     */
    private String allotWarehouseName;

    /**
     * 备注
     */
    private String remark;

    /**
     * 拒收原因
     */
    private String rejectReason;

    /**
     * 拒收原因备注
     */
    private String rejectReasonRemark;

    /**
     * 是否自动审核，0 否，默认否。1 自动审核
     */
    private Boolean autoAudit;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 创建人ID
     */
    private Integer createUserId;

    /**
     * 创建人
     */
    private String createUserName;

    /**
     * 操作时间
     */
    private Date updateTime;

    /**
     * 操作人ID
     */
    private Integer updateUserId;

    /**
     * 操作人姓名
     */
    private String updateUserName;

    /**
     * 调拨申请单号
     */
    private String allotBillNo;

    /**
     * 调拨申请单id
     */
    private Long allotBillId;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}
