package com.sw.mes.store.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @Description 入库单
 * @Author wupeng
 * @Date 2023/7/26 19:41
 **/
@Data
@TableName(value = "warehouse_input_bill")
@ApiModel(value = "入库单模型")
public class WarehouseInputBill {

    @TableId(type = IdType.AUTO)
    private Long id;

    @ApiModelProperty(value = "入库单号")
    private String billNo;

    @ApiModelProperty(value = "单据状态")
    private String status;

    @ApiModelProperty(value = "入库类型")
    private String type;

    @ApiModelProperty(value = "备注")
    private String remark;

    @ApiModelProperty(value = "创建人ID")
    private Integer createUserId;

    @ApiModelProperty(value = "创建人姓名")
    private String createUserName;

    @ApiModelProperty(value = "操作人ID")
    private Integer updateUserId;

    @ApiModelProperty(value = "操作人姓名")
    private String updateUserName;

    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    @ApiModelProperty(value = "操作时间")
    private Date updateTime;

    @ApiModelProperty(value = "拒收原因")
    private String rejectReason;

    @ApiModelProperty(value = "拒收原因备注")
    private String rejectReasonRemark;

    @ApiModelProperty(value = "是否自动审核")
    private Boolean autoAudit = false;

    private Integer warehouseId;
    
    //update liru
    @ApiModelProperty(value = "库位编码")
    private String warehouseCode;
    @ApiModelProperty(value = "来源库存地点")
    private String sourceWarehouse;

    @ApiModelProperty(value = "入库明细")
    @TableField(exist = false)
    private List<WarehouseInputBillDetail> inputBillDetails = new ArrayList<>();

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "工厂")
    private String factoryId;
    @ApiModelProperty(value = "唯一ID")
    private String uniqueNo;
    @ApiModelProperty(value = "发料人工号")
    private String senderCode;
    @ApiModelProperty(value = "发料人名称")
    private String senderName;
    @ApiModelProperty(value = "线边库存地点")
    private String lgort;
    @ApiModelProperty(value = "工单号")
    private String workOrderNo;
    @ApiModelProperty(value = "EDI信息04")
    private String dedi04;
    @ApiModelProperty(value = "预留字段")
    private String define1;
    @ApiModelProperty(value = "预留字段")
    private String define2;
    @ApiModelProperty(value = "预留字段")
    private String define3;
    @ApiModelProperty(value = "预留字段")
    private String define4;
    @ApiModelProperty(value = "预留字段")
    private String define5;
    @ApiModelProperty(value = "定向标识(待业务确认)")
    private String direction;



}
