/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.store.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @Author wupeng
 * @Description 入库单详情
 * @Date 18:49 2023/7/27
 * @Param
 * @return
 **/
@Data
@TableName(value = "warehouse_input_bill_detail")
public class WarehouseInputBillDetail implements Serializable {
    @TableId(type = IdType.AUTO)
    private Long id;

    /**
     * 入库单ID
     */
    private Long inputBillId;

    /**
     * 入库单号
     */
    private String inputBillNo;

    /**
     * 物料主数据ID
     */
    private Long materialModelId;

    /**
     * 物料主数据料号
     */
    private String materialModelCode;

    /**
     * 物料主数据名称
     */
    private String materialModelName;

    /**
     * 物料主数据类型
     */
    private String materialTypeName;

    /**
     * 物料主数据类别
     */
    private String materialCategoryName;

    /**
     * 物料等级
     */
    private String materialLevel;
    /**
     * 物料粒径
     */

    private String suppliesGrain;

    /**
     * 物料档位
     */
    private String materialGear;
    /**
     * 直径
     */
    private String diameter;

    /**
     * 唯一码
     */
    private String uniqueCode;

    /**
     * 批次号
     */
    private String batchNo;

    /**
     * 物料主数据供应商
     */
    private String supplier;

    /**
     * 物料主数据规格
     */
    private String specification;

    /**
     * 物料主数据图号
     */
    private String materialTh;

    /**
     * 入库数量
     */
    private BigDecimal count;

    /**
     * 入库类型
     **/
    private String type;

    /**
     * 物料单位
     */
    private String unitName;

    /**
     * 库位ID
     */
    private Long warehouseId;

    /**
     * 库位编号
     */
    private String warehouseCode;

    /**
     * 库位名称
     */
    private String warehouseName;

    /**
     * 单据状态
     */
    private String status;

    /**
     * 创建人ID
     */
    private Integer createUserId;

    /**
     * 创建人姓名
     **/
    private String createUserName;

    /**
     * 操作人ID
     **/
    private Integer updateUserId;

    /**
     * 操作人姓名
     **/
    private String updateUserName;

    /**
     * 创建时间
     **/
    private Date createTime;

    /**
     * 操作时间
     **/
    private Date updateTime;
    
    /**
     * 载具编号
     **/
    private String traceid;
    /**
     * SAP工厂
     */
    private String customer;

    /**
     *箱号
     */
    private String serialNo;
    /**
     *批次属性01
     */
    private String lotatt01;
    /**
     *批次属性02
     */
    private String lotatt02;
    /**
     *批次属性03
     */
    private String lotatt03;
    /**
     *批次属性04
     */
    private String lotatt04;
    /**
     *批次属性05
     */
    private String lotatt05;
    /**
     *批次属性06
     */
    private String lotatt06;
    /**
     *批次属性07
     */
    private String lotatt07;
    /**
     *质量状态
     */
    private String lotatt08;
    /**
     *批次属性09
     */
    private String lotatt09;
    /**
     *批次属性10
     */
    private String lotatt10;
    /**
     *批次属性11
     */
    private String lotatt11;
    /**
     *批次属性12
     */
    private String lotatt12;
    /**
     *批次属性13
     */
    private String lotatt13;
    /**
     *批次属性14
     */
    private String lotatt14;
    /**
     *额定天数
     */
    private String lotatt15;
    /**
     *使用天数
     */
    private String lotatt16;
    /**
     *批次属性17
     */
    private String lotatt17;
    /**
     *批次属性18
     */
    private String lotatt18;
    /**
     *批次属性19
     */
    private String lotatt19;
    /**
     *批次属性20
     */
    private String lotatt20;
    /**
     *批次属性21
     */
    private String lotatt21;
    /**
     *批次属性22
     */
    private String lotatt22;
    /**
     *批次属性23
     */
    private String lotatt23;
    /**
     *批次属性24
     */
    private String lotatt24;
    /**
     *EDI信息01
     */
    private String dedi01;
    /**
     *EDI信息02
     */
    private String dedi02;
    /**
     *EDI信息03
     */
    private String dedi03;
    /**
     *EDI信息04
     */
    private String dedi04;
    /**
     *EDI信息05
     */
    private String dedi05 ;
    /**
     *预留字段
     */
    private String define1;
    /**
     *预留字段
     */
    private String define2;
    /**
     *预留字段
     */
    private String define3;
    /**
     *预留字段
     */
    private String define4;
    /**
     *预留字段
     */
    private String define5;
    /**
     *皮重
     */
    private BigDecimal tare;
    /**
     * 晶编编码
     */
    private String crystalNo;
    /**
     * 是否退料
     */
    private boolean returnMaterial;
    
    /** 线边仓库存地 **/
    private String sourceWarehouse;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}
