/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.store.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @Author wupeng
 * @Description 出库单明细
 * @Date 18:48 2023/7/31
 * @Param
 * @return
 **/
@Data
@TableName(value = "warehouse_output_bill_detail")
public class WarehouseOutputBillDetail implements Serializable {
    @TableId(type = IdType.AUTO)
    private Long id;

    /**
     * 出库单ID
     */
    private Long outputBillId;

    /**
     * 出库单号
     */
    private String outputBillNo;

    /**
     * 物料主数据ID
     */
    private Long materialModelId;

    /**
     * 物料主数据料号
     */
    private String materialModelCode;

    /**
     * 物料主数据名称
     */
    private String materialModelName;

    /**
     * 物料主数据类型
     */
    private String materialTypeName;

    /**
     * 物料主数据类别
     */
    private String materialCategoryName;
    /**
     * 物料等级
     */
    private String materialLevel;
    /**
     * 物料粒径
     */

    private String suppliesGrain;

    /**
     * 物料档位
     */
    private String materialGear;

    /**
     * 唯一码
     */
    private String uniqueCode;

    /**
     * 手动录入唯一码，出库时录入
     */
    private String manualUniqueCode;

    /**
     * 批次号
     */
    private String batchNo;

    /**
     * 物料主数据供应商
     */
    private String supplier;

    /**
     * 物料主数据规格
     */
    private String specification;

    /**
     * 物料主数据图号
     */
    private String materialTh;

    /**
     * 出库数量
     */
    private BigDecimal outputCount;

    /**
     * 需求数量
     */
    private BigDecimal requireCount;

    /**
     * 库存数量
     */
    private BigDecimal quantity;

    /**
     * 物料单位
     */
    private String unitName;

    /**
     * 库位ID
     */
    private Long warehouseId;

    /**
     * 库位名称
     */
    private String warehouseName;
    /**
     * 库位编码
     */
    private String warehouseCode;
    /**
     * 创建人ID
     */
    private Integer createUserId;

    /**
     * 创建人名称
     */
    private String createUserName;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 操作人ID
     */
    private Integer updateUserId;

    /**
     * 操作人名称
     */
    private String updateUserName;

    /**
     * 操作时间
     */
    private Date updateTime;

    /**
     * 出库类型
     */
    private String type;

    /**
     * 去向
     */
    private String destination;
    /**
     * 载具编号
     */
    private String traceid;
    /**
     * SAP工厂
     */
    private String customer;
    /**
     * 单据状态。待出库、已出库、锁定、取消
     */
    private String status;
    /**
     * 箱号
     */
    private String serialNo;
    /**
     * 是否锁定库存
     */
    private boolean lockInventory = false;
    /**
     * 晶编编码
     */
    private String crystalNo;
    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}
