/**
 * There are <a href="https://github.com/ketayao/keta-custom">keta-custom</a> code generation
 */
package com.sw.mes.store.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * @Author
 * @Description：
 * @Date: Create in
 * @Modified By:
 */
@Data
@TableName(value = "warehouse_output_record_bill")
public class WarehouseOutputRecordBill implements Serializable {
    @TableId(type = IdType.AUTO)
    private Long id;

    /**
     * 出库审核记录单号
     */
    private String recordBillNo;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 创建人ID
     */
    private Integer createUserId;

    /**
     * 创建人
     */
    private String createUserName;

    /**
     * 单据状态。待出库、已出库、锁定、取消
     */
    private String status;

    /**
     * 出库时间
     */
    private Date updateTime;

    /**
     * 出库人ID
     */
    private Integer updateUserId;

    /**
     * 出库人姓名
     */
    private String updateUserName;

    /**
     * 出库类型
     */
    private String type;

    /**
     * 备注
     */
    private String remark;

    /**
     * 去向
     */
    private String destination;

    /**
     * 是否自动出库，1 是，0否
     */
    private Boolean autoAudit;

    /**
     * 扫描的物料号/唯一码/批次号
     */
    private String scanCode;

    /**
     * 出库申请单号
     */
    private String outputBillNo;

    /**
     * 出库申请单id
     */
    private Long outputBillId;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}
