package com.sw.mes.store.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.sw.mes.core.response.Result;
import com.sw.mes.store.entity.WarehouseStocktaking;

import java.util.List;

/**
 * 线边仓盘点服务
 *
 * @Author：wanjia
 * @Date：2024/3/17 20:04
 */
public interface WarehouseStocktakingService extends IService<WarehouseStocktaking> {

    /**
     * 根据批次号、箱号、唯一码三选一进行盘点信息查询
     *
     * @param batchNo    批次号
     * @param serialNo   箱号
     * @param traceId    托号
     * @param uniqueCode 唯一码
     * @return List<WarehouseStocktaking> 有可能箱号和托号对应多个批次，所以会返回多个
     */
    Result<List<WarehouseStocktaking>> queryStocktaking(String batchNo, String serialNo, String traceId, String uniqueCode);


    /**
     * 批量写入盘货记录
     *
     * @param stocktakingList
     * @return
     */
    int batchInsert(List<WarehouseStocktaking> stocktakingList);
}
