package com.sw.mes.syslog.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.util.Date;
import lombok.Data;

/**
 * 【记录与报表—系统日志】 系统操作日志
 * @TableName sys_log
 */
@TableName(value ="sys_log")
@Data
public class SysLog implements Serializable {
    /**
     * 
     */
    @TableId(type = IdType.AUTO)
    private Integer id;

    /**
     * 请求内容
     */
    private String content;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 用户id
     */
    private Integer createUserId;

    /**
     * 用户名称
     */
    private String createUserName;

    /**
     * 方法名
     */
    private String methodName;

    /**
     * 日志名称
     */
    private String name;

    /**
     * 返回结果
     */
    private String result;

    /**
     * 日志类型：info,error,warn,trace
     */
    private String type;

    /**
     * 请求接口地址
     */
    private String serverAddr;

    /**
     * 请求类型
     */
    private String reqType;

    /**
     * 请求ip
     */
    private String reqIp;

    /**
     * 状态
     */
    private Integer status;

    /**
     * 请求id
     */
    private String requestId;

    /**
     * 请求耗时
     */
    private Integer spendTime;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}